//-------------------------------------------------------------------------------
//$Header: /home/dashley/cvsrep/uculib01/uculib01/src/stm8/cosmic/modx/btu32rotleftninplacerxn/unittest/ut_project/stm8/cosmic/modx/utfu_btu32rotleftninplacerxn.c,v 1.2 2010/05/18 21:17:11 dashley Exp $
//-------------------------------------------------------------------------------
//Copyright (c)2010 David T. Ashley
//
//Permission is hereby granted, free of charge, to any person obtaining a copy
//of this software source code and associated documentation files (the
//"Software"), to deal in the Software without restriction, including without
//limitation the rights to use, copy, modify, merge, publish, distribute,
//sublicense, and/or sell copies of the Software, and to permit persons to whom
//the Software is furnished to do so, subject to the following conditions:
//
//The above copyright notice and this permission notice shall be included in
//all copies or substantial portions of the Software.
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
//THE SOFTWARE.
//-------------------------------------------------------------------------------
#define MODULE_UTFU_BTU32ROTLEFTNINPLACERXN

#include "\uculib01\include\stm8\cosmic\c\uculib.h"
#include "utfu_btu32rotleftninplacerxn.h"


typedef struct
   {
   UCU_UINT32  start;
   UCU_UINT8   n;
   UCU_UINT32  end;
   } BTU32ROTLEFTNINPLACERXN_TV;


//This is the table of test vectors.
//
const BTU32ROTLEFTNINPLACERXN_TV BtU32RotLeftNInPlaceRxn_Tvs[] =
   {
      //Calling convention check.
      {  0x05050505UL,    1,  0x0A0A0A0AUL  },  // [    0]
      //
      //Branch check from unit test plan.
      {  0x00000000UL,    0,  0x00000000UL  },  // [    1]
      {  0x00000000UL,    1,  0x00000000UL  },  // [    2]
      {  0x00000000UL,    7,  0x00000000UL  },  // [    3]
      {  0x00000000UL,    8,  0x00000000UL  },  // [    4]
      {  0x00000000UL,    9,  0x00000000UL  },  // [    5]
      {  0x00000000UL,   15,  0x00000000UL  },  // [    6]
      {  0x00000000UL,   16,  0x00000000UL  },  // [    7]
      {  0x00000000UL,   17,  0x00000000UL  },  // [    8]
      {  0x00000000UL,   23,  0x00000000UL  },  // [    9]
      {  0x00000000UL,   24,  0x00000000UL  },  // [   10]
      {  0x00000000UL,   25,  0x00000000UL  },  // [   11]
      {  0x00000000UL,   31,  0x00000000UL  },  // [   12]
      {  0x00000000UL,   32,  0x00000000UL  },  // [   13]
      //
      //Second branch check to get the "set the carry" branch.
      {  0xFFFFFFFFUL,    0,  0xFFFFFFFFUL  },  // [   14]
      {  0xFFFFFFFFUL,    1,  0xFFFFFFFFUL  },  // [   15]
      {  0xFFFFFFFFUL,    7,  0xFFFFFFFFUL  },  // [   16]
      {  0xFFFFFFFFUL,    8,  0xFFFFFFFFUL  },  // [   17]
      {  0xFFFFFFFFUL,    9,  0xFFFFFFFFUL  },  // [   18]
      {  0xFFFFFFFFUL,   15,  0xFFFFFFFFUL  },  // [   19]
      {  0xFFFFFFFFUL,   16,  0xFFFFFFFFUL  },  // [   20]
      {  0xFFFFFFFFUL,   17,  0xFFFFFFFFUL  },  // [   21]
      {  0xFFFFFFFFUL,   23,  0xFFFFFFFFUL  },  // [   22]
      {  0xFFFFFFFFUL,   24,  0xFFFFFFFFUL  },  // [   23]
      {  0xFFFFFFFFUL,   25,  0xFFFFFFFFUL  },  // [   24]
      {  0xFFFFFFFFUL,   31,  0xFFFFFFFFUL  },  // [   25]
      {  0xFFFFFFFFUL,   32,  0xFFFFFFFFUL  },  // [   26]
      //
      //Test that data is loaded into stack frame as expected, from unit test plan.
      {  0x01030507UL,    0,  0x01030507UL  },  // [   27]
      //
      //Modulo test.
      {  0x01030507UL,   31,  0x80818283UL  },  // [   28]
      {  0x01030507UL,   32,  0x01030507UL  },  // [   29]
      {  0x01030507UL,   33,  0x02060A0EUL  },  // [   30]
      //
      //Test that the N >= 8 clause results in the expected exchanges. 
      {  0x01030507UL,   24,  0x07010305UL  },  // [   31]
      //
      //Duplicated test, to fill one element in the array so that automatically-generated
      //test vectors start at the right place (so that comments in the automatically-generated
      //vectors are correct).
      {  0xFFFFFFFFUL,    0,  0xFFFFFFFFUL  },  // [   32]
      //
      //The test vectors below are automatically generated.  The generator program is in the directory
      //"/hl/cvsroots/uculib01/uculib01/src/stm8/cosmic/modx0/btu32rotleftninplacerxn/unittest/testvectorgen".
      {  0x00000000UL,    0,  0x00000000UL  },  // [   33] Zero left roll test.
      {  0x00000000UL,    1,  0x00000000UL  },  // [   34] Zero left roll test.
      {  0x00000000UL,    2,  0x00000000UL  },  // [   35] Zero left roll test.
      {  0x00000000UL,    3,  0x00000000UL  },  // [   36] Zero left roll test.
      {  0x00000000UL,    4,  0x00000000UL  },  // [   37] Zero left roll test.
      {  0x00000000UL,    5,  0x00000000UL  },  // [   38] Zero left roll test.
      {  0x00000000UL,    6,  0x00000000UL  },  // [   39] Zero left roll test.
      {  0x00000000UL,    7,  0x00000000UL  },  // [   40] Zero left roll test.
      {  0x00000000UL,    8,  0x00000000UL  },  // [   41] Zero left roll test.
      {  0x00000000UL,    9,  0x00000000UL  },  // [   42] Zero left roll test.
      {  0x00000000UL,   10,  0x00000000UL  },  // [   43] Zero left roll test.
      {  0x00000000UL,   11,  0x00000000UL  },  // [   44] Zero left roll test.
      {  0x00000000UL,   12,  0x00000000UL  },  // [   45] Zero left roll test.
      {  0x00000000UL,   13,  0x00000000UL  },  // [   46] Zero left roll test.
      {  0x00000000UL,   14,  0x00000000UL  },  // [   47] Zero left roll test.
      {  0x00000000UL,   15,  0x00000000UL  },  // [   48] Zero left roll test.
      {  0x00000000UL,   16,  0x00000000UL  },  // [   49] Zero left roll test.
      {  0x00000000UL,   17,  0x00000000UL  },  // [   50] Zero left roll test.
      {  0x00000000UL,   18,  0x00000000UL  },  // [   51] Zero left roll test.
      {  0x00000000UL,   19,  0x00000000UL  },  // [   52] Zero left roll test.
      {  0x00000000UL,   20,  0x00000000UL  },  // [   53] Zero left roll test.
      {  0x00000000UL,   21,  0x00000000UL  },  // [   54] Zero left roll test.
      {  0x00000000UL,   22,  0x00000000UL  },  // [   55] Zero left roll test.
      {  0x00000000UL,   23,  0x00000000UL  },  // [   56] Zero left roll test.
      {  0x00000000UL,   24,  0x00000000UL  },  // [   57] Zero left roll test.
      {  0x00000000UL,   25,  0x00000000UL  },  // [   58] Zero left roll test.
      {  0x00000000UL,   26,  0x00000000UL  },  // [   59] Zero left roll test.
      {  0x00000000UL,   27,  0x00000000UL  },  // [   60] Zero left roll test.
      {  0x00000000UL,   28,  0x00000000UL  },  // [   61] Zero left roll test.
      {  0x00000000UL,   29,  0x00000000UL  },  // [   62] Zero left roll test.
      {  0x00000000UL,   30,  0x00000000UL  },  // [   63] Zero left roll test.
      {  0x00000000UL,   31,  0x00000000UL  },  // [   64] Zero left roll test.
      {  0x00000000UL,   32,  0x00000000UL  },  // [   65] Zero left roll test.
      {  0x00000000UL,  221,  0x00000000UL  },  // [   66] Zero left roll test.
      {  0x00000000UL,  130,  0x00000000UL  },  // [   67] Zero left roll test.
      {  0x00000000UL,  232,  0x00000000UL  },  // [   68] Zero left roll test.
      {  0x00000000UL,    9,  0x00000000UL  },  // [   69] Zero left roll test.
      {  0x00000000UL,  186,  0x00000000UL  },  // [   70] Zero left roll test.
      {  0x00000000UL,  149,  0x00000000UL  },  // [   71] Zero left roll test.
      {  0x00000000UL,  135,  0x00000000UL  },  // [   72] Zero left roll test.
      {  0x00000000UL,   11,  0x00000000UL  },  // [   73] Zero left roll test.
      {  0x00000000UL,  231,  0x00000000UL  },  // [   74] Zero left roll test.
      {  0x00000000UL,  251,  0x00000000UL  },  // [   75] Zero left roll test.
      {  0x00000000UL,    8,  0x00000000UL  },  // [   76] Zero left roll test.
      {  0x00000000UL,  133,  0x00000000UL  },  // [   77] Zero left roll test.
      {  0x00000000UL,   23,  0x00000000UL  },  // [   78] Zero left roll test.
      {  0x00000000UL,   58,  0x00000000UL  },  // [   79] Zero left roll test.
      {  0x00000000UL,   50,  0x00000000UL  },  // [   80] Zero left roll test.
      {  0x00000000UL,   92,  0x00000000UL  },  // [   81] Zero left roll test.
      {  0x00000000UL,   21,  0x00000000UL  },  // [   82] Zero left roll test.
      {  0x00000000UL,   30,  0x00000000UL  },  // [   83] Zero left roll test.
      {  0x00000000UL,   21,  0x00000000UL  },  // [   84] Zero left roll test.
      {  0x00000000UL,  234,  0x00000000UL  },  // [   85] Zero left roll test.
      {  0x00000000UL,  167,  0x00000000UL  },  // [   86] Zero left roll test.
      {  0x00000000UL,  190,  0x00000000UL  },  // [   87] Zero left roll test.
      {  0x00000000UL,  191,  0x00000000UL  },  // [   88] Zero left roll test.
      {  0x00000000UL,    6,  0x00000000UL  },  // [   89] Zero left roll test.
      {  0x00000000UL,  125,  0x00000000UL  },  // [   90] Zero left roll test.
      {  0xFFFFFFFFUL,    0,  0xFFFFFFFFUL  },  // [   91] One left roll test.
      {  0xFFFFFFFFUL,    1,  0xFFFFFFFFUL  },  // [   92] One left roll test.
      {  0xFFFFFFFFUL,    2,  0xFFFFFFFFUL  },  // [   93] One left roll test.
      {  0xFFFFFFFFUL,    3,  0xFFFFFFFFUL  },  // [   94] One left roll test.
      {  0xFFFFFFFFUL,    4,  0xFFFFFFFFUL  },  // [   95] One left roll test.
      {  0xFFFFFFFFUL,    5,  0xFFFFFFFFUL  },  // [   96] One left roll test.
      {  0xFFFFFFFFUL,    6,  0xFFFFFFFFUL  },  // [   97] One left roll test.
      {  0xFFFFFFFFUL,    7,  0xFFFFFFFFUL  },  // [   98] One left roll test.
      {  0xFFFFFFFFUL,    8,  0xFFFFFFFFUL  },  // [   99] One left roll test.
      {  0xFFFFFFFFUL,    9,  0xFFFFFFFFUL  },  // [  100] One left roll test.
      {  0xFFFFFFFFUL,   10,  0xFFFFFFFFUL  },  // [  101] One left roll test.
      {  0xFFFFFFFFUL,   11,  0xFFFFFFFFUL  },  // [  102] One left roll test.
      {  0xFFFFFFFFUL,   12,  0xFFFFFFFFUL  },  // [  103] One left roll test.
      {  0xFFFFFFFFUL,   13,  0xFFFFFFFFUL  },  // [  104] One left roll test.
      {  0xFFFFFFFFUL,   14,  0xFFFFFFFFUL  },  // [  105] One left roll test.
      {  0xFFFFFFFFUL,   15,  0xFFFFFFFFUL  },  // [  106] One left roll test.
      {  0xFFFFFFFFUL,   16,  0xFFFFFFFFUL  },  // [  107] One left roll test.
      {  0xFFFFFFFFUL,   17,  0xFFFFFFFFUL  },  // [  108] One left roll test.
      {  0xFFFFFFFFUL,   18,  0xFFFFFFFFUL  },  // [  109] One left roll test.
      {  0xFFFFFFFFUL,   19,  0xFFFFFFFFUL  },  // [  110] One left roll test.
      {  0xFFFFFFFFUL,   20,  0xFFFFFFFFUL  },  // [  111] One left roll test.
      {  0xFFFFFFFFUL,   21,  0xFFFFFFFFUL  },  // [  112] One left roll test.
      {  0xFFFFFFFFUL,   22,  0xFFFFFFFFUL  },  // [  113] One left roll test.
      {  0xFFFFFFFFUL,   23,  0xFFFFFFFFUL  },  // [  114] One left roll test.
      {  0xFFFFFFFFUL,   24,  0xFFFFFFFFUL  },  // [  115] One left roll test.
      {  0xFFFFFFFFUL,   25,  0xFFFFFFFFUL  },  // [  116] One left roll test.
      {  0xFFFFFFFFUL,   26,  0xFFFFFFFFUL  },  // [  117] One left roll test.
      {  0xFFFFFFFFUL,   27,  0xFFFFFFFFUL  },  // [  118] One left roll test.
      {  0xFFFFFFFFUL,   28,  0xFFFFFFFFUL  },  // [  119] One left roll test.
      {  0xFFFFFFFFUL,   29,  0xFFFFFFFFUL  },  // [  120] One left roll test.
      {  0xFFFFFFFFUL,   30,  0xFFFFFFFFUL  },  // [  121] One left roll test.
      {  0xFFFFFFFFUL,   31,  0xFFFFFFFFUL  },  // [  122] One left roll test.
      {  0xFFFFFFFFUL,   32,  0xFFFFFFFFUL  },  // [  123] One left roll test.
      {  0xFFFFFFFFUL,   45,  0xFFFFFFFFUL  },  // [  124] One left roll test.
      {  0xFFFFFFFFUL,  164,  0xFFFFFFFFUL  },  // [  125] One left roll test.
      {  0xFFFFFFFFUL,   42,  0xFFFFFFFFUL  },  // [  126] One left roll test.
      {  0xFFFFFFFFUL,   88,  0xFFFFFFFFUL  },  // [  127] One left roll test.
      {  0xFFFFFFFFUL,  130,  0xFFFFFFFFUL  },  // [  128] One left roll test.
      {  0xFFFFFFFFUL,   35,  0xFFFFFFFFUL  },  // [  129] One left roll test.
      {  0xFFFFFFFFUL,  180,  0xFFFFFFFFUL  },  // [  130] One left roll test.
      {  0xFFFFFFFFUL,  220,  0xFFFFFFFFUL  },  // [  131] One left roll test.
      {  0xFFFFFFFFUL,   20,  0xFFFFFFFFUL  },  // [  132] One left roll test.
      {  0xFFFFFFFFUL,  177,  0xFFFFFFFFUL  },  // [  133] One left roll test.
      {  0xFFFFFFFFUL,   95,  0xFFFFFFFFUL  },  // [  134] One left roll test.
      {  0xFFFFFFFFUL,  222,  0xFFFFFFFFUL  },  // [  135] One left roll test.
      {  0xFFFFFFFFUL,   67,  0xFFFFFFFFUL  },  // [  136] One left roll test.
      {  0xFFFFFFFFUL,  184,  0xFFFFFFFFUL  },  // [  137] One left roll test.
      {  0xFFFFFFFFUL,  146,  0xFFFFFFFFUL  },  // [  138] One left roll test.
      {  0xFFFFFFFFUL,  240,  0xFFFFFFFFUL  },  // [  139] One left roll test.
      {  0xFFFFFFFFUL,  186,  0xFFFFFFFFUL  },  // [  140] One left roll test.
      {  0xFFFFFFFFUL,   40,  0xFFFFFFFFUL  },  // [  141] One left roll test.
      {  0xFFFFFFFFUL,   28,  0xFFFFFFFFUL  },  // [  142] One left roll test.
      {  0xFFFFFFFFUL,    1,  0xFFFFFFFFUL  },  // [  143] One left roll test.
      {  0xFFFFFFFFUL,   21,  0xFFFFFFFFUL  },  // [  144] One left roll test.
      {  0xFFFFFFFFUL,   79,  0xFFFFFFFFUL  },  // [  145] One left roll test.
      {  0xFFFFFFFFUL,  125,  0xFFFFFFFFUL  },  // [  146] One left roll test.
      {  0xFFFFFFFFUL,  164,  0xFFFFFFFFUL  },  // [  147] One left roll test.
      {  0xFFFFFFFFUL,   39,  0xFFFFFFFFUL  },  // [  148] One left roll test.
      {  0x0ADE12ECUL,  142,  0x84BB02B7UL  },  // [  149] Random left roll test (    1/ 3000).
      {  0xD25570FBUL,  250,  0xEF4955C3UL  },  // [  150] Random left roll test (    2/ 3000).
      {  0x3A7E56BAUL,  192,  0x3A7E56BAUL  },  // [  151] Random left roll test (    3/ 3000).
      {  0xA89C9FF9UL,  110,  0x27FE6A27UL  },  // [  152] Random left roll test (    4/ 3000).
      {  0x31600D86UL,   43,  0x006C318BUL  },  // [  153] Random left roll test (    5/ 3000).
      {  0xEC1E8552UL,  111,  0x42A9760FUL  },  // [  154] Random left roll test (    6/ 3000).
      {  0x78AB97B8UL,  187,  0xC3C55CBDUL  },  // [  155] Random left roll test (    7/ 3000).
      {  0x95EF9F5BUL,  221,  0x72BDF3EBUL  },  // [  156] Random left roll test (    8/ 3000).
      {  0x60907B8DUL,  115,  0xDC6B0483UL  },  // [  157] Random left roll test (    9/ 3000).
      {  0xD7D91DDBUL,  117,  0xBB7AFB23UL  },  // [  158] Random left roll test (   10/ 3000).
      {  0x3CFEC3D5UL,   63,  0x9E7F61EAUL  },  // [  159] Random left roll test (   11/ 3000).
      {  0x022C866AUL,  192,  0x022C866AUL  },  // [  160] Random left roll test (   12/ 3000).
      {  0xDF6D02B6UL,    8,  0x6D02B6DFUL  },  // [  161] Random left roll test (   13/ 3000).
      {  0x7013DEBDUL,  189,  0xAE027BD7UL  },  // [  162] Random left roll test (   14/ 3000).
      {  0x317BA713UL,   73,  0xF74E2662UL  },  // [  163] Random left roll test (   15/ 3000).
      {  0x16A57865UL,   54,  0x1945A95EUL  },  // [  164] Random left roll test (   16/ 3000).
      {  0x6986D2D5UL,  115,  0x96AB4C36UL  },  // [  165] Random left roll test (   17/ 3000).
      {  0xE97C5D42UL,  182,  0x50BA5F17UL  },  // [  166] Random left roll test (   18/ 3000).
      {  0x4397B1B5UL,   22,  0x6D50E5ECUL  },  // [  167] Random left roll test (   19/ 3000).
      {  0x95EC532DUL,  219,  0x6CAF6299UL  },  // [  168] Random left roll test (   20/ 3000).
      {  0xB717DFBDUL,   28,  0xDB717DFBUL  },  // [  169] Random left roll test (   21/ 3000).
      {  0x5F839B9EUL,  128,  0x5F839B9EUL  },  // [  170] Random left roll test (   22/ 3000).
      {  0x552B59AEUL,   73,  0x56B35CAAUL  },  // [  171] Random left roll test (   23/ 3000).
      {  0x1BA016FCUL,   97,  0x37402DF8UL  },  // [  172] Random left roll test (   24/ 3000).
      {  0x11087124UL,   33,  0x2210E248UL  },  // [  173] Random left roll test (   25/ 3000).
      {  0x7EA17B08UL,  251,  0x43F50BD8UL  },  // [  174] Random left roll test (   26/ 3000).
      {  0x46426E50UL,    0,  0x46426E50UL  },  // [  175] Random left roll test (   27/ 3000).
      {  0xC070E457UL,  241,  0xC8AF80E1UL  },  // [  176] Random left roll test (   28/ 3000).
      {  0x0B6F5224UL,  219,  0x205B7A91UL  },  // [  177] Random left roll test (   29/ 3000).
      {  0x8228F21CUL,  228,  0x228F21C8UL  },  // [  178] Random left roll test (   30/ 3000).
      {  0xBF4D2A9FUL,   33,  0x7E9A553FUL  },  // [  179] Random left roll test (   31/ 3000).
      {  0x175D77EBUL,   79,  0xBBF58BAEUL  },  // [  180] Random left roll test (   32/ 3000).
      {  0x65BAB160UL,   75,  0xD58B032DUL  },  // [  181] Random left roll test (   33/ 3000).
      {  0x5116D431UL,  131,  0x88B6A18AUL  },  // [  182] Random left roll test (   34/ 3000).
      {  0xCB410B0EUL,  253,  0xD9682161UL  },  // [  183] Random left roll test (   35/ 3000).
      {  0x40B05E9BUL,   49,  0xBD368160UL  },  // [  184] Random left roll test (   36/ 3000).
      {  0x856D4BB1UL,  236,  0xD4BB1856UL  },  // [  185] Random left roll test (   37/ 3000).
      {  0xCF824351UL,  170,  0x090D473EUL  },  // [  186] Random left roll test (   38/ 3000).
      {  0xB17A3B47UL,   37,  0x2F4768F6UL  },  // [  187] Random left roll test (   39/ 3000).
      {  0xCE63A5F1UL,  101,  0xCC74BE39UL  },  // [  188] Random left roll test (   40/ 3000).
      {  0x28569FD4UL,   38,  0x15A7F50AUL  },  // [  189] Random left roll test (   41/ 3000).
      {  0xB8EA8A03UL,  250,  0x0EE3AA28UL  },  // [  190] Random left roll test (   42/ 3000).
      {  0xC5CC891AUL,  133,  0xB9912358UL  },  // [  191] Random left roll test (   43/ 3000).
      {  0x47C91F03UL,   89,  0x068F923EUL  },  // [  192] Random left roll test (   44/ 3000).
      {  0xC1443B9AUL,   68,  0x1443B9ACUL  },  // [  193] Random left roll test (   45/ 3000).
      {  0x353D7F1BUL,   73,  0x7AFE366AUL  },  // [  194] Random left roll test (   46/ 3000).
      {  0xD73A0074UL,   21,  0x0E9AE740UL  },  // [  195] Random left roll test (   47/ 3000).
      {  0x294E8ECBUL,  119,  0x6594A747UL  },  // [  196] Random left roll test (   48/ 3000).
      {  0x22F70301UL,   31,  0x917B8180UL  },  // [  197] Random left roll test (   49/ 3000).
      {  0xF477DB24UL,  157,  0x9E8EFB64UL  },  // [  198] Random left roll test (   50/ 3000).
      {  0xD7F06AB6UL,    7,  0xF8355B6BUL  },  // [  199] Random left roll test (   51/ 3000).
      {  0x6A3B0599UL,    5,  0x4760B32DUL  },  // [  200] Random left roll test (   52/ 3000).
      {  0x01CF6FCBUL,  212,  0xFCB01CF6UL  },  // [  201] Random left roll test (   53/ 3000).
      {  0x5224CB3DUL,   39,  0x12659EA9UL  },  // [  202] Random left roll test (   54/ 3000).
      {  0xE92EA7FDUL,   36,  0x92EA7FDEUL  },  // [  203] Random left roll test (   55/ 3000).
      {  0xF0D33959UL,   77,  0x672B3E1AUL  },  // [  204] Random left roll test (   56/ 3000).
      {  0xA76A6720UL,  224,  0xA76A6720UL  },  // [  205] Random left roll test (   57/ 3000).
      {  0x348D6705UL,  245,  0xE0A691ACUL  },  // [  206] Random left roll test (   58/ 3000).
      {  0xE88ABA95UL,  189,  0xBD115752UL  },  // [  207] Random left roll test (   59/ 3000).
      {  0xA69D56BAUL,  138,  0x755AEA9AUL  },  // [  208] Random left roll test (   60/ 3000).
      {  0x94FD1848UL,   17,  0x309129FAUL  },  // [  209] Random left roll test (   61/ 3000).
      {  0x9AE42979UL,   96,  0x9AE42979UL  },  // [  210] Random left roll test (   62/ 3000).
      {  0x02F60581UL,  183,  0xC0817B02UL  },  // [  211] Random left roll test (   63/ 3000).
      {  0x5DA85086UL,   95,  0x2ED42843UL  },  // [  212] Random left roll test (   64/ 3000).
      {  0xE06E3E2CUL,  100,  0x06E3E2CEUL  },  // [  213] Random left roll test (   65/ 3000).
      {  0x36A314C4UL,   24,  0xC436A314UL  },  // [  214] Random left roll test (   66/ 3000).
      {  0x0047F287UL,   43,  0x3F943802UL  },  // [  215] Random left roll test (   67/ 3000).
      {  0x5645FA27UL,   80,  0xFA275645UL  },  // [  216] Random left roll test (   68/ 3000).
      {  0x16CF085CUL,  245,  0x0B82D9E1UL  },  // [  217] Random left roll test (   69/ 3000).
      {  0x23D9F19BUL,   31,  0x91ECF8CDUL  },  // [  218] Random left roll test (   70/ 3000).
      {  0x74F2F4F3UL,   14,  0xBD3CDD3CUL  },  // [  219] Random left roll test (   71/ 3000).
      {  0x20BAE5EEUL,   92,  0xE20BAE5EUL  },  // [  220] Random left roll test (   72/ 3000).
      {  0x028D6EDFUL,  220,  0xF028D6EDUL  },  // [  221] Random left roll test (   73/ 3000).
      {  0x3AB48E2FUL,  162,  0xEAD238BCUL  },  // [  222] Random left roll test (   74/ 3000).
      {  0xD58088FBUL,  226,  0x560223EFUL  },  // [  223] Random left roll test (   75/ 3000).
      {  0xE268B1ECUL,  194,  0x89A2C7B3UL  },  // [  224] Random left roll test (   76/ 3000).
      {  0x86A8EC6BUL,   47,  0x7635C354UL  },  // [  225] Random left roll test (   77/ 3000).
      {  0x458EBC29UL,  105,  0x1D78528BUL  },  // [  226] Random left roll test (   78/ 3000).
      {  0x952DD550UL,   53,  0xAA12A5BAUL  },  // [  227] Random left roll test (   79/ 3000).
      {  0xA8D7222EUL,  219,  0x7546B911UL  },  // [  228] Random left roll test (   80/ 3000).
      {  0x67CF7CA7UL,   91,  0x3B3E7BE5UL  },  // [  229] Random left roll test (   81/ 3000).
      {  0x8FDF0166UL,   97,  0x1FBE02CDUL  },  // [  230] Random left roll test (   82/ 3000).
      {  0xB8F586CFUL,   14,  0x61B3EE3DUL  },  // [  231] Random left roll test (   83/ 3000).
      {  0xB59DD87FUL,  164,  0x59DD87FBUL  },  // [  232] Random left roll test (   84/ 3000).
      {  0x600EB4BEUL,   98,  0x803AD2F9UL  },  // [  233] Random left roll test (   85/ 3000).
      {  0xD9067857UL,  100,  0x9067857DUL  },  // [  234] Random left roll test (   86/ 3000).
      {  0x00A16416UL,  173,  0x2C82C014UL  },  // [  235] Random left roll test (   87/ 3000).
      {  0x39C4FF4CUL,  125,  0x87389FE9UL  },  // [  236] Random left roll test (   88/ 3000).
      {  0x06FC23F9UL,   13,  0x847F20DFUL  },  // [  237] Random left roll test (   89/ 3000).
      {  0x452EB318UL,   44,  0xEB318452UL  },  // [  238] Random left roll test (   90/ 3000).
      {  0xE6272B46UL,  187,  0x3731395AUL  },  // [  239] Random left roll test (   91/ 3000).
      {  0x1ED7DE32UL,    2,  0x7B5F78C8UL  },  // [  240] Random left roll test (   92/ 3000).
      {  0xA7EC434CUL,   57,  0x994FD886UL  },  // [  241] Random left roll test (   93/ 3000).
      {  0x8145C6F6UL,   44,  0x5C6F6814UL  },  // [  242] Random left roll test (   94/ 3000).
      {  0x67BD2499UL,  169,  0x7A4932CFUL  },  // [  243] Random left roll test (   95/ 3000).
      {  0xE931A14CUL,   12,  0x1A14CE93UL  },  // [  244] Random left roll test (   96/ 3000).
      {  0x35986F1DUL,  141,  0x0DE3A6B3UL  },  // [  245] Random left roll test (   97/ 3000).
      {  0x109329E1UL,  189,  0x2212653CUL  },  // [  246] Random left roll test (   98/ 3000).
      {  0xCC29AA53UL,   70,  0x0A6A94F3UL  },  // [  247] Random left roll test (   99/ 3000).
      {  0xAF1E6881UL,   19,  0x440D78F3UL  },  // [  248] Random left roll test (  100/ 3000).
      {  0x24DACD97UL,  177,  0x9B2E49B5UL  },  // [  249] Random left roll test (  101/ 3000).
      {  0x08F47334UL,   96,  0x08F47334UL  },  // [  250] Random left roll test (  102/ 3000).
      {  0xF2B833E6UL,  187,  0x3795C19FUL  },  // [  251] Random left roll test (  103/ 3000).
      {  0x011C80BAUL,   97,  0x02390174UL  },  // [  252] Random left roll test (  104/ 3000).
      {  0x0BDD451CUL,   57,  0x3817BA8AUL  },  // [  253] Random left roll test (  105/ 3000).
      {  0xCE69CE65UL,  139,  0x4E732E73UL  },  // [  254] Random left roll test (  106/ 3000).
      {  0x2F8FD8A8UL,  148,  0x8A82F8FDUL  },  // [  255] Random left roll test (  107/ 3000).
      {  0x90B65248UL,    9,  0x6CA49121UL  },  // [  256] Random left roll test (  108/ 3000).
      {  0xA7AE7E03UL,   70,  0xEB9F80E9UL  },  // [  257] Random left roll test (  109/ 3000).
      {  0x2960DDEFUL,  224,  0x2960DDEFUL  },  // [  258] Random left roll test (  110/ 3000).
      {  0x6AC16709UL,   20,  0x7096AC16UL  },  // [  259] Random left roll test (  111/ 3000).
      {  0x9847284FUL,  104,  0x47284F98UL  },  // [  260] Random left roll test (  112/ 3000).
      {  0x06E05D38UL,  242,  0x74E01B81UL  },  // [  261] Random left roll test (  113/ 3000).
      {  0x0377EF93UL,  109,  0xFDF2606EUL  },  // [  262] Random left roll test (  114/ 3000).
      {  0x2C1F821AUL,  217,  0x34583F04UL  },  // [  263] Random left roll test (  115/ 3000).
      {  0x2D10502EUL,  202,  0x4140B8B4UL  },  // [  264] Random left roll test (  116/ 3000).
      {  0x63DB24A9UL,   18,  0x92A58F6CUL  },  // [  265] Random left roll test (  117/ 3000).
      {  0x0A271825UL,  103,  0x138C1285UL  },  // [  266] Random left roll test (  118/ 3000).
      {  0xE15EFDFDUL,  243,  0xEFEF0AF7UL  },  // [  267] Random left roll test (  119/ 3000).
      {  0xFAD3737DUL,  124,  0xDFAD3737UL  },  // [  268] Random left roll test (  120/ 3000).
      {  0x417B6C2EUL,  144,  0x6C2E417BUL  },  // [  269] Random left roll test (  121/ 3000).
      {  0x763146CDUL,   39,  0x18A366BBUL  },  // [  270] Random left roll test (  122/ 3000).
      {  0x662D03D7UL,   64,  0x662D03D7UL  },  // [  271] Random left roll test (  123/ 3000).
      {  0x32F75AEAUL,  246,  0xBA8CBDD6UL  },  // [  272] Random left roll test (  124/ 3000).
      {  0x6CFF6CA8UL,  197,  0x9FED950DUL  },  // [  273] Random left roll test (  125/ 3000).
      {  0xB9C05D2FUL,   87,  0x97DCE02EUL  },  // [  274] Random left roll test (  126/ 3000).
      {  0x816E9695UL,   70,  0x5BA5A560UL  },  // [  275] Random left roll test (  127/ 3000).
      {  0x544EDB39UL,  110,  0xB6CE5513UL  },  // [  276] Random left roll test (  128/ 3000).
      {  0xB1624B55UL,   85,  0x6AB62C49UL  },  // [  277] Random left roll test (  129/ 3000).
      {  0x688BAA77UL,   20,  0xA77688BAUL  },  // [  278] Random left roll test (  130/ 3000).
      {  0xD7D03718UL,  245,  0xE31AFA06UL  },  // [  279] Random left roll test (  131/ 3000).
      {  0x5ED800A8UL,  133,  0xDB00150BUL  },  // [  280] Random left roll test (  132/ 3000).
      {  0x40FA0734UL,  137,  0xF40E6881UL  },  // [  281] Random left roll test (  133/ 3000).
      {  0x31C489A7UL,  101,  0x389134E6UL  },  // [  282] Random left roll test (  134/ 3000).
      {  0x0C005982UL,   55,  0xC106002CUL  },  // [  283] Random left roll test (  135/ 3000).
      {  0xB0692A08UL,  251,  0x45834950UL  },  // [  284] Random left roll test (  136/ 3000).
      {  0x4B66F26FUL,  227,  0x5B37937AUL  },  // [  285] Random left roll test (  137/ 3000).
      {  0x1CE0638AUL,   54,  0xE2873818UL  },  // [  286] Random left roll test (  138/ 3000).
      {  0x1D0429A0UL,   91,  0x00E8214DUL  },  // [  287] Random left roll test (  139/ 3000).
      {  0x0DD6ED93UL,   84,  0xD930DD6EUL  },  // [  288] Random left roll test (  140/ 3000).
      {  0xA2833BA7UL,  115,  0xDD3D1419UL  },  // [  289] Random left roll test (  141/ 3000).
      {  0x4443E69CUL,  132,  0x443E69C4UL  },  // [  290] Random left roll test (  142/ 3000).
      {  0x7F293FC1UL,  131,  0xF949FE0BUL  },  // [  291] Random left roll test (  143/ 3000).
      {  0x978D5CE8UL,  110,  0x573A25E3UL  },  // [  292] Random left roll test (  144/ 3000).
      {  0xB88C2F67UL,   90,  0x9EE230BDUL  },  // [  293] Random left roll test (  145/ 3000).
      {  0x513F299AUL,  114,  0xA66944FCUL  },  // [  294] Random left roll test (  146/ 3000).
      {  0xAC15CD7DUL,  128,  0xAC15CD7DUL  },  // [  295] Random left roll test (  147/ 3000).
      {  0x8A46F737UL,  177,  0xEE6F148DUL  },  // [  296] Random left roll test (  148/ 3000).
      {  0xAEEF1A95UL,  101,  0xDDE352B5UL  },  // [  297] Random left roll test (  149/ 3000).
      {  0xB2B65268UL,  252,  0x8B2B6526UL  },  // [  298] Random left roll test (  150/ 3000).
      {  0xA8DECE4BUL,  190,  0xEA37B392UL  },  // [  299] Random left roll test (  151/ 3000).
      {  0xA33FACAFUL,  228,  0x33FACAFAUL  },  // [  300] Random left roll test (  152/ 3000).
      {  0xD2412EA1UL,  223,  0xE9209750UL  },  // [  301] Random left roll test (  153/ 3000).
      {  0xF3749FCCUL,  207,  0x4FE679BAUL  },  // [  302] Random left roll test (  154/ 3000).
      {  0x044B8980UL,  145,  0x13000897UL  },  // [  303] Random left roll test (  155/ 3000).
      {  0x60D2F8EBUL,   95,  0xB0697C75UL  },  // [  304] Random left roll test (  156/ 3000).
      {  0x96C2AD18UL,   50,  0xB4625B0AUL  },  // [  305] Random left roll test (  157/ 3000).
      {  0x05288CF2UL,  246,  0x3C814A23UL  },  // [  306] Random left roll test (  158/ 3000).
      {  0x704161D7UL,  134,  0x105875DCUL  },  // [  307] Random left roll test (  159/ 3000).
      {  0x82B6EFFEUL,   52,  0xFFE82B6EUL  },  // [  308] Random left roll test (  160/ 3000).
      {  0xFF6B0C18UL,  238,  0xC3063FDAUL  },  // [  309] Random left roll test (  161/ 3000).
      {  0x0AA35555UL,  114,  0x55542A8DUL  },  // [  310] Random left roll test (  162/ 3000).
      {  0x0AEB4882UL,   69,  0x5D691041UL  },  // [  311] Random left roll test (  163/ 3000).
      {  0xDD84EDC3UL,  248,  0xC3DD84EDUL  },  // [  312] Random left roll test (  164/ 3000).
      {  0x36428C28UL,  138,  0x0A30A0D9UL  },  // [  313] Random left roll test (  165/ 3000).
      {  0x69D7B3B2UL,   26,  0xC9A75ECEUL  },  // [  314] Random left roll test (  166/ 3000).
      {  0x8BBBC2D2UL,   63,  0x45DDE169UL  },  // [  315] Random left roll test (  167/ 3000).
      {  0xAA03A522UL,  174,  0xE948AA80UL  },  // [  316] Random left roll test (  168/ 3000).
      {  0xE53E7DBAUL,   91,  0xD729F3EDUL  },  // [  317] Random left roll test (  169/ 3000).
      {  0x9B296B2EUL,  104,  0x296B2E9BUL  },  // [  318] Random left roll test (  170/ 3000).
      {  0x779401EBUL,  232,  0x9401EB77UL  },  // [  319] Random left roll test (  171/ 3000).
      {  0xAE2FDDC9UL,  219,  0x4D717EEEUL  },  // [  320] Random left roll test (  172/ 3000).
      {  0x4DECDFF8UL,   39,  0xF66FFC26UL  },  // [  321] Random left roll test (  173/ 3000).
      {  0x10040C6EUL,  101,  0x00818DC2UL  },  // [  322] Random left roll test (  174/ 3000).
      {  0x97DC9E62UL,  139,  0xE4F314BEUL  },  // [  323] Random left roll test (  175/ 3000).
      {  0xD0B78D4AUL,   66,  0x42DE352BUL  },  // [  324] Random left roll test (  176/ 3000).
      {  0xFD26B75FUL,   35,  0xE935BAFFUL  },  // [  325] Random left roll test (  177/ 3000).
      {  0x3AD4E2B8UL,  191,  0x1D6A715CUL  },  // [  326] Random left roll test (  178/ 3000).
      {  0x3715CC31UL,   13,  0xB98626E2UL  },  // [  327] Random left roll test (  179/ 3000).
      {  0x6237D3DAUL,   84,  0x3DA6237DUL  },  // [  328] Random left roll test (  180/ 3000).
      {  0x847543A5UL,  193,  0x08EA874BUL  },  // [  329] Random left roll test (  181/ 3000).
      {  0x2CC4FB1DUL,  226,  0xB313EC74UL  },  // [  330] Random left roll test (  182/ 3000).
      {  0x605DE04CUL,  168,  0x5DE04C60UL  },  // [  331] Random left roll test (  183/ 3000).
      {  0xD855AE73UL,  251,  0x9EC2AD73UL  },  // [  332] Random left roll test (  184/ 3000).
      {  0xBD5CBF3BUL,  255,  0xDEAE5F9DUL  },  // [  333] Random left roll test (  185/ 3000).
      {  0x2493B334UL,   27,  0xA1249D99UL  },  // [  334] Random left roll test (  186/ 3000).
      {  0xEF448813UL,   19,  0x409F7A24UL  },  // [  335] Random left roll test (  187/ 3000).
      {  0x711EAEA7UL,  103,  0x8F5753B8UL  },  // [  336] Random left roll test (  188/ 3000).
      {  0x181820BDUL,   56,  0xBD181820UL  },  // [  337] Random left roll test (  189/ 3000).
      {  0x80C998D5UL,   37,  0x19331AB0UL  },  // [  338] Random left roll test (  190/ 3000).
      {  0x6A608FD5UL,   71,  0x3047EAB5UL  },  // [  339] Random left roll test (  191/ 3000).
      {  0xE56E1D33UL,  230,  0x5B874CF9UL  },  // [  340] Random left roll test (  192/ 3000).
      {  0xDAD3F0AFUL,   70,  0xB4FC2BF6UL  },  // [  341] Random left roll test (  193/ 3000).
      {  0xABAC3297UL,  180,  0x297ABAC3UL  },  // [  342] Random left roll test (  194/ 3000).
      {  0x13106344UL,  164,  0x31063441UL  },  // [  343] Random left roll test (  195/ 3000).
      {  0x2281448AUL,  250,  0x288A0512UL  },  // [  344] Random left roll test (  196/ 3000).
      {  0xFE714BC8UL,   71,  0x38A5E47FUL  },  // [  345] Random left roll test (  197/ 3000).
      {  0x2A3AE83EUL,    1,  0x5475D07CUL  },  // [  346] Random left roll test (  198/ 3000).
      {  0x89AE15BFUL,  101,  0x35C2B7F1UL  },  // [  347] Random left roll test (  199/ 3000).
      {  0xA25F6F64UL,   29,  0x944BEDECUL  },  // [  348] Random left roll test (  200/ 3000).
      {  0x2563F4F4UL,  146,  0xD3D0958FUL  },  // [  349] Random left roll test (  201/ 3000).
      {  0x0FE0AAA0UL,  167,  0xF0555007UL  },  // [  350] Random left roll test (  202/ 3000).
      {  0x5B6F6293UL,   39,  0xB7B149ADUL  },  // [  351] Random left roll test (  203/ 3000).
      {  0x33529310UL,  121,  0x2066A526UL  },  // [  352] Random left roll test (  204/ 3000).
      {  0xAFB9E541UL,   77,  0x3CA835F7UL  },  // [  353] Random left roll test (  205/ 3000).
      {  0xD7C9B668UL,   95,  0x6BE4DB34UL  },  // [  354] Random left roll test (  206/ 3000).
      {  0xBE1FBFAAUL,   68,  0xE1FBFAABUL  },  // [  355] Random left roll test (  207/ 3000).
      {  0x4D920BB6UL,   26,  0xD936482EUL  },  // [  356] Random left roll test (  208/ 3000).
      {  0xEB9C667CUL,   12,  0xC667CEB9UL  },  // [  357] Random left roll test (  209/ 3000).
      {  0x5F149A68UL,  109,  0x934D0BE2UL  },  // [  358] Random left roll test (  210/ 3000).
      {  0x3E449CB7UL,  195,  0xF224E5B9UL  },  // [  359] Random left roll test (  211/ 3000).
      {  0xEF087A84UL,  107,  0x43D42778UL  },  // [  360] Random left roll test (  212/ 3000).
      {  0x645A0518UL,   42,  0x68146191UL  },  // [  361] Random left roll test (  213/ 3000).
      {  0x4552DB75UL,  235,  0x96DBAA2AUL  },  // [  362] Random left roll test (  214/ 3000).
      {  0x012E7EF7UL,   17,  0xFDEE025CUL  },  // [  363] Random left roll test (  215/ 3000).
      {  0x3264D03DUL,  255,  0x9932681EUL  },  // [  364] Random left roll test (  216/ 3000).
      {  0x303ADF4CUL,  201,  0x75BE9860UL  },  // [  365] Random left roll test (  217/ 3000).
      {  0xC07C996EUL,  109,  0x932DD80FUL  },  // [  366] Random left roll test (  218/ 3000).
      {  0x52B4EA2AUL,  125,  0x4A569D45UL  },  // [  367] Random left roll test (  219/ 3000).
      {  0x7B6007DBUL,   18,  0x1F6DED80UL  },  // [  368] Random left roll test (  220/ 3000).
      {  0x5EBA675CUL,   75,  0xD33AE2F5UL  },  // [  369] Random left roll test (  221/ 3000).
      {  0xAB808C80UL,  111,  0x464055C0UL  },  // [  370] Random left roll test (  222/ 3000).
      {  0xA8A71172UL,  147,  0x8B954538UL  },  // [  371] Random left roll test (  223/ 3000).
      {  0xB02E082FUL,  225,  0x605C105FUL  },  // [  372] Random left roll test (  224/ 3000).
      {  0x082D0D11UL,   59,  0x88416868UL  },  // [  373] Random left roll test (  225/ 3000).
      {  0xD30D6069UL,    9,  0x1AC0D3A6UL  },  // [  374] Random left roll test (  226/ 3000).
      {  0xD7922D0BUL,  146,  0xB42F5E48UL  },  // [  375] Random left roll test (  227/ 3000).
      {  0x7D823BC7UL,  153,  0x8EFB0477UL  },  // [  376] Random left roll test (  228/ 3000).
      {  0xDA29D245UL,  124,  0x5DA29D24UL  },  // [  377] Random left roll test (  229/ 3000).
      {  0x1A9C03A8UL,  201,  0x38075035UL  },  // [  378] Random left roll test (  230/ 3000).
      {  0x566C19E2UL,   97,  0xACD833C4UL  },  // [  379] Random left roll test (  231/ 3000).
      {  0xDD2E531EUL,  243,  0x98F6E972UL  },  // [  380] Random left roll test (  232/ 3000).
      {  0x1D3396EDUL,   49,  0x2DDA3A67UL  },  // [  381] Random left roll test (  233/ 3000).
      {  0x5D87E198UL,  248,  0x985D87E1UL  },  // [  382] Random left roll test (  234/ 3000).
      {  0x1A70EEA4UL,   37,  0x4E1DD483UL  },  // [  383] Random left roll test (  235/ 3000).
      {  0xBBDDABCFUL,   78,  0x6AF3EEF7UL  },  // [  384] Random left roll test (  236/ 3000).
      {  0xDC5222FDUL,   70,  0x1488BF77UL  },  // [  385] Random left roll test (  237/ 3000).
      {  0xEEDA99B6UL,  232,  0xDA99B6EEUL  },  // [  386] Random left roll test (  238/ 3000).
      {  0x02B91B0BUL,   90,  0x2C0AE46CUL  },  // [  387] Random left roll test (  239/ 3000).
      {  0x69628FFDUL,   48,  0x8FFD6962UL  },  // [  388] Random left roll test (  240/ 3000).
      {  0x5E1EAE6FUL,   79,  0x5737AF0FUL  },  // [  389] Random left roll test (  241/ 3000).
      {  0x78ABE5C2UL,  236,  0xBE5C278AUL  },  // [  390] Random left roll test (  242/ 3000).
      {  0x71D28720UL,   54,  0xC81C74A1UL  },  // [  391] Random left roll test (  243/ 3000).
      {  0x9EA4C124UL,   26,  0x927A9304UL  },  // [  392] Random left roll test (  244/ 3000).
      {  0x5129F50AUL,  179,  0xA852894FUL  },  // [  393] Random left roll test (  245/ 3000).
      {  0x8EFD81DDUL,  105,  0xFB03BB1DUL  },  // [  394] Random left roll test (  246/ 3000).
      {  0xD981E27BUL,   78,  0x789EF660UL  },  // [  395] Random left roll test (  247/ 3000).
      {  0x510D0C98UL,  171,  0x6864C288UL  },  // [  396] Random left roll test (  248/ 3000).
      {  0x1EB6E9FEUL,  102,  0xADBA7F87UL  },  // [  397] Random left roll test (  249/ 3000).
      {  0x072C5F4DUL,  209,  0xBE9A0E58UL  },  // [  398] Random left roll test (  250/ 3000).
      {  0x457D6225UL,   88,  0x25457D62UL  },  // [  399] Random left roll test (  251/ 3000).
      {  0x7E6D0204UL,   69,  0xCDA0408FUL  },  // [  400] Random left roll test (  252/ 3000).
      {  0x6A4973C7UL,  133,  0x492E78EDUL  },  // [  401] Random left roll test (  253/ 3000).
      {  0xD12AE755UL,  178,  0x9D5744ABUL  },  // [  402] Random left roll test (  254/ 3000).
      {  0x9A967BE9UL,   25,  0xD3352CF7UL  },  // [  403] Random left roll test (  255/ 3000).
      {  0xDD17A033UL,  198,  0x45E80CF7UL  },  // [  404] Random left roll test (  256/ 3000).
      {  0xD4BE6D58UL,  221,  0x1A97CDABUL  },  // [  405] Random left roll test (  257/ 3000).
      {  0xCA928B52UL,   95,  0x654945A9UL  },  // [  406] Random left roll test (  258/ 3000).
      {  0x0F25AD2BUL,   86,  0x4AC3C96BUL  },  // [  407] Random left roll test (  259/ 3000).
      {  0x5440D670UL,  160,  0x5440D670UL  },  // [  408] Random left roll test (  260/ 3000).
      {  0x17DADFC9UL,  109,  0x5BF922FBUL  },  // [  409] Random left roll test (  261/ 3000).
      {  0x016AF29BUL,  106,  0xABCA6C05UL  },  // [  410] Random left roll test (  262/ 3000).
      {  0x4F0FC33FUL,   57,  0x7E9E1F86UL  },  // [  411] Random left roll test (  263/ 3000).
      {  0xBBC65BECUL,   30,  0x2EF196FBUL  },  // [  412] Random left roll test (  264/ 3000).
      {  0xE4EF182BUL,  206,  0xC60AF93BUL  },  // [  413] Random left roll test (  265/ 3000).
      {  0xD7E511C5UL,   83,  0x8E2EBF28UL  },  // [  414] Random left roll test (  266/ 3000).
      {  0x8A51BC11UL,  237,  0x3782314AUL  },  // [  415] Random left roll test (  267/ 3000).
      {  0x38A6E351UL,   59,  0x89C5371AUL  },  // [  416] Random left roll test (  268/ 3000).
      {  0xD75F702AUL,  218,  0xAB5D7DC0UL  },  // [  417] Random left roll test (  269/ 3000).
      {  0xE1B56257UL,  119,  0x2BF0DAB1UL  },  // [  418] Random left roll test (  270/ 3000).
      {  0x1161B2FAUL,   52,  0x2FA1161BUL  },  // [  419] Random left roll test (  271/ 3000).
      {  0x7C6D3639UL,  216,  0x397C6D36UL  },  // [  420] Random left roll test (  272/ 3000).
      {  0x231EA1C0UL,  152,  0xC0231EA1UL  },  // [  421] Random left roll test (  273/ 3000).
      {  0x3DE3EBF9UL,  140,  0x3EBF93DEUL  },  // [  422] Random left roll test (  274/ 3000).
      {  0x8A09FAD8UL,  163,  0x504FD6C4UL  },  // [  423] Random left roll test (  275/ 3000).
      {  0x9582F732UL,   48,  0xF7329582UL  },  // [  424] Random left roll test (  276/ 3000).
      {  0x09D3E3DCUL,   22,  0xF70274F8UL  },  // [  425] Random left roll test (  277/ 3000).
      {  0xC37417F1UL,  249,  0xE386E82FUL  },  // [  426] Random left roll test (  278/ 3000).
      {  0x3932D2B5UL,  132,  0x932D2B53UL  },  // [  427] Random left roll test (  279/ 3000).
      {  0x60BBD9BEUL,   42,  0xEF66F982UL  },  // [  428] Random left roll test (  280/ 3000).
      {  0xE1D3E495UL,   73,  0xA7C92BC3UL  },  // [  429] Random left roll test (  281/ 3000).
      {  0xEF72D11DUL,  165,  0xEE5A23BDUL  },  // [  430] Random left roll test (  282/ 3000).
      {  0x01B37073UL,  113,  0xE0E60366UL  },  // [  431] Random left roll test (  283/ 3000).
      {  0x4FF6FACFUL,   28,  0xF4FF6FACUL  },  // [  432] Random left roll test (  284/ 3000).
      {  0x19D4BED4UL,  222,  0x06752FB5UL  },  // [  433] Random left roll test (  285/ 3000).
      {  0x21F8BFC5UL,  158,  0x487E2FF1UL  },  // [  434] Random left roll test (  286/ 3000).
      {  0x4C495992UL,  246,  0x64931256UL  },  // [  435] Random left roll test (  287/ 3000).
      {  0x6F8824E1UL,  145,  0x49C2DF10UL  },  // [  436] Random left roll test (  288/ 3000).
      {  0x92010196UL,  192,  0x92010196UL  },  // [  437] Random left roll test (  289/ 3000).
      {  0xB9D2C4C8UL,  104,  0xD2C4C8B9UL  },  // [  438] Random left roll test (  290/ 3000).
      {  0xC8AFBEA8UL,   20,  0xEA8C8AFBUL  },  // [  439] Random left roll test (  291/ 3000).
      {  0xB998C8F9UL,  114,  0x23E6E663UL  },  // [  440] Random left roll test (  292/ 3000).
      {  0x17072BFEUL,  112,  0x2BFE1707UL  },  // [  441] Random left roll test (  293/ 3000).
      {  0xBEF386AAUL,  234,  0xCE1AAAFBUL  },  // [  442] Random left roll test (  294/ 3000).
      {  0x3A7E57E7UL,   39,  0x3F2BF39DUL  },  // [  443] Random left roll test (  295/ 3000).
      {  0x1BAFD735UL,   57,  0x6A375FAEUL  },  // [  444] Random left roll test (  296/ 3000).
      {  0x3641E824UL,   32,  0x3641E824UL  },  // [  445] Random left roll test (  297/ 3000).
      {  0x8AD5E97FUL,  177,  0xD2FF15ABUL  },  // [  446] Random left roll test (  298/ 3000).
      {  0x5474B70DUL,  175,  0x5B86AA3AUL  },  // [  447] Random left roll test (  299/ 3000).
      {  0xFB558F00UL,  162,  0xED563C03UL  },  // [  448] Random left roll test (  300/ 3000).
      {  0x966BC7B3UL,    9,  0xD78F672CUL  },  // [  449] Random left roll test (  301/ 3000).
      {  0x1278228BUL,  144,  0x228B1278UL  },  // [  450] Random left roll test (  302/ 3000).
      {  0xA6393DA1UL,  145,  0x7B434C72UL  },  // [  451] Random left roll test (  303/ 3000).
      {  0xF39B3515UL,  186,  0x57CE6CD4UL  },  // [  452] Random left roll test (  304/ 3000).
      {  0x3CAC917BUL,  198,  0x2B245ECFUL  },  // [  453] Random left roll test (  305/ 3000).
      {  0x05D92DF0UL,  231,  0xEC96F802UL  },  // [  454] Random left roll test (  306/ 3000).
      {  0x973F2F6FUL,   78,  0xCBDBE5CFUL  },  // [  455] Random left roll test (  307/ 3000).
      {  0xD7B62590UL,   27,  0x86BDB12CUL  },  // [  456] Random left roll test (  308/ 3000).
      {  0xB738079DUL,   52,  0x79DB7380UL  },  // [  457] Random left roll test (  309/ 3000).
      {  0x0A96A6ACUL,   64,  0x0A96A6ACUL  },  // [  458] Random left roll test (  310/ 3000).
      {  0x6F6C9364UL,   25,  0xC8DED926UL  },  // [  459] Random left roll test (  311/ 3000).
      {  0x680F3BF8UL,  158,  0x1A03CEFEUL  },  // [  460] Random left roll test (  312/ 3000).
      {  0x0C19712DUL,   25,  0x5A1832E2UL  },  // [  461] Random left roll test (  313/ 3000).
      {  0x435959A7UL,  165,  0x6B2B34E8UL  },  // [  462] Random left roll test (  314/ 3000).
      {  0x709CB1F7UL,   43,  0xE58FBB84UL  },  // [  463] Random left roll test (  315/ 3000).
      {  0x8B7F426EUL,  102,  0xDFD09BA2UL  },  // [  464] Random left roll test (  316/ 3000).
      {  0x0E95237DUL,  221,  0xA1D2A46FUL  },  // [  465] Random left roll test (  317/ 3000).
      {  0xE642A728UL,  118,  0xCA3990A9UL  },  // [  466] Random left roll test (  318/ 3000).
      {  0xBF96173FUL,  127,  0xDFCB0B9FUL  },  // [  467] Random left roll test (  319/ 3000).
      {  0xA5EB5015UL,   56,  0x15A5EB50UL  },  // [  468] Random left roll test (  320/ 3000).
      {  0xDEA982C3UL,  172,  0x982C3DEAUL  },  // [  469] Random left roll test (  321/ 3000).
      {  0x7DD1B594UL,  134,  0x746D651FUL  },  // [  470] Random left roll test (  322/ 3000).
      {  0xE2868436UL,   29,  0xDC50D086UL  },  // [  471] Random left roll test (  323/ 3000).
      {  0x6BB766E1UL,   47,  0xB370B5DBUL  },  // [  472] Random left roll test (  324/ 3000).
      {  0xAF987B3BUL,   19,  0xD9DD7CC3UL  },  // [  473] Random left roll test (  325/ 3000).
      {  0xEF1F894CUL,   44,  0xF894CEF1UL  },  // [  474] Random left roll test (  326/ 3000).
      {  0x11F67DFCUL,    2,  0x47D9F7F0UL  },  // [  475] Random left roll test (  327/ 3000).
      {  0xC50EB674UL,  203,  0x75B3A628UL  },  // [  476] Random left roll test (  328/ 3000).
      {  0x418E0F8AUL,   77,  0xC1F14831UL  },  // [  477] Random left roll test (  329/ 3000).
      {  0x8B08821CUL,   54,  0x8722C220UL  },  // [  478] Random left roll test (  330/ 3000).
      {  0x3D4C2FC4UL,  131,  0xEA617E21UL  },  // [  479] Random left roll test (  331/ 3000).
      {  0xFDD1B449UL,  152,  0x49FDD1B4UL  },  // [  480] Random left roll test (  332/ 3000).
      {  0x3A6785B3UL,  117,  0xB6674CF0UL  },  // [  481] Random left roll test (  333/ 3000).
      {  0x98C0B914UL,  215,  0x8A4C605CUL  },  // [  482] Random left roll test (  334/ 3000).
      {  0xEB81B108UL,  227,  0x5C0D8847UL  },  // [  483] Random left roll test (  335/ 3000).
      {  0x8FB18476UL,  235,  0x8C23B47DUL  },  // [  484] Random left roll test (  336/ 3000).
      {  0x33221EE4UL,   70,  0xC887B90CUL  },  // [  485] Random left roll test (  337/ 3000).
      {  0x487C11C1UL,  255,  0xA43E08E0UL  },  // [  486] Random left roll test (  338/ 3000).
      {  0x0B7C48DEUL,  161,  0x16F891BCUL  },  // [  487] Random left roll test (  339/ 3000).
      {  0xBFF4282CUL,   18,  0xA0B2FFD0UL  },  // [  488] Random left roll test (  340/ 3000).
      {  0xB1F06507UL,  237,  0x0CA0F63EUL  },  // [  489] Random left roll test (  341/ 3000).
      {  0x55FA49A2UL,  253,  0x4ABF4934UL  },  // [  490] Random left roll test (  342/ 3000).
      {  0x6F820F04UL,  194,  0xBE083C11UL  },  // [  491] Random left roll test (  343/ 3000).
      {  0xECD50970UL,  225,  0xD9AA12E1UL  },  // [  492] Random left roll test (  344/ 3000).
      {  0xE97B84A4UL,   85,  0x949D2F70UL  },  // [  493] Random left roll test (  345/ 3000).
      {  0x60EC30A2UL,  201,  0xD86144C1UL  },  // [  494] Random left roll test (  346/ 3000).
      {  0xD1B67EC0UL,  142,  0x9FB0346DUL  },  // [  495] Random left roll test (  347/ 3000).
      {  0xFC6D5E3AUL,  211,  0xF1D7E36AUL  },  // [  496] Random left roll test (  348/ 3000).
      {  0x27186A3FUL,  228,  0x7186A3F2UL  },  // [  497] Random left roll test (  349/ 3000).
      {  0xF6AECC29UL,   44,  0xECC29F6AUL  },  // [  498] Random left roll test (  350/ 3000).
      {  0xE8CD0AF8UL,   25,  0xF1D19A15UL  },  // [  499] Random left roll test (  351/ 3000).
      {  0xAB4F6C6AUL,  190,  0xAAD3DB1AUL  },  // [  500] Random left roll test (  352/ 3000).
      {  0x97E0A69CUL,  139,  0x0534E4BFUL  },  // [  501] Random left roll test (  353/ 3000).
      {  0x6A0CD7A0UL,   60,  0x06A0CD7AUL  },  // [  502] Random left roll test (  354/ 3000).
      {  0xD6C045BFUL,  245,  0xB7FAD808UL  },  // [  503] Random left roll test (  355/ 3000).
      {  0x465D8082UL,  142,  0x60209197UL  },  // [  504] Random left roll test (  356/ 3000).
      {  0xAF3DBC5AUL,  243,  0xE2D579EDUL  },  // [  505] Random left roll test (  357/ 3000).
      {  0x3C46A2D9UL,   19,  0x16C9E235UL  },  // [  506] Random left roll test (  358/ 3000).
      {  0x21FA8048UL,   22,  0x12087EA0UL  },  // [  507] Random left roll test (  359/ 3000).
      {  0x8D912D34UL,   94,  0x23644B4DUL  },  // [  508] Random left roll test (  360/ 3000).
      {  0x74A9D5CCUL,   32,  0x74A9D5CCUL  },  // [  509] Random left roll test (  361/ 3000).
      {  0x9BF1A3FBUL,  214,  0xFEE6FC68UL  },  // [  510] Random left roll test (  362/ 3000).
      {  0xD6B36127UL,   87,  0x93EB59B0UL  },  // [  511] Random left roll test (  363/ 3000).
      {  0x1BE44372UL,    4,  0xBE443721UL  },  // [  512] Random left roll test (  364/ 3000).
      {  0xF9891D61UL,   56,  0x61F9891DUL  },  // [  513] Random left roll test (  365/ 3000).
      {  0xED27EB46UL,  114,  0xAD1BB49FUL  },  // [  514] Random left roll test (  366/ 3000).
      {  0x8A73A011UL,  151,  0x08C539D0UL  },  // [  515] Random left roll test (  367/ 3000).
      {  0x2F6741D7UL,  194,  0xBD9D075CUL  },  // [  516] Random left roll test (  368/ 3000).
      {  0x99D513E0UL,   36,  0x9D513E09UL  },  // [  517] Random left roll test (  369/ 3000).
      {  0xA849A3F6UL,  171,  0x4D1FB542UL  },  // [  518] Random left roll test (  370/ 3000).
      {  0xC005CA02UL,  236,  0x5CA02C00UL  },  // [  519] Random left roll test (  371/ 3000).
      {  0x7F0D28BFUL,  109,  0xA517EFE1UL  },  // [  520] Random left roll test (  372/ 3000).
      {  0xBC97F88EUL,   87,  0x475E4BFCUL  },  // [  521] Random left roll test (  373/ 3000).
      {  0x9142B4CDUL,   95,  0xC8A15A66UL  },  // [  522] Random left roll test (  374/ 3000).
      {  0xE480F477UL,  232,  0x80F477E4UL  },  // [  523] Random left roll test (  375/ 3000).
      {  0xEAFC4994UL,   16,  0x4994EAFCUL  },  // [  524] Random left roll test (  376/ 3000).
      {  0x25958F0EUL,   48,  0x8F0E2595UL  },  // [  525] Random left roll test (  377/ 3000).
      {  0xA100318CUL,   72,  0x00318CA1UL  },  // [  526] Random left roll test (  378/ 3000).
      {  0x7AB79678UL,  171,  0xBCB3C3D5UL  },  // [  527] Random left roll test (  379/ 3000).
      {  0x640F7639UL,  224,  0x640F7639UL  },  // [  528] Random left roll test (  380/ 3000).
      {  0xE6120D6DUL,   15,  0x06B6F309UL  },  // [  529] Random left roll test (  381/ 3000).
      {  0x26B6587FUL,  137,  0x6CB0FE4DUL  },  // [  530] Random left roll test (  382/ 3000).
      {  0xDD45711FUL,  168,  0x45711FDDUL  },  // [  531] Random left roll test (  383/ 3000).
      {  0xC6604790UL,  209,  0x8F218CC0UL  },  // [  532] Random left roll test (  384/ 3000).
      {  0xD32DBE3DUL,  243,  0xF1EE996DUL  },  // [  533] Random left roll test (  385/ 3000).
      {  0xF6351818UL,  144,  0x1818F635UL  },  // [  534] Random left roll test (  386/ 3000).
      {  0x7BC63A3CUL,   57,  0x78F78C74UL  },  // [  535] Random left roll test (  387/ 3000).
      {  0xF0790ECBUL,  144,  0x0ECBF079UL  },  // [  536] Random left roll test (  388/ 3000).
      {  0x65DE1575UL,  232,  0xDE157565UL  },  // [  537] Random left roll test (  389/ 3000).
      {  0x3503EB00UL,   65,  0x6A07D600UL  },  // [  538] Random left roll test (  390/ 3000).
      {  0x0A5FAD79UL,   97,  0x14BF5AF2UL  },  // [  539] Random left roll test (  391/ 3000).
      {  0xCC054163UL,   52,  0x163CC054UL  },  // [  540] Random left roll test (  392/ 3000).
      {  0x19A5842BUL,  102,  0x69610AC6UL  },  // [  541] Random left roll test (  393/ 3000).
      {  0x4F64712AUL,  189,  0x49EC8E25UL  },  // [  542] Random left roll test (  394/ 3000).
      {  0x3BEE4E45UL,  249,  0x8A77DC9CUL  },  // [  543] Random left roll test (  395/ 3000).
      {  0x4922FB10UL,  150,  0xC41248BEUL  },  // [  544] Random left roll test (  396/ 3000).
      {  0x58A48BA0UL,  228,  0x8A48BA05UL  },  // [  545] Random left roll test (  397/ 3000).
      {  0x635FCEF5UL,   30,  0x58D7F3BDUL  },  // [  546] Random left roll test (  398/ 3000).
      {  0xE10A701BUL,  203,  0x5380DF08UL  },  // [  547] Random left roll test (  399/ 3000).
      {  0xBAC14666UL,  165,  0x5828CCD7UL  },  // [  548] Random left roll test (  400/ 3000).
      {  0xE95D5CC5UL,   55,  0x62F4AEAEUL  },  // [  549] Random left roll test (  401/ 3000).
      {  0x6FAD5586UL,   75,  0x6AAC337DUL  },  // [  550] Random left roll test (  402/ 3000).
      {  0x58D3A72FUL,   58,  0xBD634E9CUL  },  // [  551] Random left roll test (  403/ 3000).
      {  0x4137C87BUL,  161,  0x826F90F6UL  },  // [  552] Random left roll test (  404/ 3000).
      {  0x8029FB3BUL,  105,  0x53F67700UL  },  // [  553] Random left roll test (  405/ 3000).
      {  0x93896B63UL,  232,  0x896B6393UL  },  // [  554] Random left roll test (  406/ 3000).
      {  0xF30C5426UL,  131,  0x9862A137UL  },  // [  555] Random left roll test (  407/ 3000).
      {  0x261488DEUL,  200,  0x1488DE26UL  },  // [  556] Random left roll test (  408/ 3000).
      {  0xAD94F78DUL,   39,  0xCA7BC6D6UL  },  // [  557] Random left roll test (  409/ 3000).
      {  0x13E3A723UL,   27,  0x189F1D39UL  },  // [  558] Random left roll test (  410/ 3000).
      {  0xDC545D96UL,   54,  0x65B71517UL  },  // [  559] Random left roll test (  411/ 3000).
      {  0x02E6A2C9UL,    2,  0x0B9A8B24UL  },  // [  560] Random left roll test (  412/ 3000).
      {  0xF20BFBA0UL,  120,  0xA0F20BFBUL  },  // [  561] Random left roll test (  413/ 3000).
      {  0x3062CCC5UL,  132,  0x062CCC53UL  },  // [  562] Random left roll test (  414/ 3000).
      {  0x2AFDD6EDUL,  222,  0x4ABF75BBUL  },  // [  563] Random left roll test (  415/ 3000).
      {  0x8C3FD4F3UL,  242,  0x53CE30FFUL  },  // [  564] Random left roll test (  416/ 3000).
      {  0xB32F4666UL,  109,  0xE8CCD665UL  },  // [  565] Random left roll test (  417/ 3000).
      {  0x013FB884UL,  184,  0x84013FB8UL  },  // [  566] Random left roll test (  418/ 3000).
      {  0x0A238ABDUL,  167,  0x11C55E85UL  },  // [  567] Random left roll test (  419/ 3000).
      {  0x499068BEUL,   24,  0xBE499068UL  },  // [  568] Random left roll test (  420/ 3000).
      {  0xE79E484FUL,   22,  0x13F9E792UL  },  // [  569] Random left roll test (  421/ 3000).
      {  0x1737F655UL,  241,  0xECAA2E6FUL  },  // [  570] Random left roll test (  422/ 3000).
      {  0x0AED6153UL,  239,  0xB0A98576UL  },  // [  571] Random left roll test (  423/ 3000).
      {  0x0715B8AEUL,  233,  0x2B715C0EUL  },  // [  572] Random left roll test (  424/ 3000).
      {  0x7CC2E455UL,  226,  0xF30B9155UL  },  // [  573] Random left roll test (  425/ 3000).
      {  0xF5784474UL,  233,  0xF088E9EAUL  },  // [  574] Random left roll test (  426/ 3000).
      {  0x922CD3BCUL,  245,  0x7792459AUL  },  // [  575] Random left roll test (  427/ 3000).
      {  0xD4C25632UL,   46,  0x958CB530UL  },  // [  576] Random left roll test (  428/ 3000).
      {  0x62FCF4D6UL,  206,  0x3D3598BFUL  },  // [  577] Random left roll test (  429/ 3000).
      {  0xBE0EA06BUL,  110,  0xA81AEF83UL  },  // [  578] Random left roll test (  430/ 3000).
      {  0xB0F1D478UL,   69,  0x1E3A8F16UL  },  // [  579] Random left roll test (  431/ 3000).
      {  0x68728303UL,  181,  0x606D0E50UL  },  // [  580] Random left roll test (  432/ 3000).
      {  0x102E6F67UL,  131,  0x81737B38UL  },  // [  581] Random left roll test (  433/ 3000).
      {  0xEB69D219UL,  197,  0x6D3A433DUL  },  // [  582] Random left roll test (  434/ 3000).
      {  0xB4CA62A7UL,  186,  0x9ED3298AUL  },  // [  583] Random left roll test (  435/ 3000).
      {  0x26B0945DUL,  253,  0xA4D6128BUL  },  // [  584] Random left roll test (  436/ 3000).
      {  0xCDB8FEF4UL,  139,  0xC7F7A66DUL  },  // [  585] Random left roll test (  437/ 3000).
      {  0xBC4F5B6DUL,  236,  0xF5B6DBC4UL  },  // [  586] Random left roll test (  438/ 3000).
      {  0x0BD83C3FUL,  216,  0x3F0BD83CUL  },  // [  587] Random left roll test (  439/ 3000).
      {  0x79839C3DUL,  110,  0xE70F5E60UL  },  // [  588] Random left roll test (  440/ 3000).
      {  0x8B76E61FUL,  221,  0xF16EDCC3UL  },  // [  589] Random left roll test (  441/ 3000).
      {  0xDC0E6E98UL,  134,  0x039BA637UL  },  // [  590] Random left roll test (  442/ 3000).
      {  0x5FCD55E0UL,  148,  0x5E05FCD5UL  },  // [  591] Random left roll test (  443/ 3000).
      {  0xFF99D9AAUL,   32,  0xFF99D9AAUL  },  // [  592] Random left roll test (  444/ 3000).
      {  0xAA4F025DUL,   27,  0xED527812UL  },  // [  593] Random left roll test (  445/ 3000).
      {  0x63D37E6CUL,  129,  0xC7A6FCD8UL  },  // [  594] Random left roll test (  446/ 3000).
      {  0xF0AF5E51UL,   24,  0x51F0AF5EUL  },  // [  595] Random left roll test (  447/ 3000).
      {  0x60E059EAUL,    7,  0x702CF530UL  },  // [  596] Random left roll test (  448/ 3000).
      {  0x75CA37BEUL,  210,  0xDEF9D728UL  },  // [  597] Random left roll test (  449/ 3000).
      {  0x5B12AB1BUL,   61,  0x6B625563UL  },  // [  598] Random left roll test (  450/ 3000).
      {  0xCEA1607BUL,  106,  0x8581EF3AUL  },  // [  599] Random left roll test (  451/ 3000).
      {  0x74BBA5C9UL,  255,  0xBA5DD2E4UL  },  // [  600] Random left roll test (  452/ 3000).
      {  0xAE565F38UL,  223,  0x572B2F9CUL  },  // [  601] Random left roll test (  453/ 3000).
      {  0x581CC138UL,  160,  0x581CC138UL  },  // [  602] Random left roll test (  454/ 3000).
      {  0x3813980BUL,   88,  0x0B381398UL  },  // [  603] Random left roll test (  455/ 3000).
      {  0x7A396E19UL,   12,  0x96E197A3UL  },  // [  604] Random left roll test (  456/ 3000).
      {  0xE02CECD6UL,   46,  0x3B35B80BUL  },  // [  605] Random left roll test (  457/ 3000).
      {  0x28ACB239UL,   68,  0x8ACB2392UL  },  // [  606] Random left roll test (  458/ 3000).
      {  0x17DC25AAUL,   40,  0xDC25AA17UL  },  // [  607] Random left roll test (  459/ 3000).
      {  0x5510DC15UL,  252,  0x55510DC1UL  },  // [  608] Random left roll test (  460/ 3000).
      {  0xBCC85EEEUL,   83,  0xF775E642UL  },  // [  609] Random left roll test (  461/ 3000).
      {  0xC95E6185UL,  157,  0xB92BCC30UL  },  // [  610] Random left roll test (  462/ 3000).
      {  0x52D7B96CUL,  212,  0x96C52D7BUL  },  // [  611] Random left roll test (  463/ 3000).
      {  0x0932B295UL,   36,  0x932B2950UL  },  // [  612] Random left roll test (  464/ 3000).
      {  0x609AA07BUL,   25,  0xF6C13540UL  },  // [  613] Random left roll test (  465/ 3000).
      {  0xDD46A4CEUL,  236,  0x6A4CEDD4UL  },  // [  614] Random left roll test (  466/ 3000).
      {  0x10307D84UL,   61,  0x82060FB0UL  },  // [  615] Random left roll test (  467/ 3000).
      {  0xE2D87106UL,  110,  0x1C41B8B6UL  },  // [  616] Random left roll test (  468/ 3000).
      {  0x271B71D6UL,  177,  0xE3AC4E36UL  },  // [  617] Random left roll test (  469/ 3000).
      {  0xF741C872UL,  175,  0xE4397BA0UL  },  // [  618] Random left roll test (  470/ 3000).
      {  0x587ED209UL,  110,  0xB482561FUL  },  // [  619] Random left roll test (  471/ 3000).
      {  0x834FECABUL,  178,  0xB2AE0D3FUL  },  // [  620] Random left roll test (  472/ 3000).
      {  0x05D892BDUL,  214,  0xAF417624UL  },  // [  621] Random left roll test (  473/ 3000).
      {  0xCF24E453UL,   68,  0xF24E453CUL  },  // [  622] Random left roll test (  474/ 3000).
      {  0x2A95E564UL,  138,  0x579590AAUL  },  // [  623] Random left roll test (  475/ 3000).
      {  0x7C48E2AFUL,  144,  0xE2AF7C48UL  },  // [  624] Random left roll test (  476/ 3000).
      {  0xFD93817FUL,  153,  0xFFFB2702UL  },  // [  625] Random left roll test (  477/ 3000).
      {  0x4E6CF19BUL,   37,  0xCD9E3369UL  },  // [  626] Random left roll test (  478/ 3000).
      {  0x95999400UL,   29,  0x12B33280UL  },  // [  627] Random left roll test (  479/ 3000).
      {  0x760FAE38UL,   34,  0xD83EB8E1UL  },  // [  628] Random left roll test (  480/ 3000).
      {  0x82DF4DB3UL,  137,  0xBE9B6705UL  },  // [  629] Random left roll test (  481/ 3000).
      {  0x4442FADBUL,   68,  0x442FADB4UL  },  // [  630] Random left roll test (  482/ 3000).
      {  0x252E1BF9UL,   92,  0x9252E1BFUL  },  // [  631] Random left roll test (  483/ 3000).
      {  0xD2D987F7UL,   84,  0x7F7D2D98UL  },  // [  632] Random left roll test (  484/ 3000).
      {  0x3E9D73ADUL,  101,  0xD3AE75A7UL  },  // [  633] Random left roll test (  485/ 3000).
      {  0x6E04F3C3UL,  203,  0x279E1B70UL  },  // [  634] Random left roll test (  486/ 3000).
      {  0xD94BDA2CUL,  103,  0xA5ED166CUL  },  // [  635] Random left roll test (  487/ 3000).
      {  0xF61E8155UL,    8,  0x1E8155F6UL  },  // [  636] Random left roll test (  488/ 3000).
      {  0x60567989UL,  149,  0x312C0ACFUL  },  // [  637] Random left roll test (  489/ 3000).
      {  0x23CEA2EAUL,  139,  0x7517511EUL  },  // [  638] Random left roll test (  490/ 3000).
      {  0xA2D2C3C6UL,  110,  0xB0F1A8B4UL  },  // [  639] Random left roll test (  491/ 3000).
      {  0xBD20DDBBUL,  188,  0xBBD20DDBUL  },  // [  640] Random left roll test (  492/ 3000).
      {  0xEB1D8050UL,  212,  0x050EB1D8UL  },  // [  641] Random left roll test (  493/ 3000).
      {  0xD4B2AD26UL,   69,  0x9655A4DAUL  },  // [  642] Random left roll test (  494/ 3000).
      {  0xAC7C1E72UL,  210,  0x79CAB1F0UL  },  // [  643] Random left roll test (  495/ 3000).
      {  0x1279AFD1UL,   40,  0x79AFD112UL  },  // [  644] Random left roll test (  496/ 3000).
      {  0x688C2868UL,   91,  0x43446143UL  },  // [  645] Random left roll test (  497/ 3000).
      {  0x5B8199B1UL,  157,  0x2B703336UL  },  // [  646] Random left roll test (  498/ 3000).
      {  0xD0DB4B22UL,   12,  0xB4B22D0DUL  },  // [  647] Random left roll test (  499/ 3000).
      {  0x122C09B9UL,  165,  0x45813722UL  },  // [  648] Random left roll test (  500/ 3000).
      {  0x1BAEA95AUL,   61,  0x4375D52BUL  },  // [  649] Random left roll test (  501/ 3000).
      {  0xEBD6B557UL,  230,  0xF5AD55FAUL  },  // [  650] Random left roll test (  502/ 3000).
      {  0xB08E0D43UL,  236,  0xE0D43B08UL  },  // [  651] Random left roll test (  503/ 3000).
      {  0x555A996CUL,  212,  0x96C555A9UL  },  // [  652] Random left roll test (  504/ 3000).
      {  0x89CCDF0BUL,   96,  0x89CCDF0BUL  },  // [  653] Random left roll test (  505/ 3000).
      {  0xE79124C1UL,  173,  0x24983CF2UL  },  // [  654] Random left roll test (  506/ 3000).
      {  0xD3AE3637UL,   20,  0x637D3AE3UL  },  // [  655] Random left roll test (  507/ 3000).
      {  0x795883D5UL,   84,  0x3D579588UL  },  // [  656] Random left roll test (  508/ 3000).
      {  0x007831B3UL,   56,  0xB3007831UL  },  // [  657] Random left roll test (  509/ 3000).
      {  0x943B4494UL,   55,  0x4A4A1DA2UL  },  // [  658] Random left roll test (  510/ 3000).
      {  0xF1E4DDC6UL,   92,  0x6F1E4DDCUL  },  // [  659] Random left roll test (  511/ 3000).
      {  0x1121188AUL,    0,  0x1121188AUL  },  // [  660] Random left roll test (  512/ 3000).
      {  0x7A3FA547UL,  248,  0x477A3FA5UL  },  // [  661] Random left roll test (  513/ 3000).
      {  0xC4EFB32EUL,   90,  0xBB13BECCUL  },  // [  662] Random left roll test (  514/ 3000).
      {  0x9C49FD3CUL,   86,  0x4F27127FUL  },  // [  663] Random left roll test (  515/ 3000).
      {  0x69187186UL,  199,  0x8C38C334UL  },  // [  664] Random left roll test (  516/ 3000).
      {  0x93FD6B47UL,   53,  0x68F27FADUL  },  // [  665] Random left roll test (  517/ 3000).
      {  0x886A1699UL,  135,  0x350B4CC4UL  },  // [  666] Random left roll test (  518/ 3000).
      {  0xF598F381UL,   32,  0xF598F381UL  },  // [  667] Random left roll test (  519/ 3000).
      {  0x13019A22UL,  232,  0x019A2213UL  },  // [  668] Random left roll test (  520/ 3000).
      {  0x4112A96EUL,  107,  0x954B7208UL  },  // [  669] Random left roll test (  521/ 3000).
      {  0x8A0675B8UL,  103,  0x033ADC45UL  },  // [  670] Random left roll test (  522/ 3000).
      {  0xEE91DBF1UL,  113,  0xB7E3DD23UL  },  // [  671] Random left roll test (  523/ 3000).
      {  0xB0B255EDUL,   74,  0xC957B6C2UL  },  // [  672] Random left roll test (  524/ 3000).
      {  0x22A20582UL,  185,  0x0445440BUL  },  // [  673] Random left roll test (  525/ 3000).
      {  0x1A40A168UL,  206,  0x285A0690UL  },  // [  674] Random left roll test (  526/ 3000).
      {  0x4259473DUL,  244,  0x73D42594UL  },  // [  675] Random left roll test (  527/ 3000).
      {  0xB7DC51F5UL,  151,  0xFADBEE28UL  },  // [  676] Random left roll test (  528/ 3000).
      {  0x9E63B9F5UL,  187,  0xACF31DCFUL  },  // [  677] Random left roll test (  529/ 3000).
      {  0xD1636DA5UL,  184,  0xA5D1636DUL  },  // [  678] Random left roll test (  530/ 3000).
      {  0x06D46067UL,  146,  0x819C1B51UL  },  // [  679] Random left roll test (  531/ 3000).
      {  0x5E355C8FUL,  199,  0x1AAE47AFUL  },  // [  680] Random left roll test (  532/ 3000).
      {  0x2FBBA639UL,   52,  0x6392FBBAUL  },  // [  681] Random left roll test (  533/ 3000).
      {  0xAE772251UL,   39,  0x3B9128D7UL  },  // [  682] Random left roll test (  534/ 3000).
      {  0xB3AE5A4AUL,  216,  0x4AB3AE5AUL  },  // [  683] Random left roll test (  535/ 3000).
      {  0x697F0D95UL,  243,  0x6CAB4BF8UL  },  // [  684] Random left roll test (  536/ 3000).
      {  0xEC652A3CUL,    6,  0x194A8F3BUL  },  // [  685] Random left roll test (  537/ 3000).
      {  0x5505648AUL,  106,  0x15922954UL  },  // [  686] Random left roll test (  538/ 3000).
      {  0xD139F74AUL,  140,  0x9F74AD13UL  },  // [  687] Random left roll test (  539/ 3000).
      {  0x91264FD2UL,  105,  0x4C9FA522UL  },  // [  688] Random left roll test (  540/ 3000).
      {  0x599CD4BEUL,   92,  0xE599CD4BUL  },  // [  689] Random left roll test (  541/ 3000).
      {  0x5049070DUL,  231,  0x248386A8UL  },  // [  690] Random left roll test (  542/ 3000).
      {  0x013A5F7EUL,    6,  0x4E97DF80UL  },  // [  691] Random left roll test (  543/ 3000).
      {  0x47DAAC89UL,  192,  0x47DAAC89UL  },  // [  692] Random left roll test (  544/ 3000).
      {  0x7ACB3FC8UL,   91,  0x43D659FEUL  },  // [  693] Random left roll test (  545/ 3000).
      {  0x544C0C3BUL,  226,  0x513030EDUL  },  // [  694] Random left roll test (  546/ 3000).
      {  0x5ECA91CEUL,  200,  0xCA91CE5EUL  },  // [  695] Random left roll test (  547/ 3000).
      {  0xEB96D222UL,   31,  0x75CB6911UL  },  // [  696] Random left roll test (  548/ 3000).
      {  0x5B8348C2UL,  133,  0x7069184BUL  },  // [  697] Random left roll test (  549/ 3000).
      {  0x6BBCFC39UL,   19,  0xE1CB5DE7UL  },  // [  698] Random left roll test (  550/ 3000).
      {  0xC315A7B9UL,   57,  0x73862B4FUL  },  // [  699] Random left roll test (  551/ 3000).
      {  0xBB82C55BUL,  207,  0x62ADDDC1UL  },  // [  700] Random left roll test (  552/ 3000).
      {  0xFE685D54UL,  131,  0xF342EAA7UL  },  // [  701] Random left roll test (  553/ 3000).
      {  0xE1C4A053UL,   51,  0x029F0E25UL  },  // [  702] Random left roll test (  554/ 3000).
      {  0x93A29A4EUL,  163,  0x9D14D274UL  },  // [  703] Random left roll test (  555/ 3000).
      {  0xFCB6D2F1UL,  135,  0x5B6978FEUL  },  // [  704] Random left roll test (  556/ 3000).
      {  0x48C27F32UL,  254,  0x92309FCCUL  },  // [  705] Random left roll test (  557/ 3000).
      {  0x1C948BB5UL,   16,  0x8BB51C94UL  },  // [  706] Random left roll test (  558/ 3000).
      {  0xE7AAD3D4UL,   50,  0x4F539EABUL  },  // [  707] Random left roll test (  559/ 3000).
      {  0x1F9D0CDCUL,  100,  0xF9D0CDC1UL  },  // [  708] Random left roll test (  560/ 3000).
      {  0x1262AB89UL,  129,  0x24C55712UL  },  // [  709] Random left roll test (  561/ 3000).
      {  0x3139C8D3UL,   18,  0x234CC4E7UL  },  // [  710] Random left roll test (  562/ 3000).
      {  0x6C898329UL,    9,  0x130652D9UL  },  // [  711] Random left roll test (  563/ 3000).
      {  0xA22E7DBDUL,   27,  0xED1173EDUL  },  // [  712] Random left roll test (  564/ 3000).
      {  0x3A5752E1UL,   30,  0x4E95D4B8UL  },  // [  713] Random left roll test (  565/ 3000).
      {  0xDA4448E0UL,  219,  0x06D22247UL  },  // [  714] Random left roll test (  566/ 3000).
      {  0xEE7C7F69UL,  117,  0xED3DCF8FUL  },  // [  715] Random left roll test (  567/ 3000).
      {  0x2A120A5CUL,  208,  0x0A5C2A12UL  },  // [  716] Random left roll test (  568/ 3000).
      {  0xFD5261A5UL,   71,  0xA930D2FEUL  },  // [  717] Random left roll test (  569/ 3000).
      {  0x0F231147UL,  233,  0x46228E1EUL  },  // [  718] Random left roll test (  570/ 3000).
      {  0xB60123B2UL,   72,  0x0123B2B6UL  },  // [  719] Random left roll test (  571/ 3000).
      {  0x468F6BC5UL,   97,  0x8D1ED78AUL  },  // [  720] Random left roll test (  572/ 3000).
      {  0x2C919B89UL,  160,  0x2C919B89UL  },  // [  721] Random left roll test (  573/ 3000).
      {  0x44D80A69UL,  236,  0x80A6944DUL  },  // [  722] Random left roll test (  574/ 3000).
      {  0x6F5FEE47UL,  226,  0xBD7FB91DUL  },  // [  723] Random left roll test (  575/ 3000).
      {  0x25C18401UL,   80,  0x840125C1UL  },  // [  724] Random left roll test (  576/ 3000).
      {  0xE72D7B22UL,  133,  0xE5AF645CUL  },  // [  725] Random left roll test (  577/ 3000).
      {  0x1F018DDDUL,  238,  0x637747C0UL  },  // [  726] Random left roll test (  578/ 3000).
      {  0x7EBB1D3EUL,  252,  0xE7EBB1D3UL  },  // [  727] Random left roll test (  579/ 3000).
      {  0x1735F6BDUL,   95,  0x8B9AFB5EUL  },  // [  728] Random left roll test (  580/ 3000).
      {  0x5E9E75ECUL,  247,  0xF62F4F3AUL  },  // [  729] Random left roll test (  581/ 3000).
      {  0x1B8D0403UL,  184,  0x031B8D04UL  },  // [  730] Random left roll test (  582/ 3000).
      {  0x351C4940UL,  246,  0x500D4712UL  },  // [  731] Random left roll test (  583/ 3000).
      {  0x6E03AF3BUL,  152,  0x3B6E03AFUL  },  // [  732] Random left roll test (  584/ 3000).
      {  0x4A31D046UL,  185,  0x8C9463A0UL  },  // [  733] Random left roll test (  585/ 3000).
      {  0x5C0A413EUL,  127,  0x2E05209FUL  },  // [  734] Random left roll test (  586/ 3000).
      {  0x09E34331UL,  227,  0x4F1A1988UL  },  // [  735] Random left roll test (  587/ 3000).
      {  0x75FD386CUL,  163,  0xAFE9C363UL  },  // [  736] Random left roll test (  588/ 3000).
      {  0x9A882171UL,    0,  0x9A882171UL  },  // [  737] Random left roll test (  589/ 3000).
      {  0x8538B835UL,   15,  0x5C1AC29CUL  },  // [  738] Random left roll test (  590/ 3000).
      {  0x08AE2BA9UL,  241,  0x5752115CUL  },  // [  739] Random left roll test (  591/ 3000).
      {  0x912D6114UL,  167,  0x96B08A48UL  },  // [  740] Random left roll test (  592/ 3000).
      {  0xD930649CUL,  178,  0x927364C1UL  },  // [  741] Random left roll test (  593/ 3000).
      {  0x36CCE72FUL,  176,  0xE72F36CCUL  },  // [  742] Random left roll test (  594/ 3000).
      {  0x2CEA3074UL,   82,  0xC1D0B3A8UL  },  // [  743] Random left roll test (  595/ 3000).
      {  0x81C6167AUL,   74,  0x1859EA07UL  },  // [  744] Random left roll test (  596/ 3000).
      {  0x9DF5FBDDUL,   49,  0xF7BB3BEBUL  },  // [  745] Random left roll test (  597/ 3000).
      {  0x20602F22UL,  194,  0x8180BC88UL  },  // [  746] Random left roll test (  598/ 3000).
      {  0x1719F251UL,   54,  0x9445C67CUL  },  // [  747] Random left roll test (  599/ 3000).
      {  0x4916572DUL,  192,  0x4916572DUL  },  // [  748] Random left roll test (  600/ 3000).
      {  0x8D21FBAEUL,  124,  0xE8D21FBAUL  },  // [  749] Random left roll test (  601/ 3000).
      {  0x34A76396UL,  156,  0x634A7639UL  },  // [  750] Random left roll test (  602/ 3000).
      {  0x935895CCUL,  109,  0x12B9926BUL  },  // [  751] Random left roll test (  603/ 3000).
      {  0x3CD3C2BCUL,    0,  0x3CD3C2BCUL  },  // [  752] Random left roll test (  604/ 3000).
      {  0x1E70B4FDUL,  148,  0x4FD1E70BUL  },  // [  753] Random left roll test (  605/ 3000).
      {  0x08C7B436UL,    5,  0x18F686C1UL  },  // [  754] Random left roll test (  606/ 3000).
      {  0x7BB6F5FAUL,  203,  0xB7AFD3DDUL  },  // [  755] Random left roll test (  607/ 3000).
      {  0x69FAC4A2UL,  166,  0x7EB1289AUL  },  // [  756] Random left roll test (  608/ 3000).
      {  0x95D1B3E3UL,   11,  0x8D9F1CAEUL  },  // [  757] Random left roll test (  609/ 3000).
      {  0xFFF75373UL,   15,  0xA9B9FFFBUL  },  // [  758] Random left roll test (  610/ 3000).
      {  0xA024FA28UL,  110,  0x3E8A2809UL  },  // [  759] Random left roll test (  611/ 3000).
      {  0x15959971UL,   55,  0xB88ACACCUL  },  // [  760] Random left roll test (  612/ 3000).
      {  0x2D8C20A7UL,  199,  0xC6105396UL  },  // [  761] Random left roll test (  613/ 3000).
      {  0xCE917BDCUL,  166,  0xA45EF733UL  },  // [  762] Random left roll test (  614/ 3000).
      {  0x2FD90738UL,  110,  0x41CE0BF6UL  },  // [  763] Random left roll test (  615/ 3000).
      {  0xDD72144CUL,   29,  0x9BAE4289UL  },  // [  764] Random left roll test (  616/ 3000).
      {  0x5DB58046UL,   59,  0x32EDAC02UL  },  // [  765] Random left roll test (  617/ 3000).
      {  0xFD48CAE3UL,  186,  0x8FF5232BUL  },  // [  766] Random left roll test (  618/ 3000).
      {  0x34476B76UL,  243,  0x5BB1A23BUL  },  // [  767] Random left roll test (  619/ 3000).
      {  0x574E442EUL,  137,  0x9C885CAEUL  },  // [  768] Random left roll test (  620/ 3000).
      {  0xB28A6033UL,   40,  0x8A6033B2UL  },  // [  769] Random left roll test (  621/ 3000).
      {  0xD4D38152UL,   43,  0x9C0A96A6UL  },  // [  770] Random left roll test (  622/ 3000).
      {  0x177041FCUL,  227,  0xBB820FE0UL  },  // [  771] Random left roll test (  623/ 3000).
      {  0xF8B2FBC5UL,   78,  0xBEF17E2CUL  },  // [  772] Random left roll test (  624/ 3000).
      {  0x452A873EUL,  141,  0x50E7C8A5UL  },  // [  773] Random left roll test (  625/ 3000).
      {  0xADD11AD5UL,   34,  0xB7446B56UL  },  // [  774] Random left roll test (  626/ 3000).
      {  0x8D7736D7UL,  229,  0xAEE6DAF1UL  },  // [  775] Random left roll test (  627/ 3000).
      {  0x825B3FD0UL,  210,  0xFF42096CUL  },  // [  776] Random left roll test (  628/ 3000).
      {  0x53FC207FUL,  133,  0x7F840FEAUL  },  // [  777] Random left roll test (  629/ 3000).
      {  0x644F0ED9UL,    4,  0x44F0ED96UL  },  // [  778] Random left roll test (  630/ 3000).
      {  0xBA1790B3UL,  252,  0x3BA1790BUL  },  // [  779] Random left roll test (  631/ 3000).
      {  0xAD640DF4UL,   52,  0xDF4AD640UL  },  // [  780] Random left roll test (  632/ 3000).
      {  0x02E2D989UL,  147,  0xCC481716UL  },  // [  781] Random left roll test (  633/ 3000).
      {  0x79471B78UL,  205,  0xE36F0F28UL  },  // [  782] Random left roll test (  634/ 3000).
      {  0x8A3AA055UL,   39,  0x1D502AC5UL  },  // [  783] Random left roll test (  635/ 3000).
      {  0x268501CFUL,   32,  0x268501CFUL  },  // [  784] Random left roll test (  636/ 3000).
      {  0x26B26713UL,  142,  0x99C4C9ACUL  },  // [  785] Random left roll test (  637/ 3000).
      {  0x1E93BAF4UL,   72,  0x93BAF41EUL  },  // [  786] Random left roll test (  638/ 3000).
      {  0x761E77A1UL,   38,  0x879DE85DUL  },  // [  787] Random left roll test (  639/ 3000).
      {  0xBBE6FD96UL,    9,  0xCDFB2D77UL  },  // [  788] Random left roll test (  640/ 3000).
      {  0x50277F81UL,  227,  0x813BFC0AUL  },  // [  789] Random left roll test (  641/ 3000).
      {  0x796778EBUL,  139,  0x3BC75BCBUL  },  // [  790] Random left roll test (  642/ 3000).
      {  0x4538D5F6UL,   14,  0x357D914EUL  },  // [  791] Random left roll test (  643/ 3000).
      {  0xBAF0485CUL,  253,  0x975E090BUL  },  // [  792] Random left roll test (  644/ 3000).
      {  0x10EB265BUL,   89,  0xB621D64CUL  },  // [  793] Random left roll test (  645/ 3000).
      {  0xDC855764UL,  109,  0xAAEC9B90UL  },  // [  794] Random left roll test (  646/ 3000).
      {  0x95CEA02DUL,   52,  0x02D95CEAUL  },  // [  795] Random left roll test (  647/ 3000).
      {  0xA41A47B0UL,  235,  0xD23D8520UL  },  // [  796] Random left roll test (  648/ 3000).
      {  0xD8F067F6UL,  248,  0xF6D8F067UL  },  // [  797] Random left roll test (  649/ 3000).
      {  0x66BDACCBUL,   81,  0x5996CD7BUL  },  // [  798] Random left roll test (  650/ 3000).
      {  0xAE912D8CUL,   59,  0x6574896CUL  },  // [  799] Random left roll test (  651/ 3000).
      {  0xE2833067UL,    2,  0x8A0CC19FUL  },  // [  800] Random left roll test (  652/ 3000).
      {  0xABC47F51UL,  144,  0x7F51ABC4UL  },  // [  801] Random left roll test (  653/ 3000).
      {  0xAD2AC8F1UL,  130,  0xB4AB23C6UL  },  // [  802] Random left roll test (  654/ 3000).
      {  0xB892F67DUL,  114,  0xD9F6E24BUL  },  // [  803] Random left roll test (  655/ 3000).
      {  0xFFB7BFC4UL,  221,  0x9FF6F7F8UL  },  // [  804] Random left roll test (  656/ 3000).
      {  0x1BB31F5CUL,  164,  0xBB31F5C1UL  },  // [  805] Random left roll test (  657/ 3000).
      {  0x664E82B7UL,   37,  0xC9D056ECUL  },  // [  806] Random left roll test (  658/ 3000).
      {  0x32ECE865UL,    6,  0xBB3A194CUL  },  // [  807] Random left roll test (  659/ 3000).
      {  0x31CCF656UL,   60,  0x631CCF65UL  },  // [  808] Random left roll test (  660/ 3000).
      {  0x5CA20126UL,   74,  0x88049972UL  },  // [  809] Random left roll test (  661/ 3000).
      {  0xFA6BC272UL,  168,  0x6BC272FAUL  },  // [  810] Random left roll test (  662/ 3000).
      {  0xA9368968UL,   45,  0xD12D1526UL  },  // [  811] Random left roll test (  663/ 3000).
      {  0xF192F75FUL,   92,  0xFF192F75UL  },  // [  812] Random left roll test (  664/ 3000).
      {  0xA71E5A57UL,  204,  0xE5A57A71UL  },  // [  813] Random left roll test (  665/ 3000).
      {  0x0420C535UL,  169,  0x418A6A08UL  },  // [  814] Random left roll test (  666/ 3000).
      {  0x6080D20BUL,  196,  0x080D20B6UL  },  // [  815] Random left roll test (  667/ 3000).
      {  0x93532AE1UL,   43,  0x99570C9AUL  },  // [  816] Random left roll test (  668/ 3000).
      {  0x08A648FAUL,  147,  0x47D04532UL  },  // [  817] Random left roll test (  669/ 3000).
      {  0x14ABF20BUL,  251,  0x58A55F90UL  },  // [  818] Random left roll test (  670/ 3000).
      {  0xB5A2391CUL,    4,  0x5A2391CBUL  },  // [  819] Random left roll test (  671/ 3000).
      {  0x1D469661UL,  163,  0xEA34B308UL  },  // [  820] Random left roll test (  672/ 3000).
      {  0x233C5D13UL,  146,  0x744C8CF1UL  },  // [  821] Random left roll test (  673/ 3000).
      {  0x5B3C6C3AUL,  197,  0x678D874BUL  },  // [  822] Random left roll test (  674/ 3000).
      {  0x6A48C591UL,  220,  0x16A48C59UL  },  // [  823] Random left roll test (  675/ 3000).
      {  0x1865837FUL,   89,  0xFE30CB06UL  },  // [  824] Random left roll test (  676/ 3000).
      {  0xA41A31DAUL,  116,  0x1DAA41A3UL  },  // [  825] Random left roll test (  677/ 3000).
      {  0x4B0E134BUL,  132,  0xB0E134B4UL  },  // [  826] Random left roll test (  678/ 3000).
      {  0x505E1476UL,   17,  0x28ECA0BCUL  },  // [  827] Random left roll test (  679/ 3000).
      {  0xF730BDB0UL,  121,  0x61EE617BUL  },  // [  828] Random left roll test (  680/ 3000).
      {  0x2571E5E9UL,  139,  0x8F2F492BUL  },  // [  829] Random left roll test (  681/ 3000).
      {  0x3E3D84E8UL,  172,  0xD84E83E3UL  },  // [  830] Random left roll test (  682/ 3000).
      {  0xA8A8914BUL,   61,  0x75151229UL  },  // [  831] Random left roll test (  683/ 3000).
      {  0xD71644FBUL,  148,  0x4FBD7164UL  },  // [  832] Random left roll test (  684/ 3000).
      {  0x0DCB7974UL,  208,  0x79740DCBUL  },  // [  833] Random left roll test (  685/ 3000).
      {  0x10CDCB6FUL,  207,  0xE5B78866UL  },  // [  834] Random left roll test (  686/ 3000).
      {  0x6E33F650UL,  172,  0x3F6506E3UL  },  // [  835] Random left roll test (  687/ 3000).
      {  0x6D4FB3A4UL,   46,  0xECE91B53UL  },  // [  836] Random left roll test (  688/ 3000).
      {  0xADDB2B68UL,  172,  0xB2B68ADDUL  },  // [  837] Random left roll test (  689/ 3000).
      {  0x45331845UL,    9,  0x66308A8AUL  },  // [  838] Random left roll test (  690/ 3000).
      {  0x0AFFE73DUL,   27,  0xE857FF39UL  },  // [  839] Random left roll test (  691/ 3000).
      {  0x7BD665ABUL,  187,  0x5BDEB32DUL  },  // [  840] Random left roll test (  692/ 3000).
      {  0x0B0D9195UL,  232,  0x0D91950BUL  },  // [  841] Random left roll test (  693/ 3000).
      {  0x186C14B1UL,   37,  0x0D829623UL  },  // [  842] Random left roll test (  694/ 3000).
      {  0x795C66D9UL,  124,  0x9795C66DUL  },  // [  843] Random left roll test (  695/ 3000).
      {  0x964203A5UL,   55,  0xD2CB2101UL  },  // [  844] Random left roll test (  696/ 3000).
      {  0xB70F89C0UL,   87,  0xE05B87C4UL  },  // [  845] Random left roll test (  697/ 3000).
      {  0x8679D3DDUL,   47,  0xE9EEC33CUL  },  // [  846] Random left roll test (  698/ 3000).
      {  0xAC338B44UL,    9,  0x67168958UL  },  // [  847] Random left roll test (  699/ 3000).
      {  0xE05DF87AUL,   21,  0x0F5C0BBFUL  },  // [  848] Random left roll test (  700/ 3000).
      {  0x4DC9A0CAUL,   57,  0x949B9341UL  },  // [  849] Random left roll test (  701/ 3000).
      {  0xA4B32F1BUL,  131,  0x259978DDUL  },  // [  850] Random left roll test (  702/ 3000).
      {  0x4E95526CUL,   61,  0x89D2AA4DUL  },  // [  851] Random left roll test (  703/ 3000).
      {  0x06E61C61UL,  135,  0x730E3083UL  },  // [  852] Random left roll test (  704/ 3000).
      {  0x32FD13B3UL,  141,  0xA276665FUL  },  // [  853] Random left roll test (  705/ 3000).
      {  0x9F779554UL,   23,  0xAA4FBBCAUL  },  // [  854] Random left roll test (  706/ 3000).
      {  0xA655852DUL,   73,  0xAB0A5B4CUL  },  // [  855] Random left roll test (  707/ 3000).
      {  0x80E08002UL,  133,  0x1C100050UL  },  // [  856] Random left roll test (  708/ 3000).
      {  0x0FEBC952UL,   76,  0xBC9520FEUL  },  // [  857] Random left roll test (  709/ 3000).
      {  0x67F4A8C6UL,  247,  0x6333FA54UL  },  // [  858] Random left roll test (  710/ 3000).
      {  0x4408697AUL,  138,  0x21A5E910UL  },  // [  859] Random left roll test (  711/ 3000).
      {  0xBC612291UL,   21,  0x52378C24UL  },  // [  860] Random left roll test (  712/ 3000).
      {  0x72A09926UL,   39,  0x504C9339UL  },  // [  861] Random left roll test (  713/ 3000).
      {  0xABE90D9BUL,    1,  0x57D21B37UL  },  // [  862] Random left roll test (  714/ 3000).
      {  0x3CB93B2FUL,   81,  0x765E7972UL  },  // [  863] Random left roll test (  715/ 3000).
      {  0x6EE2A324UL,    8,  0xE2A3246EUL  },  // [  864] Random left roll test (  716/ 3000).
      {  0xD9F1581FUL,  141,  0x2B03FB3EUL  },  // [  865] Random left roll test (  717/ 3000).
      {  0x23134A25UL,   27,  0x29189A51UL  },  // [  866] Random left roll test (  718/ 3000).
      {  0xF7006236UL,  120,  0x36F70062UL  },  // [  867] Random left roll test (  719/ 3000).
      {  0x3972B1B6UL,   74,  0xCAC6D8E5UL  },  // [  868] Random left roll test (  720/ 3000).
      {  0x5F47D79BUL,  244,  0x79B5F47DUL  },  // [  869] Random left roll test (  721/ 3000).
      {  0x9A673CA4UL,  182,  0x292699CFUL  },  // [  870] Random left roll test (  722/ 3000).
      {  0x02C6C7B9UL,   57,  0x72058D8FUL  },  // [  871] Random left roll test (  723/ 3000).
      {  0x3DA37073UL,  233,  0x46E0E67BUL  },  // [  872] Random left roll test (  724/ 3000).
      {  0x8291CA19UL,  153,  0x33052394UL  },  // [  873] Random left roll test (  725/ 3000).
      {  0x34A0CCE3UL,  246,  0x38CD2833UL  },  // [  874] Random left roll test (  726/ 3000).
      {  0x19B0198EUL,   61,  0xC3360331UL  },  // [  875] Random left roll test (  727/ 3000).
      {  0xB82FC8D5UL,  131,  0xC17E46ADUL  },  // [  876] Random left roll test (  728/ 3000).
      {  0x282D105CUL,  232,  0x2D105C28UL  },  // [  877] Random left roll test (  729/ 3000).
      {  0x8998A417UL,    7,  0xCC520BC4UL  },  // [  878] Random left roll test (  730/ 3000).
      {  0x529361CCUL,   57,  0x98A526C3UL  },  // [  879] Random left roll test (  731/ 3000).
      {  0x6F044752UL,  249,  0xA4DE088EUL  },  // [  880] Random left roll test (  732/ 3000).
      {  0xEFEE8C04UL,  223,  0x77F74602UL  },  // [  881] Random left roll test (  733/ 3000).
      {  0x82020487UL,   49,  0x090F0404UL  },  // [  882] Random left roll test (  734/ 3000).
      {  0x316571E3UL,  193,  0x62CAE3C6UL  },  // [  883] Random left roll test (  735/ 3000).
      {  0x982622FDUL,  150,  0xBF660988UL  },  // [  884] Random left roll test (  736/ 3000).
      {  0xA5599ED6UL,  160,  0xA5599ED6UL  },  // [  885] Random left roll test (  737/ 3000).
      {  0xD482846CUL,   64,  0xD482846CUL  },  // [  886] Random left roll test (  738/ 3000).
      {  0xFC9BA9BCUL,  184,  0xBCFC9BA9UL  },  // [  887] Random left roll test (  739/ 3000).
      {  0x28E4992DUL,   34,  0xA39264B4UL  },  // [  888] Random left roll test (  740/ 3000).
      {  0x6A73402AUL,   66,  0xA9CD00A9UL  },  // [  889] Random left roll test (  741/ 3000).
      {  0x581DD2CBUL,  126,  0xD60774B2UL  },  // [  890] Random left roll test (  742/ 3000).
      {  0xAF9681CDUL,  195,  0x7CB40E6DUL  },  // [  891] Random left roll test (  743/ 3000).
      {  0x355A5894UL,   68,  0x55A58943UL  },  // [  892] Random left roll test (  744/ 3000).
      {  0xF25D2CFAUL,  226,  0xC974B3EBUL  },  // [  893] Random left roll test (  745/ 3000).
      {  0x08C2869EUL,   97,  0x11850D3CUL  },  // [  894] Random left roll test (  746/ 3000).
      {  0x5987DA4DUL,  156,  0xD5987DA4UL  },  // [  895] Random left roll test (  747/ 3000).
      {  0x434FE9AFUL,   93,  0xE869FD35UL  },  // [  896] Random left roll test (  748/ 3000).
      {  0x817E264BUL,  120,  0x4B817E26UL  },  // [  897] Random left roll test (  749/ 3000).
      {  0x35B148BDUL,   23,  0x5E9AD8A4UL  },  // [  898] Random left roll test (  750/ 3000).
      {  0x29831274UL,  207,  0x893A14C1UL  },  // [  899] Random left roll test (  751/ 3000).
      {  0x3B6E2919UL,  220,  0x93B6E291UL  },  // [  900] Random left roll test (  752/ 3000).
      {  0xCA8CE873UL,  140,  0xCE873CA8UL  },  // [  901] Random left roll test (  753/ 3000).
      {  0xECC6F0D0UL,  223,  0x76637868UL  },  // [  902] Random left roll test (  754/ 3000).
      {  0x81FD3471UL,  194,  0x07F4D1C6UL  },  // [  903] Random left roll test (  755/ 3000).
      {  0x4B3FAEF8UL,  234,  0xFEBBE12CUL  },  // [  904] Random left roll test (  756/ 3000).
      {  0xCE51A258UL,  139,  0x8D12C672UL  },  // [  905] Random left roll test (  757/ 3000).
      {  0x6C19C610UL,  173,  0x38C20D83UL  },  // [  906] Random left roll test (  758/ 3000).
      {  0x7C5970DEUL,  153,  0xBCF8B2E1UL  },  // [  907] Random left roll test (  759/ 3000).
      {  0x91765C26UL,   55,  0x1348BB2EUL  },  // [  908] Random left roll test (  760/ 3000).
      {  0x30D36F30UL,  220,  0x030D36F3UL  },  // [  909] Random left roll test (  761/ 3000).
      {  0x2AC06727UL,  239,  0x33939560UL  },  // [  910] Random left roll test (  762/ 3000).
      {  0x7DC17D73UL,  253,  0x6FB82FAEUL  },  // [  911] Random left roll test (  763/ 3000).
      {  0xEE0C30DCUL,   90,  0x73B830C3UL  },  // [  912] Random left roll test (  764/ 3000).
      {  0x2E4C60FEUL,   21,  0x1FC5C98CUL  },  // [  913] Random left roll test (  765/ 3000).
      {  0x56A008FBUL,  230,  0xA8023ED5UL  },  // [  914] Random left roll test (  766/ 3000).
      {  0x9612758CUL,    5,  0xC24EB192UL  },  // [  915] Random left roll test (  767/ 3000).
      {  0x4536B51DUL,   81,  0x6A3A8A6DUL  },  // [  916] Random left roll test (  768/ 3000).
      {  0x062816D0UL,   21,  0xDA00C502UL  },  // [  917] Random left roll test (  769/ 3000).
      {  0x9D9B99F6UL,  224,  0x9D9B99F6UL  },  // [  918] Random left roll test (  770/ 3000).
      {  0x1A3FDC79UL,   47,  0xEE3C8D1FUL  },  // [  919] Random left roll test (  771/ 3000).
      {  0x815CAE65UL,  105,  0xB95CCB02UL  },  // [  920] Random left roll test (  772/ 3000).
      {  0x567CF174UL,  250,  0xD159F3C5UL  },  // [  921] Random left roll test (  773/ 3000).
      {  0xCC0D25E2UL,   86,  0x78B30349UL  },  // [  922] Random left roll test (  774/ 3000).
      {  0x23A4D21CUL,  247,  0x0E11D269UL  },  // [  923] Random left roll test (  775/ 3000).
      {  0xF009B1D0UL,  246,  0x743C026CUL  },  // [  924] Random left roll test (  776/ 3000).
      {  0x460404DEUL,  206,  0x01379181UL  },  // [  925] Random left roll test (  777/ 3000).
      {  0x08585C4BUL,   59,  0x5842C2E2UL  },  // [  926] Random left roll test (  778/ 3000).
      {  0x8CB54774UL,   89,  0xE9196A8EUL  },  // [  927] Random left roll test (  779/ 3000).
      {  0x9A8B2E2EUL,   80,  0x2E2E9A8BUL  },  // [  928] Random left roll test (  780/ 3000).
      {  0x30953A83UL,   82,  0xEA0CC254UL  },  // [  929] Random left roll test (  781/ 3000).
      {  0xD21985B7UL,  224,  0xD21985B7UL  },  // [  930] Random left roll test (  782/ 3000).
      {  0xC9DDD967UL,   25,  0xCF93BBB2UL  },  // [  931] Random left roll test (  783/ 3000).
      {  0x732AE9C4UL,   82,  0xA711CCABUL  },  // [  932] Random left roll test (  784/ 3000).
      {  0x4C6C04A7UL,  201,  0xD8094E98UL  },  // [  933] Random left roll test (  785/ 3000).
      {  0x28CFD587UL,  111,  0xEAC39467UL  },  // [  934] Random left roll test (  786/ 3000).
      {  0x2BDE4E3DUL,  146,  0x38F4AF79UL  },  // [  935] Random left roll test (  787/ 3000).
      {  0x969EFA55UL,  233,  0x3DF4AB2DUL  },  // [  936] Random left roll test (  788/ 3000).
      {  0x03E1F7C9UL,  219,  0x481F0FBEUL  },  // [  937] Random left roll test (  789/ 3000).
      {  0x3FA21F0CUL,  195,  0xFD10F861UL  },  // [  938] Random left roll test (  790/ 3000).
      {  0x6D037B81UL,  156,  0x16D037B8UL  },  // [  939] Random left roll test (  791/ 3000).
      {  0x6DB92908UL,  247,  0x8436DC94UL  },  // [  940] Random left roll test (  792/ 3000).
      {  0xFFEC824CUL,   90,  0x33FFB209UL  },  // [  941] Random left roll test (  793/ 3000).
      {  0xD8B61EEEUL,  175,  0x0F776C5BUL  },  // [  942] Random left roll test (  794/ 3000).
      {  0xA4394673UL,   55,  0x39D21CA3UL  },  // [  943] Random left roll test (  795/ 3000).
      {  0x9C048BDCUL,  180,  0xBDC9C048UL  },  // [  944] Random left roll test (  796/ 3000).
      {  0xDD14E578UL,  234,  0x5395E374UL  },  // [  945] Random left roll test (  797/ 3000).
      {  0x5D8214CDUL,  235,  0x10A66AECUL  },  // [  946] Random left roll test (  798/ 3000).
      {  0x5D94E9DEUL,  251,  0xF2ECA74EUL  },  // [  947] Random left roll test (  799/ 3000).
      {  0xA7EC35FDUL,    5,  0xFD86BFB4UL  },  // [  948] Random left roll test (  800/ 3000).
      {  0x6AF93E6CUL,  157,  0x8D5F27CDUL  },  // [  949] Random left roll test (  801/ 3000).
      {  0xAE3DF88AUL,  172,  0xDF88AAE3UL  },  // [  950] Random left roll test (  802/ 3000).
      {  0xD7E655DFUL,  109,  0xCABBFAFCUL  },  // [  951] Random left roll test (  803/ 3000).
      {  0x01250C4CUL,  253,  0x8024A189UL  },  // [  952] Random left roll test (  804/ 3000).
      {  0xD39E04AEUL,   31,  0x69CF0257UL  },  // [  953] Random left roll test (  805/ 3000).
      {  0xC83E5C92UL,    4,  0x83E5C92CUL  },  // [  954] Random left roll test (  806/ 3000).
      {  0xD791C5E7UL,  220,  0x7D791C5EUL  },  // [  955] Random left roll test (  807/ 3000).
      {  0xDC927316UL,   49,  0xE62DB924UL  },  // [  956] Random left roll test (  808/ 3000).
      {  0xF02CF589UL,  102,  0x0B3D627CUL  },  // [  957] Random left roll test (  809/ 3000).
      {  0x3A105C25UL,   79,  0x2E129D08UL  },  // [  958] Random left roll test (  810/ 3000).
      {  0x323357A4UL,   93,  0x86466AF4UL  },  // [  959] Random left roll test (  811/ 3000).
      {  0xCD8C1F26UL,   49,  0x3E4D9B18UL  },  // [  960] Random left roll test (  812/ 3000).
      {  0x7E265C07UL,  180,  0xC077E265UL  },  // [  961] Random left roll test (  813/ 3000).
      {  0xFA3566F7UL,  212,  0x6F7FA356UL  },  // [  962] Random left roll test (  814/ 3000).
      {  0xB386F330UL,   60,  0x0B386F33UL  },  // [  963] Random left roll test (  815/ 3000).
      {  0x665CF486UL,   95,  0x332E7A43UL  },  // [  964] Random left roll test (  816/ 3000).
      {  0xD4EAAE70UL,   79,  0x57386A75UL  },  // [  965] Random left roll test (  817/ 3000).
      {  0x1AB2D87FUL,   52,  0x87F1AB2DUL  },  // [  966] Random left roll test (  818/ 3000).
      {  0x5E7BD1BFUL,  107,  0xDE8DFAF3UL  },  // [  967] Random left roll test (  819/ 3000).
      {  0x72388E9EUL,  143,  0x474F391CUL  },  // [  968] Random left roll test (  820/ 3000).
      {  0x831B3A69UL,  142,  0xCE9A60C6UL  },  // [  969] Random left roll test (  821/ 3000).
      {  0x348ABF1DUL,  139,  0x55F8E9A4UL  },  // [  970] Random left roll test (  822/ 3000).
      {  0x12848662UL,  153,  0xC425090CUL  },  // [  971] Random left roll test (  823/ 3000).
      {  0xB2484AD4UL,   42,  0x212B52C9UL  },  // [  972] Random left roll test (  824/ 3000).
      {  0x94FD18A4UL,   30,  0x253F4629UL  },  // [  973] Random left roll test (  825/ 3000).
      {  0x8DFE6C13UL,  170,  0xF9B04E37UL  },  // [  974] Random left roll test (  826/ 3000).
      {  0x8B670BC3UL,  213,  0x78716CE1UL  },  // [  975] Random left roll test (  827/ 3000).
      {  0x3C508E32UL,   98,  0xF14238C8UL  },  // [  976] Random left roll test (  828/ 3000).
      {  0x0F597367UL,  123,  0x387ACB9BUL  },  // [  977] Random left roll test (  829/ 3000).
      {  0x1C99C572UL,   26,  0xC8726715UL  },  // [  978] Random left roll test (  830/ 3000).
      {  0x8248FA65UL,  123,  0x2C1247D3UL  },  // [  979] Random left roll test (  831/ 3000).
      {  0x0D830323UL,   37,  0xB0606461UL  },  // [  980] Random left roll test (  832/ 3000).
      {  0xF19F4762UL,   16,  0x4762F19FUL  },  // [  981] Random left roll test (  833/ 3000).
      {  0x1E0C351FUL,  235,  0x61A8F8F0UL  },  // [  982] Random left roll test (  834/ 3000).
      {  0x613B12FCUL,  240,  0x12FC613BUL  },  // [  983] Random left roll test (  835/ 3000).
      {  0xD839B4BBUL,   89,  0x77B07369UL  },  // [  984] Random left roll test (  836/ 3000).
      {  0x7DD8C2B9UL,   77,  0x18572FBBUL  },  // [  985] Random left roll test (  837/ 3000).
      {  0x2B559CF0UL,  160,  0x2B559CF0UL  },  // [  986] Random left roll test (  838/ 3000).
      {  0x9E49E492UL,  104,  0x49E4929EUL  },  // [  987] Random left roll test (  839/ 3000).
      {  0x1FE01117UL,  203,  0x0088B8FFUL  },  // [  988] Random left roll test (  840/ 3000).
      {  0x0762BF90UL,   72,  0x62BF9007UL  },  // [  989] Random left roll test (  841/ 3000).
      {  0x75B9CF3BUL,  222,  0xDD6E73CEUL  },  // [  990] Random left roll test (  842/ 3000).
      {  0x10D40051UL,  166,  0x35001444UL  },  // [  991] Random left roll test (  843/ 3000).
      {  0x39C91617UL,   31,  0x9CE48B0BUL  },  // [  992] Random left roll test (  844/ 3000).
      {  0xEE32AD7BUL,   69,  0xC655AF7DUL  },  // [  993] Random left roll test (  845/ 3000).
      {  0xEAA7EC16UL,  217,  0x2DD54FD8UL  },  // [  994] Random left roll test (  846/ 3000).
      {  0x9DE4E7DDUL,  144,  0xE7DD9DE4UL  },  // [  995] Random left roll test (  847/ 3000).
      {  0x0638EE40UL,  164,  0x638EE400UL  },  // [  996] Random left roll test (  848/ 3000).
      {  0xA3A716C9UL,  153,  0x93474E2DUL  },  // [  997] Random left roll test (  849/ 3000).
      {  0xB79B3E7AUL,  243,  0xF3D5BCD9UL  },  // [  998] Random left roll test (  850/ 3000).
      {  0xAAAC8DD9UL,  176,  0x8DD9AAACUL  },  // [  999] Random left roll test (  851/ 3000).
      {  0x99785DD3UL,  122,  0x4E65E177UL  },  // [ 1000] Random left roll test (  852/ 3000).
      {  0x5873F696UL,  131,  0xC39FB4B2UL  },  // [ 1001] Random left roll test (  853/ 3000).
      {  0x791FD8A2UL,  180,  0x8A2791FDUL  },  // [ 1002] Random left roll test (  854/ 3000).
      {  0x8DCAA057UL,  140,  0xAA0578DCUL  },  // [ 1003] Random left roll test (  855/ 3000).
      {  0x7724AC28UL,  173,  0x95850EE4UL  },  // [ 1004] Random left roll test (  856/ 3000).
      {  0x3F57532AUL,   71,  0xABA9951FUL  },  // [ 1005] Random left roll test (  857/ 3000).
      {  0x4181CA6DUL,  118,  0x9B506072UL  },  // [ 1006] Random left roll test (  858/ 3000).
      {  0x29F4DECBUL,  201,  0xE9BD9653UL  },  // [ 1007] Random left roll test (  859/ 3000).
      {  0xF09ED9A7UL,  148,  0x9A7F09EDUL  },  // [ 1008] Random left roll test (  860/ 3000).
      {  0xCC0BF730UL,   50,  0xDCC3302FUL  },  // [ 1009] Random left roll test (  861/ 3000).
      {  0x6BD6268DUL,  186,  0x35AF589AUL  },  // [ 1010] Random left roll test (  862/ 3000).
      {  0x49455932UL,  174,  0x564C9251UL  },  // [ 1011] Random left roll test (  863/ 3000).
      {  0xD02E9AFDUL,   87,  0x7EE8174DUL  },  // [ 1012] Random left roll test (  864/ 3000).
      {  0x793FE00DUL,  144,  0xE00D793FUL  },  // [ 1013] Random left roll test (  865/ 3000).
      {  0xDA3AA797UL,  201,  0x754F2FB4UL  },  // [ 1014] Random left roll test (  866/ 3000).
      {  0x88A12848UL,  220,  0x888A1284UL  },  // [ 1015] Random left roll test (  867/ 3000).
      {  0x8FB93654UL,   40,  0xB936548FUL  },  // [ 1016] Random left roll test (  868/ 3000).
      {  0x7463F6CCUL,  170,  0x8FDB31D1UL  },  // [ 1017] Random left roll test (  869/ 3000).
      {  0xEF5F784AUL,  110,  0xDE12BBD7UL  },  // [ 1018] Random left roll test (  870/ 3000).
      {  0x28D91D7EUL,   34,  0xA36475F8UL  },  // [ 1019] Random left roll test (  871/ 3000).
      {  0x792CA370UL,  165,  0x25946E0FUL  },  // [ 1020] Random left roll test (  872/ 3000).
      {  0x7CE8CE90UL,  118,  0xA41F3A33UL  },  // [ 1021] Random left roll test (  873/ 3000).
      {  0x6B63FBD3UL,   21,  0x7A6D6C7FUL  },  // [ 1022] Random left roll test (  874/ 3000).
      {  0x4D14F062UL,  150,  0x1893453CUL  },  // [ 1023] Random left roll test (  875/ 3000).
      {  0xB284C80BUL,   93,  0x76509901UL  },  // [ 1024] Random left roll test (  876/ 3000).
      {  0x3EBBC597UL,  170,  0xEF165CFAUL  },  // [ 1025] Random left roll test (  877/ 3000).
      {  0x89954B75UL,   97,  0x132A96EBUL  },  // [ 1026] Random left roll test (  878/ 3000).
      {  0x0C470DA5UL,  222,  0x4311C369UL  },  // [ 1027] Random left roll test (  879/ 3000).
      {  0xA1A8C5DDUL,  174,  0x3177686AUL  },  // [ 1028] Random left roll test (  880/ 3000).
      {  0x6288F940UL,    3,  0x1447CA03UL  },  // [ 1029] Random left roll test (  881/ 3000).
      {  0x0517F253UL,  168,  0x17F25305UL  },  // [ 1030] Random left roll test (  882/ 3000).
      {  0x55D54723UL,  149,  0xE46ABAA8UL  },  // [ 1031] Random left roll test (  883/ 3000).
      {  0x79ABD6EAUL,  157,  0x4F357ADDUL  },  // [ 1032] Random left roll test (  884/ 3000).
      {  0x7DE68EDCUL,  152,  0xDC7DE68EUL  },  // [ 1033] Random left roll test (  885/ 3000).
      {  0xB01550EFUL,  177,  0xA1DF602AUL  },  // [ 1034] Random left roll test (  886/ 3000).
      {  0xB0FB612EUL,  166,  0x3ED84BACUL  },  // [ 1035] Random left roll test (  887/ 3000).
      {  0x57956AB2UL,   60,  0x257956ABUL  },  // [ 1036] Random left roll test (  888/ 3000).
      {  0xDFC65D56UL,  143,  0x2EAB6FE3UL  },  // [ 1037] Random left roll test (  889/ 3000).
      {  0x69F80346UL,   42,  0xE00D19A7UL  },  // [ 1038] Random left roll test (  890/ 3000).
      {  0xDEE04384UL,  231,  0x7021C26FUL  },  // [ 1039] Random left roll test (  891/ 3000).
      {  0xD1556C55UL,   78,  0x5B157455UL  },  // [ 1040] Random left roll test (  892/ 3000).
      {  0x4B8B01A7UL,   69,  0x716034E9UL  },  // [ 1041] Random left roll test (  893/ 3000).
      {  0x0F3F9AECUL,  109,  0xF35D81E7UL  },  // [ 1042] Random left roll test (  894/ 3000).
      {  0xE825E228UL,  191,  0x7412F114UL  },  // [ 1043] Random left roll test (  895/ 3000).
      {  0x21E0E2CAUL,   86,  0xB2887838UL  },  // [ 1044] Random left roll test (  896/ 3000).
      {  0xD2AE171CUL,  167,  0x570B8E69UL  },  // [ 1045] Random left roll test (  897/ 3000).
      {  0x9745ABB0UL,  187,  0x84BA2D5DUL  },  // [ 1046] Random left roll test (  898/ 3000).
      {  0x52257994UL,   98,  0x4895E651UL  },  // [ 1047] Random left roll test (  899/ 3000).
      {  0xEA760301UL,   39,  0x3B0180F5UL  },  // [ 1048] Random left roll test (  900/ 3000).
      {  0x48B6A6D4UL,   19,  0x36A245B5UL  },  // [ 1049] Random left roll test (  901/ 3000).
      {  0xF8E4E5A7UL,  107,  0x272D3FC7UL  },  // [ 1050] Random left roll test (  902/ 3000).
      {  0xE1D62249UL,  250,  0x27875889UL  },  // [ 1051] Random left roll test (  903/ 3000).
      {  0xA07483ABUL,  242,  0x0EAE81D2UL  },  // [ 1052] Random left roll test (  904/ 3000).
      {  0x61D5231EUL,   32,  0x61D5231EUL  },  // [ 1053] Random left roll test (  905/ 3000).
      {  0xC9304289UL,  182,  0xA2724C10UL  },  // [ 1054] Random left roll test (  906/ 3000).
      {  0x65296BD0UL,  213,  0x7A0CA52DUL  },  // [ 1055] Random left roll test (  907/ 3000).
      {  0xD04FCAB2UL,   21,  0x565A09F9UL  },  // [ 1056] Random left roll test (  908/ 3000).
      {  0x817314A8UL,  234,  0xCC52A205UL  },  // [ 1057] Random left roll test (  909/ 3000).
      {  0xD3D7ADDBUL,  115,  0x6EDE9EBDUL  },  // [ 1058] Random left roll test (  910/ 3000).
      {  0x36ED2408UL,  117,  0x8106DDA4UL  },  // [ 1059] Random left roll test (  911/ 3000).
      {  0x7554FD18UL,  232,  0x54FD1875UL  },  // [ 1060] Random left roll test (  912/ 3000).
      {  0x26CF8255UL,  248,  0x5526CF82UL  },  // [ 1061] Random left roll test (  913/ 3000).
      {  0x38CBB176UL,  201,  0x9762EC71UL  },  // [ 1062] Random left roll test (  914/ 3000).
      {  0xD0AE9273UL,  152,  0x73D0AE92UL  },  // [ 1063] Random left roll test (  915/ 3000).
      {  0xC61186E9UL,   11,  0x8C374E30UL  },  // [ 1064] Random left roll test (  916/ 3000).
      {  0x706F0E27UL,  112,  0x0E27706FUL  },  // [ 1065] Random left roll test (  917/ 3000).
      {  0xE0DF1FA4UL,  193,  0xC1BE3F49UL  },  // [ 1066] Random left roll test (  918/ 3000).
      {  0x551FA24FUL,  252,  0xF551FA24UL  },  // [ 1067] Random left roll test (  919/ 3000).
      {  0xCE79F25EUL,  149,  0x4BD9CF3EUL  },  // [ 1068] Random left roll test (  920/ 3000).
      {  0x56F95807UL,  193,  0xADF2B00EUL  },  // [ 1069] Random left roll test (  921/ 3000).
      {  0xFB24EA18UL,  157,  0x1F649D43UL  },  // [ 1070] Random left roll test (  922/ 3000).
      {  0x10D4F1E3UL,   64,  0x10D4F1E3UL  },  // [ 1071] Random left roll test (  923/ 3000).
      {  0x8B63A0E3UL,  227,  0x5B1D071CUL  },  // [ 1072] Random left roll test (  924/ 3000).
      {  0x23609C18UL,  193,  0x46C13830UL  },  // [ 1073] Random left roll test (  925/ 3000).
      {  0xEF255A25UL,  113,  0xB44BDE4AUL  },  // [ 1074] Random left roll test (  926/ 3000).
      {  0xA47F01AEUL,  178,  0x06BA91FCUL  },  // [ 1075] Random left roll test (  927/ 3000).
      {  0x865EEB2FUL,   58,  0xBE197BACUL  },  // [ 1076] Random left roll test (  928/ 3000).
      {  0x951C174BUL,   45,  0x82E972A3UL  },  // [ 1077] Random left roll test (  929/ 3000).
      {  0x678287E4UL,   43,  0x143F233CUL  },  // [ 1078] Random left roll test (  930/ 3000).
      {  0xFBD402AAUL,  129,  0xF7A80555UL  },  // [ 1079] Random left roll test (  931/ 3000).
      {  0x274B0AB9UL,   39,  0xA5855C93UL  },  // [ 1080] Random left roll test (  932/ 3000).
      {  0x6F91C5C6UL,  159,  0x37C8E2E3UL  },  // [ 1081] Random left roll test (  933/ 3000).
      {  0x35183CABUL,   41,  0x3079566AUL  },  // [ 1082] Random left roll test (  934/ 3000).
      {  0x47FC8BFEUL,  235,  0xE45FF23FUL  },  // [ 1083] Random left roll test (  935/ 3000).
      {  0xB54DC996UL,  219,  0xB5AA6E4CUL  },  // [ 1084] Random left roll test (  936/ 3000).
      {  0xF7ABE57BUL,   32,  0xF7ABE57BUL  },  // [ 1085] Random left roll test (  937/ 3000).
      {  0x5A98E2A9UL,  145,  0xC552B531UL  },  // [ 1086] Random left roll test (  938/ 3000).
      {  0x13E7CE75UL,   71,  0xF3E73A89UL  },  // [ 1087] Random left roll test (  939/ 3000).
      {  0xB9256A8BUL,   20,  0xA8BB9256UL  },  // [ 1088] Random left roll test (  940/ 3000).
      {  0xF2A348AAUL,  225,  0xE5469155UL  },  // [ 1089] Random left roll test (  941/ 3000).
      {  0x251E6DF7UL,  226,  0x9479B7DCUL  },  // [ 1090] Random left roll test (  942/ 3000).
      {  0x61A6578EUL,  145,  0xAF1CC34CUL  },  // [ 1091] Random left roll test (  943/ 3000).
      {  0x09C9A8CBUL,   87,  0x6584E4D4UL  },  // [ 1092] Random left roll test (  944/ 3000).
      {  0x44E1B224UL,  110,  0x6C891138UL  },  // [ 1093] Random left roll test (  945/ 3000).
      {  0x554E4994UL,  225,  0xAA9C9328UL  },  // [ 1094] Random left roll test (  946/ 3000).
      {  0x86DAE15FUL,   19,  0x0AFC36D7UL  },  // [ 1095] Random left roll test (  947/ 3000).
      {  0x1AE5E8E3UL,  138,  0x97A38C6BUL  },  // [ 1096] Random left roll test (  948/ 3000).
      {  0xB91A4077UL,   42,  0x6901DEE4UL  },  // [ 1097] Random left roll test (  949/ 3000).
      {  0xA981662AUL,  114,  0x98AAA605UL  },  // [ 1098] Random left roll test (  950/ 3000).
      {  0x63E8255AUL,  119,  0xAD31F412UL  },  // [ 1099] Random left roll test (  951/ 3000).
      {  0x5FB8693EUL,  146,  0xA4F97EE1UL  },  // [ 1100] Random left roll test (  952/ 3000).
      {  0xA1E450CBUL,    5,  0x3C8A1974UL  },  // [ 1101] Random left roll test (  953/ 3000).
      {  0x4BA07443UL,  225,  0x9740E886UL  },  // [ 1102] Random left roll test (  954/ 3000).
      {  0x408A9339UL,   94,  0x5022A4CEUL  },  // [ 1103] Random left roll test (  955/ 3000).
      {  0xEC47A5B4UL,   21,  0xB69D88F4UL  },  // [ 1104] Random left roll test (  956/ 3000).
      {  0x5F8D2F77UL,  208,  0x2F775F8DUL  },  // [ 1105] Random left roll test (  957/ 3000).
      {  0x7085B7AFUL,   98,  0xC216DEBDUL  },  // [ 1106] Random left roll test (  958/ 3000).
      {  0x22F0E056UL,  157,  0xC45E1C0AUL  },  // [ 1107] Random left roll test (  959/ 3000).
      {  0x8D30B017UL,  251,  0xBC698580UL  },  // [ 1108] Random left roll test (  960/ 3000).
      {  0x0C3EFF32UL,  115,  0xF99061F7UL  },  // [ 1109] Random left roll test (  961/ 3000).
      {  0x499066E1UL,  107,  0x83370A4CUL  },  // [ 1110] Random left roll test (  962/ 3000).
      {  0x272A2B60UL,  184,  0x60272A2BUL  },  // [ 1111] Random left roll test (  963/ 3000).
      {  0x1E21B113UL,  138,  0x86C44C78UL  },  // [ 1112] Random left roll test (  964/ 3000).
      {  0x0E5535FAUL,  239,  0x9AFD072AUL  },  // [ 1113] Random left roll test (  965/ 3000).
      {  0xDC746592UL,  162,  0x71D1964BUL  },  // [ 1114] Random left roll test (  966/ 3000).
      {  0x557B72FBUL,  197,  0xAF6E5F6AUL  },  // [ 1115] Random left roll test (  967/ 3000).
      {  0x72144318UL,  233,  0x288630E4UL  },  // [ 1116] Random left roll test (  968/ 3000).
      {  0x07D3D08AUL,    6,  0xF4F42281UL  },  // [ 1117] Random left roll test (  969/ 3000).
      {  0x5070BF99UL,  190,  0x541C2FE6UL  },  // [ 1118] Random left roll test (  970/ 3000).
      {  0x9A3B7338UL,  202,  0xEDCCE268UL  },  // [ 1119] Random left roll test (  971/ 3000).
      {  0x15866C70UL,  183,  0x380AC336UL  },  // [ 1120] Random left roll test (  972/ 3000).
      {  0x2E66BABEUL,  160,  0x2E66BABEUL  },  // [ 1121] Random left roll test (  973/ 3000).
      {  0xC60A763DUL,  238,  0x9D8F7182UL  },  // [ 1122] Random left roll test (  974/ 3000).
      {  0x2EA34EDAUL,   22,  0xB68BA8D3UL  },  // [ 1123] Random left roll test (  975/ 3000).
      {  0xB3370446UL,    4,  0x3370446BUL  },  // [ 1124] Random left roll test (  976/ 3000).
      {  0xAEE26F78UL,  250,  0xE2BB89BDUL  },  // [ 1125] Random left roll test (  977/ 3000).
      {  0x54B07C91UL,   13,  0x0F922A96UL  },  // [ 1126] Random left roll test (  978/ 3000).
      {  0x69B98F5DUL,   96,  0x69B98F5DUL  },  // [ 1127] Random left roll test (  979/ 3000).
      {  0x834361D1UL,   98,  0x0D0D8746UL  },  // [ 1128] Random left roll test (  980/ 3000).
      {  0x42CB22EDUL,   15,  0x9176A165UL  },  // [ 1129] Random left roll test (  981/ 3000).
      {  0x5C4B49CEUL,  145,  0x939CB896UL  },  // [ 1130] Random left roll test (  982/ 3000).
      {  0xDB33CEBEUL,  144,  0xCEBEDB33UL  },  // [ 1131] Random left roll test (  983/ 3000).
      {  0x2D3DC2E1UL,   89,  0xC25A7B85UL  },  // [ 1132] Random left roll test (  984/ 3000).
      {  0x9B4D18DDUL,   89,  0xBB369A31UL  },  // [ 1133] Random left roll test (  985/ 3000).
      {  0x6A4BEA09UL,  135,  0x25F504B5UL  },  // [ 1134] Random left roll test (  986/ 3000).
      {  0x0DDD488FUL,  173,  0xA911E1BBUL  },  // [ 1135] Random left roll test (  987/ 3000).
      {  0x88E2AABBUL,  140,  0x2AABB88EUL  },  // [ 1136] Random left roll test (  988/ 3000).
      {  0x59CB5FCBUL,  242,  0x7F2D672DUL  },  // [ 1137] Random left roll test (  989/ 3000).
      {  0xDF56FA9DUL,  225,  0xBEADF53BUL  },  // [ 1138] Random left roll test (  990/ 3000).
      {  0x1F59DA5EUL,  159,  0x0FACED2FUL  },  // [ 1139] Random left roll test (  991/ 3000).
      {  0xB2634247UL,  175,  0xA123D931UL  },  // [ 1140] Random left roll test (  992/ 3000).
      {  0x6994C260UL,   58,  0x81A65309UL  },  // [ 1141] Random left roll test (  993/ 3000).
      {  0x2D982C58UL,   59,  0xC16CC162UL  },  // [ 1142] Random left roll test (  994/ 3000).
      {  0x9927B75CUL,   53,  0xEB9324F6UL  },  // [ 1143] Random left roll test (  995/ 3000).
      {  0xD58ADB84UL,   74,  0x2B6E1356UL  },  // [ 1144] Random left roll test (  996/ 3000).
      {  0xDDF4A0A5UL,  148,  0x0A5DDF4AUL  },  // [ 1145] Random left roll test (  997/ 3000).
      {  0xD101AB81UL,  238,  0x6AE07440UL  },  // [ 1146] Random left roll test (  998/ 3000).
      {  0x0837218CUL,   85,  0x318106E4UL  },  // [ 1147] Random left roll test (  999/ 3000).
      {  0x932A7C31UL,   95,  0xC9953E18UL  },  // [ 1148] Random left roll test ( 1000/ 3000).
      {  0x408E302EUL,  125,  0xC811C605UL  },  // [ 1149] Random left roll test ( 1001/ 3000).
      {  0x8C9478E7UL,   90,  0x9E3251E3UL  },  // [ 1150] Random left roll test ( 1002/ 3000).
      {  0x70A268C1UL,  180,  0x8C170A26UL  },  // [ 1151] Random left roll test ( 1003/ 3000).
      {  0x8664011CUL,  252,  0xC8664011UL  },  // [ 1152] Random left roll test ( 1004/ 3000).
      {  0xF0F5AF9AUL,   33,  0xE1EB5F35UL  },  // [ 1153] Random left roll test ( 1005/ 3000).
      {  0xF4D91EA8UL,  226,  0xD3647AA3UL  },  // [ 1154] Random left roll test ( 1006/ 3000).
      {  0xB8FC167AUL,   19,  0xB3D5C7E0UL  },  // [ 1155] Random left roll test ( 1007/ 3000).
      {  0x222DAEB3UL,   52,  0xEB3222DAUL  },  // [ 1156] Random left roll test ( 1008/ 3000).
      {  0x66D7C6E0UL,   40,  0xD7C6E066UL  },  // [ 1157] Random left roll test ( 1009/ 3000).
      {  0x442413B8UL,  157,  0x08848277UL  },  // [ 1158] Random left roll test ( 1010/ 3000).
      {  0x3F9DA3EEUL,  194,  0xFE768FB8UL  },  // [ 1159] Random left roll test ( 1011/ 3000).
      {  0xAD2192D1UL,   23,  0x68D690C9UL  },  // [ 1160] Random left roll test ( 1012/ 3000).
      {  0x7CAFD369UL,  144,  0xD3697CAFUL  },  // [ 1161] Random left roll test ( 1013/ 3000).
      {  0x35D8BF37UL,  119,  0x9B9AEC5FUL  },  // [ 1162] Random left roll test ( 1014/ 3000).
      {  0x269868B8UL,   19,  0x45C134C3UL  },  // [ 1163] Random left roll test ( 1015/ 3000).
      {  0x276C7430UL,  234,  0xB1D0C09DUL  },  // [ 1164] Random left roll test ( 1016/ 3000).
      {  0xE077FFE8UL,   17,  0xFFD1C0EFUL  },  // [ 1165] Random left roll test ( 1017/ 3000).
      {  0x086A1FCDUL,  230,  0x1A87F342UL  },  // [ 1166] Random left roll test ( 1018/ 3000).
      {  0x195BBD99UL,    3,  0xCADDECC8UL  },  // [ 1167] Random left roll test ( 1019/ 3000).
      {  0x679FD0CFUL,  132,  0x79FD0CF6UL  },  // [ 1168] Random left roll test ( 1020/ 3000).
      {  0x084100BBUL,   13,  0x20176108UL  },  // [ 1169] Random left roll test ( 1021/ 3000).
      {  0x90CDFD19UL,   95,  0xC866FE8CUL  },  // [ 1170] Random left roll test ( 1022/ 3000).
      {  0x8EB8AA4FUL,   15,  0x5527C75CUL  },  // [ 1171] Random left roll test ( 1023/ 3000).
      {  0x455A7094UL,   59,  0xA22AD384UL  },  // [ 1172] Random left roll test ( 1024/ 3000).
      {  0x000CE1E3UL,   28,  0x3000CE1EUL  },  // [ 1173] Random left roll test ( 1025/ 3000).
      {  0xC86F7434UL,  182,  0x0D321BDDUL  },  // [ 1174] Random left roll test ( 1026/ 3000).
      {  0x290639C6UL,  215,  0xE314831CUL  },  // [ 1175] Random left roll test ( 1027/ 3000).
      {  0x8135A5A0UL,  240,  0xA5A08135UL  },  // [ 1176] Random left roll test ( 1028/ 3000).
      {  0x05F7898FUL,  163,  0x2FBC4C78UL  },  // [ 1177] Random left roll test ( 1029/ 3000).
      {  0x26E1E21AUL,  140,  0x1E21A26EUL  },  // [ 1178] Random left roll test ( 1030/ 3000).
      {  0x90B6C745UL,  228,  0x0B6C7459UL  },  // [ 1179] Random left roll test ( 1031/ 3000).
      {  0xF2DC6B86UL,  176,  0x6B86F2DCUL  },  // [ 1180] Random left roll test ( 1032/ 3000).
      {  0x7156A643UL,   42,  0x5A990DC5UL  },  // [ 1181] Random left roll test ( 1033/ 3000).
      {  0x705182B6UL,  181,  0x56CE0A30UL  },  // [ 1182] Random left roll test ( 1034/ 3000).
      {  0xB9310C6BUL,   91,  0x5DC98863UL  },  // [ 1183] Random left roll test ( 1035/ 3000).
      {  0xB24684EAUL,   73,  0x8D09D564UL  },  // [ 1184] Random left roll test ( 1036/ 3000).
      {  0xA1D9F789UL,  212,  0x789A1D9FUL  },  // [ 1185] Random left roll test ( 1037/ 3000).
      {  0xC6BE6412UL,    0,  0xC6BE6412UL  },  // [ 1186] Random left roll test ( 1038/ 3000).
      {  0xBD84FACDUL,  122,  0x36F613EBUL  },  // [ 1187] Random left roll test ( 1039/ 3000).
      {  0xB837898FUL,   13,  0xF131F706UL  },  // [ 1188] Random left roll test ( 1040/ 3000).
      {  0x5E4B071AUL,   48,  0x071A5E4BUL  },  // [ 1189] Random left roll test ( 1041/ 3000).
      {  0xA7E04C21UL,   21,  0x8434FC09UL  },  // [ 1190] Random left roll test ( 1042/ 3000).
      {  0x25ED41ACUL,  184,  0xAC25ED41UL  },  // [ 1191] Random left roll test ( 1043/ 3000).
      {  0x220D404BUL,   32,  0x220D404BUL  },  // [ 1192] Random left roll test ( 1044/ 3000).
      {  0xC7026217UL,  143,  0x310BE381UL  },  // [ 1193] Random left roll test ( 1045/ 3000).
      {  0x95CE15A5UL,    0,  0x95CE15A5UL  },  // [ 1194] Random left roll test ( 1046/ 3000).
      {  0xD65449B5UL,  152,  0xB5D65449UL  },  // [ 1195] Random left roll test ( 1047/ 3000).
      {  0xDC0EAFB2UL,   50,  0xBECB703AUL  },  // [ 1196] Random left roll test ( 1048/ 3000).
      {  0xA7189DE6UL,  214,  0x79A9C627UL  },  // [ 1197] Random left roll test ( 1049/ 3000).
      {  0x70235D0AUL,   25,  0x14E046BAUL  },  // [ 1198] Random left roll test ( 1050/ 3000).
      {  0xB1CC1B70UL,   93,  0x1639836EUL  },  // [ 1199] Random left roll test ( 1051/ 3000).
      {  0xAE81EB73UL,   57,  0xE75D03D6UL  },  // [ 1200] Random left roll test ( 1052/ 3000).
      {  0x44060D3BUL,  170,  0x1834ED10UL  },  // [ 1201] Random left roll test ( 1053/ 3000).
      {  0xBAEBE9EBUL,  150,  0x7AEEBAFAUL  },  // [ 1202] Random left roll test ( 1054/ 3000).
      {  0x28633841UL,  117,  0x08250C67UL  },  // [ 1203] Random left roll test ( 1055/ 3000).
      {  0x3ADC2964UL,  185,  0xC875B852UL  },  // [ 1204] Random left roll test ( 1056/ 3000).
      {  0xC3333ACCUL,   47,  0x9D666199UL  },  // [ 1205] Random left roll test ( 1057/ 3000).
      {  0x66003855UL,  182,  0x1559800EUL  },  // [ 1206] Random left roll test ( 1058/ 3000).
      {  0xE2067F7CUL,  182,  0xDF38819FUL  },  // [ 1207] Random left roll test ( 1059/ 3000).
      {  0xC192E199UL,   42,  0x4B866706UL  },  // [ 1208] Random left roll test ( 1060/ 3000).
      {  0xAA37721FUL,   95,  0xD51BB90FUL  },  // [ 1209] Random left roll test ( 1061/ 3000).
      {  0x24635F1BUL,  184,  0x1B24635FUL  },  // [ 1210] Random left roll test ( 1062/ 3000).
      {  0x994F6665UL,  153,  0xCB329ECCUL  },  // [ 1211] Random left roll test ( 1063/ 3000).
      {  0xD38B96D5UL,  127,  0xE9C5CB6AUL  },  // [ 1212] Random left roll test ( 1064/ 3000).
      {  0x13E00E99UL,  154,  0x644F803AUL  },  // [ 1213] Random left roll test ( 1065/ 3000).
      {  0x53A47EF4UL,  147,  0xF7A29D23UL  },  // [ 1214] Random left roll test ( 1066/ 3000).
      {  0x6B3A7EB2UL,   17,  0xFD64D674UL  },  // [ 1215] Random left roll test ( 1067/ 3000).
      {  0x02BE2F6AUL,   90,  0xA80AF8BDUL  },  // [ 1216] Random left roll test ( 1068/ 3000).
      {  0xE88800A9UL,  174,  0x002A7A22UL  },  // [ 1217] Random left roll test ( 1069/ 3000).
      {  0xA300B3C7UL,  240,  0xB3C7A300UL  },  // [ 1218] Random left roll test ( 1070/ 3000).
      {  0x169E7348UL,  247,  0xA40B4F39UL  },  // [ 1219] Random left roll test ( 1071/ 3000).
      {  0x754B425AUL,   30,  0x9D52D096UL  },  // [ 1220] Random left roll test ( 1072/ 3000).
      {  0x404293E1UL,  167,  0x2149F0A0UL  },  // [ 1221] Random left roll test ( 1073/ 3000).
      {  0xB698E6F1UL,   40,  0x98E6F1B6UL  },  // [ 1222] Random left roll test ( 1074/ 3000).
      {  0xABA63E3DUL,   65,  0x574C7C7BUL  },  // [ 1223] Random left roll test ( 1075/ 3000).
      {  0x737EE222UL,  112,  0xE222737EUL  },  // [ 1224] Random left roll test ( 1076/ 3000).
      {  0xED39E6EBUL,  182,  0xBAFB4E79UL  },  // [ 1225] Random left roll test ( 1077/ 3000).
      {  0x0233FECBUL,   50,  0xFB2C08CFUL  },  // [ 1226] Random left roll test ( 1078/ 3000).
      {  0x04075430UL,  166,  0x01D50C01UL  },  // [ 1227] Random left roll test ( 1079/ 3000).
      {  0x5DCBD18AUL,   11,  0x5E8C52EEUL  },  // [ 1228] Random left roll test ( 1080/ 3000).
      {  0xB60FBE96UL,  125,  0xD6C1F7D2UL  },  // [ 1229] Random left roll test ( 1081/ 3000).
      {  0xD0EBEF47UL,  164,  0x0EBEF47DUL  },  // [ 1230] Random left roll test ( 1082/ 3000).
      {  0xFC247A4BUL,  122,  0x2FF091E9UL  },  // [ 1231] Random left roll test ( 1083/ 3000).
      {  0x7BCA0673UL,   50,  0x19CDEF28UL  },  // [ 1232] Random left roll test ( 1084/ 3000).
      {  0xF3C31C70UL,  172,  0x31C70F3CUL  },  // [ 1233] Random left roll test ( 1085/ 3000).
      {  0x1B4399E8UL,  145,  0x33D03687UL  },  // [ 1234] Random left roll test ( 1086/ 3000).
      {  0xAE05D1C8UL,  101,  0xC0BA3915UL  },  // [ 1235] Random left roll test ( 1087/ 3000).
      {  0xEBBF33DAUL,  192,  0xEBBF33DAUL  },  // [ 1236] Random left roll test ( 1088/ 3000).
      {  0xB0F2405AUL,  113,  0x80B561E4UL  },  // [ 1237] Random left roll test ( 1089/ 3000).
      {  0x86FD6FA4UL,  177,  0xDF490DFAUL  },  // [ 1238] Random left roll test ( 1090/ 3000).
      {  0x49872952UL,   44,  0x72952498UL  },  // [ 1239] Random left roll test ( 1091/ 3000).
      {  0xE0D4543CUL,   95,  0x706A2A1EUL  },  // [ 1240] Random left roll test ( 1092/ 3000).
      {  0x449C2264UL,   53,  0x4C889384UL  },  // [ 1241] Random left roll test ( 1093/ 3000).
      {  0x4A1C63F3UL,   16,  0x63F34A1CUL  },  // [ 1242] Random left roll test ( 1094/ 3000).
      {  0x2D13DF5DUL,    5,  0xA27BEBA5UL  },  // [ 1243] Random left roll test ( 1095/ 3000).
      {  0xCDB2834FUL,  217,  0x9F9B6506UL  },  // [ 1244] Random left roll test ( 1096/ 3000).
      {  0xBCC9BB39UL,  194,  0xF326ECE6UL  },  // [ 1245] Random left roll test ( 1097/ 3000).
      {  0xC920EC46UL,  137,  0x41D88D92UL  },  // [ 1246] Random left roll test ( 1098/ 3000).
      {  0x9A4D0551UL,  180,  0x5519A4D0UL  },  // [ 1247] Random left roll test ( 1099/ 3000).
      {  0xD7341BF6UL,  212,  0xBF6D7341UL  },  // [ 1248] Random left roll test ( 1100/ 3000).
      {  0x18C156C8UL,   95,  0x0C60AB64UL  },  // [ 1249] Random left roll test ( 1101/ 3000).
      {  0x5402D8E3UL,   15,  0x6C71AA01UL  },  // [ 1250] Random left roll test ( 1102/ 3000).
      {  0x311FB0EEUL,   59,  0x7188FD87UL  },  // [ 1251] Random left roll test ( 1103/ 3000).
      {  0x3DD6EE0EUL,   21,  0xC1C7BADDUL  },  // [ 1252] Random left roll test ( 1104/ 3000).
      {  0x697DAD46UL,  118,  0x519A5F6BUL  },  // [ 1253] Random left roll test ( 1105/ 3000).
      {  0x1CF132EBUL,    4,  0xCF132EB1UL  },  // [ 1254] Random left roll test ( 1106/ 3000).
      {  0xFC1BA472UL,   78,  0xE91CBF06UL  },  // [ 1255] Random left roll test ( 1107/ 3000).
      {  0x62FEDC06UL,  252,  0x662FEDC0UL  },  // [ 1256] Random left roll test ( 1108/ 3000).
      {  0x02A6972AUL,   93,  0x4054D2E5UL  },  // [ 1257] Random left roll test ( 1109/ 3000).
      {  0x58007E3BUL,   73,  0x00FC76B0UL  },  // [ 1258] Random left roll test ( 1110/ 3000).
      {  0x28F50045UL,   63,  0x947A8022UL  },  // [ 1259] Random left roll test ( 1111/ 3000).
      {  0xA809F00DUL,  222,  0x6A027C03UL  },  // [ 1260] Random left roll test ( 1112/ 3000).
      {  0x231161B0UL,  249,  0x604622C3UL  },  // [ 1261] Random left roll test ( 1113/ 3000).
      {  0xB8DC103EUL,  196,  0x8DC103EBUL  },  // [ 1262] Random left roll test ( 1114/ 3000).
      {  0x8037812CUL,  140,  0x7812C803UL  },  // [ 1263] Random left roll test ( 1115/ 3000).
      {  0x627966E5UL,   38,  0x9E59B958UL  },  // [ 1264] Random left roll test ( 1116/ 3000).
      {  0x46999A05UL,  157,  0xA8D33340UL  },  // [ 1265] Random left roll test ( 1117/ 3000).
      {  0xF0903637UL,   71,  0x481B1BF8UL  },  // [ 1266] Random left roll test ( 1118/ 3000).
      {  0xAF7FDDFEUL,  170,  0xFF77FABDUL  },  // [ 1267] Random left roll test ( 1119/ 3000).
      {  0x6669AE00UL,  234,  0xA6B80199UL  },  // [ 1268] Random left roll test ( 1120/ 3000).
      {  0xA79CD16AUL,  112,  0xD16AA79CUL  },  // [ 1269] Random left roll test ( 1121/ 3000).
      {  0x211540AFUL,   81,  0x815E422AUL  },  // [ 1270] Random left roll test ( 1122/ 3000).
      {  0xB7BE5047UL,  253,  0xF6F7CA08UL  },  // [ 1271] Random left roll test ( 1123/ 3000).
      {  0xA76D0694UL,   65,  0x4EDA0D29UL  },  // [ 1272] Random left roll test ( 1124/ 3000).
      {  0x8DAE6FE7UL,   73,  0x5CDFCF1BUL  },  // [ 1273] Random left roll test ( 1125/ 3000).
      {  0xC21822B7UL,  216,  0xB7C21822UL  },  // [ 1274] Random left roll test ( 1126/ 3000).
      {  0x46ED48C6UL,  210,  0x23191BB5UL  },  // [ 1275] Random left roll test ( 1127/ 3000).
      {  0x33DDAD7CUL,  180,  0xD7C33DDAUL  },  // [ 1276] Random left roll test ( 1128/ 3000).
      {  0x1F6C3835UL,   51,  0xC1A8FB61UL  },  // [ 1277] Random left roll test ( 1129/ 3000).
      {  0xA0B63317UL,   75,  0xB198BD05UL  },  // [ 1278] Random left roll test ( 1130/ 3000).
      {  0xF3B5556AUL,   23,  0xB579DAAAUL  },  // [ 1279] Random left roll test ( 1131/ 3000).
      {  0xE27B863CUL,  165,  0x4F70C79CUL  },  // [ 1280] Random left roll test ( 1132/ 3000).
      {  0x4888C5B9UL,   49,  0x8B729111UL  },  // [ 1281] Random left roll test ( 1133/ 3000).
      {  0x41A6954DUL,  111,  0x4AA6A0D3UL  },  // [ 1282] Random left roll test ( 1134/ 3000).
      {  0x1D525345UL,  201,  0xA4A68A3AUL  },  // [ 1283] Random left roll test ( 1135/ 3000).
      {  0x888092B4UL,  165,  0x10125691UL  },  // [ 1284] Random left roll test ( 1136/ 3000).
      {  0x05379341UL,  215,  0xA0829BC9UL  },  // [ 1285] Random left roll test ( 1137/ 3000).
      {  0x14D1468DUL,  193,  0x29A28D1AUL  },  // [ 1286] Random left roll test ( 1138/ 3000).
      {  0xEB7CE208UL,  110,  0x38823ADFUL  },  // [ 1287] Random left roll test ( 1139/ 3000).
      {  0x0470BE5EUL,   66,  0x11C2F978UL  },  // [ 1288] Random left roll test ( 1140/ 3000).
      {  0x4F7036B3UL,   46,  0x0DACD3DCUL  },  // [ 1289] Random left roll test ( 1141/ 3000).
      {  0xC2CCBC3BUL,   88,  0x3BC2CCBCUL  },  // [ 1290] Random left roll test ( 1142/ 3000).
      {  0xBF06B2A0UL,  143,  0x59505F83UL  },  // [ 1291] Random left roll test ( 1143/ 3000).
      {  0xE9EDBC43UL,   26,  0x0FA7B6F1UL  },  // [ 1292] Random left roll test ( 1144/ 3000).
      {  0x49AC00DFUL,   81,  0x01BE9358UL  },  // [ 1293] Random left roll test ( 1145/ 3000).
      {  0x858B66D7UL,  162,  0x162D9B5EUL  },  // [ 1294] Random left roll test ( 1146/ 3000).
      {  0xF838E365UL,   98,  0xE0E38D97UL  },  // [ 1295] Random left roll test ( 1147/ 3000).
      {  0xBD543FDFUL,   65,  0x7AA87FBFUL  },  // [ 1296] Random left roll test ( 1148/ 3000).
      {  0x7B12D40BUL,  181,  0x816F625AUL  },  // [ 1297] Random left roll test ( 1149/ 3000).
      {  0x2667D056UL,  205,  0xFA0AC4CCUL  },  // [ 1298] Random left roll test ( 1150/ 3000).
      {  0x548478F9UL,  178,  0xE3E55211UL  },  // [ 1299] Random left roll test ( 1151/ 3000).
      {  0x08820597UL,  204,  0x20597088UL  },  // [ 1300] Random left roll test ( 1152/ 3000).
      {  0xD9300950UL,   83,  0x4A86C980UL  },  // [ 1301] Random left roll test ( 1153/ 3000).
      {  0x7B18DCD6UL,    3,  0xD8C6E6B3UL  },  // [ 1302] Random left roll test ( 1154/ 3000).
      {  0x980AFE1BUL,  154,  0x6E602BF8UL  },  // [ 1303] Random left roll test ( 1155/ 3000).
      {  0xE67E5536UL,   55,  0x9B733F2AUL  },  // [ 1304] Random left roll test ( 1156/ 3000).
      {  0x279890B5UL,  146,  0x42D49E62UL  },  // [ 1305] Random left roll test ( 1157/ 3000).
      {  0x7A4A629AUL,   92,  0xA7A4A629UL  },  // [ 1306] Random left roll test ( 1158/ 3000).
      {  0x0930473DUL,  183,  0x9E849823UL  },  // [ 1307] Random left roll test ( 1159/ 3000).
      {  0xD5E14FFEUL,  154,  0xFB57853FUL  },  // [ 1308] Random left roll test ( 1160/ 3000).
      {  0xB3F8B318UL,   88,  0x18B3F8B3UL  },  // [ 1309] Random left roll test ( 1161/ 3000).
      {  0x1C3CBEE1UL,  246,  0xB8470F2FUL  },  // [ 1310] Random left roll test ( 1162/ 3000).
      {  0x0B97A6DEUL,   82,  0x9B782E5EUL  },  // [ 1311] Random left roll test ( 1163/ 3000).
      {  0xC1EFFBAAUL,  207,  0xFDD560F7UL  },  // [ 1312] Random left roll test ( 1164/ 3000).
      {  0x6BEE37F5UL,   90,  0xD5AFB8DFUL  },  // [ 1313] Random left roll test ( 1165/ 3000).
      {  0x7B1089E0UL,   81,  0x13C0F621UL  },  // [ 1314] Random left roll test ( 1166/ 3000).
      {  0xB675EF23UL,  194,  0xD9D7BC8EUL  },  // [ 1315] Random left roll test ( 1167/ 3000).
      {  0x258FE621UL,  228,  0x58FE6212UL  },  // [ 1316] Random left roll test ( 1168/ 3000).
      {  0x26A80492UL,  217,  0x244D5009UL  },  // [ 1317] Random left roll test ( 1169/ 3000).
      {  0x011D25C5UL,  200,  0x1D25C501UL  },  // [ 1318] Random left roll test ( 1170/ 3000).
      {  0x0AB050BBUL,    2,  0x2AC142ECUL  },  // [ 1319] Random left roll test ( 1171/ 3000).
      {  0xD5B8A8BEUL,  104,  0xB8A8BED5UL  },  // [ 1320] Random left roll test ( 1172/ 3000).
      {  0x3F70F0FBUL,  176,  0xF0FB3F70UL  },  // [ 1321] Random left roll test ( 1173/ 3000).
      {  0xEE7AD554UL,  253,  0x9DCF5AAAUL  },  // [ 1322] Random left roll test ( 1174/ 3000).
      {  0x71DD9DABUL,  148,  0xDAB71DD9UL  },  // [ 1323] Random left roll test ( 1175/ 3000).
      {  0x70CE4113UL,  218,  0x4DC33904UL  },  // [ 1324] Random left roll test ( 1176/ 3000).
      {  0xA6C5B00AUL,  111,  0xD8055362UL  },  // [ 1325] Random left roll test ( 1177/ 3000).
      {  0x2FFDA9EBUL,  177,  0x53D65FFBUL  },  // [ 1326] Random left roll test ( 1178/ 3000).
      {  0x1D157DB9UL,  189,  0x23A2AFB7UL  },  // [ 1327] Random left roll test ( 1179/ 3000).
      {  0x2C395A76UL,  175,  0xAD3B161CUL  },  // [ 1328] Random left roll test ( 1180/ 3000).
      {  0x316FB724UL,  163,  0x8B7DB921UL  },  // [ 1329] Random left roll test ( 1181/ 3000).
      {  0xB0F0EECDUL,  138,  0xC3BB36C3UL  },  // [ 1330] Random left roll test ( 1182/ 3000).
      {  0x5789B51FUL,  104,  0x89B51F57UL  },  // [ 1331] Random left roll test ( 1183/ 3000).
      {  0xAB9592BEUL,    1,  0x572B257DUL  },  // [ 1332] Random left roll test ( 1184/ 3000).
      {  0x0387AFDEUL,   47,  0xD7EF01C3UL  },  // [ 1333] Random left roll test ( 1185/ 3000).
      {  0x122618CDUL,  178,  0x63344898UL  },  // [ 1334] Random left roll test ( 1186/ 3000).
      {  0x23CDE24BUL,   62,  0xC8F37892UL  },  // [ 1335] Random left roll test ( 1187/ 3000).
      {  0x37C745B9UL,   40,  0xC745B937UL  },  // [ 1336] Random left roll test ( 1188/ 3000).
      {  0x750538C7UL,  207,  0x9C63BA82UL  },  // [ 1337] Random left roll test ( 1189/ 3000).
      {  0x351FEBD6UL,  219,  0xB1A8FF5EUL  },  // [ 1338] Random left roll test ( 1190/ 3000).
      {  0x8B7C47E4UL,  229,  0x6F88FC91UL  },  // [ 1339] Random left roll test ( 1191/ 3000).
      {  0x4901C557UL,  192,  0x4901C557UL  },  // [ 1340] Random left roll test ( 1192/ 3000).
      {  0xA3FB6D8FUL,  224,  0xA3FB6D8FUL  },  // [ 1341] Random left roll test ( 1193/ 3000).
      {  0x3A6EC1C6UL,   72,  0x6EC1C63AUL  },  // [ 1342] Random left roll test ( 1194/ 3000).
      {  0xB63A32AFUL,  194,  0xD8E8CABEUL  },  // [ 1343] Random left roll test ( 1195/ 3000).
      {  0x034A6CD1UL,  227,  0x1A536688UL  },  // [ 1344] Random left roll test ( 1196/ 3000).
      {  0x51F6BB1FUL,  145,  0x763EA3EDUL  },  // [ 1345] Random left roll test ( 1197/ 3000).
      {  0x1531B9AFUL,   41,  0x63735E2AUL  },  // [ 1346] Random left roll test ( 1198/ 3000).
      {  0xFF419877UL,   35,  0xFA0CC3BFUL  },  // [ 1347] Random left roll test ( 1199/ 3000).
      {  0x14ADAC6DUL,   58,  0xB452B6B1UL  },  // [ 1348] Random left roll test ( 1200/ 3000).
      {  0xB56B9EB3UL,  205,  0x73D676ADUL  },  // [ 1349] Random left roll test ( 1201/ 3000).
      {  0xA9FAF4A4UL,   40,  0xFAF4A4A9UL  },  // [ 1350] Random left roll test ( 1202/ 3000).
      {  0xD1B1D66DUL,  175,  0xEB36E8D8UL  },  // [ 1351] Random left roll test ( 1203/ 3000).
      {  0xD72D3CC5UL,  216,  0xC5D72D3CUL  },  // [ 1352] Random left roll test ( 1204/ 3000).
      {  0x11C45EC8UL,    9,  0x88BD9023UL  },  // [ 1353] Random left roll test ( 1205/ 3000).
      {  0xA2CF6EF3UL,   93,  0x7459EDDEUL  },  // [ 1354] Random left roll test ( 1206/ 3000).
      {  0xE24958F9UL,  233,  0x92B1F3C4UL  },  // [ 1355] Random left roll test ( 1207/ 3000).
      {  0x2B42C8A4UL,   10,  0x0B2290ADUL  },  // [ 1356] Random left roll test ( 1208/ 3000).
      {  0x0BCCE2F0UL,  212,  0x2F00BCCEUL  },  // [ 1357] Random left roll test ( 1209/ 3000).
      {  0x153719ECUL,  167,  0x9B8CF60AUL  },  // [ 1358] Random left roll test ( 1210/ 3000).
      {  0x676278E7UL,   62,  0xD9D89E39UL  },  // [ 1359] Random left roll test ( 1211/ 3000).
      {  0xEAEAB6B1UL,   60,  0x1EAEAB6BUL  },  // [ 1360] Random left roll test ( 1212/ 3000).
      {  0x8B30BEB0UL,   24,  0xB08B30BEUL  },  // [ 1361] Random left roll test ( 1213/ 3000).
      {  0xA74850B2UL,  116,  0x0B2A7485UL  },  // [ 1362] Random left roll test ( 1214/ 3000).
      {  0x63B3EA2EUL,  251,  0x731D9F51UL  },  // [ 1363] Random left roll test ( 1215/ 3000).
      {  0xA32E0F9CUL,  128,  0xA32E0F9CUL  },  // [ 1364] Random left roll test ( 1216/ 3000).
      {  0xB2DEC72BUL,   26,  0xAECB7B1CUL  },  // [ 1365] Random left roll test ( 1217/ 3000).
      {  0x59EA773EUL,   50,  0xDCF967A9UL  },  // [ 1366] Random left roll test ( 1218/ 3000).
      {  0xF3C197CEUL,  155,  0x779E0CBEUL  },  // [ 1367] Random left roll test ( 1219/ 3000).
      {  0x6503DD95UL,   90,  0x55940F76UL  },  // [ 1368] Random left roll test ( 1220/ 3000).
      {  0x2624C52CUL,  130,  0x989314B0UL  },  // [ 1369] Random left roll test ( 1221/ 3000).
      {  0x70E0C25AUL,   82,  0x0969C383UL  },  // [ 1370] Random left roll test ( 1222/ 3000).
      {  0x1BE8D711UL,  206,  0x35C446FAUL  },  // [ 1371] Random left roll test ( 1223/ 3000).
      {  0xBB69D359UL,  226,  0xEDA74D66UL  },  // [ 1372] Random left roll test ( 1224/ 3000).
      {  0x53461426UL,  215,  0x1329A30AUL  },  // [ 1373] Random left roll test ( 1225/ 3000).
      {  0x1BDB7A42UL,    7,  0xEDBD210DUL  },  // [ 1374] Random left roll test ( 1226/ 3000).
      {  0xEEAEED74UL,  189,  0x9DD5DDAEUL  },  // [ 1375] Random left roll test ( 1227/ 3000).
      {  0x21BECB80UL,   44,  0xECB8021BUL  },  // [ 1376] Random left roll test ( 1228/ 3000).
      {  0x37F2DCA0UL,  103,  0xF96E501BUL  },  // [ 1377] Random left roll test ( 1229/ 3000).
      {  0x37DED8D1UL,    2,  0xDF7B6344UL  },  // [ 1378] Random left roll test ( 1230/ 3000).
      {  0xBF946B3BUL,   34,  0xFE51ACEEUL  },  // [ 1379] Random left roll test ( 1231/ 3000).
      {  0xD47CCC1FUL,  249,  0x3FA8F998UL  },  // [ 1380] Random left roll test ( 1232/ 3000).
      {  0xBE15005CUL,  114,  0x0172F854UL  },  // [ 1381] Random left roll test ( 1233/ 3000).
      {  0xFB6F3FF1UL,   18,  0xFFC7EDBCUL  },  // [ 1382] Random left roll test ( 1234/ 3000).
      {  0xC1268296UL,  252,  0x6C126829UL  },  // [ 1383] Random left roll test ( 1235/ 3000).
      {  0xCE2ADD08UL,  180,  0xD08CE2ADUL  },  // [ 1384] Random left roll test ( 1236/ 3000).
      {  0xAA028EDBUL,   45,  0x51DB7540UL  },  // [ 1385] Random left roll test ( 1237/ 3000).
      {  0xC2EA1DDDUL,   27,  0xEE1750EEUL  },  // [ 1386] Random left roll test ( 1238/ 3000).
      {  0x67EF005FUL,   51,  0x02FB3F78UL  },  // [ 1387] Random left roll test ( 1239/ 3000).
      {  0x36C859FAUL,  117,  0x3F46D90BUL  },  // [ 1388] Random left roll test ( 1240/ 3000).
      {  0x4DB147B4UL,   35,  0x6D8A3DA2UL  },  // [ 1389] Random left roll test ( 1241/ 3000).
      {  0xC99D41D5UL,  250,  0x57267507UL  },  // [ 1390] Random left roll test ( 1242/ 3000).
      {  0x339D889AUL,   86,  0x268CE762UL  },  // [ 1391] Random left roll test ( 1243/ 3000).
      {  0x4D30FCE8UL,  167,  0x987E7426UL  },  // [ 1392] Random left roll test ( 1244/ 3000).
      {  0x6620E226UL,  121,  0x4CCC41C4UL  },  // [ 1393] Random left roll test ( 1245/ 3000).
      {  0xBD1957FDUL,  227,  0xE8CABFEDUL  },  // [ 1394] Random left roll test ( 1246/ 3000).
      {  0xDD410B57UL,   95,  0xEEA085ABUL  },  // [ 1395] Random left roll test ( 1247/ 3000).
      {  0x5B45C39AUL,   58,  0x696D170EUL  },  // [ 1396] Random left roll test ( 1248/ 3000).
      {  0x08D78CB3UL,  255,  0x846BC659UL  },  // [ 1397] Random left roll test ( 1249/ 3000).
      {  0x5F3FB022UL,  197,  0xE7F6044BUL  },  // [ 1398] Random left roll test ( 1250/ 3000).
      {  0xB2C5CE2CUL,   75,  0x2E716596UL  },  // [ 1399] Random left roll test ( 1251/ 3000).
      {  0x93988744UL,    1,  0x27310E89UL  },  // [ 1400] Random left roll test ( 1252/ 3000).
      {  0x711B5C2AUL,  132,  0x11B5C2A7UL  },  // [ 1401] Random left roll test ( 1253/ 3000).
      {  0xC37189A5UL,  209,  0x134B86E3UL  },  // [ 1402] Random left roll test ( 1254/ 3000).
      {  0xED15F16BUL,  173,  0xBE2D7DA2UL  },  // [ 1403] Random left roll test ( 1255/ 3000).
      {  0x6E30BF52UL,  184,  0x526E30BFUL  },  // [ 1404] Random left roll test ( 1256/ 3000).
      {  0x9BD1CF07UL,    3,  0xDE8E783CUL  },  // [ 1405] Random left roll test ( 1257/ 3000).
      {  0xC1AA35F7UL,  242,  0xD7DF06A8UL  },  // [ 1406] Random left roll test ( 1258/ 3000).
      {  0x23FA3868UL,   55,  0x3411FD1CUL  },  // [ 1407] Random left roll test ( 1259/ 3000).
      {  0x4E5E00EFUL,   38,  0x97803BD3UL  },  // [ 1408] Random left roll test ( 1260/ 3000).
      {  0x099DD1EEUL,  177,  0xA3DC133BUL  },  // [ 1409] Random left roll test ( 1261/ 3000).
      {  0x42D34324UL,   31,  0x2169A192UL  },  // [ 1410] Random left roll test ( 1262/ 3000).
      {  0xDE74B77FUL,  119,  0xBFEF3A5BUL  },  // [ 1411] Random left roll test ( 1263/ 3000).
      {  0xB6D2798FUL,  180,  0x98FB6D27UL  },  // [ 1412] Random left roll test ( 1264/ 3000).
      {  0xA0DC20ECUL,  186,  0xB2837083UL  },  // [ 1413] Random left roll test ( 1265/ 3000).
      {  0xAC75FE8AUL,  223,  0x563AFF45UL  },  // [ 1414] Random left roll test ( 1266/ 3000).
      {  0x6D5B08E5UL,  209,  0x11CADAB6UL  },  // [ 1415] Random left roll test ( 1267/ 3000).
      {  0x6BCC9928UL,  147,  0xC9435E64UL  },  // [ 1416] Random left roll test ( 1268/ 3000).
      {  0xDC64409FUL,  172,  0x4409FDC6UL  },  // [ 1417] Random left roll test ( 1269/ 3000).
      {  0x600D9E3FUL,   83,  0xF1FB006CUL  },  // [ 1418] Random left roll test ( 1270/ 3000).
      {  0x5EED0D25UL,  230,  0xBB434957UL  },  // [ 1419] Random left roll test ( 1271/ 3000).
      {  0x4D1D5CC6UL,   82,  0x73193475UL  },  // [ 1420] Random left roll test ( 1272/ 3000).
      {  0xC0907792UL,  120,  0x92C09077UL  },  // [ 1421] Random left roll test ( 1273/ 3000).
      {  0x13C914C8UL,  157,  0x02792299UL  },  // [ 1422] Random left roll test ( 1274/ 3000).
      {  0x07DB6E0AUL,  211,  0x70503EDBUL  },  // [ 1423] Random left roll test ( 1275/ 3000).
      {  0xDF556176UL,  175,  0xB0BB6FAAUL  },  // [ 1424] Random left roll test ( 1276/ 3000).
      {  0x1EA61951UL,   46,  0x865447A9UL  },  // [ 1425] Random left roll test ( 1277/ 3000).
      {  0xF9144AB0UL,  166,  0x4512AC3EUL  },  // [ 1426] Random left roll test ( 1278/ 3000).
      {  0xABE7A234UL,    5,  0x7CF44695UL  },  // [ 1427] Random left roll test ( 1279/ 3000).
      {  0x9351AAEAUL,  212,  0xAEA9351AUL  },  // [ 1428] Random left roll test ( 1280/ 3000).
      {  0x07B0268AUL,  102,  0xEC09A281UL  },  // [ 1429] Random left roll test ( 1281/ 3000).
      {  0x897F9E75UL,  130,  0x25FE79D6UL  },  // [ 1430] Random left roll test ( 1282/ 3000).
      {  0x791C70A1UL,   53,  0x142F238EUL  },  // [ 1431] Random left roll test ( 1283/ 3000).
      {  0x002E8561UL,   50,  0x158400BAUL  },  // [ 1432] Random left roll test ( 1284/ 3000).
      {  0xAE0CA25CUL,  187,  0xE5706512UL  },  // [ 1433] Random left roll test ( 1285/ 3000).
      {  0xC747B247UL,   61,  0xF8E8F648UL  },  // [ 1434] Random left roll test ( 1286/ 3000).
      {  0xF530676BUL,  136,  0x30676BF5UL  },  // [ 1435] Random left roll test ( 1287/ 3000).
      {  0x3A052337UL,  236,  0x523373A0UL  },  // [ 1436] Random left roll test ( 1288/ 3000).
      {  0xF839DFC0UL,   74,  0xE77F03E0UL  },  // [ 1437] Random left roll test ( 1289/ 3000).
      {  0xA503F5B4UL,  147,  0xADA5281FUL  },  // [ 1438] Random left roll test ( 1290/ 3000).
      {  0x4CDCF0A0UL,  206,  0x3C281337UL  },  // [ 1439] Random left roll test ( 1291/ 3000).
      {  0x8C6D2CCCUL,  161,  0x18DA5999UL  },  // [ 1440] Random left roll test ( 1292/ 3000).
      {  0x6F81A860UL,  129,  0xDF0350C0UL  },  // [ 1441] Random left roll test ( 1293/ 3000).
      {  0xD47C37D0UL,  188,  0x0D47C37DUL  },  // [ 1442] Random left roll test ( 1294/ 3000).
      {  0xEB794DF4UL,  187,  0xA75BCA6FUL  },  // [ 1443] Random left roll test ( 1295/ 3000).
      {  0xA2538737UL,   26,  0xDE894E1CUL  },  // [ 1444] Random left roll test ( 1296/ 3000).
      {  0x1E54B001UL,  105,  0xA960023CUL  },  // [ 1445] Random left roll test ( 1297/ 3000).
      {  0x42E7A336UL,  243,  0x19B2173DUL  },  // [ 1446] Random left roll test ( 1298/ 3000).
      {  0x6D41E0C3UL,  255,  0xB6A0F061UL  },  // [ 1447] Random left roll test ( 1299/ 3000).
      {  0x2F21E3DCUL,   72,  0x21E3DC2FUL  },  // [ 1448] Random left roll test ( 1300/ 3000).
      {  0xEC79FCCBUL,   56,  0xCBEC79FCUL  },  // [ 1449] Random left roll test ( 1301/ 3000).
      {  0xED42E8DAUL,   91,  0xD76A1746UL  },  // [ 1450] Random left roll test ( 1302/ 3000).
      {  0x8F94C7FDUL,  134,  0xE531FF63UL  },  // [ 1451] Random left roll test ( 1303/ 3000).
      {  0xEC1E7B96UL,   45,  0xCF72DD83UL  },  // [ 1452] Random left roll test ( 1304/ 3000).
      {  0x2E2E3E38UL,   36,  0xE2E3E382UL  },  // [ 1453] Random left roll test ( 1305/ 3000).
      {  0xBA3DF8B1UL,   42,  0xF7E2C6E8UL  },  // [ 1454] Random left roll test ( 1306/ 3000).
      {  0x8D021A3CUL,  193,  0x1A043479UL  },  // [ 1455] Random left roll test ( 1307/ 3000).
      {  0xF9261F62UL,   82,  0x7D8BE498UL  },  // [ 1456] Random left roll test ( 1308/ 3000).
      {  0xCC4E6C30UL,   53,  0x861989CDUL  },  // [ 1457] Random left roll test ( 1309/ 3000).
      {  0x6D84B60FUL,  100,  0xD84B60F6UL  },  // [ 1458] Random left roll test ( 1310/ 3000).
      {  0x7B2E9654UL,   19,  0xB2A3D974UL  },  // [ 1459] Random left roll test ( 1311/ 3000).
      {  0x62BAC2FAUL,  235,  0xD617D315UL  },  // [ 1460] Random left roll test ( 1312/ 3000).
      {  0x3E5D0C57UL,  118,  0x15CF9743UL  },  // [ 1461] Random left roll test ( 1313/ 3000).
      {  0x0AD3FE14UL,  115,  0xF0A0569FUL  },  // [ 1462] Random left roll test ( 1314/ 3000).
      {  0xC6ECD34BUL,  204,  0xCD34BC6EUL  },  // [ 1463] Random left roll test ( 1315/ 3000).
      {  0xD95188FAUL,   88,  0xFAD95188UL  },  // [ 1464] Random left roll test ( 1316/ 3000).
      {  0x32A8BD20UL,  176,  0xBD2032A8UL  },  // [ 1465] Random left roll test ( 1317/ 3000).
      {  0x908BE3BFUL,  167,  0x45F1DFC8UL  },  // [ 1466] Random left roll test ( 1318/ 3000).
      {  0xE95F0260UL,  185,  0xC1D2BE04UL  },  // [ 1467] Random left roll test ( 1319/ 3000).
      {  0xFB65FC53UL,  253,  0x7F6CBF8AUL  },  // [ 1468] Random left roll test ( 1320/ 3000).
      {  0x18B60C2CUL,   81,  0x1858316CUL  },  // [ 1469] Random left roll test ( 1321/ 3000).
      {  0x69AF4BC9UL,  121,  0x92D35E97UL  },  // [ 1470] Random left roll test ( 1322/ 3000).
      {  0x7917063BUL,  177,  0x0C76F22EUL  },  // [ 1471] Random left roll test ( 1323/ 3000).
      {  0xCA36F97DUL,   70,  0x8DBE5F72UL  },  // [ 1472] Random left roll test ( 1324/ 3000).
      {  0x331E6656UL,  123,  0xB198F332UL  },  // [ 1473] Random left roll test ( 1325/ 3000).
      {  0x12D852E0UL,   25,  0xC025B0A5UL  },  // [ 1474] Random left roll test ( 1326/ 3000).
      {  0x0D39BAC8UL,   12,  0x9BAC80D3UL  },  // [ 1475] Random left roll test ( 1327/ 3000).
      {  0x5D8ADE4DUL,   41,  0x15BC9ABBUL  },  // [ 1476] Random left roll test ( 1328/ 3000).
      {  0x01A4BE5FUL,  117,  0xCBE03497UL  },  // [ 1477] Random left roll test ( 1329/ 3000).
      {  0x9A0C8595UL,  249,  0x2B34190BUL  },  // [ 1478] Random left roll test ( 1330/ 3000).
      {  0xF3F4FA19UL,   12,  0x4FA19F3FUL  },  // [ 1479] Random left roll test ( 1331/ 3000).
      {  0xA6E63571UL,   31,  0xD3731AB8UL  },  // [ 1480] Random left roll test ( 1332/ 3000).
      {  0x4020DAABUL,  184,  0xAB4020DAUL  },  // [ 1481] Random left roll test ( 1333/ 3000).
      {  0x54CD40C2UL,    9,  0x9A8184A9UL  },  // [ 1482] Random left roll test ( 1334/ 3000).
      {  0xB9E49C32UL,  157,  0x573C9386UL  },  // [ 1483] Random left roll test ( 1335/ 3000).
      {  0xDFC9AB57UL,  113,  0x56AFBF93UL  },  // [ 1484] Random left roll test ( 1336/ 3000).
      {  0xD375BD84UL,   56,  0x84D375BDUL  },  // [ 1485] Random left roll test ( 1337/ 3000).
      {  0x55C8797CUL,   97,  0xAB90F2F8UL  },  // [ 1486] Random left roll test ( 1338/ 3000).
      {  0x8D18CC9CUL,   36,  0xD18CC9C8UL  },  // [ 1487] Random left roll test ( 1339/ 3000).
      {  0x016B9C18UL,  233,  0xD7383002UL  },  // [ 1488] Random left roll test ( 1340/ 3000).
      {  0x1C2171A8UL,   63,  0x0E10B8D4UL  },  // [ 1489] Random left roll test ( 1341/ 3000).
      {  0xD302B974UL,  196,  0x302B974DUL  },  // [ 1490] Random left roll test ( 1342/ 3000).
      {  0x9ACD8404UL,  204,  0xD84049ACUL  },  // [ 1491] Random left roll test ( 1343/ 3000).
      {  0x719A1578UL,  164,  0x19A15787UL  },  // [ 1492] Random left roll test ( 1344/ 3000).
      {  0x74500301UL,   46,  0x00C05D14UL  },  // [ 1493] Random left roll test ( 1345/ 3000).
      {  0x2F155DC2UL,   85,  0xB845E2ABUL  },  // [ 1494] Random left roll test ( 1346/ 3000).
      {  0x35C840D4UL,  174,  0x10350D72UL  },  // [ 1495] Random left roll test ( 1347/ 3000).
      {  0x9F75C196UL,  201,  0xEB832D3EUL  },  // [ 1496] Random left roll test ( 1348/ 3000).
      {  0xC2D7CCEEUL,  239,  0xE677616BUL  },  // [ 1497] Random left roll test ( 1349/ 3000).
      {  0x48ADD5C6UL,   33,  0x915BAB8CUL  },  // [ 1498] Random left roll test ( 1350/ 3000).
      {  0x47713ADAUL,  249,  0xB48EE275UL  },  // [ 1499] Random left roll test ( 1351/ 3000).
      {  0x7F416A8CUL,   23,  0x463FA0B5UL  },  // [ 1500] Random left roll test ( 1352/ 3000).
      {  0x915091E9UL,   35,  0x8A848F4CUL  },  // [ 1501] Random left roll test ( 1353/ 3000).
      {  0xBAD1E0C8UL,  178,  0x8322EB47UL  },  // [ 1502] Random left roll test ( 1354/ 3000).
      {  0x6354EA1DUL,   46,  0x3A8758D5UL  },  // [ 1503] Random left roll test ( 1355/ 3000).
      {  0x9116725BUL,    5,  0x22CE4B72UL  },  // [ 1504] Random left roll test ( 1356/ 3000).
      {  0x14484FACUL,  152,  0xAC14484FUL  },  // [ 1505] Random left roll test ( 1357/ 3000).
      {  0x705E9399UL,   54,  0xE65C17A4UL  },  // [ 1506] Random left roll test ( 1358/ 3000).
      {  0x98833CADUL,  113,  0x795B3106UL  },  // [ 1507] Random left roll test ( 1359/ 3000).
      {  0x8CFD0EC9UL,   27,  0x4C67E876UL  },  // [ 1508] Random left roll test ( 1360/ 3000).
      {  0x16BD4D9DUL,   39,  0x5EA6CE8BUL  },  // [ 1509] Random left roll test ( 1361/ 3000).
      {  0xD2A91AA2UL,   49,  0x3545A552UL  },  // [ 1510] Random left roll test ( 1362/ 3000).
      {  0x9929C91BUL,  139,  0x4E48DCC9UL  },  // [ 1511] Random left roll test ( 1363/ 3000).
      {  0x98EA17C4UL,  233,  0xD42F8931UL  },  // [ 1512] Random left roll test ( 1364/ 3000).
      {  0x236D3AC2UL,   42,  0xB4EB088DUL  },  // [ 1513] Random left roll test ( 1365/ 3000).
      {  0xBD4336C5UL,  199,  0xA19B62DEUL  },  // [ 1514] Random left roll test ( 1366/ 3000).
      {  0x3DA44236UL,  137,  0x48846C7BUL  },  // [ 1515] Random left roll test ( 1367/ 3000).
      {  0xDCA41B56UL,  112,  0x1B56DCA4UL  },  // [ 1516] Random left roll test ( 1368/ 3000).
      {  0xE45DF4EEUL,   56,  0xEEE45DF4UL  },  // [ 1517] Random left roll test ( 1369/ 3000).
      {  0x1B2C4492UL,  182,  0x2486CB11UL  },  // [ 1518] Random left roll test ( 1370/ 3000).
      {  0x7289CD0FUL,  110,  0x7343DCA2UL  },  // [ 1519] Random left roll test ( 1371/ 3000).
      {  0x1AD6AD9BUL,   22,  0x66C6B5ABUL  },  // [ 1520] Random left roll test ( 1372/ 3000).
      {  0x97CADC2DUL,   75,  0x56E16CBEUL  },  // [ 1521] Random left roll test ( 1373/ 3000).
      {  0x82705BE8UL,  250,  0xA209C16FUL  },  // [ 1522] Random left roll test ( 1374/ 3000).
      {  0x6433242DUL,    2,  0x90CC90B5UL  },  // [ 1523] Random left roll test ( 1375/ 3000).
      {  0x6817FE89UL,  185,  0x12D02FFDUL  },  // [ 1524] Random left roll test ( 1376/ 3000).
      {  0x2895D00AUL,  186,  0x28A25740UL  },  // [ 1525] Random left roll test ( 1377/ 3000).
      {  0xAC06F417UL,   80,  0xF417AC06UL  },  // [ 1526] Random left roll test ( 1378/ 3000).
      {  0x981AF461UL,    1,  0x3035E8C3UL  },  // [ 1527] Random left roll test ( 1379/ 3000).
      {  0xF7664DC5UL,  174,  0x93717DD9UL  },  // [ 1528] Random left roll test ( 1380/ 3000).
      {  0xD67EB03CUL,  201,  0xFD6079ACUL  },  // [ 1529] Random left roll test ( 1381/ 3000).
      {  0x7B03ECFEUL,  187,  0xF3D81F67UL  },  // [ 1530] Random left roll test ( 1382/ 3000).
      {  0x70C964A9UL,  176,  0x64A970C9UL  },  // [ 1531] Random left roll test ( 1383/ 3000).
      {  0xEE6D38CCUL,  237,  0xA7199DCDUL  },  // [ 1532] Random left roll test ( 1384/ 3000).
      {  0xA9080BADUL,  251,  0x6D48405DUL  },  // [ 1533] Random left roll test ( 1385/ 3000).
      {  0xAFC17AEFUL,  214,  0xBBEBF05EUL  },  // [ 1534] Random left roll test ( 1386/ 3000).
      {  0xCFDFFE5EUL,   69,  0xFBFFCBD9UL  },  // [ 1535] Random left roll test ( 1387/ 3000).
      {  0xCC560DC2UL,  177,  0x1B8598ACUL  },  // [ 1536] Random left roll test ( 1388/ 3000).
      {  0x1AAACDFBUL,   22,  0x7EC6AAB3UL  },  // [ 1537] Random left roll test ( 1389/ 3000).
      {  0x462193D2UL,   43,  0x0C9E9231UL  },  // [ 1538] Random left roll test ( 1390/ 3000).
      {  0xE0962F9BUL,  228,  0x0962F9BEUL  },  // [ 1539] Random left roll test ( 1391/ 3000).
      {  0x163547EFUL,  154,  0xBC58D51FUL  },  // [ 1540] Random left roll test ( 1392/ 3000).
      {  0xB263B6B7UL,  245,  0xD6F64C76UL  },  // [ 1541] Random left roll test ( 1393/ 3000).
      {  0xCA4787F0UL,  152,  0xF0CA4787UL  },  // [ 1542] Random left roll test ( 1394/ 3000).
      {  0x8555F283UL,  247,  0x41C2AAF9UL  },  // [ 1543] Random left roll test ( 1395/ 3000).
      {  0x72E33974UL,  164,  0x2E339747UL  },  // [ 1544] Random left roll test ( 1396/ 3000).
      {  0xBFEF0344UL,  130,  0xFFBC0D12UL  },  // [ 1545] Random left roll test ( 1397/ 3000).
      {  0xB0EAB057UL,   28,  0x7B0EAB05UL  },  // [ 1546] Random left roll test ( 1398/ 3000).
      {  0xBA97980CUL,   55,  0x065D4BCCUL  },  // [ 1547] Random left roll test ( 1399/ 3000).
      {  0x54DD12F5UL,   79,  0x897AAA6EUL  },  // [ 1548] Random left roll test ( 1400/ 3000).
      {  0xF9F3FF43UL,  250,  0x0FE7CFFDUL  },  // [ 1549] Random left roll test ( 1401/ 3000).
      {  0x85EE6CBEUL,  206,  0x9B2FA17BUL  },  // [ 1550] Random left roll test ( 1402/ 3000).
      {  0x2398DC93UL,  124,  0x32398DC9UL  },  // [ 1551] Random left roll test ( 1403/ 3000).
      {  0x169A6941UL,  220,  0x1169A694UL  },  // [ 1552] Random left roll test ( 1404/ 3000).
      {  0x0E091961UL,  176,  0x19610E09UL  },  // [ 1553] Random left roll test ( 1405/ 3000).
      {  0x2D5A92F1UL,  169,  0xB525E25AUL  },  // [ 1554] Random left roll test ( 1406/ 3000).
      {  0xCE309A8FUL,   48,  0x9A8FCE30UL  },  // [ 1555] Random left roll test ( 1407/ 3000).
      {  0x345D8C88UL,  251,  0x41A2EC64UL  },  // [ 1556] Random left roll test ( 1408/ 3000).
      {  0x0F461B18UL,    1,  0x1E8C3630UL  },  // [ 1557] Random left roll test ( 1409/ 3000).
      {  0x859B2346UL,  203,  0xD91A342CUL  },  // [ 1558] Random left roll test ( 1410/ 3000).
      {  0xEC87C9DCUL,  208,  0xC9DCEC87UL  },  // [ 1559] Random left roll test ( 1411/ 3000).
      {  0x665694F1UL,  191,  0xB32B4A78UL  },  // [ 1560] Random left roll test ( 1412/ 3000).
      {  0xCFDF4696UL,   12,  0xF4696CFDUL  },  // [ 1561] Random left roll test ( 1413/ 3000).
      {  0x02FE1F0DUL,   19,  0xF86817F0UL  },  // [ 1562] Random left roll test ( 1414/ 3000).
      {  0xB9C638ADUL,   24,  0xADB9C638UL  },  // [ 1563] Random left roll test ( 1415/ 3000).
      {  0x2602931AUL,  240,  0x931A2602UL  },  // [ 1564] Random left roll test ( 1416/ 3000).
      {  0x4DCA3FEFUL,  255,  0xA6E51FF7UL  },  // [ 1565] Random left roll test ( 1417/ 3000).
      {  0x57F62BD6UL,  245,  0x7ACAFEC5UL  },  // [ 1566] Random left roll test ( 1418/ 3000).
      {  0x325D7122UL,   92,  0x2325D712UL  },  // [ 1567] Random left roll test ( 1419/ 3000).
      {  0x44BBF81EUL,   25,  0x3C8977F0UL  },  // [ 1568] Random left roll test ( 1420/ 3000).
      {  0x33D853C9UL,  195,  0x9EC29E49UL  },  // [ 1569] Random left roll test ( 1421/ 3000).
      {  0xBC05E640UL,  159,  0x5E02F320UL  },  // [ 1570] Random left roll test ( 1422/ 3000).
      {  0xE2DCBF96UL,   26,  0x5B8B72FEUL  },  // [ 1571] Random left roll test ( 1423/ 3000).
      {  0x9D4CD64FUL,  191,  0xCEA66B27UL  },  // [ 1572] Random left roll test ( 1424/ 3000).
      {  0xD811FA63UL,  146,  0xE98F6047UL  },  // [ 1573] Random left roll test ( 1425/ 3000).
      {  0xD4116106UL,  120,  0x06D41161UL  },  // [ 1574] Random left roll test ( 1426/ 3000).
      {  0x4DB390BBUL,   58,  0xED36CE42UL  },  // [ 1575] Random left roll test ( 1427/ 3000).
      {  0xEB7E2450UL,   33,  0xD6FC48A1UL  },  // [ 1576] Random left roll test ( 1428/ 3000).
      {  0x6B5A3494UL,   73,  0xB46928D6UL  },  // [ 1577] Random left roll test ( 1429/ 3000).
      {  0x3808F3E8UL,  172,  0x8F3E8380UL  },  // [ 1578] Random left roll test ( 1430/ 3000).
      {  0xD9E700BAUL,   80,  0x00BAD9E7UL  },  // [ 1579] Random left roll test ( 1431/ 3000).
      {  0x91AC8795UL,  244,  0x79591AC8UL  },  // [ 1580] Random left roll test ( 1432/ 3000).
      {  0xF157EBFEUL,  216,  0xFEF157EBUL  },  // [ 1581] Random left roll test ( 1433/ 3000).
      {  0xC6A80281UL,   90,  0x071AA00AUL  },  // [ 1582] Random left roll test ( 1434/ 3000).
      {  0x91FB2022UL,  237,  0x6404523FUL  },  // [ 1583] Random left roll test ( 1435/ 3000).
      {  0x9552D835UL,  142,  0xB60D6554UL  },  // [ 1584] Random left roll test ( 1436/ 3000).
      {  0x2254EF5AUL,  228,  0x254EF5A2UL  },  // [ 1585] Random left roll test ( 1437/ 3000).
      {  0xD9A87500UL,   82,  0xD40366A1UL  },  // [ 1586] Random left roll test ( 1438/ 3000).
      {  0x964E8446UL,   51,  0x2234B274UL  },  // [ 1587] Random left roll test ( 1439/ 3000).
      {  0x21D4223EUL,  186,  0xF8875088UL  },  // [ 1588] Random left roll test ( 1440/ 3000).
      {  0x0B1E0C8BUL,    8,  0x1E0C8B0BUL  },  // [ 1589] Random left roll test ( 1441/ 3000).
      {  0x7809B216UL,  181,  0x42CF0136UL  },  // [ 1590] Random left roll test ( 1442/ 3000).
      {  0x1013325FUL,  241,  0x64BE2026UL  },  // [ 1591] Random left roll test ( 1443/ 3000).
      {  0xF0469314UL,   43,  0x3498A782UL  },  // [ 1592] Random left roll test ( 1444/ 3000).
      {  0x0388B39FUL,   11,  0x459CF81CUL  },  // [ 1593] Random left roll test ( 1445/ 3000).
      {  0xC7711CFBUL,  194,  0x1DC473EFUL  },  // [ 1594] Random left roll test ( 1446/ 3000).
      {  0x1B6AD9DCUL,  171,  0x56CEE0DBUL  },  // [ 1595] Random left roll test ( 1447/ 3000).
      {  0x336B41A2UL,   83,  0x0D119B5AUL  },  // [ 1596] Random left roll test ( 1448/ 3000).
      {  0x2DC8067EUL,  227,  0x6E4033F1UL  },  // [ 1597] Random left roll test ( 1449/ 3000).
      {  0x47998C8AUL,   52,  0xC8A47998UL  },  // [ 1598] Random left roll test ( 1450/ 3000).
      {  0xC5AA07B5UL,  235,  0x503DAE2DUL  },  // [ 1599] Random left roll test ( 1451/ 3000).
      {  0xB875CE11UL,  216,  0x11B875CEUL  },  // [ 1600] Random left roll test ( 1452/ 3000).
      {  0xE7E28D53UL,   98,  0x9F8A354FUL  },  // [ 1601] Random left roll test ( 1453/ 3000).
      {  0xFF238EE8UL,  158,  0x3FC8E3BAUL  },  // [ 1602] Random left roll test ( 1454/ 3000).
      {  0x25E95D81UL,  100,  0x5E95D812UL  },  // [ 1603] Random left roll test ( 1455/ 3000).
      {  0xCA7B614DUL,   28,  0xDCA7B614UL  },  // [ 1604] Random left roll test ( 1456/ 3000).
      {  0xFEAD25CEUL,   72,  0xAD25CEFEUL  },  // [ 1605] Random left roll test ( 1457/ 3000).
      {  0x1D8C20B1UL,  145,  0x41623B18UL  },  // [ 1606] Random left roll test ( 1458/ 3000).
      {  0xCD2C0A1EUL,  141,  0x8143D9A5UL  },  // [ 1607] Random left roll test ( 1459/ 3000).
      {  0xED9D183EUL,  188,  0xEED9D183UL  },  // [ 1608] Random left roll test ( 1460/ 3000).
      {  0x3ACB7753UL,  108,  0xB77533ACUL  },  // [ 1609] Random left roll test ( 1461/ 3000).
      {  0x0974FA87UL,  100,  0x974FA870UL  },  // [ 1610] Random left roll test ( 1462/ 3000).
      {  0x2BF10356UL,   21,  0x6AC57E20UL  },  // [ 1611] Random left roll test ( 1463/ 3000).
      {  0x0A676394UL,   14,  0xD8E50299UL  },  // [ 1612] Random left roll test ( 1464/ 3000).
      {  0xFD92ECECUL,   90,  0xB3F64BB3UL  },  // [ 1613] Random left roll test ( 1465/ 3000).
      {  0xFA3210BDUL,  155,  0xEFD19085UL  },  // [ 1614] Random left roll test ( 1466/ 3000).
      {  0x48BFAB7DUL,   19,  0x5BEA45FDUL  },  // [ 1615] Random left roll test ( 1467/ 3000).
      {  0x8E137FA7UL,   49,  0xFF4F1C26UL  },  // [ 1616] Random left roll test ( 1468/ 3000).
      {  0x078ECC8BUL,   41,  0x1D99160FUL  },  // [ 1617] Random left roll test ( 1469/ 3000).
      {  0x9D9E6484UL,   34,  0x76799212UL  },  // [ 1618] Random left roll test ( 1470/ 3000).
      {  0xDD5181DFUL,   57,  0xBFBAA303UL  },  // [ 1619] Random left roll test ( 1471/ 3000).
      {  0x4098CCCBUL,    0,  0x4098CCCBUL  },  // [ 1620] Random left roll test ( 1472/ 3000).
      {  0xD7CEBB54UL,  130,  0x5F3AED53UL  },  // [ 1621] Random left roll test ( 1473/ 3000).
      {  0xE68782D4UL,  212,  0x2D4E6878UL  },  // [ 1622] Random left roll test ( 1474/ 3000).
      {  0x3D8FD4BEUL,  152,  0xBE3D8FD4UL  },  // [ 1623] Random left roll test ( 1475/ 3000).
      {  0x13D3104DUL,  141,  0x6209A27AUL  },  // [ 1624] Random left roll test ( 1476/ 3000).
      {  0x131D0EC6UL,   44,  0xD0EC6131UL  },  // [ 1625] Random left roll test ( 1477/ 3000).
      {  0xD2040BACUL,  213,  0x759A4081UL  },  // [ 1626] Random left roll test ( 1478/ 3000).
      {  0x6E18A99CUL,   37,  0xC315338DUL  },  // [ 1627] Random left roll test ( 1479/ 3000).
      {  0xA4FB34A1UL,   13,  0x6694349FUL  },  // [ 1628] Random left roll test ( 1480/ 3000).
      {  0x7C9668C2UL,   68,  0xC9668C27UL  },  // [ 1629] Random left roll test ( 1481/ 3000).
      {  0xA17DC9D4UL,   70,  0x5F727528UL  },  // [ 1630] Random left roll test ( 1482/ 3000).
      {  0x1FD426E7UL,  145,  0x4DCE3FA8UL  },  // [ 1631] Random left roll test ( 1483/ 3000).
      {  0x6ACE5C80UL,  111,  0x2E403567UL  },  // [ 1632] Random left roll test ( 1484/ 3000).
      {  0x0DD89321UL,  157,  0x21BB1264UL  },  // [ 1633] Random left roll test ( 1485/ 3000).
      {  0x3D143037UL,   95,  0x9E8A181BUL  },  // [ 1634] Random left roll test ( 1486/ 3000).
      {  0xAFD4143FUL,   26,  0xFEBF5050UL  },  // [ 1635] Random left roll test ( 1487/ 3000).
      {  0x8F4406C2UL,  124,  0x28F4406CUL  },  // [ 1636] Random left roll test ( 1488/ 3000).
      {  0xCF493C2DUL,   44,  0x93C2DCF4UL  },  // [ 1637] Random left roll test ( 1489/ 3000).
      {  0x3AE985F6UL,  191,  0x1D74C2FBUL  },  // [ 1638] Random left roll test ( 1490/ 3000).
      {  0xB509AF17UL,   37,  0xA135E2F6UL  },  // [ 1639] Random left roll test ( 1491/ 3000).
      {  0x16BBA3F5UL,  103,  0x5DD1FA8BUL  },  // [ 1640] Random left roll test ( 1492/ 3000).
      {  0xC35A5231UL,   83,  0x918E1AD2UL  },  // [ 1641] Random left roll test ( 1493/ 3000).
      {  0x9FFB0D03UL,   59,  0x1CFFD868UL  },  // [ 1642] Random left roll test ( 1494/ 3000).
      {  0x091F611DUL,   47,  0xB08E848FUL  },  // [ 1643] Random left roll test ( 1495/ 3000).
      {  0xD582F3B1UL,  242,  0xCEC7560BUL  },  // [ 1644] Random left roll test ( 1496/ 3000).
      {  0x4D0D03B5UL,  252,  0x54D0D03BUL  },  // [ 1645] Random left roll test ( 1497/ 3000).
      {  0xF64EC499UL,  150,  0x267D93B1UL  },  // [ 1646] Random left roll test ( 1498/ 3000).
      {  0x14A22134UL,  125,  0x82944426UL  },  // [ 1647] Random left roll test ( 1499/ 3000).
      {  0x2170D4BBUL,  111,  0x6A5D90B8UL  },  // [ 1648] Random left roll test ( 1500/ 3000).
      {  0x547D0C32UL,  196,  0x47D0C325UL  },  // [ 1649] Random left roll test ( 1501/ 3000).
      {  0x9304BF3AUL,  127,  0x49825F9DUL  },  // [ 1650] Random left roll test ( 1502/ 3000).
      {  0x018277D1UL,  170,  0x09DF4406UL  },  // [ 1651] Random left roll test ( 1503/ 3000).
      {  0xB5A131B9UL,   92,  0x9B5A131BUL  },  // [ 1652] Random left roll test ( 1504/ 3000).
      {  0xD97B3E46UL,  219,  0x36CBD9F2UL  },  // [ 1653] Random left roll test ( 1505/ 3000).
      {  0x07E8206DUL,  186,  0xB41FA081UL  },  // [ 1654] Random left roll test ( 1506/ 3000).
      {  0xE15AE9DAUL,   91,  0xD70AD74EUL  },  // [ 1655] Random left roll test ( 1507/ 3000).
      {  0x3B564204UL,   82,  0x0810ED59UL  },  // [ 1656] Random left roll test ( 1508/ 3000).
      {  0xDC5DAF52UL,  246,  0xD4B7176BUL  },  // [ 1657] Random left roll test ( 1509/ 3000).
      {  0xF2C27770UL,  221,  0x1E584EEEUL  },  // [ 1658] Random left roll test ( 1510/ 3000).
      {  0x192CDF3EUL,  248,  0x3E192CDFUL  },  // [ 1659] Random left roll test ( 1511/ 3000).
      {  0x24CD2634UL,   51,  0x31A12669UL  },  // [ 1660] Random left roll test ( 1512/ 3000).
      {  0x7FB1BC7DUL,  211,  0xE3EBFD8DUL  },  // [ 1661] Random left roll test ( 1513/ 3000).
      {  0x49DC875DUL,   31,  0xA4EE43AEUL  },  // [ 1662] Random left roll test ( 1514/ 3000).
      {  0xE8D4D6A2UL,  100,  0x8D4D6A2EUL  },  // [ 1663] Random left roll test ( 1515/ 3000).
      {  0x00B20020UL,   26,  0x8002C800UL  },  // [ 1664] Random left roll test ( 1516/ 3000).
      {  0x77CDD8B2UL,  159,  0x3BE6EC59UL  },  // [ 1665] Random left roll test ( 1517/ 3000).
      {  0x33F1F6C0UL,   51,  0xB6019F8FUL  },  // [ 1666] Random left roll test ( 1518/ 3000).
      {  0x42174B0DUL,    7,  0x0BA586A1UL  },  // [ 1667] Random left roll test ( 1519/ 3000).
      {  0x6EFBD5BEUL,  218,  0xF9BBEF56UL  },  // [ 1668] Random left roll test ( 1520/ 3000).
      {  0x7AF355D0UL,   53,  0xBA0F5E6AUL  },  // [ 1669] Random left roll test ( 1521/ 3000).
      {  0x3D1E0BB0UL,  167,  0x8F05D81EUL  },  // [ 1670] Random left roll test ( 1522/ 3000).
      {  0x312D41EFUL,   10,  0xB507BCC4UL  },  // [ 1671] Random left roll test ( 1523/ 3000).
      {  0xD44D81E1UL,  208,  0x81E1D44DUL  },  // [ 1672] Random left roll test ( 1524/ 3000).
      {  0x3CBA208CUL,  129,  0x79744118UL  },  // [ 1673] Random left roll test ( 1525/ 3000).
      {  0xC9A27F3DUL,   10,  0x89FCF726UL  },  // [ 1674] Random left roll test ( 1526/ 3000).
      {  0xD5E76DF5UL,  222,  0x7579DB7DUL  },  // [ 1675] Random left roll test ( 1527/ 3000).
      {  0xD7563809UL,  233,  0xAC7013AEUL  },  // [ 1676] Random left roll test ( 1528/ 3000).
      {  0x090F6A33UL,   52,  0xA33090F6UL  },  // [ 1677] Random left roll test ( 1529/ 3000).
      {  0x4B9F7F85UL,   10,  0x7DFE152EUL  },  // [ 1678] Random left roll test ( 1530/ 3000).
      {  0xBD51DC67UL,   75,  0x8EE33DEAUL  },  // [ 1679] Random left roll test ( 1531/ 3000).
      {  0x4DD02CC7UL,  181,  0x98E9BA05UL  },  // [ 1680] Random left roll test ( 1532/ 3000).
      {  0xD4562142UL,  249,  0x85A8AC42UL  },  // [ 1681] Random left roll test ( 1533/ 3000).
      {  0x18820F79UL,   29,  0x231041EFUL  },  // [ 1682] Random left roll test ( 1534/ 3000).
      {  0x0C258F7FUL,  231,  0x12C7BF86UL  },  // [ 1683] Random left roll test ( 1535/ 3000).
      {  0xEB2DBD0FUL,  237,  0xB7A1FD65UL  },  // [ 1684] Random left roll test ( 1536/ 3000).
      {  0x247BD372UL,  122,  0xC891EF4DUL  },  // [ 1685] Random left roll test ( 1537/ 3000).
      {  0x5B6D2609UL,  228,  0xB6D26095UL  },  // [ 1686] Random left roll test ( 1538/ 3000).
      {  0xE5921A3CUL,  104,  0x921A3CE5UL  },  // [ 1687] Random left roll test ( 1539/ 3000).
      {  0x936C8568UL,  205,  0x90AD126DUL  },  // [ 1688] Random left roll test ( 1540/ 3000).
      {  0x809F52C0UL,   39,  0x4FA96040UL  },  // [ 1689] Random left roll test ( 1541/ 3000).
      {  0x76750E3EUL,  156,  0xE76750E3UL  },  // [ 1690] Random left roll test ( 1542/ 3000).
      {  0xF37F2A01UL,   88,  0x01F37F2AUL  },  // [ 1691] Random left roll test ( 1543/ 3000).
      {  0xF8F9E2BCUL,   50,  0x8AF3E3E7UL  },  // [ 1692] Random left roll test ( 1544/ 3000).
      {  0xBAC305C3UL,   97,  0x75860B87UL  },  // [ 1693] Random left roll test ( 1545/ 3000).
      {  0x394411A7UL,   29,  0xE7288234UL  },  // [ 1694] Random left roll test ( 1546/ 3000).
      {  0x16125104UL,  144,  0x51041612UL  },  // [ 1695] Random left roll test ( 1547/ 3000).
      {  0xED077422UL,    3,  0x683BA117UL  },  // [ 1696] Random left roll test ( 1548/ 3000).
      {  0xD7947FBBUL,  230,  0xE51FEEF5UL  },  // [ 1697] Random left roll test ( 1549/ 3000).
      {  0xE30A9E65UL,   83,  0xF32F1854UL  },  // [ 1698] Random left roll test ( 1550/ 3000).
      {  0xC4D0DD49UL,  168,  0xD0DD49C4UL  },  // [ 1699] Random left roll test ( 1551/ 3000).
      {  0x1B3D6240UL,  163,  0xD9EB1200UL  },  // [ 1700] Random left roll test ( 1552/ 3000).
      {  0x4362ED0BUL,   80,  0xED0B4362UL  },  // [ 1701] Random left roll test ( 1553/ 3000).
      {  0x4AD627E9UL,  240,  0x27E94AD6UL  },  // [ 1702] Random left roll test ( 1554/ 3000).
      {  0x145CAC4BUL,  129,  0x28B95896UL  },  // [ 1703] Random left roll test ( 1555/ 3000).
      {  0xCB15FB15UL,  170,  0x57EC572CUL  },  // [ 1704] Random left roll test ( 1556/ 3000).
      {  0x7797A3DEUL,    2,  0xDE5E8F79UL  },  // [ 1705] Random left roll test ( 1557/ 3000).
      {  0xC3E95471UL,   71,  0xF4AA38E1UL  },  // [ 1706] Random left roll test ( 1558/ 3000).
      {  0x1E2F05D8UL,  176,  0x05D81E2FUL  },  // [ 1707] Random left roll test ( 1559/ 3000).
      {  0x76D53888UL,   80,  0x388876D5UL  },  // [ 1708] Random left roll test ( 1560/ 3000).
      {  0x785E16DFUL,  239,  0x0B6FBC2FUL  },  // [ 1709] Random left roll test ( 1561/ 3000).
      {  0xF113448DUL,   25,  0x1BE22689UL  },  // [ 1710] Random left roll test ( 1562/ 3000).
      {  0x52DD5FE4UL,    4,  0x2DD5FE45UL  },  // [ 1711] Random left roll test ( 1563/ 3000).
      {  0x76ADA609UL,   58,  0x25DAB698UL  },  // [ 1712] Random left roll test ( 1564/ 3000).
      {  0x41138D98UL,  110,  0xE3661044UL  },  // [ 1713] Random left roll test ( 1565/ 3000).
      {  0x128C2CC5UL,   16,  0x2CC5128CUL  },  // [ 1714] Random left roll test ( 1566/ 3000).
      {  0x7E4FFC7AUL,   87,  0x3D3F27FEUL  },  // [ 1715] Random left roll test ( 1567/ 3000).
      {  0x5575EF2EUL,  222,  0x955D7BCBUL  },  // [ 1716] Random left roll test ( 1568/ 3000).
      {  0x3CD363D9UL,  193,  0x79A6C7B2UL  },  // [ 1717] Random left roll test ( 1569/ 3000).
      {  0x1C56155FUL,  221,  0xE38AC2ABUL  },  // [ 1718] Random left roll test ( 1570/ 3000).
      {  0x7B8099DEUL,  151,  0xEF3DC04CUL  },  // [ 1719] Random left roll test ( 1571/ 3000).
      {  0x0C8B86CCUL,  195,  0x645C3660UL  },  // [ 1720] Random left roll test ( 1572/ 3000).
      {  0x8EA5B092UL,   19,  0x8494752DUL  },  // [ 1721] Random left roll test ( 1573/ 3000).
      {  0x1AE803A7UL,  226,  0x6BA00E9CUL  },  // [ 1722] Random left roll test ( 1574/ 3000).
      {  0xC8678C36UL,  202,  0x9E30DB21UL  },  // [ 1723] Random left roll test ( 1575/ 3000).
      {  0x23B97792UL,   68,  0x3B977922UL  },  // [ 1724] Random left roll test ( 1576/ 3000).
      {  0xF135BF38UL,   33,  0xE26B7E71UL  },  // [ 1725] Random left roll test ( 1577/ 3000).
      {  0xD594B5E9UL,  206,  0x2D7A7565UL  },  // [ 1726] Random left roll test ( 1578/ 3000).
      {  0x37C30177UL,  100,  0x7C301773UL  },  // [ 1727] Random left roll test ( 1579/ 3000).
      {  0x6163F864UL,  220,  0x46163F86UL  },  // [ 1728] Random left roll test ( 1580/ 3000).
      {  0xE52963C1UL,  111,  0xB1E0F294UL  },  // [ 1729] Random left roll test ( 1581/ 3000).
      {  0x60BCF3FCUL,  195,  0x05E79FE3UL  },  // [ 1730] Random left roll test ( 1582/ 3000).
      {  0xF6A6064BUL,   78,  0x8192FDA9UL  },  // [ 1731] Random left roll test ( 1583/ 3000).
      {  0xBE5B05A8UL,  129,  0x7CB60B51UL  },  // [ 1732] Random left roll test ( 1584/ 3000).
      {  0x215628F6UL,   52,  0x8F621562UL  },  // [ 1733] Random left roll test ( 1585/ 3000).
      {  0xB62935DCUL,  254,  0x2D8A4D77UL  },  // [ 1734] Random left roll test ( 1586/ 3000).
      {  0x4D5663E8UL,  132,  0xD5663E84UL  },  // [ 1735] Random left roll test ( 1587/ 3000).
      {  0x72A2545DUL,   19,  0xA2EB9512UL  },  // [ 1736] Random left roll test ( 1588/ 3000).
      {  0x0B1991F6UL,  102,  0xC6647D82UL  },  // [ 1737] Random left roll test ( 1589/ 3000).
      {  0x0D09B71EUL,   64,  0x0D09B71EUL  },  // [ 1738] Random left roll test ( 1590/ 3000).
      {  0x55E2EA75UL,  126,  0x5578BA9DUL  },  // [ 1739] Random left roll test ( 1591/ 3000).
      {  0xD8673F5AUL,  104,  0x673F5AD8UL  },  // [ 1740] Random left roll test ( 1592/ 3000).
      {  0xFE9E5A24UL,  109,  0xCB449FD3UL  },  // [ 1741] Random left roll test ( 1593/ 3000).
      {  0x4913DA59UL,   59,  0xCA489ED2UL  },  // [ 1742] Random left roll test ( 1594/ 3000).
      {  0x9B21E0B3UL,  225,  0x3643C167UL  },  // [ 1743] Random left roll test ( 1595/ 3000).
      {  0x73D62415UL,  249,  0x2AE7AC48UL  },  // [ 1744] Random left roll test ( 1596/ 3000).
      {  0x4453F564UL,   48,  0xF5644453UL  },  // [ 1745] Random left roll test ( 1597/ 3000).
      {  0x12FEF656UL,   10,  0xFBD9584BUL  },  // [ 1746] Random left roll test ( 1598/ 3000).
      {  0x944095C1UL,  213,  0xB8328812UL  },  // [ 1747] Random left roll test ( 1599/ 3000).
      {  0x566463B6UL,  190,  0x959918EDUL  },  // [ 1748] Random left roll test ( 1600/ 3000).
      {  0xDEC80B22UL,  223,  0x6F640591UL  },  // [ 1749] Random left roll test ( 1601/ 3000).
      {  0x822DD47AUL,   33,  0x045BA8F5UL  },  // [ 1750] Random left roll test ( 1602/ 3000).
      {  0x7C4CF4E6UL,   49,  0xE9CCF899UL  },  // [ 1751] Random left roll test ( 1603/ 3000).
      {  0xE1BAC435UL,  245,  0x86BC3758UL  },  // [ 1752] Random left roll test ( 1604/ 3000).
      {  0x94459170UL,  175,  0xC8B84A22UL  },  // [ 1753] Random left roll test ( 1605/ 3000).
      {  0x25DC0238UL,  119,  0x1C12EE01UL  },  // [ 1754] Random left roll test ( 1606/ 3000).
      {  0x1749387BUL,  248,  0x7B174938UL  },  // [ 1755] Random left roll test ( 1607/ 3000).
      {  0xDB3E496CUL,  250,  0xB36CF925UL  },  // [ 1756] Random left roll test ( 1608/ 3000).
      {  0xCCA514EFUL,   28,  0xFCCA514EUL  },  // [ 1757] Random left roll test ( 1609/ 3000).
      {  0x07613CADUL,  127,  0x83B09E56UL  },  // [ 1758] Random left roll test ( 1610/ 3000).
      {  0x9A04C272UL,  107,  0x261394D0UL  },  // [ 1759] Random left roll test ( 1611/ 3000).
      {  0xD18DE446UL,   98,  0x4637911BUL  },  // [ 1760] Random left roll test ( 1612/ 3000).
      {  0x3E4BCF6CUL,  184,  0x6C3E4BCFUL  },  // [ 1761] Random left roll test ( 1613/ 3000).
      {  0x005B39CDUL,  227,  0x02D9CE68UL  },  // [ 1762] Random left roll test ( 1614/ 3000).
      {  0xC283DCB5UL,   47,  0xEE5AE141UL  },  // [ 1763] Random left roll test ( 1615/ 3000).
      {  0x18B90D6AUL,   73,  0x721AD431UL  },  // [ 1764] Random left roll test ( 1616/ 3000).
      {  0xED282FB4UL,  215,  0xDA769417UL  },  // [ 1765] Random left roll test ( 1617/ 3000).
      {  0x47AF4DDBUL,  126,  0xD1EBD376UL  },  // [ 1766] Random left roll test ( 1618/ 3000).
      {  0xEADD9671UL,  241,  0x2CE3D5BBUL  },  // [ 1767] Random left roll test ( 1619/ 3000).
      {  0x4A5B4494UL,   68,  0xA5B44944UL  },  // [ 1768] Random left roll test ( 1620/ 3000).
      {  0xDEC6ADC4UL,  255,  0x6F6356E2UL  },  // [ 1769] Random left roll test ( 1621/ 3000).
      {  0xD28257C4UL,    4,  0x28257C4DUL  },  // [ 1770] Random left roll test ( 1622/ 3000).
      {  0x31616F59UL,   88,  0x5931616FUL  },  // [ 1771] Random left roll test ( 1623/ 3000).
      {  0x406A3D66UL,  212,  0xD66406A3UL  },  // [ 1772] Random left roll test ( 1624/ 3000).
      {  0x48B1AB71UL,   27,  0x8A458D5BUL  },  // [ 1773] Random left roll test ( 1625/ 3000).
      {  0xC6687D96UL,  127,  0x63343ECBUL  },  // [ 1774] Random left roll test ( 1626/ 3000).
      {  0x6EE12E15UL,  224,  0x6EE12E15UL  },  // [ 1775] Random left roll test ( 1627/ 3000).
      {  0xA472B9DEUL,   43,  0x95CEF523UL  },  // [ 1776] Random left roll test ( 1628/ 3000).
      {  0x04420CACUL,  177,  0x19580884UL  },  // [ 1777] Random left roll test ( 1629/ 3000).
      {  0x0A742438UL,  147,  0x21C053A1UL  },  // [ 1778] Random left roll test ( 1630/ 3000).
      {  0xC12AFCE6UL,   49,  0xF9CD8255UL  },  // [ 1779] Random left roll test ( 1631/ 3000).
      {  0x31327D73UL,  116,  0xD7331327UL  },  // [ 1780] Random left roll test ( 1632/ 3000).
      {  0xB056B2B0UL,   93,  0x160AD656UL  },  // [ 1781] Random left roll test ( 1633/ 3000).
      {  0xDC3F3900UL,  118,  0x40370FCEUL  },  // [ 1782] Random left roll test ( 1634/ 3000).
      {  0xD5924ED8UL,   73,  0x249DB1ABUL  },  // [ 1783] Random left roll test ( 1635/ 3000).
      {  0xBFDF618CUL,   45,  0xEC3197FBUL  },  // [ 1784] Random left roll test ( 1636/ 3000).
      {  0xFAB69427UL,   34,  0xEADA509FUL  },  // [ 1785] Random left roll test ( 1637/ 3000).
      {  0xBC194C52UL,  173,  0x298A5783UL  },  // [ 1786] Random left roll test ( 1638/ 3000).
      {  0x7CE04A06UL,  100,  0xCE04A067UL  },  // [ 1787] Random left roll test ( 1639/ 3000).
      {  0x726DAD1AUL,  180,  0xD1A726DAUL  },  // [ 1788] Random left roll test ( 1640/ 3000).
      {  0x53B2D525UL,   16,  0xD52553B2UL  },  // [ 1789] Random left roll test ( 1641/ 3000).
      {  0xCD46DC32UL,  255,  0x66A36E19UL  },  // [ 1790] Random left roll test ( 1642/ 3000).
      {  0x8F674226UL,  155,  0x347B3A11UL  },  // [ 1791] Random left roll test ( 1643/ 3000).
      {  0xD5D47C53UL,   13,  0x8F8A7ABAUL  },  // [ 1792] Random left roll test ( 1644/ 3000).
      {  0x2F316533UL,  123,  0x99798B29UL  },  // [ 1793] Random left roll test ( 1645/ 3000).
      {  0x3A875385UL,  100,  0xA8753853UL  },  // [ 1794] Random left roll test ( 1646/ 3000).
      {  0x3668C83EUL,  238,  0x320F8D9AUL  },  // [ 1795] Random left roll test ( 1647/ 3000).
      {  0xB1B3D009UL,   96,  0xB1B3D009UL  },  // [ 1796] Random left roll test ( 1648/ 3000).
      {  0xD5C99973UL,   42,  0x2665CF57UL  },  // [ 1797] Random left roll test ( 1649/ 3000).
      {  0x6184DCCAUL,   82,  0x73298613UL  },  // [ 1798] Random left roll test ( 1650/ 3000).
      {  0xD69F4501UL,   64,  0xD69F4501UL  },  // [ 1799] Random left roll test ( 1651/ 3000).
      {  0x095B745DUL,  180,  0x45D095B7UL  },  // [ 1800] Random left roll test ( 1652/ 3000).
      {  0xBDC6AEC5UL,  127,  0xDEE35762UL  },  // [ 1801] Random left roll test ( 1653/ 3000).
      {  0xDD88C8D5UL,  226,  0x76232357UL  },  // [ 1802] Random left roll test ( 1654/ 3000).
      {  0xD226C10EUL,  158,  0xB489B043UL  },  // [ 1803] Random left roll test ( 1655/ 3000).
      {  0xCFA34A0AUL,  197,  0xF4694159UL  },  // [ 1804] Random left roll test ( 1656/ 3000).
      {  0x5629B3F2UL,   80,  0xB3F25629UL  },  // [ 1805] Random left roll test ( 1657/ 3000).
      {  0x1A9B9B93UL,  122,  0x4C6A6E6EUL  },  // [ 1806] Random left roll test ( 1658/ 3000).
      {  0xB2BBEE0CUL,   46,  0xFB832CAEUL  },  // [ 1807] Random left roll test ( 1659/ 3000).
      {  0xAB8AF4A5UL,  153,  0x4B5715E9UL  },  // [ 1808] Random left roll test ( 1660/ 3000).
      {  0xBE286781UL,  157,  0x37C50CF0UL  },  // [ 1809] Random left roll test ( 1661/ 3000).
      {  0xB0A6B990UL,   21,  0x321614D7UL  },  // [ 1810] Random left roll test ( 1662/ 3000).
      {  0xD7E293DDUL,   72,  0xE293DDD7UL  },  // [ 1811] Random left roll test ( 1663/ 3000).
      {  0xABEAD473UL,   88,  0x73ABEAD4UL  },  // [ 1812] Random left roll test ( 1664/ 3000).
      {  0x6B561D83UL,   23,  0xC1B5AB0EUL  },  // [ 1813] Random left roll test ( 1665/ 3000).
      {  0x756B6592UL,   16,  0x6592756BUL  },  // [ 1814] Random left roll test ( 1666/ 3000).
      {  0xE1A561BDUL,  171,  0x2B0DEF0DUL  },  // [ 1815] Random left roll test ( 1667/ 3000).
      {  0xDCF1E87CUL,   79,  0xF43E6E78UL  },  // [ 1816] Random left roll test ( 1668/ 3000).
      {  0xB8485564UL,  210,  0x5592E121UL  },  // [ 1817] Random left roll test ( 1669/ 3000).
      {  0xF96C0A45UL,  125,  0xBF2D8148UL  },  // [ 1818] Random left roll test ( 1670/ 3000).
      {  0x48F38B15UL,  148,  0xB1548F38UL  },  // [ 1819] Random left roll test ( 1671/ 3000).
      {  0x4B5EA02AUL,   92,  0xA4B5EA02UL  },  // [ 1820] Random left roll test ( 1672/ 3000).
      {  0x9CC37829UL,  140,  0x378299CCUL  },  // [ 1821] Random left roll test ( 1673/ 3000).
      {  0xF85DD77DUL,    6,  0x1775DF7EUL  },  // [ 1822] Random left roll test ( 1674/ 3000).
      {  0x2BC0EB0EUL,  145,  0xD61C5781UL  },  // [ 1823] Random left roll test ( 1675/ 3000).
      {  0xF312A427UL,  132,  0x312A427FUL  },  // [ 1824] Random left roll test ( 1676/ 3000).
      {  0xFCBA4B2EUL,  231,  0x5D25977EUL  },  // [ 1825] Random left roll test ( 1677/ 3000).
      {  0x9BA59EF1UL,  225,  0x374B3DE3UL  },  // [ 1826] Random left roll test ( 1678/ 3000).
      {  0x65BFFA11UL,   98,  0x96FFE845UL  },  // [ 1827] Random left roll test ( 1679/ 3000).
      {  0xD0C088B0UL,  213,  0x161A1811UL  },  // [ 1828] Random left roll test ( 1680/ 3000).
      {  0x68A7A046UL,   13,  0xF408CD14UL  },  // [ 1829] Random left roll test ( 1681/ 3000).
      {  0x16B4827CUL,   22,  0x9F05AD20UL  },  // [ 1830] Random left roll test ( 1682/ 3000).
      {  0xE7DA1AF1UL,  150,  0xBC79F686UL  },  // [ 1831] Random left roll test ( 1683/ 3000).
      {  0xDA24BD71UL,  203,  0x25EB8ED1UL  },  // [ 1832] Random left roll test ( 1684/ 3000).
      {  0x6F8D8510UL,   35,  0x7C6C2883UL  },  // [ 1833] Random left roll test ( 1685/ 3000).
      {  0x6214665EUL,  118,  0x97988519UL  },  // [ 1834] Random left roll test ( 1686/ 3000).
      {  0x468C144CUL,  131,  0x3460A262UL  },  // [ 1835] Random left roll test ( 1687/ 3000).
      {  0x8E6B77C8UL,   51,  0xBE44735BUL  },  // [ 1836] Random left roll test ( 1688/ 3000).
      {  0x330DA85CUL,   45,  0xB50B8661UL  },  // [ 1837] Random left roll test ( 1689/ 3000).
      {  0xC9650D02UL,  163,  0x4B286816UL  },  // [ 1838] Random left roll test ( 1690/ 3000).
      {  0xFA79B9FCUL,   58,  0xF3E9E6E7UL  },  // [ 1839] Random left roll test ( 1691/ 3000).
      {  0xADE1C91DUL,  199,  0xF0E48ED6UL  },  // [ 1840] Random left roll test ( 1692/ 3000).
      {  0x5F3E7A6EUL,  104,  0x3E7A6E5FUL  },  // [ 1841] Random left roll test ( 1693/ 3000).
      {  0x04FD7BB0UL,  145,  0xF76009FAUL  },  // [ 1842] Random left roll test ( 1694/ 3000).
      {  0x8928E3F9UL,    0,  0x8928E3F9UL  },  // [ 1843] Random left roll test ( 1695/ 3000).
      {  0x952E6E05UL,  100,  0x52E6E059UL  },  // [ 1844] Random left roll test ( 1696/ 3000).
      {  0xC249187CUL,   76,  0x9187CC24UL  },  // [ 1845] Random left roll test ( 1697/ 3000).
      {  0x7EC0056EUL,  130,  0xFB0015B9UL  },  // [ 1846] Random left roll test ( 1698/ 3000).
      {  0xD4BA7FE7UL,  245,  0xFCFA974FUL  },  // [ 1847] Random left roll test ( 1699/ 3000).
      {  0x88D1F040UL,   79,  0xF8204468UL  },  // [ 1848] Random left roll test ( 1700/ 3000).
      {  0x7C301711UL,  113,  0x2E22F860UL  },  // [ 1849] Random left roll test ( 1701/ 3000).
      {  0xCFE920E6UL,   99,  0x7F490736UL  },  // [ 1850] Random left roll test ( 1702/ 3000).
      {  0x4D15F15AUL,  194,  0x3457C569UL  },  // [ 1851] Random left roll test ( 1703/ 3000).
      {  0x5DBB5040UL,   41,  0x76A080BBUL  },  // [ 1852] Random left roll test ( 1704/ 3000).
      {  0x177BECB0UL,  113,  0xD9602EF7UL  },  // [ 1853] Random left roll test ( 1705/ 3000).
      {  0x5A270822UL,  113,  0x1044B44EUL  },  // [ 1854] Random left roll test ( 1706/ 3000).
      {  0x58804D50UL,  108,  0x04D50588UL  },  // [ 1855] Random left roll test ( 1707/ 3000).
      {  0x0660E360UL,  139,  0x071B0033UL  },  // [ 1856] Random left roll test ( 1708/ 3000).
      {  0x2DDD9FB6UL,  195,  0x6EECFDB1UL  },  // [ 1857] Random left roll test ( 1709/ 3000).
      {  0x9A59000CUL,  159,  0x4D2C8006UL  },  // [ 1858] Random left roll test ( 1710/ 3000).
      {  0x65C7729AUL,   67,  0x2E3B94D3UL  },  // [ 1859] Random left roll test ( 1711/ 3000).
      {  0x1E045D33UL,  246,  0x4CC78117UL  },  // [ 1860] Random left roll test ( 1712/ 3000).
      {  0x91F14060UL,    4,  0x1F140609UL  },  // [ 1861] Random left roll test ( 1713/ 3000).
      {  0x6E4432CCUL,  198,  0x910CB31BUL  },  // [ 1862] Random left roll test ( 1714/ 3000).
      {  0x6860E0A6UL,  241,  0xC14CD0C1UL  },  // [ 1863] Random left roll test ( 1715/ 3000).
      {  0xCD41851BUL,   74,  0x06146F35UL  },  // [ 1864] Random left roll test ( 1716/ 3000).
      {  0xD06B0A32UL,   43,  0x58519683UL  },  // [ 1865] Random left roll test ( 1717/ 3000).
      {  0x976BD338UL,  207,  0xE99C4BB5UL  },  // [ 1866] Random left roll test ( 1718/ 3000).
      {  0xF19CE116UL,  188,  0x6F19CE11UL  },  // [ 1867] Random left roll test ( 1719/ 3000).
      {  0xA253EEF5UL,  120,  0xF5A253EEUL  },  // [ 1868] Random left roll test ( 1720/ 3000).
      {  0x112E92D8UL,   72,  0x2E92D811UL  },  // [ 1869] Random left roll test ( 1721/ 3000).
      {  0x99CBC056UL,  147,  0x02B4CE5EUL  },  // [ 1870] Random left roll test ( 1722/ 3000).
      {  0x07C2A7E5UL,  247,  0xF283E153UL  },  // [ 1871] Random left roll test ( 1723/ 3000).
      {  0x489CD5FFUL,   40,  0x9CD5FF48UL  },  // [ 1872] Random left roll test ( 1724/ 3000).
      {  0x8F48B7DDUL,  165,  0xE916FBB1UL  },  // [ 1873] Random left roll test ( 1725/ 3000).
      {  0x4FFB9416UL,   69,  0xFF7282C9UL  },  // [ 1874] Random left roll test ( 1726/ 3000).
      {  0x9A7EF92FUL,  141,  0xDF25F34FUL  },  // [ 1875] Random left roll test ( 1727/ 3000).
      {  0x96F88582UL,   36,  0x6F885829UL  },  // [ 1876] Random left roll test ( 1728/ 3000).
      {  0x37FB1A5AUL,  213,  0x4B46FF63UL  },  // [ 1877] Random left roll test ( 1729/ 3000).
      {  0x84499869UL,  142,  0x661A6112UL  },  // [ 1878] Random left roll test ( 1730/ 3000).
      {  0x7128E5CCUL,   25,  0x98E251CBUL  },  // [ 1879] Random left roll test ( 1731/ 3000).
      {  0xB76C94D2UL,   52,  0x4D2B76C9UL  },  // [ 1880] Random left roll test ( 1732/ 3000).
      {  0x9754F299UL,   65,  0x2EA9E533UL  },  // [ 1881] Random left roll test ( 1733/ 3000).
      {  0x57244DD1UL,   39,  0x9226E8ABUL  },  // [ 1882] Random left roll test ( 1734/ 3000).
      {  0xFD79F8D2UL,  181,  0x1A5FAF3FUL  },  // [ 1883] Random left roll test ( 1735/ 3000).
      {  0x115F74BEUL,    2,  0x457DD2F8UL  },  // [ 1884] Random left roll test ( 1736/ 3000).
      {  0x4DB35CFFUL,  194,  0x36CD73FDUL  },  // [ 1885] Random left roll test ( 1737/ 3000).
      {  0x230A6BC5UL,   51,  0x5E291853UL  },  // [ 1886] Random left roll test ( 1738/ 3000).
      {  0xAC10FF05UL,  154,  0x16B043FCUL  },  // [ 1887] Random left roll test ( 1739/ 3000).
      {  0x31C537CAUL,   82,  0xDF28C714UL  },  // [ 1888] Random left roll test ( 1740/ 3000).
      {  0xC389DC5FUL,  119,  0x2FE1C4EEUL  },  // [ 1889] Random left roll test ( 1741/ 3000).
      {  0xDA54AC29UL,  250,  0xA76952B0UL  },  // [ 1890] Random left roll test ( 1742/ 3000).
      {  0x0CC3F36BUL,  157,  0x61987E6DUL  },  // [ 1891] Random left roll test ( 1743/ 3000).
      {  0xD0B10D6AUL,  231,  0x5886B568UL  },  // [ 1892] Random left roll test ( 1744/ 3000).
      {  0x667979A9UL,   80,  0x79A96679UL  },  // [ 1893] Random left roll test ( 1745/ 3000).
      {  0x92CB8662UL,   53,  0xCC525970UL  },  // [ 1894] Random left roll test ( 1746/ 3000).
      {  0x5EF2B5E7UL,  207,  0x5AF3AF79UL  },  // [ 1895] Random left roll test ( 1747/ 3000).
      {  0xCCB6ABCBUL,   82,  0xAF2F32DAUL  },  // [ 1896] Random left roll test ( 1748/ 3000).
      {  0x9F3BAF0BUL,  148,  0xF0B9F3BAUL  },  // [ 1897] Random left roll test ( 1749/ 3000).
      {  0x9D03604CUL,    1,  0x3A06C099UL  },  // [ 1898] Random left roll test ( 1750/ 3000).
      {  0x4440F2B6UL,  215,  0x5B222079UL  },  // [ 1899] Random left roll test ( 1751/ 3000).
      {  0x436E6704UL,   36,  0x36E67044UL  },  // [ 1900] Random left roll test ( 1752/ 3000).
      {  0xCDA53AFCUL,  180,  0xAFCCDA53UL  },  // [ 1901] Random left roll test ( 1753/ 3000).
      {  0xD7EA6164UL,  203,  0x530B26BFUL  },  // [ 1902] Random left roll test ( 1754/ 3000).
      {  0xCD69B2D6UL,  228,  0xD69B2D6CUL  },  // [ 1903] Random left roll test ( 1755/ 3000).
      {  0x70E5AAA9UL,  229,  0x1CB5552EUL  },  // [ 1904] Random left roll test ( 1756/ 3000).
      {  0xC8D8380EUL,   77,  0x0701D91BUL  },  // [ 1905] Random left roll test ( 1757/ 3000).
      {  0x904D4776UL,   83,  0x3BB4826AUL  },  // [ 1906] Random left roll test ( 1758/ 3000).
      {  0xB7FCBD7CUL,  180,  0xD7CB7FCBUL  },  // [ 1907] Random left roll test ( 1759/ 3000).
      {  0x53A5EF8AUL,    8,  0xA5EF8A53UL  },  // [ 1908] Random left roll test ( 1760/ 3000).
      {  0x87185275UL,  120,  0x75871852UL  },  // [ 1909] Random left roll test ( 1761/ 3000).
      {  0x1FCDEAAFUL,   55,  0x578FE6F5UL  },  // [ 1910] Random left roll test ( 1762/ 3000).
      {  0xA05A9EF3UL,   75,  0xD4F79D02UL  },  // [ 1911] Random left roll test ( 1763/ 3000).
      {  0x2550B4F6UL,   17,  0x69EC4AA1UL  },  // [ 1912] Random left roll test ( 1764/ 3000).
      {  0x72B6B943UL,  239,  0x5CA1B95BUL  },  // [ 1913] Random left roll test ( 1765/ 3000).
      {  0x1FDF740EUL,   23,  0x070FEFBAUL  },  // [ 1914] Random left roll test ( 1766/ 3000).
      {  0xC576CA2DUL,   75,  0xB6516E2BUL  },  // [ 1915] Random left roll test ( 1767/ 3000).
      {  0x3F5CFFB2UL,   10,  0x73FEC8FDUL  },  // [ 1916] Random left roll test ( 1768/ 3000).
      {  0x1AAA76BFUL,   82,  0xDAFC6AA9UL  },  // [ 1917] Random left roll test ( 1769/ 3000).
      {  0x96480065UL,  228,  0x64800659UL  },  // [ 1918] Random left roll test ( 1770/ 3000).
      {  0xED331F7AUL,  207,  0x8FBD7699UL  },  // [ 1919] Random left roll test ( 1771/ 3000).
      {  0x8E94524CUL,   58,  0x323A5149UL  },  // [ 1920] Random left roll test ( 1772/ 3000).
      {  0x82B3E09AUL,    9,  0x67C13505UL  },  // [ 1921] Random left roll test ( 1773/ 3000).
      {  0x8D74641FUL,  172,  0x4641F8D7UL  },  // [ 1922] Random left roll test ( 1774/ 3000).
      {  0x1160120BUL,  106,  0x80482C45UL  },  // [ 1923] Random left roll test ( 1775/ 3000).
      {  0x448C5876UL,    2,  0x123161D9UL  },  // [ 1924] Random left roll test ( 1776/ 3000).
      {  0xF003C548UL,  123,  0x47801E2AUL  },  // [ 1925] Random left roll test ( 1777/ 3000).
      {  0x664AB255UL,   89,  0xAACC9564UL  },  // [ 1926] Random left roll test ( 1778/ 3000).
      {  0xE611EE85UL,  172,  0x1EE85E61UL  },  // [ 1927] Random left roll test ( 1779/ 3000).
      {  0x93BCB676UL,    2,  0x4EF2D9DAUL  },  // [ 1928] Random left roll test ( 1780/ 3000).
      {  0x8F205B09UL,  189,  0x31E40B61UL  },  // [ 1929] Random left roll test ( 1781/ 3000).
      {  0x2B7B4C1EUL,  159,  0x15BDA60FUL  },  // [ 1930] Random left roll test ( 1782/ 3000).
      {  0x5E79EE0EUL,  136,  0x79EE0E5EUL  },  // [ 1931] Random left roll test ( 1783/ 3000).
      {  0x1E80D990UL,    0,  0x1E80D990UL  },  // [ 1932] Random left roll test ( 1784/ 3000).
      {  0xAD626D0BUL,   57,  0x175AC4DAUL  },  // [ 1933] Random left roll test ( 1785/ 3000).
      {  0xE51AD139UL,   11,  0xD689CF28UL  },  // [ 1934] Random left roll test ( 1786/ 3000).
      {  0x829D1B5BUL,  252,  0xB829D1B5UL  },  // [ 1935] Random left roll test ( 1787/ 3000).
      {  0xB7F250A1UL,  180,  0x0A1B7F25UL  },  // [ 1936] Random left roll test ( 1788/ 3000).
      {  0xA3441663UL,   63,  0xD1A20B31UL  },  // [ 1937] Random left roll test ( 1789/ 3000).
      {  0x4CB0111DUL,  127,  0xA658088EUL  },  // [ 1938] Random left roll test ( 1790/ 3000).
      {  0x42500A96UL,  122,  0x5909402AUL  },  // [ 1939] Random left roll test ( 1791/ 3000).
      {  0xB4182104UL,  210,  0x8412D060UL  },  // [ 1940] Random left roll test ( 1792/ 3000).
      {  0x86722676UL,   55,  0x3B433913UL  },  // [ 1941] Random left roll test ( 1793/ 3000).
      {  0xBE382B28UL,  102,  0x8E0ACA2FUL  },  // [ 1942] Random left roll test ( 1794/ 3000).
      {  0xDCB3D7F8UL,   82,  0x5FE372CFUL  },  // [ 1943] Random left roll test ( 1795/ 3000).
      {  0x99832838UL,   44,  0x32838998UL  },  // [ 1944] Random left roll test ( 1796/ 3000).
      {  0xA254AECBUL,  126,  0xE8952BB2UL  },  // [ 1945] Random left roll test ( 1797/ 3000).
      {  0xBFCCDDBBUL,  224,  0xBFCCDDBBUL  },  // [ 1946] Random left roll test ( 1798/ 3000).
      {  0x2A0E5E44UL,   99,  0x5072F221UL  },  // [ 1947] Random left roll test ( 1799/ 3000).
      {  0x160D2A82UL,  205,  0xA55042C1UL  },  // [ 1948] Random left roll test ( 1800/ 3000).
      {  0x37B7E699UL,    7,  0xDBF34C9BUL  },  // [ 1949] Random left roll test ( 1801/ 3000).
      {  0x3FB59CD8UL,   49,  0x39B07F6BUL  },  // [ 1950] Random left roll test ( 1802/ 3000).
      {  0xA8B55201UL,    9,  0x6AA40351UL  },  // [ 1951] Random left roll test ( 1803/ 3000).
      {  0xD3B8A0F3UL,  188,  0x3D3B8A0FUL  },  // [ 1952] Random left roll test ( 1804/ 3000).
      {  0x11BB3794UL,    2,  0x46ECDE50UL  },  // [ 1953] Random left roll test ( 1805/ 3000).
      {  0x4E3B82FCUL,  213,  0x5F89C770UL  },  // [ 1954] Random left roll test ( 1806/ 3000).
      {  0xE6DD4B37UL,  231,  0x6EA59BF3UL  },  // [ 1955] Random left roll test ( 1807/ 3000).
      {  0xABF1B022UL,  217,  0x4557E360UL  },  // [ 1956] Random left roll test ( 1808/ 3000).
      {  0x00486447UL,  129,  0x0090C88EUL  },  // [ 1957] Random left roll test ( 1809/ 3000).
      {  0x85F2A565UL,  106,  0xCA959617UL  },  // [ 1958] Random left roll test ( 1810/ 3000).
      {  0x4BF110E3UL,   99,  0x5F88871AUL  },  // [ 1959] Random left roll test ( 1811/ 3000).
      {  0x52639F60UL,  255,  0x2931CFB0UL  },  // [ 1960] Random left roll test ( 1812/ 3000).
      {  0x67A91788UL,  209,  0x2F10CF52UL  },  // [ 1961] Random left roll test ( 1813/ 3000).
      {  0xE1A2FBE7UL,   26,  0x9F868BEFUL  },  // [ 1962] Random left roll test ( 1814/ 3000).
      {  0x862A4F05UL,   14,  0x93C1618AUL  },  // [ 1963] Random left roll test ( 1815/ 3000).
      {  0xDD04354AUL,  207,  0x1AA56E82UL  },  // [ 1964] Random left roll test ( 1816/ 3000).
      {  0x08086EA7UL,   48,  0x6EA70808UL  },  // [ 1965] Random left roll test ( 1817/ 3000).
      {  0x5B3E2EDDUL,  175,  0x176EAD9FUL  },  // [ 1966] Random left roll test ( 1818/ 3000).
      {  0x8A779236UL,   29,  0xD14EF246UL  },  // [ 1967] Random left roll test ( 1819/ 3000).
      {  0x27F0B6D8UL,    4,  0x7F0B6D82UL  },  // [ 1968] Random left roll test ( 1820/ 3000).
      {  0xD593E0A2UL,   80,  0xE0A2D593UL  },  // [ 1969] Random left roll test ( 1821/ 3000).
      {  0x69B9444DUL,   66,  0xA6E51135UL  },  // [ 1970] Random left roll test ( 1822/ 3000).
      {  0xC5E29AB6UL,    7,  0xF14D5B62UL  },  // [ 1971] Random left roll test ( 1823/ 3000).
      {  0x743FCA2EUL,  233,  0x7F945CE8UL  },  // [ 1972] Random left roll test ( 1824/ 3000).
      {  0x74A99FB4UL,  202,  0xA67ED1D2UL  },  // [ 1973] Random left roll test ( 1825/ 3000).
      {  0x8B2ABFBCUL,  167,  0x955FDE45UL  },  // [ 1974] Random left roll test ( 1826/ 3000).
      {  0x10D15400UL,  203,  0x8AA00086UL  },  // [ 1975] Random left roll test ( 1827/ 3000).
      {  0x6DACC00BUL,   28,  0xB6DACC00UL  },  // [ 1976] Random left roll test ( 1828/ 3000).
      {  0x3EC41208UL,   58,  0x20FB1048UL  },  // [ 1977] Random left roll test ( 1829/ 3000).
      {  0x6F24278AUL,  217,  0x14DE484FUL  },  // [ 1978] Random left roll test ( 1830/ 3000).
      {  0xC00BCF98UL,  229,  0x0179F318UL  },  // [ 1979] Random left roll test ( 1831/ 3000).
      {  0x11760A9BUL,  121,  0x3622EC15UL  },  // [ 1980] Random left roll test ( 1832/ 3000).
      {  0x7A3BFE4EUL,  255,  0x3D1DFF27UL  },  // [ 1981] Random left roll test ( 1833/ 3000).
      {  0xCFF3AF81UL,  191,  0xE7F9D7C0UL  },  // [ 1982] Random left roll test ( 1834/ 3000).
      {  0x27AB459FUL,   14,  0xD167C9EAUL  },  // [ 1983] Random left roll test ( 1835/ 3000).
      {  0x11AB35B8UL,   54,  0x6E046ACDUL  },  // [ 1984] Random left roll test ( 1836/ 3000).
      {  0x0701C106UL,  210,  0x04181C07UL  },  // [ 1985] Random left roll test ( 1837/ 3000).
      {  0xF0C75C45UL,  246,  0x117C31D7UL  },  // [ 1986] Random left roll test ( 1838/ 3000).
      {  0xBC46681BUL,  180,  0x81BBC466UL  },  // [ 1987] Random left roll test ( 1839/ 3000).
      {  0x054B758FUL,  109,  0x6EB1E0A9UL  },  // [ 1988] Random left roll test ( 1840/ 3000).
      {  0x313F2ED8UL,  200,  0x3F2ED831UL  },  // [ 1989] Random left roll test ( 1841/ 3000).
      {  0x4D968D10UL,    9,  0x2D1A209BUL  },  // [ 1990] Random left roll test ( 1842/ 3000).
      {  0xF33717CEUL,   43,  0xB8BE7799UL  },  // [ 1991] Random left roll test ( 1843/ 3000).
      {  0x2FA13BB1UL,   56,  0xB12FA13BUL  },  // [ 1992] Random left roll test ( 1844/ 3000).
      {  0x3BBF2AA8UL,  238,  0xCAAA0EEFUL  },  // [ 1993] Random left roll test ( 1845/ 3000).
      {  0xEB504181UL,  232,  0x504181EBUL  },  // [ 1994] Random left roll test ( 1846/ 3000).
      {  0xB9F3A581UL,  103,  0xF9D2C0DCUL  },  // [ 1995] Random left roll test ( 1847/ 3000).
      {  0xCDC8555FUL,  175,  0x2AAFE6E4UL  },  // [ 1996] Random left roll test ( 1848/ 3000).
      {  0x664A0881UL,  143,  0x0440B325UL  },  // [ 1997] Random left roll test ( 1849/ 3000).
      {  0xA99118F9UL,  255,  0xD4C88C7CUL  },  // [ 1998] Random left roll test ( 1850/ 3000).
      {  0xDD07E53CUL,  222,  0x3741F94FUL  },  // [ 1999] Random left roll test ( 1851/ 3000).
      {  0x89EE6F87UL,  176,  0x6F8789EEUL  },  // [ 2000] Random left roll test ( 1852/ 3000).
      {  0x7518E78BUL,   99,  0xA8C73C5BUL  },  // [ 2001] Random left roll test ( 1853/ 3000).
      {  0x5FAA7A28UL,    0,  0x5FAA7A28UL  },  // [ 2002] Random left roll test ( 1854/ 3000).
      {  0x4DD81DDBUL,  100,  0xDD81DDB4UL  },  // [ 2003] Random left roll test ( 1855/ 3000).
      {  0xDF9473CAUL,   94,  0xB7E51CF2UL  },  // [ 2004] Random left roll test ( 1856/ 3000).
      {  0xA042307FUL,  226,  0x8108C1FEUL  },  // [ 2005] Random left roll test ( 1857/ 3000).
      {  0x0B9EE734UL,  220,  0x40B9EE73UL  },  // [ 2006] Random left roll test ( 1858/ 3000).
      {  0xC26770C4UL,  163,  0x133B8626UL  },  // [ 2007] Random left roll test ( 1859/ 3000).
      {  0x74B55B82UL,  178,  0x6E09D2D5UL  },  // [ 2008] Random left roll test ( 1860/ 3000).
      {  0x758677D4UL,  164,  0x58677D47UL  },  // [ 2009] Random left roll test ( 1861/ 3000).
      {  0xD9B3DEB2UL,  200,  0xB3DEB2D9UL  },  // [ 2010] Random left roll test ( 1862/ 3000).
      {  0xB8B89B65UL,   40,  0xB89B65B8UL  },  // [ 2011] Random left roll test ( 1863/ 3000).
      {  0xFBFD83D0UL,  190,  0x3EFF60F4UL  },  // [ 2012] Random left roll test ( 1864/ 3000).
      {  0xCCF77D3AUL,  173,  0xEFA7599EUL  },  // [ 2013] Random left roll test ( 1865/ 3000).
      {  0xA024F7ECUL,  247,  0xF650127BUL  },  // [ 2014] Random left roll test ( 1866/ 3000).
      {  0xFC4ABB9BUL,  250,  0x6FF12AEEUL  },  // [ 2015] Random left roll test ( 1867/ 3000).
      {  0x1D7FA4F3UL,   84,  0x4F31D7FAUL  },  // [ 2016] Random left roll test ( 1868/ 3000).
      {  0xFE9F48C9UL,  148,  0x8C9FE9F4UL  },  // [ 2017] Random left roll test ( 1869/ 3000).
      {  0x0863840DUL,   55,  0x068431C2UL  },  // [ 2018] Random left roll test ( 1870/ 3000).
      {  0xF5836CE7UL,  174,  0xDB39FD60UL  },  // [ 2019] Random left roll test ( 1871/ 3000).
      {  0x2A3362DAUL,   73,  0x66C5B454UL  },  // [ 2020] Random left roll test ( 1872/ 3000).
      {  0x199B2FF5UL,   92,  0x5199B2FFUL  },  // [ 2021] Random left roll test ( 1873/ 3000).
      {  0x9B2FC38BUL,  234,  0xBF0E2E6CUL  },  // [ 2022] Random left roll test ( 1874/ 3000).
      {  0xDE838E3AUL,  103,  0x41C71D6FUL  },  // [ 2023] Random left roll test ( 1875/ 3000).
      {  0xBF3A7B8BUL,  122,  0x2EFCE9EEUL  },  // [ 2024] Random left roll test ( 1876/ 3000).
      {  0xB2A98EFCUL,  255,  0x5954C77EUL  },  // [ 2025] Random left roll test ( 1877/ 3000).
      {  0xCE8CA3CEUL,  142,  0x28F3B3A3UL  },  // [ 2026] Random left roll test ( 1878/ 3000).
      {  0x8B641F60UL,   51,  0xFB045B20UL  },  // [ 2027] Random left roll test ( 1879/ 3000).
      {  0xE1E2C364UL,   49,  0x86C9C3C5UL  },  // [ 2028] Random left roll test ( 1880/ 3000).
      {  0x46FD48ADUL,  200,  0xFD48AD46UL  },  // [ 2029] Random left roll test ( 1881/ 3000).
      {  0xF6281EA7UL,  223,  0xFB140F53UL  },  // [ 2030] Random left roll test ( 1882/ 3000).
      {  0x114591B8UL,  234,  0x1646E045UL  },  // [ 2031] Random left roll test ( 1883/ 3000).
      {  0x1E3C2E14UL,   96,  0x1E3C2E14UL  },  // [ 2032] Random left roll test ( 1884/ 3000).
      {  0x2D71E141UL,  254,  0x4B5C7850UL  },  // [ 2033] Random left roll test ( 1885/ 3000).
      {  0xEFD3D50AUL,  217,  0x15DFA7AAUL  },  // [ 2034] Random left roll test ( 1886/ 3000).
      {  0x99F6A90FUL,  168,  0xF6A90F99UL  },  // [ 2035] Random left roll test ( 1887/ 3000).
      {  0x1F396105UL,  213,  0x20A3E72CUL  },  // [ 2036] Random left roll test ( 1888/ 3000).
      {  0xA09BCE3FUL,  202,  0x6F38FE82UL  },  // [ 2037] Random left roll test ( 1889/ 3000).
      {  0x44840C91UL,    6,  0x21032451UL  },  // [ 2038] Random left roll test ( 1890/ 3000).
      {  0x6BEBF17CUL,  103,  0xF5F8BE35UL  },  // [ 2039] Random left roll test ( 1891/ 3000).
      {  0x16736217UL,   65,  0x2CE6C42EUL  },  // [ 2040] Random left roll test ( 1892/ 3000).
      {  0x2A37C33BUL,  246,  0xCECA8DF0UL  },  // [ 2041] Random left roll test ( 1893/ 3000).
      {  0xC9B30408UL,  104,  0xB30408C9UL  },  // [ 2042] Random left roll test ( 1894/ 3000).
      {  0x5A6A9BF3UL,  172,  0xA9BF35A6UL  },  // [ 2043] Random left roll test ( 1895/ 3000).
      {  0x8EE99A14UL,  228,  0xEE99A148UL  },  // [ 2044] Random left roll test ( 1896/ 3000).
      {  0xD6A8D698UL,  153,  0x31AD51ADUL  },  // [ 2045] Random left roll test ( 1897/ 3000).
      {  0xB3EEBD7DUL,  148,  0xD7DB3EEBUL  },  // [ 2046] Random left roll test ( 1898/ 3000).
      {  0xC2CAC7B1UL,  103,  0x6563D8E1UL  },  // [ 2047] Random left roll test ( 1899/ 3000).
      {  0x2F5A672FUL,   21,  0xE5E5EB4CUL  },  // [ 2048] Random left roll test ( 1900/ 3000).
      {  0x336258A1UL,  147,  0xC5099B12UL  },  // [ 2049] Random left roll test ( 1901/ 3000).
      {  0xE2CA87CEUL,  145,  0x0F9DC595UL  },  // [ 2050] Random left roll test ( 1902/ 3000).
      {  0xC52B6257UL,   91,  0xBE295B12UL  },  // [ 2051] Random left roll test ( 1903/ 3000).
      {  0x19F0C355UL,  177,  0x86AA33E1UL  },  // [ 2052] Random left roll test ( 1904/ 3000).
      {  0x7C76334EUL,   69,  0x8EC669CFUL  },  // [ 2053] Random left roll test ( 1905/ 3000).
      {  0xA43614CFUL,  241,  0x299F486CUL  },  // [ 2054] Random left roll test ( 1906/ 3000).
      {  0xF994FA60UL,  232,  0x94FA60F9UL  },  // [ 2055] Random left roll test ( 1907/ 3000).
      {  0x17A3C124UL,  213,  0x2482F478UL  },  // [ 2056] Random left roll test ( 1908/ 3000).
      {  0x3394E00FUL,  203,  0xA700799CUL  },  // [ 2057] Random left roll test ( 1909/ 3000).
      {  0x33D85DBBUL,  138,  0x6176ECCFUL  },  // [ 2058] Random left roll test ( 1910/ 3000).
      {  0xF304218BUL,  229,  0x6084317EUL  },  // [ 2059] Random left roll test ( 1911/ 3000).
      {  0x37854851UL,   29,  0x26F0A90AUL  },  // [ 2060] Random left roll test ( 1912/ 3000).
      {  0x45216ED8UL,  121,  0xB08A42DDUL  },  // [ 2061] Random left roll test ( 1913/ 3000).
      {  0x09D6DCCFUL,   14,  0xB733C275UL  },  // [ 2062] Random left roll test ( 1914/ 3000).
      {  0x588784DBUL,  132,  0x88784DB5UL  },  // [ 2063] Random left roll test ( 1915/ 3000).
      {  0xF368A4BDUL,  156,  0xDF368A4BUL  },  // [ 2064] Random left roll test ( 1916/ 3000).
      {  0xBA65ED84UL,   79,  0xF6C25D32UL  },  // [ 2065] Random left roll test ( 1917/ 3000).
      {  0x4D22C684UL,  154,  0x11348B1AUL  },  // [ 2066] Random left roll test ( 1918/ 3000).
      {  0x1E03E3D4UL,   71,  0x01F1EA0FUL  },  // [ 2067] Random left roll test ( 1919/ 3000).
      {  0xF4E69BB8UL,   68,  0x4E69BB8FUL  },  // [ 2068] Random left roll test ( 1920/ 3000).
      {  0x3C233F17UL,   90,  0x5CF08CFCUL  },  // [ 2069] Random left roll test ( 1921/ 3000).
      {  0x17EF71FDUL,  102,  0xFBDC7F45UL  },  // [ 2070] Random left roll test ( 1922/ 3000).
      {  0xC7E972F0UL,   16,  0x72F0C7E9UL  },  // [ 2071] Random left roll test ( 1923/ 3000).
      {  0x18F3BDBEUL,   62,  0x863CEF6FUL  },  // [ 2072] Random left roll test ( 1924/ 3000).
      {  0x1F55C909UL,   76,  0x5C9091F5UL  },  // [ 2073] Random left roll test ( 1925/ 3000).
      {  0xC8D54BCAUL,  149,  0x79591AA9UL  },  // [ 2074] Random left roll test ( 1926/ 3000).
      {  0x1BD9583AUL,   65,  0x37B2B074UL  },  // [ 2075] Random left roll test ( 1927/ 3000).
      {  0x24ECE5E6UL,  119,  0xF3127672UL  },  // [ 2076] Random left roll test ( 1928/ 3000).
      {  0xE56BED26UL,   50,  0xB49B95AFUL  },  // [ 2077] Random left roll test ( 1929/ 3000).
      {  0x8A6A1A3AUL,  176,  0x1A3A8A6AUL  },  // [ 2078] Random left roll test ( 1930/ 3000).
      {  0x3B7B9A13UL,   36,  0xB7B9A133UL  },  // [ 2079] Random left roll test ( 1931/ 3000).
      {  0x89FC671EUL,  237,  0x8CE3D13FUL  },  // [ 2080] Random left roll test ( 1932/ 3000).
      {  0x9F8D68A2UL,   15,  0xB4514FC6UL  },  // [ 2081] Random left roll test ( 1933/ 3000).
      {  0x6A48DCCBUL,  250,  0x2DA92373UL  },  // [ 2082] Random left roll test ( 1934/ 3000).
      {  0x18AF7D4AUL,  192,  0x18AF7D4AUL  },  // [ 2083] Random left roll test ( 1935/ 3000).
      {  0xD1C3E03AUL,  114,  0x80EB470FUL  },  // [ 2084] Random left roll test ( 1936/ 3000).
      {  0x77532FF6UL,  124,  0x677532FFUL  },  // [ 2085] Random left roll test ( 1937/ 3000).
      {  0x495B1105UL,  162,  0x256C4415UL  },  // [ 2086] Random left roll test ( 1938/ 3000).
      {  0xD05BBBC9UL,   56,  0xC9D05BBBUL  },  // [ 2087] Random left roll test ( 1939/ 3000).
      {  0x9D22F6BBUL,   45,  0x5ED773A4UL  },  // [ 2088] Random left roll test ( 1940/ 3000).
      {  0x501F55E2UL,   89,  0xC4A03EABUL  },  // [ 2089] Random left roll test ( 1941/ 3000).
      {  0xEAEAB061UL,  159,  0xF5755830UL  },  // [ 2090] Random left roll test ( 1942/ 3000).
      {  0x2C8EB3F6UL,   13,  0xD67EC591UL  },  // [ 2091] Random left roll test ( 1943/ 3000).
      {  0xC3C36D95UL,  129,  0x8786DB2BUL  },  // [ 2092] Random left roll test ( 1944/ 3000).
      {  0x0B3B7EE1UL,  133,  0x676FDC21UL  },  // [ 2093] Random left roll test ( 1945/ 3000).
      {  0x81433FF2UL,  105,  0x867FE502UL  },  // [ 2094] Random left roll test ( 1946/ 3000).
      {  0x027716CBUL,  124,  0xB027716CUL  },  // [ 2095] Random left roll test ( 1947/ 3000).
      {  0xA1F3841DUL,    4,  0x1F3841DAUL  },  // [ 2096] Random left roll test ( 1948/ 3000).
      {  0x46F01A34UL,  138,  0xC068D11BUL  },  // [ 2097] Random left roll test ( 1949/ 3000).
      {  0x85579C01UL,   72,  0x579C0185UL  },  // [ 2098] Random left roll test ( 1950/ 3000).
      {  0x491AED19UL,  157,  0x29235DA3UL  },  // [ 2099] Random left roll test ( 1951/ 3000).
      {  0xC31C6671UL,  124,  0x1C31C667UL  },  // [ 2100] Random left roll test ( 1952/ 3000).
      {  0xDFB8AFF3UL,  178,  0xBFCF7EE2UL  },  // [ 2101] Random left roll test ( 1953/ 3000).
      {  0xD00E28C3UL,  129,  0xA01C5187UL  },  // [ 2102] Random left roll test ( 1954/ 3000).
      {  0x861C9355UL,  160,  0x861C9355UL  },  // [ 2103] Random left roll test ( 1955/ 3000).
      {  0xAEEE582DUL,  240,  0x582DAEEEUL  },  // [ 2104] Random left roll test ( 1956/ 3000).
      {  0xD895E026UL,  160,  0xD895E026UL  },  // [ 2105] Random left roll test ( 1957/ 3000).
      {  0xD0FC8197UL,  230,  0x3F2065F4UL  },  // [ 2106] Random left roll test ( 1958/ 3000).
      {  0x335126CFUL,    8,  0x5126CF33UL  },  // [ 2107] Random left roll test ( 1959/ 3000).
      {  0x6859F7C5UL,  113,  0xEF8AD0B3UL  },  // [ 2108] Random left roll test ( 1960/ 3000).
      {  0x07D9D6BFUL,   83,  0xB5F83ECEUL  },  // [ 2109] Random left roll test ( 1961/ 3000).
      {  0x896FC497UL,  157,  0xF12DF892UL  },  // [ 2110] Random left roll test ( 1962/ 3000).
      {  0x08C19A21UL,   57,  0x42118334UL  },  // [ 2111] Random left roll test ( 1963/ 3000).
      {  0x3E74BB63UL,   41,  0xE976C67CUL  },  // [ 2112] Random left roll test ( 1964/ 3000).
      {  0x8E74C46DUL,  177,  0x88DB1CE9UL  },  // [ 2113] Random left roll test ( 1965/ 3000).
      {  0x710D32F5UL,   93,  0xAE21A65EUL  },  // [ 2114] Random left roll test ( 1966/ 3000).
      {  0x932C7F1CUL,  107,  0x63F8E499UL  },  // [ 2115] Random left roll test ( 1967/ 3000).
      {  0x4D141D43UL,  220,  0x34D141D4UL  },  // [ 2116] Random left roll test ( 1968/ 3000).
      {  0xE57A7EC2UL,    3,  0x2BD3F617UL  },  // [ 2117] Random left roll test ( 1969/ 3000).
      {  0xBF344ABDUL,   84,  0xABDBF344UL  },  // [ 2118] Random left roll test ( 1970/ 3000).
      {  0x5EE33EE9UL,   37,  0xDC67DD2BUL  },  // [ 2119] Random left roll test ( 1971/ 3000).
      {  0xF1BB1CE5UL,   90,  0x97C6EC73UL  },  // [ 2120] Random left roll test ( 1972/ 3000).
      {  0xFED9E19BUL,  244,  0x19BFED9EUL  },  // [ 2121] Random left roll test ( 1973/ 3000).
      {  0x52D34648UL,   99,  0x969A3242UL  },  // [ 2122] Random left roll test ( 1974/ 3000).
      {  0xFCE70ADCUL,  145,  0x15B9F9CEUL  },  // [ 2123] Random left roll test ( 1975/ 3000).
      {  0x8D165635UL,  145,  0xAC6B1A2CUL  },  // [ 2124] Random left roll test ( 1976/ 3000).
      {  0xB01A57DAUL,   33,  0x6034AFB5UL  },  // [ 2125] Random left roll test ( 1977/ 3000).
      {  0x3BC10DF7UL,  168,  0xC10DF73BUL  },  // [ 2126] Random left roll test ( 1978/ 3000).
      {  0xFF4BC745UL,  229,  0xE978E8BFUL  },  // [ 2127] Random left roll test ( 1979/ 3000).
      {  0x5D3B554BUL,  203,  0xDAAA5AE9UL  },  // [ 2128] Random left roll test ( 1980/ 3000).
      {  0x69B21DE6UL,  244,  0xDE669B21UL  },  // [ 2129] Random left roll test ( 1981/ 3000).
      {  0xC3FEBC29UL,  181,  0x85387FD7UL  },  // [ 2130] Random left roll test ( 1982/ 3000).
      {  0xCA79F541UL,   59,  0x0E53CFAAUL  },  // [ 2131] Random left roll test ( 1983/ 3000).
      {  0xA41395BEUL,  105,  0x272B7D48UL  },  // [ 2132] Random left roll test ( 1984/ 3000).
      {  0x10CF7AF3UL,  234,  0x3DEBCC43UL  },  // [ 2133] Random left roll test ( 1985/ 3000).
      {  0x4042DE46UL,  211,  0xF2320216UL  },  // [ 2134] Random left roll test ( 1986/ 3000).
      {  0xE5F9441CUL,   25,  0x39CBF288UL  },  // [ 2135] Random left roll test ( 1987/ 3000).
      {  0xCD7683FBUL,  172,  0x683FBCD7UL  },  // [ 2136] Random left roll test ( 1988/ 3000).
      {  0x53A28DEEUL,   11,  0x146F729DUL  },  // [ 2137] Random left roll test ( 1989/ 3000).
      {  0x2E3DBE0AUL,   42,  0xF6F828B8UL  },  // [ 2138] Random left roll test ( 1990/ 3000).
      {  0x06159057UL,   27,  0xB830AC82UL  },  // [ 2139] Random left roll test ( 1991/ 3000).
      {  0x2121EF74UL,   39,  0x90F7BA10UL  },  // [ 2140] Random left roll test ( 1992/ 3000).
      {  0x9E8F1767UL,   87,  0xB3CF478BUL  },  // [ 2141] Random left roll test ( 1993/ 3000).
      {  0xF8285C24UL,   48,  0x5C24F828UL  },  // [ 2142] Random left roll test ( 1994/ 3000).
      {  0xF03EA209UL,  169,  0x7D4413E0UL  },  // [ 2143] Random left roll test ( 1995/ 3000).
      {  0xCE8633E3UL,  101,  0xD0C67C79UL  },  // [ 2144] Random left roll test ( 1996/ 3000).
      {  0xB40800E8UL,  118,  0x3A2D0200UL  },  // [ 2145] Random left roll test ( 1997/ 3000).
      {  0x1618AD50UL,   17,  0x5AA02C31UL  },  // [ 2146] Random left roll test ( 1998/ 3000).
      {  0x93B8AF05UL,   52,  0xF0593B8AUL  },  // [ 2147] Random left roll test ( 1999/ 3000).
      {  0x27C776ACUL,  248,  0xAC27C776UL  },  // [ 2148] Random left roll test ( 2000/ 3000).
      {  0xE78A4DDAUL,   56,  0xDAE78A4DUL  },  // [ 2149] Random left roll test ( 2001/ 3000).
      {  0x73C8267CUL,  240,  0x267C73C8UL  },  // [ 2150] Random left roll test ( 2002/ 3000).
      {  0xF5A4C337UL,   46,  0x30CDFD69UL  },  // [ 2151] Random left roll test ( 2003/ 3000).
      {  0x5B1AFB0FUL,  254,  0xD6C6BEC3UL  },  // [ 2152] Random left roll test ( 2004/ 3000).
      {  0xA0F42AFAUL,  252,  0xAA0F42AFUL  },  // [ 2153] Random left roll test ( 2005/ 3000).
      {  0xFAFED551UL,   13,  0xDAAA3F5FUL  },  // [ 2154] Random left roll test ( 2006/ 3000).
      {  0x70B63EECUL,  117,  0xDD8E16C7UL  },  // [ 2155] Random left roll test ( 2007/ 3000).
      {  0x174EC0F1UL,   92,  0x1174EC0FUL  },  // [ 2156] Random left roll test ( 2008/ 3000).
      {  0x6F0A6627UL,  191,  0xB7853313UL  },  // [ 2157] Random left roll test ( 2009/ 3000).
      {  0xC0BA470CUL,  228,  0x0BA470CCUL  },  // [ 2158] Random left roll test ( 2010/ 3000).
      {  0x3E888E2BUL,  195,  0xF4447159UL  },  // [ 2159] Random left roll test ( 2011/ 3000).
      {  0xCC89A212UL,   24,  0x12CC89A2UL  },  // [ 2160] Random left roll test ( 2012/ 3000).
      {  0xE2FDE68FUL,  114,  0x9A3F8BF7UL  },  // [ 2161] Random left roll test ( 2013/ 3000).
      {  0x271B8720UL,   46,  0xE1C809C6UL  },  // [ 2162] Random left roll test ( 2014/ 3000).
      {  0x55932976UL,   14,  0xCA5D9564UL  },  // [ 2163] Random left roll test ( 2015/ 3000).
      {  0xD7767DABUL,   42,  0xD9F6AF5DUL  },  // [ 2164] Random left roll test ( 2016/ 3000).
      {  0xBF772491UL,  223,  0xDFBB9248UL  },  // [ 2165] Random left roll test ( 2017/ 3000).
      {  0xC990D3E5UL,   82,  0x4F972643UL  },  // [ 2166] Random left roll test ( 2018/ 3000).
      {  0x14B717C6UL,   33,  0x296E2F8CUL  },  // [ 2167] Random left roll test ( 2019/ 3000).
      {  0xA11C7337UL,  199,  0x8E399BD0UL  },  // [ 2168] Random left roll test ( 2020/ 3000).
      {  0xC9562D29UL,  166,  0x558B4A72UL  },  // [ 2169] Random left roll test ( 2021/ 3000).
      {  0x5E042951UL,  167,  0x0214A8AFUL  },  // [ 2170] Random left roll test ( 2022/ 3000).
      {  0xECEF2DCBUL,  218,  0x2FB3BCB7UL  },  // [ 2171] Random left roll test ( 2023/ 3000).
      {  0x9904F779UL,  200,  0x04F77999UL  },  // [ 2172] Random left roll test ( 2024/ 3000).
      {  0x4E9BE795UL,  215,  0xCAA74DF3UL  },  // [ 2173] Random left roll test ( 2025/ 3000).
      {  0xB702BCECUL,  170,  0x0AF3B2DCUL  },  // [ 2174] Random left roll test ( 2026/ 3000).
      {  0x7422FD68UL,   69,  0x845FAD0EUL  },  // [ 2175] Random left roll test ( 2027/ 3000).
      {  0xAA9C106AUL,  154,  0xAAAA7041UL  },  // [ 2176] Random left roll test ( 2028/ 3000).
      {  0x1F23EFA5UL,  221,  0xA3E47DF4UL  },  // [ 2177] Random left roll test ( 2029/ 3000).
      {  0x223C72DBUL,  254,  0xC88F1CB6UL  },  // [ 2178] Random left roll test ( 2030/ 3000).
      {  0x018A7FA2UL,  200,  0x8A7FA201UL  },  // [ 2179] Random left roll test ( 2031/ 3000).
      {  0xF7769DC3UL,   27,  0x1FBBB4EEUL  },  // [ 2180] Random left roll test ( 2032/ 3000).
      {  0xBB76B4ACUL,  133,  0x6ED69597UL  },  // [ 2181] Random left roll test ( 2033/ 3000).
      {  0x1ACA3D43UL,  208,  0x3D431ACAUL  },  // [ 2182] Random left roll test ( 2034/ 3000).
      {  0x5BCFB3ACUL,  151,  0xD62DE7D9UL  },  // [ 2183] Random left roll test ( 2035/ 3000).
      {  0x71D5763CUL,  109,  0xAEC78E3AUL  },  // [ 2184] Random left roll test ( 2036/ 3000).
      {  0x3D8A9159UL,   79,  0x48AC9EC5UL  },  // [ 2185] Random left roll test ( 2037/ 3000).
      {  0xC12E92CEUL,  218,  0x3B04BA4BUL  },  // [ 2186] Random left roll test ( 2038/ 3000).
      {  0x3C3E7477UL,    5,  0x87CE8EE7UL  },  // [ 2187] Random left roll test ( 2039/ 3000).
      {  0x4483C51FUL,  177,  0x8A3E8907UL  },  // [ 2188] Random left roll test ( 2040/ 3000).
      {  0xF297FC16UL,   70,  0xA5FF05BCUL  },  // [ 2189] Random left roll test ( 2041/ 3000).
      {  0x785595CDUL,   41,  0xAB2B9AF0UL  },  // [ 2190] Random left roll test ( 2042/ 3000).
      {  0xB8B4246EUL,  199,  0x5A12375CUL  },  // [ 2191] Random left roll test ( 2043/ 3000).
      {  0x4628EF33UL,  241,  0xDE668C51UL  },  // [ 2192] Random left roll test ( 2044/ 3000).
      {  0x9666952BUL,  178,  0x54AE599AUL  },  // [ 2193] Random left roll test ( 2045/ 3000).
      {  0x6651D879UL,   16,  0xD8796651UL  },  // [ 2194] Random left roll test ( 2046/ 3000).
      {  0xF2EF62D6UL,  109,  0xEC5ADE5DUL  },  // [ 2195] Random left roll test ( 2047/ 3000).
      {  0x6E7387CBUL,   46,  0xE1F2DB9CUL  },  // [ 2196] Random left roll test ( 2048/ 3000).
      {  0x66143B83UL,  245,  0x706CC287UL  },  // [ 2197] Random left roll test ( 2049/ 3000).
      {  0xDD528019UL,  225,  0xBAA50033UL  },  // [ 2198] Random left roll test ( 2050/ 3000).
      {  0xC6157D9DUL,  155,  0xEE30ABECUL  },  // [ 2199] Random left roll test ( 2051/ 3000).
      {  0x82B6F11CUL,  232,  0xB6F11C82UL  },  // [ 2200] Random left roll test ( 2052/ 3000).
      {  0x7349DD82UL,  202,  0x277609CDUL  },  // [ 2201] Random left roll test ( 2053/ 3000).
      {  0xE2054708UL,  171,  0x2A384710UL  },  // [ 2202] Random left roll test ( 2054/ 3000).
      {  0x6F350BABUL,  207,  0x85D5B79AUL  },  // [ 2203] Random left roll test ( 2055/ 3000).
      {  0xEB632C21UL,  153,  0x43D6C658UL  },  // [ 2204] Random left roll test ( 2056/ 3000).
      {  0x1660AEDAUL,  255,  0x0B30576DUL  },  // [ 2205] Random left roll test ( 2057/ 3000).
      {  0x763E36B3UL,   62,  0xDD8F8DACUL  },  // [ 2206] Random left roll test ( 2058/ 3000).
      {  0x50427F20UL,   74,  0x09FC8141UL  },  // [ 2207] Random left roll test ( 2059/ 3000).
      {  0x42AD688BUL,  229,  0x55AD1168UL  },  // [ 2208] Random left roll test ( 2060/ 3000).
      {  0x562C6E2CUL,  170,  0xB1B8B158UL  },  // [ 2209] Random left roll test ( 2061/ 3000).
      {  0xA602BCDAUL,  121,  0xB54C0579UL  },  // [ 2210] Random left roll test ( 2062/ 3000).
      {  0x20503DA9UL,  251,  0x490281EDUL  },  // [ 2211] Random left roll test ( 2063/ 3000).
      {  0x5BDDEC36UL,  140,  0xDEC365BDUL  },  // [ 2212] Random left roll test ( 2064/ 3000).
      {  0x4200D8D8UL,  238,  0x36361080UL  },  // [ 2213] Random left roll test ( 2065/ 3000).
      {  0xC1E90D44UL,   16,  0x0D44C1E9UL  },  // [ 2214] Random left roll test ( 2066/ 3000).
      {  0x31243A6EUL,  189,  0xC624874DUL  },  // [ 2215] Random left roll test ( 2067/ 3000).
      {  0xF01D66EBUL,  154,  0xAFC0759BUL  },  // [ 2216] Random left roll test ( 2068/ 3000).
      {  0xDCA59BB1UL,   16,  0x9BB1DCA5UL  },  // [ 2217] Random left roll test ( 2069/ 3000).
      {  0x888743CAUL,   36,  0x88743CA8UL  },  // [ 2218] Random left roll test ( 2070/ 3000).
      {  0x7ACA51AFUL,   99,  0xD6528D7BUL  },  // [ 2219] Random left roll test ( 2071/ 3000).
      {  0xF0084884UL,   46,  0x12213C02UL  },  // [ 2220] Random left roll test ( 2072/ 3000).
      {  0xC57691FBUL,  191,  0xE2BB48FDUL  },  // [ 2221] Random left roll test ( 2073/ 3000).
      {  0x08A4525EUL,   38,  0x29149782UL  },  // [ 2222] Random left roll test ( 2074/ 3000).
      {  0xEBCB134EUL,  103,  0xE589A775UL  },  // [ 2223] Random left roll test ( 2075/ 3000).
      {  0x1008A7E2UL,  140,  0x8A7E2100UL  },  // [ 2224] Random left roll test ( 2076/ 3000).
      {  0x7BFC3976UL,  167,  0xFE1CBB3DUL  },  // [ 2225] Random left roll test ( 2077/ 3000).
      {  0x05659979UL,  102,  0x59665E41UL  },  // [ 2226] Random left roll test ( 2078/ 3000).
      {  0xE6E8298FUL,  113,  0x531FCDD0UL  },  // [ 2227] Random left roll test ( 2079/ 3000).
      {  0x712D6413UL,  216,  0x13712D64UL  },  // [ 2228] Random left roll test ( 2080/ 3000).
      {  0xDCC5E46CUL,  201,  0x8BC8D9B9UL  },  // [ 2229] Random left roll test ( 2081/ 3000).
      {  0x7FB95BD6UL,   35,  0xFDCADEB3UL  },  // [ 2230] Random left roll test ( 2082/ 3000).
      {  0x8CB58DACUL,  154,  0xB232D636UL  },  // [ 2231] Random left roll test ( 2083/ 3000).
      {  0x4BF2D75DUL,  183,  0xAEA5F96BUL  },  // [ 2232] Random left roll test ( 2084/ 3000).
      {  0xBBABAD5CUL,  204,  0xBAD5CBBAUL  },  // [ 2233] Random left roll test ( 2085/ 3000).
      {  0x1C10C7E2UL,   47,  0x63F10E08UL  },  // [ 2234] Random left roll test ( 2086/ 3000).
      {  0x383F2EE4UL,  252,  0x4383F2EEUL  },  // [ 2235] Random left roll test ( 2087/ 3000).
      {  0x420EF0E1UL,   76,  0xEF0E1420UL  },  // [ 2236] Random left roll test ( 2088/ 3000).
      {  0x419EFCD8UL,   77,  0xDF9B0833UL  },  // [ 2237] Random left roll test ( 2089/ 3000).
      {  0xDF80B5F3UL,  216,  0xF3DF80B5UL  },  // [ 2238] Random left roll test ( 2090/ 3000).
      {  0x634F708CUL,  172,  0xF708C634UL  },  // [ 2239] Random left roll test ( 2091/ 3000).
      {  0xD494AC7DUL,  242,  0xB1F75252UL  },  // [ 2240] Random left roll test ( 2092/ 3000).
      {  0x397A9E42UL,  196,  0x97A9E423UL  },  // [ 2241] Random left roll test ( 2093/ 3000).
      {  0xCE63337EUL,  168,  0x63337ECEUL  },  // [ 2242] Random left roll test ( 2094/ 3000).
      {  0xA4B343DEUL,  187,  0xF5259A1EUL  },  // [ 2243] Random left roll test ( 2095/ 3000).
      {  0xB1008120UL,  180,  0x120B1008UL  },  // [ 2244] Random left roll test ( 2096/ 3000).
      {  0x954DAFC3UL,   86,  0xF0E5536BUL  },  // [ 2245] Random left roll test ( 2097/ 3000).
      {  0xAD116BEAUL,  214,  0xFAAB445AUL  },  // [ 2246] Random left roll test ( 2098/ 3000).
      {  0x6150B82BUL,   89,  0x56C2A170UL  },  // [ 2247] Random left roll test ( 2099/ 3000).
      {  0x9AD0B5FBUL,  129,  0x35A16BF7UL  },  // [ 2248] Random left roll test ( 2100/ 3000).
      {  0xC5F26E46UL,    6,  0x7C9B91B1UL  },  // [ 2249] Random left roll test ( 2101/ 3000).
      {  0xD134220FUL,  174,  0x0883F44DUL  },  // [ 2250] Random left roll test ( 2102/ 3000).
      {  0xE02A3EC6UL,  151,  0x6370151FUL  },  // [ 2251] Random left roll test ( 2103/ 3000).
      {  0xD0BB2084UL,  151,  0x42685D90UL  },  // [ 2252] Random left roll test ( 2104/ 3000).
      {  0x6464D80FUL,  229,  0x8C9B01ECUL  },  // [ 2253] Random left roll test ( 2105/ 3000).
      {  0xF049661DUL,  148,  0x61DF0496UL  },  // [ 2254] Random left roll test ( 2106/ 3000).
      {  0x0A462631UL,  104,  0x4626310AUL  },  // [ 2255] Random left roll test ( 2107/ 3000).
      {  0xD3C3BD5CUL,   90,  0x734F0EF5UL  },  // [ 2256] Random left roll test ( 2108/ 3000).
      {  0x20AFE147UL,  106,  0xBF851C82UL  },  // [ 2257] Random left roll test ( 2109/ 3000).
      {  0x1369D257UL,  233,  0xD3A4AE26UL  },  // [ 2258] Random left roll test ( 2110/ 3000).
      {  0xE38247D2UL,  170,  0x091F4B8EUL  },  // [ 2259] Random left roll test ( 2111/ 3000).
      {  0xF6F676B5UL,  105,  0xECED6BEDUL  },  // [ 2260] Random left roll test ( 2112/ 3000).
      {  0x181579DDUL,  239,  0xBCEE8C0AUL  },  // [ 2261] Random left roll test ( 2113/ 3000).
      {  0x1A31CEF8UL,  151,  0x7C0D18E7UL  },  // [ 2262] Random left roll test ( 2114/ 3000).
      {  0xF2B5DAD9UL,   13,  0xBB5B3E56UL  },  // [ 2263] Random left roll test ( 2115/ 3000).
      {  0x11B83A5AUL,   69,  0x37074B42UL  },  // [ 2264] Random left roll test ( 2116/ 3000).
      {  0x0CAF4329UL,  228,  0xCAF43290UL  },  // [ 2265] Random left roll test ( 2117/ 3000).
      {  0x1661C279UL,    1,  0x2CC384F2UL  },  // [ 2266] Random left roll test ( 2118/ 3000).
      {  0x886ADC59UL,   26,  0x6621AB71UL  },  // [ 2267] Random left roll test ( 2119/ 3000).
      {  0x4EC60DD4UL,   80,  0x0DD44EC6UL  },  // [ 2268] Random left roll test ( 2120/ 3000).
      {  0x55481D73UL,  219,  0x9AAA40EBUL  },  // [ 2269] Random left roll test ( 2121/ 3000).
      {  0x45EBD204UL,  173,  0x7A4088BDUL  },  // [ 2270] Random left roll test ( 2122/ 3000).
      {  0x428745CBUL,  170,  0x1D172D0AUL  },  // [ 2271] Random left roll test ( 2123/ 3000).
      {  0xF226143FUL,   92,  0xFF226143UL  },  // [ 2272] Random left roll test ( 2124/ 3000).
      {  0x3A8DAE7DUL,   21,  0xCFA751B5UL  },  // [ 2273] Random left roll test ( 2125/ 3000).
      {  0xC2D43606UL,   47,  0x1B03616AUL  },  // [ 2274] Random left roll test ( 2126/ 3000).
      {  0xBC067826UL,   49,  0xF04D780CUL  },  // [ 2275] Random left roll test ( 2127/ 3000).
      {  0x6B95F8E9UL,  155,  0x4B5CAFC7UL  },  // [ 2276] Random left roll test ( 2128/ 3000).
      {  0x99B44207UL,  166,  0x6D1081E6UL  },  // [ 2277] Random left roll test ( 2129/ 3000).
      {  0x1DC41B60UL,  184,  0x601DC41BUL  },  // [ 2278] Random left roll test ( 2130/ 3000).
      {  0xE2BD4487UL,   29,  0xFC57A890UL  },  // [ 2279] Random left roll test ( 2131/ 3000).
      {  0x9513D637UL,  241,  0xAC6F2A27UL  },  // [ 2280] Random left roll test ( 2132/ 3000).
      {  0x59FDCFE0UL,  244,  0xFE059FDCUL  },  // [ 2281] Random left roll test ( 2133/ 3000).
      {  0xC636A7D8UL,  230,  0x8DA9F631UL  },  // [ 2282] Random left roll test ( 2134/ 3000).
      {  0x8FE92E9DUL,  198,  0xFA4BA763UL  },  // [ 2283] Random left roll test ( 2135/ 3000).
      {  0x586A1C06UL,   88,  0x06586A1CUL  },  // [ 2284] Random left roll test ( 2136/ 3000).
      {  0x250BDD2FUL,   11,  0x5EE97928UL  },  // [ 2285] Random left roll test ( 2137/ 3000).
      {  0xF2BA4F16UL,  136,  0xBA4F16F2UL  },  // [ 2286] Random left roll test ( 2138/ 3000).
      {  0xA7900F87UL,  117,  0xF0F4F201UL  },  // [ 2287] Random left roll test ( 2139/ 3000).
      {  0x4AF4B8E2UL,  122,  0x892BD2E3UL  },  // [ 2288] Random left roll test ( 2140/ 3000).
      {  0x730C4BC1UL,   40,  0x0C4BC173UL  },  // [ 2289] Random left roll test ( 2141/ 3000).
      {  0x9D629227UL,  136,  0x6292279DUL  },  // [ 2290] Random left roll test ( 2142/ 3000).
      {  0xE4CF3028UL,   20,  0x028E4CF3UL  },  // [ 2291] Random left roll test ( 2143/ 3000).
      {  0x4107447EUL,  250,  0xF9041D11UL  },  // [ 2292] Random left roll test ( 2144/ 3000).
      {  0x3FE48E71UL,  101,  0xFC91CE27UL  },  // [ 2293] Random left roll test ( 2145/ 3000).
      {  0x85FA9C96UL,  112,  0x9C9685FAUL  },  // [ 2294] Random left roll test ( 2146/ 3000).
      {  0xD542B852UL,   79,  0x5C296AA1UL  },  // [ 2295] Random left roll test ( 2147/ 3000).
      {  0xB06CE149UL,   34,  0xC1B38526UL  },  // [ 2296] Random left roll test ( 2148/ 3000).
      {  0x0BCC9008UL,  200,  0xCC90080BUL  },  // [ 2297] Random left roll test ( 2149/ 3000).
      {  0x86C19D0EUL,  119,  0x874360CEUL  },  // [ 2298] Random left roll test ( 2150/ 3000).
      {  0x40B4435BUL,  239,  0x21ADA05AUL  },  // [ 2299] Random left roll test ( 2151/ 3000).
      {  0x4ECB1ADBUL,  111,  0x8D6DA765UL  },  // [ 2300] Random left roll test ( 2152/ 3000).
      {  0xB5B1582BUL,   17,  0xB0576B62UL  },  // [ 2301] Random left roll test ( 2153/ 3000).
      {  0x0367A02DUL,   45,  0xF405A06CUL  },  // [ 2302] Random left roll test ( 2154/ 3000).
      {  0xFA097E88UL,  156,  0x8FA097E8UL  },  // [ 2303] Random left roll test ( 2155/ 3000).
      {  0xBAED16BDUL,  202,  0xB45AF6EBUL  },  // [ 2304] Random left roll test ( 2156/ 3000).
      {  0x9F518C38UL,   58,  0xE27D4630UL  },  // [ 2305] Random left roll test ( 2157/ 3000).
      {  0xEFBEBD5AUL,   47,  0x5EAD77DFUL  },  // [ 2306] Random left roll test ( 2158/ 3000).
      {  0xFAE48CDFUL,  204,  0x48CDFFAEUL  },  // [ 2307] Random left roll test ( 2159/ 3000).
      {  0xEBE70739UL,  157,  0x3D7CE0E7UL  },  // [ 2308] Random left roll test ( 2160/ 3000).
      {  0x3CBDB2D8UL,  240,  0xB2D83CBDUL  },  // [ 2309] Random left roll test ( 2161/ 3000).
      {  0x052DB96BUL,  145,  0x72D60A5BUL  },  // [ 2310] Random left roll test ( 2162/ 3000).
      {  0x78964B7BUL,  122,  0xEDE2592DUL  },  // [ 2311] Random left roll test ( 2163/ 3000).
      {  0x213E2223UL,   89,  0x46427C44UL  },  // [ 2312] Random left roll test ( 2164/ 3000).
      {  0x2D0CEC43UL,  143,  0x76219686UL  },  // [ 2313] Random left roll test ( 2165/ 3000).
      {  0x45420FC4UL,  152,  0xC445420FUL  },  // [ 2314] Random left roll test ( 2166/ 3000).
      {  0x52100241UL,  129,  0xA4200482UL  },  // [ 2315] Random left roll test ( 2167/ 3000).
      {  0xC9BAE3DFUL,  242,  0x8F7F26EBUL  },  // [ 2316] Random left roll test ( 2168/ 3000).
      {  0xE23762F0UL,   23,  0x78711BB1UL  },  // [ 2317] Random left roll test ( 2169/ 3000).
      {  0x13FA5C36UL,  213,  0x86C27F4BUL  },  // [ 2318] Random left roll test ( 2170/ 3000).
      {  0xE4EAADC0UL,   19,  0x6E072755UL  },  // [ 2319] Random left roll test ( 2171/ 3000).
      {  0xED8619B8UL,  203,  0x30CDC76CUL  },  // [ 2320] Random left roll test ( 2172/ 3000).
      {  0x5C9CF44FUL,  141,  0x9E89EB93UL  },  // [ 2321] Random left roll test ( 2173/ 3000).
      {  0xE2AF75A0UL,  243,  0xAD07157BUL  },  // [ 2322] Random left roll test ( 2174/ 3000).
      {  0x62D27D1AUL,  233,  0xA4FA34C5UL  },  // [ 2323] Random left roll test ( 2175/ 3000).
      {  0x43610551UL,   38,  0xD8415450UL  },  // [ 2324] Random left roll test ( 2176/ 3000).
      {  0x409DA8E9UL,  123,  0x4A04ED47UL  },  // [ 2325] Random left roll test ( 2177/ 3000).
      {  0x8A73622AUL,  186,  0xAA29CD88UL  },  // [ 2326] Random left roll test ( 2178/ 3000).
      {  0x90C72DC1UL,  194,  0x431CB706UL  },  // [ 2327] Random left roll test ( 2179/ 3000).
      {  0xCE2C14E8UL,  106,  0xB053A338UL  },  // [ 2328] Random left roll test ( 2180/ 3000).
      {  0x77B2BC30UL,  230,  0xECAF0C1DUL  },  // [ 2329] Random left roll test ( 2181/ 3000).
      {  0x049C6C35UL,  232,  0x9C6C3504UL  },  // [ 2330] Random left roll test ( 2182/ 3000).
      {  0x2B2ECECAUL,  109,  0xD9D94565UL  },  // [ 2331] Random left roll test ( 2183/ 3000).
      {  0xCD2E3E5CUL,  106,  0xB8F97334UL  },  // [ 2332] Random left roll test ( 2184/ 3000).
      {  0xF79ECF83UL,  219,  0x1FBCF67CUL  },  // [ 2333] Random left roll test ( 2185/ 3000).
      {  0x259F980AUL,   92,  0xA259F980UL  },  // [ 2334] Random left roll test ( 2186/ 3000).
      {  0xDCF2DB17UL,   42,  0xCB6C5F73UL  },  // [ 2335] Random left roll test ( 2187/ 3000).
      {  0xCDB82308UL,  184,  0x08CDB823UL  },  // [ 2336] Random left roll test ( 2188/ 3000).
      {  0x5CFF4643UL,   96,  0x5CFF4643UL  },  // [ 2337] Random left roll test ( 2189/ 3000).
      {  0x540FB30AUL,   73,  0x1F6614A8UL  },  // [ 2338] Random left roll test ( 2190/ 3000).
      {  0x33A2226DUL,   10,  0x8889B4CEUL  },  // [ 2339] Random left roll test ( 2191/ 3000).
      {  0xF6641D9EUL,  251,  0xF7B320ECUL  },  // [ 2340] Random left roll test ( 2192/ 3000).
      {  0xD3CBA6D7UL,  124,  0x7D3CBA6DUL  },  // [ 2341] Random left roll test ( 2193/ 3000).
      {  0x896588CDUL,  166,  0x59623362UL  },  // [ 2342] Random left roll test ( 2194/ 3000).
      {  0xFCBFC557UL,  143,  0xE2ABFE5FUL  },  // [ 2343] Random left roll test ( 2195/ 3000).
      {  0xDB61A382UL,  119,  0xC16DB0D1UL  },  // [ 2344] Random left roll test ( 2196/ 3000).
      {  0xECAD43D3UL,  155,  0x9F656A1EUL  },  // [ 2345] Random left roll test ( 2197/ 3000).
      {  0x64AA7F03UL,   95,  0xB2553F81UL  },  // [ 2346] Random left roll test ( 2198/ 3000).
      {  0x145606D1UL,   84,  0x6D114560UL  },  // [ 2347] Random left roll test ( 2199/ 3000).
      {  0xDE1B9AA8UL,  121,  0x51BC3735UL  },  // [ 2348] Random left roll test ( 2200/ 3000).
      {  0x10A04328UL,  101,  0x14086502UL  },  // [ 2349] Random left roll test ( 2201/ 3000).
      {  0x6E425D5AUL,   34,  0xB9097569UL  },  // [ 2350] Random left roll test ( 2202/ 3000).
      {  0xF05CE2EBUL,    7,  0x2E7175F8UL  },  // [ 2351] Random left roll test ( 2203/ 3000).
      {  0x600EB60CUL,  159,  0x30075B06UL  },  // [ 2352] Random left roll test ( 2204/ 3000).
      {  0x54BBD5DDUL,   48,  0xD5DD54BBUL  },  // [ 2353] Random left roll test ( 2205/ 3000).
      {  0x772727C8UL,  100,  0x72727C87UL  },  // [ 2354] Random left roll test ( 2206/ 3000).
      {  0xD2A6DEE7UL,  247,  0x73E9536FUL  },  // [ 2355] Random left roll test ( 2207/ 3000).
      {  0x9D92954FUL,  177,  0x2A9F3B25UL  },  // [ 2356] Random left roll test ( 2208/ 3000).
      {  0xD1D93280UL,  253,  0x1A3B2650UL  },  // [ 2357] Random left roll test ( 2209/ 3000).
      {  0xD89BD5D3UL,  232,  0x9BD5D3D8UL  },  // [ 2358] Random left roll test ( 2210/ 3000).
      {  0xA3A7EDA5UL,  204,  0x7EDA5A3AUL  },  // [ 2359] Random left roll test ( 2211/ 3000).
      {  0x06ED4E19UL,  199,  0x76A70C83UL  },  // [ 2360] Random left roll test ( 2212/ 3000).
      {  0xA846858AUL,  237,  0xD0B15508UL  },  // [ 2361] Random left roll test ( 2213/ 3000).
      {  0x862591DCUL,  245,  0x3B90C4B2UL  },  // [ 2362] Random left roll test ( 2214/ 3000).
      {  0xD707ACB0UL,   50,  0xB2C35C1EUL  },  // [ 2363] Random left roll test ( 2215/ 3000).
      {  0xA2CCB5DAUL,  193,  0x45996BB5UL  },  // [ 2364] Random left roll test ( 2216/ 3000).
      {  0x80C2AA09UL,   32,  0x80C2AA09UL  },  // [ 2365] Random left roll test ( 2217/ 3000).
      {  0x94B41913UL,   95,  0xCA5A0C89UL  },  // [ 2366] Random left roll test ( 2218/ 3000).
      {  0x5F79F35AUL,  136,  0x79F35A5FUL  },  // [ 2367] Random left roll test ( 2219/ 3000).
      {  0x60D81E1AUL,  152,  0x1A60D81EUL  },  // [ 2368] Random left roll test ( 2220/ 3000).
      {  0xA23183AEUL,   77,  0x3075D446UL  },  // [ 2369] Random left roll test ( 2221/ 3000).
      {  0xD6DF5456UL,  107,  0xFAA2B6B6UL  },  // [ 2370] Random left roll test ( 2222/ 3000).
      {  0x8A88B6D7UL,  193,  0x15116DAFUL  },  // [ 2371] Random left roll test ( 2223/ 3000).
      {  0xA355BDF7UL,  180,  0xDF7A355BUL  },  // [ 2372] Random left roll test ( 2224/ 3000).
      {  0xA7A83727UL,  188,  0x7A7A8372UL  },  // [ 2373] Random left roll test ( 2225/ 3000).
      {  0x39CEF9A1UL,  150,  0x684E73BEUL  },  // [ 2374] Random left roll test ( 2226/ 3000).
      {  0xD067C685UL,  211,  0x342E833EUL  },  // [ 2375] Random left roll test ( 2227/ 3000).
      {  0x3495DCDCUL,  160,  0x3495DCDCUL  },  // [ 2376] Random left roll test ( 2228/ 3000).
      {  0xAC9BD7C8UL,  221,  0x15937AF9UL  },  // [ 2377] Random left roll test ( 2229/ 3000).
      {  0xFE8BC4B8UL,  114,  0x12E3FA2FUL  },  // [ 2378] Random left roll test ( 2230/ 3000).
      {  0xAD2546E0UL,  188,  0x0AD2546EUL  },  // [ 2379] Random left roll test ( 2231/ 3000).
      {  0x2ED53B81UL,   90,  0x04BB54EEUL  },  // [ 2380] Random left roll test ( 2232/ 3000).
      {  0xC1028876UL,  254,  0xB040A21DUL  },  // [ 2381] Random left roll test ( 2233/ 3000).
      {  0x1837E25EUL,  129,  0x306FC4BCUL  },  // [ 2382] Random left roll test ( 2234/ 3000).
      {  0xF8627178UL,  135,  0x3138BC7CUL  },  // [ 2383] Random left roll test ( 2235/ 3000).
      {  0xB5E90143UL,   41,  0xD202876BUL  },  // [ 2384] Random left roll test ( 2236/ 3000).
      {  0x209EF0CDUL,  119,  0x66904F78UL  },  // [ 2385] Random left roll test ( 2237/ 3000).
      {  0xFB244B56UL,  238,  0x12D5BEC9UL  },  // [ 2386] Random left roll test ( 2238/ 3000).
      {  0x9BFCBFADUL,  253,  0xB37F97F5UL  },  // [ 2387] Random left roll test ( 2239/ 3000).
      {  0xA449E415UL,  179,  0x20AD224FUL  },  // [ 2388] Random left roll test ( 2240/ 3000).
      {  0xB28543D1UL,   58,  0x46CA150FUL  },  // [ 2389] Random left roll test ( 2241/ 3000).
      {  0x0D8AE6E3UL,   27,  0x186C5737UL  },  // [ 2390] Random left roll test ( 2242/ 3000).
      {  0x0ED564DEUL,  240,  0x64DE0ED5UL  },  // [ 2391] Random left roll test ( 2243/ 3000).
      {  0x356E33C8UL,   40,  0x6E33C835UL  },  // [ 2392] Random left roll test ( 2244/ 3000).
      {  0x9B7DB908UL,   18,  0xE4226DF6UL  },  // [ 2393] Random left roll test ( 2245/ 3000).
      {  0x194733ADUL,  135,  0xA399D68CUL  },  // [ 2394] Random left roll test ( 2246/ 3000).
      {  0x5C6A6396UL,   42,  0xA98E5971UL  },  // [ 2395] Random left roll test ( 2247/ 3000).
      {  0x121F1245UL,  221,  0xA243E248UL  },  // [ 2396] Random left roll test ( 2248/ 3000).
      {  0x526766E1UL,   13,  0xECDC2A4CUL  },  // [ 2397] Random left roll test ( 2249/ 3000).
      {  0xF8916B4CUL,   84,  0xB4CF8916UL  },  // [ 2398] Random left roll test ( 2250/ 3000).
      {  0x02207438UL,  140,  0x07438022UL  },  // [ 2399] Random left roll test ( 2251/ 3000).
      {  0xED24F116UL,   38,  0x493C45BBUL  },  // [ 2400] Random left roll test ( 2252/ 3000).
      {  0xF145CC7AUL,  244,  0xC7AF145CUL  },  // [ 2401] Random left roll test ( 2253/ 3000).
      {  0x087F798AUL,  177,  0xF31410FEUL  },  // [ 2402] Random left roll test ( 2254/ 3000).
      {  0x2C4E6EC7UL,   86,  0xB1CB139BUL  },  // [ 2403] Random left roll test ( 2255/ 3000).
      {  0x34D5BB1CUL,   53,  0x63869AB7UL  },  // [ 2404] Random left roll test ( 2256/ 3000).
      {  0x76CDDA46UL,  113,  0xB48CED9BUL  },  // [ 2405] Random left roll test ( 2257/ 3000).
      {  0xAA887759UL,  107,  0x43BACD54UL  },  // [ 2406] Random left roll test ( 2258/ 3000).
      {  0x5B12EEA8UL,  125,  0x0B625DD5UL  },  // [ 2407] Random left roll test ( 2259/ 3000).
      {  0xB2C436A0UL,   91,  0x059621B5UL  },  // [ 2408] Random left roll test ( 2260/ 3000).
      {  0xD189BF9DUL,  116,  0xF9DD189BUL  },  // [ 2409] Random left roll test ( 2261/ 3000).
      {  0x54AD0658UL,  175,  0x832C2A56UL  },  // [ 2410] Random left roll test ( 2262/ 3000).
      {  0x64F9E7CBUL,  195,  0x27CF3E5BUL  },  // [ 2411] Random left roll test ( 2263/ 3000).
      {  0x93B1A5B5UL,   51,  0x2DAC9D8DUL  },  // [ 2412] Random left roll test ( 2264/ 3000).
      {  0x86EB01CFUL,  167,  0x7580E7C3UL  },  // [ 2413] Random left roll test ( 2265/ 3000).
      {  0xFD9E6B9BUL,  160,  0xFD9E6B9BUL  },  // [ 2414] Random left roll test ( 2266/ 3000).
      {  0xCDD3D6BDUL,  238,  0xF5AF7374UL  },  // [ 2415] Random left roll test ( 2267/ 3000).
      {  0x4C465E60UL,  194,  0x31197981UL  },  // [ 2416] Random left roll test ( 2268/ 3000).
      {  0x7A8ED53DUL,  149,  0xA7AF51DAUL  },  // [ 2417] Random left roll test ( 2269/ 3000).
      {  0x77266490UL,  172,  0x66490772UL  },  // [ 2418] Random left roll test ( 2270/ 3000).
      {  0xB30349AAUL,  110,  0xD26AACC0UL  },  // [ 2419] Random left roll test ( 2271/ 3000).
      {  0xC561567BUL,  242,  0x59EF1585UL  },  // [ 2420] Random left roll test ( 2272/ 3000).
      {  0x644C1FCBUL,  183,  0xE5B2260FUL  },  // [ 2421] Random left roll test ( 2273/ 3000).
      {  0xCA7FC682UL,  145,  0x8D0594FFUL  },  // [ 2422] Random left roll test ( 2274/ 3000).
      {  0x15DBC7BAUL,  191,  0x0AEDE3DDUL  },  // [ 2423] Random left roll test ( 2275/ 3000).
      {  0xA6CAA7A0UL,   66,  0x9B2A9E82UL  },  // [ 2424] Random left roll test ( 2276/ 3000).
      {  0x1034C0FFUL,  166,  0x0D303FC4UL  },  // [ 2425] Random left roll test ( 2277/ 3000).
      {  0xD9C8940AUL,  194,  0x6722502BUL  },  // [ 2426] Random left roll test ( 2278/ 3000).
      {  0x626106BFUL,  163,  0x130835FBUL  },  // [ 2427] Random left roll test ( 2279/ 3000).
      {  0xE8F868AAUL,  244,  0x8AAE8F86UL  },  // [ 2428] Random left roll test ( 2280/ 3000).
      {  0x093EA20EUL,  117,  0x41C127D4UL  },  // [ 2429] Random left roll test ( 2281/ 3000).
      {  0x8D9B19D9UL,  180,  0x9D98D9B1UL  },  // [ 2430] Random left roll test ( 2282/ 3000).
      {  0xA1C3ADFCUL,   80,  0xADFCA1C3UL  },  // [ 2431] Random left roll test ( 2283/ 3000).
      {  0x59C5AFBBUL,   10,  0x16BEED67UL  },  // [ 2432] Random left roll test ( 2284/ 3000).
      {  0xDB2181A6UL,   36,  0xB2181A6DUL  },  // [ 2433] Random left roll test ( 2285/ 3000).
      {  0x806A68DDUL,  238,  0x9A37601AUL  },  // [ 2434] Random left roll test ( 2286/ 3000).
      {  0x35DB845BUL,   57,  0xB66BB708UL  },  // [ 2435] Random left roll test ( 2287/ 3000).
      {  0xD3BF6286UL,  204,  0xF6286D3BUL  },  // [ 2436] Random left roll test ( 2288/ 3000).
      {  0x6C7D212FUL,   72,  0x7D212F6CUL  },  // [ 2437] Random left roll test ( 2289/ 3000).
      {  0xF5190032UL,  159,  0x7A8C8019UL  },  // [ 2438] Random left roll test ( 2290/ 3000).
      {  0xD4FA7C27UL,  116,  0xC27D4FA7UL  },  // [ 2439] Random left roll test ( 2291/ 3000).
      {  0xE1D7B01BUL,   29,  0x7C3AF603UL  },  // [ 2440] Random left roll test ( 2292/ 3000).
      {  0x2C946918UL,   90,  0x60B251A4UL  },  // [ 2441] Random left roll test ( 2293/ 3000).
      {  0xFEBD3D33UL,  198,  0xAF4F4CFFUL  },  // [ 2442] Random left roll test ( 2294/ 3000).
      {  0x181ED45CUL,   53,  0x8B8303DAUL  },  // [ 2443] Random left roll test ( 2295/ 3000).
      {  0x3E2D0CC4UL,    8,  0x2D0CC43EUL  },  // [ 2444] Random left roll test ( 2296/ 3000).
      {  0xAA1635DFUL,   11,  0xB1AEFD50UL  },  // [ 2445] Random left roll test ( 2297/ 3000).
      {  0x469B6D78UL,   78,  0xDB5E11A6UL  },  // [ 2446] Random left roll test ( 2298/ 3000).
      {  0x1A73DBBFUL,   15,  0xEDDF8D39UL  },  // [ 2447] Random left roll test ( 2299/ 3000).
      {  0x53222C73UL,  124,  0x353222C7UL  },  // [ 2448] Random left roll test ( 2300/ 3000).
      {  0x93B6F26EUL,  180,  0x26E93B6FUL  },  // [ 2449] Random left roll test ( 2301/ 3000).
      {  0x1AAA51D1UL,  249,  0xA23554A3UL  },  // [ 2450] Random left roll test ( 2302/ 3000).
      {  0x2D32F8EFUL,  122,  0xBCB4CBE3UL  },  // [ 2451] Random left roll test ( 2303/ 3000).
      {  0x4CE045E2UL,  199,  0x7022F126UL  },  // [ 2452] Random left roll test ( 2304/ 3000).
      {  0x059C6792UL,  116,  0x792059C6UL  },  // [ 2453] Random left roll test ( 2305/ 3000).
      {  0x881E545EUL,   47,  0x2A2F440FUL  },  // [ 2454] Random left roll test ( 2306/ 3000).
      {  0x52B5EB6BUL,   98,  0x4AD7ADADUL  },  // [ 2455] Random left roll test ( 2307/ 3000).
      {  0xBDEE953BUL,  102,  0x7BA54EEFUL  },  // [ 2456] Random left roll test ( 2308/ 3000).
      {  0x9EB943A4UL,   26,  0x927AE50EUL  },  // [ 2457] Random left roll test ( 2309/ 3000).
      {  0x879D811BUL,   48,  0x811B879DUL  },  // [ 2458] Random left roll test ( 2310/ 3000).
      {  0x97684096UL,  112,  0x40969768UL  },  // [ 2459] Random left roll test ( 2311/ 3000).
      {  0x51C0824DUL,  155,  0x6A8E0412UL  },  // [ 2460] Random left roll test ( 2312/ 3000).
      {  0x2A675243UL,   23,  0x219533A9UL  },  // [ 2461] Random left roll test ( 2313/ 3000).
      {  0x98A65888UL,   58,  0x22629962UL  },  // [ 2462] Random left roll test ( 2314/ 3000).
      {  0x7A0C7E1CUL,  128,  0x7A0C7E1CUL  },  // [ 2463] Random left roll test ( 2315/ 3000).
      {  0x4C337898UL,  184,  0x984C3378UL  },  // [ 2464] Random left roll test ( 2316/ 3000).
      {  0x8FB7B500UL,  186,  0x023EDED4UL  },  // [ 2465] Random left roll test ( 2317/ 3000).
      {  0xD1B7AE2CUL,  121,  0x59A36F5CUL  },  // [ 2466] Random left roll test ( 2318/ 3000).
      {  0x4D505D33UL,   81,  0xBA669AA0UL  },  // [ 2467] Random left roll test ( 2319/ 3000).
      {  0x1E7A5A4AUL,  166,  0x9E969287UL  },  // [ 2468] Random left roll test ( 2320/ 3000).
      {  0xE87DFA5CUL,  167,  0x3EFD2E74UL  },  // [ 2469] Random left roll test ( 2321/ 3000).
      {  0xCC518A2EUL,  129,  0x98A3145DUL  },  // [ 2470] Random left roll test ( 2322/ 3000).
      {  0xE3FDA020UL,  217,  0x41C7FB40UL  },  // [ 2471] Random left roll test ( 2323/ 3000).
      {  0x70DEBEF6UL,   62,  0x9C37AFBDUL  },  // [ 2472] Random left roll test ( 2324/ 3000).
      {  0x68FC412EUL,  232,  0xFC412E68UL  },  // [ 2473] Random left roll test ( 2325/ 3000).
      {  0x929E0B04UL,   16,  0x0B04929EUL  },  // [ 2474] Random left roll test ( 2326/ 3000).
      {  0xE61172EDUL,  249,  0xDBCC22E5UL  },  // [ 2475] Random left roll test ( 2327/ 3000).
      {  0x170B3064UL,  244,  0x064170B3UL  },  // [ 2476] Random left roll test ( 2328/ 3000).
      {  0xABE8DE7DUL,  128,  0xABE8DE7DUL  },  // [ 2477] Random left roll test ( 2329/ 3000).
      {  0x9BCD8632UL,  161,  0x379B0C65UL  },  // [ 2478] Random left roll test ( 2330/ 3000).
      {  0xB6E93842UL,    1,  0x6DD27085UL  },  // [ 2479] Random left roll test ( 2331/ 3000).
      {  0x9466EC4DUL,  217,  0x9B28CDD8UL  },  // [ 2480] Random left roll test ( 2332/ 3000).
      {  0xA58C4021UL,  142,  0x10086963UL  },  // [ 2481] Random left roll test ( 2333/ 3000).
      {  0xA0B2A3F4UL,   33,  0x416547E9UL  },  // [ 2482] Random left roll test ( 2334/ 3000).
      {  0x684B95E7UL,  145,  0x2BCED097UL  },  // [ 2483] Random left roll test ( 2335/ 3000).
      {  0x2F9D78D0UL,  135,  0xCEBC6817UL  },  // [ 2484] Random left roll test ( 2336/ 3000).
      {  0xF26B6E1FUL,  179,  0x70FF935BUL  },  // [ 2485] Random left roll test ( 2337/ 3000).
      {  0x52C80E90UL,  212,  0xE9052C80UL  },  // [ 2486] Random left roll test ( 2338/ 3000).
      {  0xFA7DF107UL,  189,  0xFF4FBE20UL  },  // [ 2487] Random left roll test ( 2339/ 3000).
      {  0xAE05DFB0UL,  193,  0x5C0BBF61UL  },  // [ 2488] Random left roll test ( 2340/ 3000).
      {  0x32E53DD1UL,  223,  0x99729EE8UL  },  // [ 2489] Random left roll test ( 2341/ 3000).
      {  0xE8AA6A16UL,  130,  0xA2A9A85BUL  },  // [ 2490] Random left roll test ( 2342/ 3000).
      {  0x7B804913UL,   57,  0x26F70092UL  },  // [ 2491] Random left roll test ( 2343/ 3000).
      {  0x17E9139AUL,   18,  0x4E685FA4UL  },  // [ 2492] Random left roll test ( 2344/ 3000).
      {  0xDA77BB24UL,  125,  0x9B4EF764UL  },  // [ 2493] Random left roll test ( 2345/ 3000).
      {  0xB0432020UL,  140,  0x32020B04UL  },  // [ 2494] Random left roll test ( 2346/ 3000).
      {  0xB2B0E533UL,  228,  0x2B0E533BUL  },  // [ 2495] Random left roll test ( 2347/ 3000).
      {  0x9F6882F5UL,  132,  0xF6882F59UL  },  // [ 2496] Random left roll test ( 2348/ 3000).
      {  0x6661D479UL,  163,  0x330EA3CBUL  },  // [ 2497] Random left roll test ( 2349/ 3000).
      {  0x3B75090EUL,  127,  0x1DBA8487UL  },  // [ 2498] Random left roll test ( 2350/ 3000).
      {  0x7477E6D8UL,    3,  0xA3BF36C3UL  },  // [ 2499] Random left roll test ( 2351/ 3000).
      {  0x93E66263UL,  212,  0x26393E66UL  },  // [ 2500] Random left roll test ( 2352/ 3000).
      {  0x2B1CAB11UL,  222,  0x4AC72AC4UL  },  // [ 2501] Random left roll test ( 2353/ 3000).
      {  0x4BE87148UL,  104,  0xE871484BUL  },  // [ 2502] Random left roll test ( 2354/ 3000).
      {  0x39E0FF8FUL,  159,  0x9CF07FC7UL  },  // [ 2503] Random left roll test ( 2355/ 3000).
      {  0x61EBE6A4UL,   17,  0xCD48C3D7UL  },  // [ 2504] Random left roll test ( 2356/ 3000).
      {  0xFDB35E4AUL,  168,  0xB35E4AFDUL  },  // [ 2505] Random left roll test ( 2357/ 3000).
      {  0x5BF0BEC8UL,  118,  0xB216FC2FUL  },  // [ 2506] Random left roll test ( 2358/ 3000).
      {  0xC457A0E5UL,  114,  0x8397115EUL  },  // [ 2507] Random left roll test ( 2359/ 3000).
      {  0x44445987UL,  207,  0x2CC3A222UL  },  // [ 2508] Random left roll test ( 2360/ 3000).
      {  0xE1EF481EUL,  160,  0xE1EF481EUL  },  // [ 2509] Random left roll test ( 2361/ 3000).
      {  0x36DF7995UL,   35,  0xB6FBCCA9UL  },  // [ 2510] Random left roll test ( 2362/ 3000).
      {  0xA34BAAE2UL,   53,  0x5C546975UL  },  // [ 2511] Random left roll test ( 2363/ 3000).
      {  0x71E2DD41UL,   74,  0x8B7505C7UL  },  // [ 2512] Random left roll test ( 2364/ 3000).
      {  0x9737A3BCUL,  254,  0x25CDE8EFUL  },  // [ 2513] Random left roll test ( 2365/ 3000).
      {  0xCA8CFFA5UL,  213,  0xF4B9519FUL  },  // [ 2514] Random left roll test ( 2366/ 3000).
      {  0x97483987UL,    0,  0x97483987UL  },  // [ 2515] Random left roll test ( 2367/ 3000).
      {  0x58188519UL,   45,  0x10A32B03UL  },  // [ 2516] Random left roll test ( 2368/ 3000).
      {  0x1FFB70CAUL,  228,  0xFFB70CA1UL  },  // [ 2517] Random left roll test ( 2369/ 3000).
      {  0x7539BB85UL,  181,  0x70AEA737UL  },  // [ 2518] Random left roll test ( 2370/ 3000).
      {  0x4D70BD85UL,  169,  0xE17B0A9AUL  },  // [ 2519] Random left roll test ( 2371/ 3000).
      {  0x2D943203UL,   83,  0x90196CA1UL  },  // [ 2520] Random left roll test ( 2372/ 3000).
      {  0x904846A5UL,  100,  0x04846A59UL  },  // [ 2521] Random left roll test ( 2373/ 3000).
      {  0xA3980928UL,  182,  0x4A28E602UL  },  // [ 2522] Random left roll test ( 2374/ 3000).
      {  0xFDAE4041UL,  161,  0xFB5C8083UL  },  // [ 2523] Random left roll test ( 2375/ 3000).
      {  0x256004D1UL,  202,  0x80134495UL  },  // [ 2524] Random left roll test ( 2376/ 3000).
      {  0xAAFB660AUL,   23,  0x05557DB3UL  },  // [ 2525] Random left roll test ( 2377/ 3000).
      {  0xC46CC42EUL,  120,  0x2EC46CC4UL  },  // [ 2526] Random left roll test ( 2378/ 3000).
      {  0x21A27BACUL,   38,  0x689EEB08UL  },  // [ 2527] Random left roll test ( 2379/ 3000).
      {  0x4D6DD4B0UL,  171,  0x6EA5826BUL  },  // [ 2528] Random left roll test ( 2380/ 3000).
      {  0xDBD00C93UL,   61,  0x7B7A0192UL  },  // [ 2529] Random left roll test ( 2381/ 3000).
      {  0xF1DC2FFFUL,  109,  0x85FFFE3BUL  },  // [ 2530] Random left roll test ( 2382/ 3000).
      {  0x959D14FBUL,  189,  0x72B3A29FUL  },  // [ 2531] Random left roll test ( 2383/ 3000).
      {  0xCDC576DCUL,  148,  0x6DCCDC57UL  },  // [ 2532] Random left roll test ( 2384/ 3000).
      {  0x4D9DDBAEUL,  109,  0xBB75C9B3UL  },  // [ 2533] Random left roll test ( 2385/ 3000).
      {  0xDD7CC24EUL,  160,  0xDD7CC24EUL  },  // [ 2534] Random left roll test ( 2386/ 3000).
      {  0xA5C2FC94UL,  240,  0xFC94A5C2UL  },  // [ 2535] Random left roll test ( 2387/ 3000).
      {  0xAF11FE98UL,   86,  0xA62BC47FUL  },  // [ 2536] Random left roll test ( 2388/ 3000).
      {  0x7F98A778UL,    4,  0xF98A7787UL  },  // [ 2537] Random left roll test ( 2389/ 3000).
      {  0xE40D1665UL,   59,  0x2F2068B3UL  },  // [ 2538] Random left roll test ( 2390/ 3000).
      {  0x6DA33151UL,  176,  0x31516DA3UL  },  // [ 2539] Random left roll test ( 2391/ 3000).
      {  0x2FCF0841UL,   13,  0xE10825F9UL  },  // [ 2540] Random left roll test ( 2392/ 3000).
      {  0x567BFA43UL,   82,  0xE90D59EFUL  },  // [ 2541] Random left roll test ( 2393/ 3000).
      {  0x07461987UL,  181,  0x30E0E8C3UL  },  // [ 2542] Random left roll test ( 2394/ 3000).
      {  0xF56469B5UL,   66,  0xD591A6D7UL  },  // [ 2543] Random left roll test ( 2395/ 3000).
      {  0xA0218B42UL,  245,  0x68540431UL  },  // [ 2544] Random left roll test ( 2396/ 3000).
      {  0x2A228651UL,  149,  0xCA254450UL  },  // [ 2545] Random left roll test ( 2397/ 3000).
      {  0xA420E462UL,   59,  0x15210723UL  },  // [ 2546] Random left roll test ( 2398/ 3000).
      {  0xE50D1810UL,   34,  0x94346043UL  },  // [ 2547] Random left roll test ( 2399/ 3000).
      {  0x156EBB58UL,  131,  0xAB75DAC0UL  },  // [ 2548] Random left roll test ( 2400/ 3000).
      {  0x463A4BB0UL,  178,  0x2EC118E9UL  },  // [ 2549] Random left roll test ( 2401/ 3000).
      {  0xDC6C581DUL,  185,  0x3BB8D8B0UL  },  // [ 2550] Random left roll test ( 2402/ 3000).
      {  0x9ECA7FB9UL,  187,  0xCCF653FDUL  },  // [ 2551] Random left roll test ( 2403/ 3000).
      {  0x5D4D2611UL,  251,  0x8AEA6930UL  },  // [ 2552] Random left roll test ( 2404/ 3000).
      {  0x68369FE0UL,   18,  0x7F81A0DAUL  },  // [ 2553] Random left roll test ( 2405/ 3000).
      {  0x71E9B5BEUL,   12,  0x9B5BE71EUL  },  // [ 2554] Random left roll test ( 2406/ 3000).
      {  0x9E181E54UL,  234,  0x60795278UL  },  // [ 2555] Random left roll test ( 2407/ 3000).
      {  0x48079F5CUL,   49,  0x3EB8900FUL  },  // [ 2556] Random left roll test ( 2408/ 3000).
      {  0xC8D56155UL,  140,  0x56155C8DUL  },  // [ 2557] Random left roll test ( 2409/ 3000).
      {  0x666BFBE9UL,   85,  0x7D2CCD7FUL  },  // [ 2558] Random left roll test ( 2410/ 3000).
      {  0x9F2283D7UL,   79,  0x41EBCF91UL  },  // [ 2559] Random left roll test ( 2411/ 3000).
      {  0x58D60C78UL,   42,  0x5831E163UL  },  // [ 2560] Random left roll test ( 2412/ 3000).
      {  0xE5EB6224UL,  243,  0x11272F5BUL  },  // [ 2561] Random left roll test ( 2413/ 3000).
      {  0x82031F82UL,   62,  0xA080C7E0UL  },  // [ 2562] Random left roll test ( 2414/ 3000).
      {  0x48D30603UL,   83,  0x301A4698UL  },  // [ 2563] Random left roll test ( 2415/ 3000).
      {  0xE4530845UL,   69,  0x8A6108BCUL  },  // [ 2564] Random left roll test ( 2416/ 3000).
      {  0xBECDB46CUL,  131,  0xF66DA365UL  },  // [ 2565] Random left roll test ( 2417/ 3000).
      {  0x6CEEC875UL,   76,  0xEC8756CEUL  },  // [ 2566] Random left roll test ( 2418/ 3000).
      {  0x14D00E20UL,   42,  0x40388053UL  },  // [ 2567] Random left roll test ( 2419/ 3000).
      {  0x22FFD86BUL,   31,  0x917FEC35UL  },  // [ 2568] Random left roll test ( 2420/ 3000).
      {  0xDFBB48EAUL,  165,  0xF7691D5BUL  },  // [ 2569] Random left roll test ( 2421/ 3000).
      {  0xE61DD15DUL,  223,  0xF30EE8AEUL  },  // [ 2570] Random left roll test ( 2422/ 3000).
      {  0x7C8FBEF0UL,  102,  0x23EFBC1FUL  },  // [ 2571] Random left roll test ( 2423/ 3000).
      {  0x0C812018UL,  203,  0x0900C064UL  },  // [ 2572] Random left roll test ( 2424/ 3000).
      {  0x0DE7184CUL,   28,  0xC0DE7184UL  },  // [ 2573] Random left roll test ( 2425/ 3000).
      {  0xE369BDF4UL,  254,  0x38DA6F7DUL  },  // [ 2574] Random left roll test ( 2426/ 3000).
      {  0xDB3526A5UL,  194,  0x6CD49A97UL  },  // [ 2575] Random left roll test ( 2427/ 3000).
      {  0xBECA0996UL,  242,  0x265AFB28UL  },  // [ 2576] Random left roll test ( 2428/ 3000).
      {  0x5B67FB97UL,  194,  0x6D9FEE5DUL  },  // [ 2577] Random left roll test ( 2429/ 3000).
      {  0x8FB1FCB3UL,   87,  0x59C7D8FEUL  },  // [ 2578] Random left roll test ( 2430/ 3000).
      {  0x2FBA76B0UL,   99,  0x7DD3B581UL  },  // [ 2579] Random left roll test ( 2431/ 3000).
      {  0x258BB819UL,  226,  0x962EE064UL  },  // [ 2580] Random left roll test ( 2432/ 3000).
      {  0x7A3D4370UL,   79,  0xA1B83D1EUL  },  // [ 2581] Random left roll test ( 2433/ 3000).
      {  0x7AE9B21DUL,  111,  0xD90EBD74UL  },  // [ 2582] Random left roll test ( 2434/ 3000).
      {  0x23FB00CFUL,  166,  0xFEC033C8UL  },  // [ 2583] Random left roll test ( 2435/ 3000).
      {  0x04CEC7F0UL,   34,  0x133B1FC0UL  },  // [ 2584] Random left roll test ( 2436/ 3000).
      {  0x838B2DBAUL,   10,  0x2CB6EA0EUL  },  // [ 2585] Random left roll test ( 2437/ 3000).
      {  0x3CC30F3FUL,   28,  0xF3CC30F3UL  },  // [ 2586] Random left roll test ( 2438/ 3000).
      {  0x742CA2F2UL,  149,  0x5E4E8594UL  },  // [ 2587] Random left roll test ( 2439/ 3000).
      {  0xC677A6DBUL,  175,  0xD36DE33BUL  },  // [ 2588] Random left roll test ( 2440/ 3000).
      {  0x8DC7FAA5UL,  232,  0xC7FAA58DUL  },  // [ 2589] Random left roll test ( 2441/ 3000).
      {  0xAF35BDCAUL,  143,  0xDEE5579AUL  },  // [ 2590] Random left roll test ( 2442/ 3000).
      {  0x4B02BBA9UL,  196,  0xB02BBA94UL  },  // [ 2591] Random left roll test ( 2443/ 3000).
      {  0x6898A505UL,  164,  0x898A5056UL  },  // [ 2592] Random left roll test ( 2444/ 3000).
      {  0x253BF4E3UL,   91,  0x1929DFA7UL  },  // [ 2593] Random left roll test ( 2445/ 3000).
      {  0xE4416416UL,  130,  0x9105905BUL  },  // [ 2594] Random left roll test ( 2446/ 3000).
      {  0xA67F25B0UL,  230,  0x9FC96C29UL  },  // [ 2595] Random left roll test ( 2447/ 3000).
      {  0xB9578EF5UL,  159,  0xDCABC77AUL  },  // [ 2596] Random left roll test ( 2448/ 3000).
      {  0x9A52AB0DUL,   72,  0x52AB0D9AUL  },  // [ 2597] Random left roll test ( 2449/ 3000).
      {  0x379EAD03UL,   52,  0xD03379EAUL  },  // [ 2598] Random left roll test ( 2450/ 3000).
      {  0x56B618AAUL,  242,  0x62A95AD8UL  },  // [ 2599] Random left roll test ( 2451/ 3000).
      {  0x08522AC2UL,  254,  0x82148AB0UL  },  // [ 2600] Random left roll test ( 2452/ 3000).
      {  0x8733C036UL,  110,  0xF00DA1CCUL  },  // [ 2601] Random left roll test ( 2453/ 3000).
      {  0x7F5AE4EBUL,  216,  0xEB7F5AE4UL  },  // [ 2602] Random left roll test ( 2454/ 3000).
      {  0x3C02B589UL,  240,  0xB5893C02UL  },  // [ 2603] Random left roll test ( 2455/ 3000).
      {  0x857A7CEEUL,  148,  0xCEE857A7UL  },  // [ 2604] Random left roll test ( 2456/ 3000).
      {  0x582C1BE9UL,  239,  0x0DF4AC16UL  },  // [ 2605] Random left roll test ( 2457/ 3000).
      {  0x82B594DEUL,  248,  0xDE82B594UL  },  // [ 2606] Random left roll test ( 2458/ 3000).
      {  0x60B95DD8UL,  106,  0xE5776182UL  },  // [ 2607] Random left roll test ( 2459/ 3000).
      {  0x440559E1UL,  205,  0xAB3C2880UL  },  // [ 2608] Random left roll test ( 2460/ 3000).
      {  0x5DFEF2D6UL,  176,  0xF2D65DFEUL  },  // [ 2609] Random left roll test ( 2461/ 3000).
      {  0x380622E9UL,  164,  0x80622E93UL  },  // [ 2610] Random left roll test ( 2462/ 3000).
      {  0x8DD2EF9EUL,  216,  0x9E8DD2EFUL  },  // [ 2611] Random left roll test ( 2463/ 3000).
      {  0x15BE862CUL,  186,  0xB056FA18UL  },  // [ 2612] Random left roll test ( 2464/ 3000).
      {  0x488FF19EUL,   93,  0xC911FE33UL  },  // [ 2613] Random left roll test ( 2465/ 3000).
      {  0x7D7202CBUL,  169,  0xE40596FAUL  },  // [ 2614] Random left roll test ( 2466/ 3000).
      {  0x3D519CF8UL,    7,  0xA8CE7C1EUL  },  // [ 2615] Random left roll test ( 2467/ 3000).
      {  0xE3B9BEB4UL,   16,  0xBEB4E3B9UL  },  // [ 2616] Random left roll test ( 2468/ 3000).
      {  0xAC6DF17AUL,   82,  0xC5EAB1B7UL  },  // [ 2617] Random left roll test ( 2469/ 3000).
      {  0x319DD20BUL,  115,  0x90598CEEUL  },  // [ 2618] Random left roll test ( 2470/ 3000).
      {  0xE614510DUL,  129,  0xCC28A21BUL  },  // [ 2619] Random left roll test ( 2471/ 3000).
      {  0xCB51DBE8UL,    3,  0x5A8EDF46UL  },  // [ 2620] Random left roll test ( 2472/ 3000).
      {  0x9534425EUL,   10,  0xD1097A54UL  },  // [ 2621] Random left roll test ( 2473/ 3000).
      {  0xBFD3605BUL,  110,  0xD816EFF4UL  },  // [ 2622] Random left roll test ( 2474/ 3000).
      {  0xFEE1D449UL,  178,  0x5127FB87UL  },  // [ 2623] Random left roll test ( 2475/ 3000).
      {  0x05AC652DUL,  192,  0x05AC652DUL  },  // [ 2624] Random left roll test ( 2476/ 3000).
      {  0xFC449CB4UL,  245,  0x969F8893UL  },  // [ 2625] Random left roll test ( 2477/ 3000).
      {  0xAE939002UL,  205,  0x720055D2UL  },  // [ 2626] Random left roll test ( 2478/ 3000).
      {  0x763CC21CUL,  204,  0xCC21C763UL  },  // [ 2627] Random left roll test ( 2479/ 3000).
      {  0x617FBF8DUL,   40,  0x7FBF8D61UL  },  // [ 2628] Random left roll test ( 2480/ 3000).
      {  0x8E2A2CBAUL,  147,  0x65D47151UL  },  // [ 2629] Random left roll test ( 2481/ 3000).
      {  0xAB5AA1E1UL,   69,  0x6B543C35UL  },  // [ 2630] Random left roll test ( 2482/ 3000).
      {  0x1D097147UL,   67,  0xE84B8A38UL  },  // [ 2631] Random left roll test ( 2483/ 3000).
      {  0x8865F323UL,  179,  0x991C432FUL  },  // [ 2632] Random left roll test ( 2484/ 3000).
      {  0xC5C2139FUL,   78,  0x84E7F170UL  },  // [ 2633] Random left roll test ( 2485/ 3000).
      {  0xC70239A9UL,  169,  0x0473538EUL  },  // [ 2634] Random left roll test ( 2486/ 3000).
      {  0x1B48A3EAUL,  175,  0x51F50DA4UL  },  // [ 2635] Random left roll test ( 2487/ 3000).
      {  0x6F9DFB30UL,  231,  0xCEFD9837UL  },  // [ 2636] Random left roll test ( 2488/ 3000).
      {  0x9F2A3A84UL,   12,  0xA3A849F2UL  },  // [ 2637] Random left roll test ( 2489/ 3000).
      {  0x2634B7E3UL,  113,  0x6FC64C69UL  },  // [ 2638] Random left roll test ( 2490/ 3000).
      {  0x5FA4D4C0UL,  160,  0x5FA4D4C0UL  },  // [ 2639] Random left roll test ( 2491/ 3000).
      {  0xD4F39928UL,  229,  0x9E73251AUL  },  // [ 2640] Random left roll test ( 2492/ 3000).
      {  0x377F3D23UL,   55,  0x919BBF9EUL  },  // [ 2641] Random left roll test ( 2493/ 3000).
      {  0x8C2A70FBUL,  222,  0xE30A9C3EUL  },  // [ 2642] Random left roll test ( 2494/ 3000).
      {  0x1555E98EUL,   44,  0x5E98E155UL  },  // [ 2643] Random left roll test ( 2495/ 3000).
      {  0x977AC99FUL,  170,  0xEB267E5DUL  },  // [ 2644] Random left roll test ( 2496/ 3000).
      {  0x5EC4C43DUL,  110,  0x310F57B1UL  },  // [ 2645] Random left roll test ( 2497/ 3000).
      {  0xF86F50EFUL,   12,  0xF50EFF86UL  },  // [ 2646] Random left roll test ( 2498/ 3000).
      {  0x026C8016UL,  106,  0xB2005809UL  },  // [ 2647] Random left roll test ( 2499/ 3000).
      {  0xC7547DD0UL,   71,  0xAA3EE863UL  },  // [ 2648] Random left roll test ( 2500/ 3000).
      {  0xE0093938UL,  195,  0x0049C9C7UL  },  // [ 2649] Random left roll test ( 2501/ 3000).
      {  0x11FBC4A7UL,  247,  0x5388FDE2UL  },  // [ 2650] Random left roll test ( 2502/ 3000).
      {  0xB694C3D0UL,  122,  0x42DA530FUL  },  // [ 2651] Random left roll test ( 2503/ 3000).
      {  0x2AD71B93UL,  149,  0x72655AE3UL  },  // [ 2652] Random left roll test ( 2504/ 3000).
      {  0x3CC10B86UL,   59,  0x31E6085CUL  },  // [ 2653] Random left roll test ( 2505/ 3000).
      {  0x3A0302F8UL,  233,  0x0605F074UL  },  // [ 2654] Random left roll test ( 2506/ 3000).
      {  0x5BAE340DUL,   56,  0x0D5BAE34UL  },  // [ 2655] Random left roll test ( 2507/ 3000).
      {  0x346A4650UL,  251,  0x81A35232UL  },  // [ 2656] Random left roll test ( 2508/ 3000).
      {  0x67075698UL,  202,  0x1D5A619CUL  },  // [ 2657] Random left roll test ( 2509/ 3000).
      {  0xBC303EA3UL,  147,  0xF51DE181UL  },  // [ 2658] Random left roll test ( 2510/ 3000).
      {  0x0F613CDBUL,   89,  0xB61EC279UL  },  // [ 2659] Random left roll test ( 2511/ 3000).
      {  0x84F5BD2DUL,   49,  0x7A5B09EBUL  },  // [ 2660] Random left roll test ( 2512/ 3000).
      {  0xAA84ED2EUL,   85,  0xA5D5509DUL  },  // [ 2661] Random left roll test ( 2513/ 3000).
      {  0x78C815D9UL,  163,  0xC640AECBUL  },  // [ 2662] Random left roll test ( 2514/ 3000).
      {  0x0FA0D336UL,  241,  0xA66C1F41UL  },  // [ 2663] Random left roll test ( 2515/ 3000).
      {  0xE1896E27UL,  193,  0xC312DC4FUL  },  // [ 2664] Random left roll test ( 2516/ 3000).
      {  0xEC2260EFUL,  124,  0xFEC2260EUL  },  // [ 2665] Random left roll test ( 2517/ 3000).
      {  0xA0B79A66UL,  233,  0x6F34CD41UL  },  // [ 2666] Random left roll test ( 2518/ 3000).
      {  0x205A27E9UL,  193,  0x40B44FD2UL  },  // [ 2667] Random left roll test ( 2519/ 3000).
      {  0x9CD67788UL,  126,  0x27359DE2UL  },  // [ 2668] Random left roll test ( 2520/ 3000).
      {  0x4D57E44DUL,  249,  0x9A9AAFC8UL  },  // [ 2669] Random left roll test ( 2521/ 3000).
      {  0x2A7E6EDCUL,  140,  0xE6EDC2A7UL  },  // [ 2670] Random left roll test ( 2522/ 3000).
      {  0xBB8C8290UL,  201,  0x19052177UL  },  // [ 2671] Random left roll test ( 2523/ 3000).
      {  0x1E1A7058UL,    5,  0xC34E0B03UL  },  // [ 2672] Random left roll test ( 2524/ 3000).
      {  0x9AD62618UL,   23,  0x0C4D6B13UL  },  // [ 2673] Random left roll test ( 2525/ 3000).
      {  0xD7C6A2F2UL,   61,  0x5AF8D45EUL  },  // [ 2674] Random left roll test ( 2526/ 3000).
      {  0x0E5C4CA1UL,  113,  0x99421CB8UL  },  // [ 2675] Random left roll test ( 2527/ 3000).
      {  0x7210F589UL,  170,  0x43D625C8UL  },  // [ 2676] Random left roll test ( 2528/ 3000).
      {  0x7197F723UL,   84,  0x7237197FUL  },  // [ 2677] Random left roll test ( 2529/ 3000).
      {  0x1AE47123UL,  100,  0xAE471231UL  },  // [ 2678] Random left roll test ( 2530/ 3000).
      {  0xD2EB9F2EUL,  201,  0xD73E5DA5UL  },  // [ 2679] Random left roll test ( 2531/ 3000).
      {  0x8775E624UL,   59,  0x243BAF31UL  },  // [ 2680] Random left roll test ( 2532/ 3000).
      {  0x01D67095UL,  178,  0xC2540759UL  },  // [ 2681] Random left roll test ( 2533/ 3000).
      {  0xFD2C78E4UL,  110,  0x1E393F4BUL  },  // [ 2682] Random left roll test ( 2534/ 3000).
      {  0xF080D0BCUL,  125,  0x9E101A17UL  },  // [ 2683] Random left roll test ( 2535/ 3000).
      {  0xA3B5267BUL,  215,  0x3DD1DA93UL  },  // [ 2684] Random left roll test ( 2536/ 3000).
      {  0x51F9E88FUL,  103,  0xFCF447A8UL  },  // [ 2685] Random left roll test ( 2537/ 3000).
      {  0x1D6411BAUL,  157,  0x43AC8237UL  },  // [ 2686] Random left roll test ( 2538/ 3000).
      {  0x27046216UL,  236,  0x46216270UL  },  // [ 2687] Random left roll test ( 2539/ 3000).
      {  0x028C7D7EUL,   30,  0x80A31F5FUL  },  // [ 2688] Random left roll test ( 2540/ 3000).
      {  0xF6D24E56UL,  212,  0xE56F6D24UL  },  // [ 2689] Random left roll test ( 2541/ 3000).
      {  0x5CD393BBUL,  151,  0xDDAE69C9UL  },  // [ 2690] Random left roll test ( 2542/ 3000).
      {  0x0222C7F0UL,  239,  0x63F80111UL  },  // [ 2691] Random left roll test ( 2543/ 3000).
      {  0x5D0E2E7DUL,   34,  0x7438B9F5UL  },  // [ 2692] Random left roll test ( 2544/ 3000).
      {  0xFF5A2F77UL,  191,  0xFFAD17BBUL  },  // [ 2693] Random left roll test ( 2545/ 3000).
      {  0x0AEAA3AFUL,   13,  0x5475E15DUL  },  // [ 2694] Random left roll test ( 2546/ 3000).
      {  0xB914AF6CUL,  204,  0x4AF6CB91UL  },  // [ 2695] Random left roll test ( 2547/ 3000).
      {  0xD63802DFUL,  211,  0x16FEB1C0UL  },  // [ 2696] Random left roll test ( 2548/ 3000).
      {  0x301A236BUL,    3,  0x80D11B59UL  },  // [ 2697] Random left roll test ( 2549/ 3000).
      {  0xAF720BF2UL,   50,  0x2FCABDC8UL  },  // [ 2698] Random left roll test ( 2550/ 3000).
      {  0x96635991UL,  228,  0x66359919UL  },  // [ 2699] Random left roll test ( 2551/ 3000).
      {  0x3F179459UL,  111,  0xCA2C9F8BUL  },  // [ 2700] Random left roll test ( 2552/ 3000).
      {  0x5B3994A9UL,  179,  0xA54AD9CCUL  },  // [ 2701] Random left roll test ( 2553/ 3000).
      {  0x32C63778UL,  233,  0x8C6EF065UL  },  // [ 2702] Random left roll test ( 2554/ 3000).
      {  0x7C6341D6UL,  187,  0xB3E31A0EUL  },  // [ 2703] Random left roll test ( 2555/ 3000).
      {  0xE96C12B3UL,   32,  0xE96C12B3UL  },  // [ 2704] Random left roll test ( 2556/ 3000).
      {  0xC30577F2UL,  236,  0x577F2C30UL  },  // [ 2705] Random left roll test ( 2557/ 3000).
      {  0x559EBA4BUL,   77,  0xD7496AB3UL  },  // [ 2706] Random left roll test ( 2558/ 3000).
      {  0x0745E6A5UL,   42,  0x179A941DUL  },  // [ 2707] Random left roll test ( 2559/ 3000).
      {  0x0E0BF08DUL,  103,  0x05F84687UL  },  // [ 2708] Random left roll test ( 2560/ 3000).
      {  0xAF146320UL,   32,  0xAF146320UL  },  // [ 2709] Random left roll test ( 2561/ 3000).
      {  0x1642EF01UL,   25,  0x022C85DEUL  },  // [ 2710] Random left roll test ( 2562/ 3000).
      {  0x2AF34C5CUL,  244,  0xC5C2AF34UL  },  // [ 2711] Random left roll test ( 2563/ 3000).
      {  0x871B6BFBUL,  164,  0x71B6BFB8UL  },  // [ 2712] Random left roll test ( 2564/ 3000).
      {  0x33DFE36CUL,   27,  0x619EFF1BUL  },  // [ 2713] Random left roll test ( 2565/ 3000).
      {  0x31987D62UL,  125,  0x46330FACUL  },  // [ 2714] Random left roll test ( 2566/ 3000).
      {  0x7201D77AUL,  142,  0x75DE9C80UL  },  // [ 2715] Random left roll test ( 2567/ 3000).
      {  0x79979716UL,   62,  0x9E65E5C5UL  },  // [ 2716] Random left roll test ( 2568/ 3000).
      {  0xDEC743FCUL,  192,  0xDEC743FCUL  },  // [ 2717] Random left roll test ( 2569/ 3000).
      {  0x21ADCD1DUL,   62,  0x486B7347UL  },  // [ 2718] Random left roll test ( 2570/ 3000).
      {  0x2ADF732EUL,  126,  0x8AB7DCCBUL  },  // [ 2719] Random left roll test ( 2571/ 3000).
      {  0x95878AA1UL,  144,  0x8AA19587UL  },  // [ 2720] Random left roll test ( 2572/ 3000).
      {  0x27FEAFE7UL,  251,  0x393FF57FUL  },  // [ 2721] Random left roll test ( 2573/ 3000).
      {  0x27C15B79UL,  201,  0x82B6F24FUL  },  // [ 2722] Random left roll test ( 2574/ 3000).
      {  0x75E9C4D3UL,  169,  0xD389A6EBUL  },  // [ 2723] Random left roll test ( 2575/ 3000).
      {  0x4D90AF7BUL,   31,  0xA6C857BDUL  },  // [ 2724] Random left roll test ( 2576/ 3000).
      {  0x11DC2CF4UL,  149,  0x9E823B85UL  },  // [ 2725] Random left roll test ( 2577/ 3000).
      {  0x4DD469A6UL,   29,  0xC9BA8D34UL  },  // [ 2726] Random left roll test ( 2578/ 3000).
      {  0x630CADFFUL,  229,  0x6195BFECUL  },  // [ 2727] Random left roll test ( 2579/ 3000).
      {  0xDDCCDD44UL,  192,  0xDDCCDD44UL  },  // [ 2728] Random left roll test ( 2580/ 3000).
      {  0x600E218BUL,  122,  0x2D803886UL  },  // [ 2729] Random left roll test ( 2581/ 3000).
      {  0x1E82984FUL,  210,  0x613C7A0AUL  },  // [ 2730] Random left roll test ( 2582/ 3000).
      {  0x18130F7AUL,  231,  0x0987BD0CUL  },  // [ 2731] Random left roll test ( 2583/ 3000).
      {  0x06D9BB97UL,   99,  0x36CDDCB8UL  },  // [ 2732] Random left roll test ( 2584/ 3000).
      {  0x6CDA3CBBUL,  149,  0x976D9B47UL  },  // [ 2733] Random left roll test ( 2585/ 3000).
      {  0xCC8AE1BFUL,  149,  0x37F9915CUL  },  // [ 2734] Random left roll test ( 2586/ 3000).
      {  0x6AA62B0AUL,  175,  0x15853553UL  },  // [ 2735] Random left roll test ( 2587/ 3000).
      {  0xFC008B43UL,  192,  0xFC008B43UL  },  // [ 2736] Random left roll test ( 2588/ 3000).
      {  0x1B98CF76UL,   69,  0x7319EEC3UL  },  // [ 2737] Random left roll test ( 2589/ 3000).
      {  0xAA8BA974UL,  118,  0x5D2AA2EAUL  },  // [ 2738] Random left roll test ( 2590/ 3000).
      {  0x3F85475AUL,  253,  0x47F0A8EBUL  },  // [ 2739] Random left roll test ( 2591/ 3000).
      {  0x6C8E7EAAUL,  240,  0x7EAA6C8EUL  },  // [ 2740] Random left roll test ( 2592/ 3000).
      {  0xA271E314UL,  235,  0x8F18A513UL  },  // [ 2741] Random left roll test ( 2593/ 3000).
      {  0x2BF009AFUL,   65,  0x57E0135EUL  },  // [ 2742] Random left roll test ( 2594/ 3000).
      {  0x8BEE0177UL,   91,  0xBC5F700BUL  },  // [ 2743] Random left roll test ( 2595/ 3000).
      {  0xCED97432UL,  129,  0x9DB2E865UL  },  // [ 2744] Random left roll test ( 2596/ 3000).
      {  0x54AE8386UL,   96,  0x54AE8386UL  },  // [ 2745] Random left roll test ( 2597/ 3000).
      {  0xF78BDFADUL,   87,  0xD6FBC5EFUL  },  // [ 2746] Random left roll test ( 2598/ 3000).
      {  0x95ABECF3UL,  135,  0xD5F679CAUL  },  // [ 2747] Random left roll test ( 2599/ 3000).
      {  0x6EAC4676UL,  218,  0xD9BAB119UL  },  // [ 2748] Random left roll test ( 2600/ 3000).
      {  0x3EC28D72UL,  231,  0x6146B91FUL  },  // [ 2749] Random left roll test ( 2601/ 3000).
      {  0xCD541C21UL,   85,  0x8439AA83UL  },  // [ 2750] Random left roll test ( 2602/ 3000).
      {  0x242AEA0EUL,  243,  0x50712157UL  },  // [ 2751] Random left roll test ( 2603/ 3000).
      {  0x5755E825UL,  158,  0x55D57A09UL  },  // [ 2752] Random left roll test ( 2604/ 3000).
      {  0x5DEFB0BFUL,  145,  0x617EBBDFUL  },  // [ 2753] Random left roll test ( 2605/ 3000).
      {  0xBCC2CF01UL,   56,  0x01BCC2CFUL  },  // [ 2754] Random left roll test ( 2606/ 3000).
      {  0xB96BDCD0UL,  200,  0x6BDCD0B9UL  },  // [ 2755] Random left roll test ( 2607/ 3000).
      {  0xE73C58B7UL,   18,  0x62DF9CF1UL  },  // [ 2756] Random left roll test ( 2608/ 3000).
      {  0x353CF5D2UL,  106,  0xF3D748D4UL  },  // [ 2757] Random left roll test ( 2609/ 3000).
      {  0x1E4E777AUL,  214,  0xDE87939DUL  },  // [ 2758] Random left roll test ( 2610/ 3000).
      {  0xBF2E71BBUL,   79,  0x38DDDF97UL  },  // [ 2759] Random left roll test ( 2611/ 3000).
      {  0x2A943192UL,  115,  0x8C9154A1UL  },  // [ 2760] Random left roll test ( 2612/ 3000).
      {  0xF577E85FUL,   29,  0xFEAEFD0BUL  },  // [ 2761] Random left roll test ( 2613/ 3000).
      {  0xA416B84CUL,  125,  0x9482D709UL  },  // [ 2762] Random left roll test ( 2614/ 3000).
      {  0xA9376AFEUL,  224,  0xA9376AFEUL  },  // [ 2763] Random left roll test ( 2615/ 3000).
      {  0x3C416E17UL,   74,  0x05B85CF1UL  },  // [ 2764] Random left roll test ( 2616/ 3000).
      {  0xCBFED95EUL,   38,  0xFFB657B2UL  },  // [ 2765] Random left roll test ( 2617/ 3000).
      {  0x3A67E379UL,  207,  0xF1BC9D33UL  },  // [ 2766] Random left roll test ( 2618/ 3000).
      {  0xCDC2E669UL,    6,  0x70B99A73UL  },  // [ 2767] Random left roll test ( 2619/ 3000).
      {  0xD147780FUL,  123,  0x7E8A3BC0UL  },  // [ 2768] Random left roll test ( 2620/ 3000).
      {  0xA5C93EC1UL,  233,  0x927D834BUL  },  // [ 2769] Random left roll test ( 2621/ 3000).
      {  0x68459AB9UL,   31,  0xB422CD5CUL  },  // [ 2770] Random left roll test ( 2622/ 3000).
      {  0xA2D64B45UL,  239,  0x25A2D16BUL  },  // [ 2771] Random left roll test ( 2623/ 3000).
      {  0xEAECFEDBUL,  122,  0x6FABB3FBUL  },  // [ 2772] Random left roll test ( 2624/ 3000).
      {  0x53379573UL,   29,  0x6A66F2AEUL  },  // [ 2773] Random left roll test ( 2625/ 3000).
      {  0x85839A94UL,   22,  0xA52160E6UL  },  // [ 2774] Random left roll test ( 2626/ 3000).
      {  0xD4E5CA53UL,  118,  0x94F53972UL  },  // [ 2775] Random left roll test ( 2627/ 3000).
      {  0xA5057C9FUL,   80,  0x7C9FA505UL  },  // [ 2776] Random left roll test ( 2628/ 3000).
      {  0x7638ED7CUL,   57,  0xF8EC71DAUL  },  // [ 2777] Random left roll test ( 2629/ 3000).
      {  0xCFB864B7UL,  119,  0x5BE7DC32UL  },  // [ 2778] Random left roll test ( 2630/ 3000).
      {  0xAAB2723AUL,  152,  0x3AAAB272UL  },  // [ 2779] Random left roll test ( 2631/ 3000).
      {  0x7384B891UL,  156,  0x17384B89UL  },  // [ 2780] Random left roll test ( 2632/ 3000).
      {  0x98901B3AUL,   37,  0x12036753UL  },  // [ 2781] Random left roll test ( 2633/ 3000).
      {  0x5DC60137UL,  202,  0x1804DD77UL  },  // [ 2782] Random left roll test ( 2634/ 3000).
      {  0x3768BC22UL,  237,  0x178446EDUL  },  // [ 2783] Random left roll test ( 2635/ 3000).
      {  0x819872FEUL,   21,  0x5FD0330EUL  },  // [ 2784] Random left roll test ( 2636/ 3000).
      {  0xB7715742UL,   94,  0xADDC55D0UL  },  // [ 2785] Random left roll test ( 2637/ 3000).
      {  0x2DB1699AUL,   83,  0x4CD16D8BUL  },  // [ 2786] Random left roll test ( 2638/ 3000).
      {  0x2C16C47BUL,  103,  0x0B623D96UL  },  // [ 2787] Random left roll test ( 2639/ 3000).
      {  0xCA6E5443UL,  113,  0xA88794DCUL  },  // [ 2788] Random left roll test ( 2640/ 3000).
      {  0x63A4AEFDUL,  102,  0xE92BBF58UL  },  // [ 2789] Random left roll test ( 2641/ 3000).
      {  0xEE94CE9FUL,  108,  0x4CE9FEE9UL  },  // [ 2790] Random left roll test ( 2642/ 3000).
      {  0x132DFE08UL,  244,  0xE08132DFUL  },  // [ 2791] Random left roll test ( 2643/ 3000).
      {  0x58D6B2DAUL,   98,  0x635ACB69UL  },  // [ 2792] Random left roll test ( 2644/ 3000).
      {  0x797B52FFUL,   42,  0xED4BFDE5UL  },  // [ 2793] Random left roll test ( 2645/ 3000).
      {  0xB5835D8BUL,   96,  0xB5835D8BUL  },  // [ 2794] Random left roll test ( 2646/ 3000).
      {  0xFBD0FBFAUL,  216,  0xFAFBD0FBUL  },  // [ 2795] Random left roll test ( 2647/ 3000).
      {  0x279D2883UL,   55,  0x4193CE94UL  },  // [ 2796] Random left roll test ( 2648/ 3000).
      {  0x12B86AA8UL,  180,  0xAA812B86UL  },  // [ 2797] Random left roll test ( 2649/ 3000).
      {  0xF464C4CBUL,  150,  0x32FD1931UL  },  // [ 2798] Random left roll test ( 2650/ 3000).
      {  0xBA3B8570UL,  125,  0x174770AEUL  },  // [ 2799] Random left roll test ( 2651/ 3000).
      {  0xDF378E7DUL,  200,  0x378E7DDFUL  },  // [ 2800] Random left roll test ( 2652/ 3000).
      {  0xFB403512UL,  213,  0xA25F6806UL  },  // [ 2801] Random left roll test ( 2653/ 3000).
      {  0x7E11B67BUL,  228,  0xE11B67B7UL  },  // [ 2802] Random left roll test ( 2654/ 3000).
      {  0x40FFC470UL,   56,  0x7040FFC4UL  },  // [ 2803] Random left roll test ( 2655/ 3000).
      {  0x3E7CDEC6UL,    3,  0xF3E6F631UL  },  // [ 2804] Random left roll test ( 2656/ 3000).
      {  0x0F5A9709UL,  151,  0x8487AD4BUL  },  // [ 2805] Random left roll test ( 2657/ 3000).
      {  0x8796879EUL,   33,  0x0F2D0F3DUL  },  // [ 2806] Random left roll test ( 2658/ 3000).
      {  0x09C2FC63UL,   29,  0x61385F8CUL  },  // [ 2807] Random left roll test ( 2659/ 3000).
      {  0x152CD183UL,  230,  0x4B3460C5UL  },  // [ 2808] Random left roll test ( 2660/ 3000).
      {  0x15E2A46BUL,   45,  0x548D62BCUL  },  // [ 2809] Random left roll test ( 2661/ 3000).
      {  0x8FE964DCUL,  241,  0xC9B91FD2UL  },  // [ 2810] Random left roll test ( 2662/ 3000).
      {  0x29508D1CUL,  193,  0x52A11A38UL  },  // [ 2811] Random left roll test ( 2663/ 3000).
      {  0x2B259885UL,  146,  0x6214AC96UL  },  // [ 2812] Random left roll test ( 2664/ 3000).
      {  0x861C214DUL,  198,  0x87085361UL  },  // [ 2813] Random left roll test ( 2665/ 3000).
      {  0x8C161195UL,  109,  0xC232B182UL  },  // [ 2814] Random left roll test ( 2666/ 3000).
      {  0x7C2D6BACUL,   76,  0xD6BAC7C2UL  },  // [ 2815] Random left roll test ( 2667/ 3000).
      {  0x72F3702FUL,  125,  0xEE5E6E05UL  },  // [ 2816] Random left roll test ( 2668/ 3000).
      {  0x068BA139UL,  247,  0x9C8345D0UL  },  // [ 2817] Random left roll test ( 2669/ 3000).
      {  0x19210C02UL,   82,  0x30086484UL  },  // [ 2818] Random left roll test ( 2670/ 3000).
      {  0x1735BFFCUL,  210,  0xFFF05CD6UL  },  // [ 2819] Random left roll test ( 2671/ 3000).
      {  0x541FECAEUL,  247,  0x572A0FF6UL  },  // [ 2820] Random left roll test ( 2672/ 3000).
      {  0x69AB6542UL,  226,  0xA6AD9509UL  },  // [ 2821] Random left roll test ( 2673/ 3000).
      {  0x4CEE7220UL,   49,  0xE44099DCUL  },  // [ 2822] Random left roll test ( 2674/ 3000).
      {  0x029B3363UL,  182,  0xD8C0A6CCUL  },  // [ 2823] Random left roll test ( 2675/ 3000).
      {  0x072B986EUL,  244,  0x86E072B9UL  },  // [ 2824] Random left roll test ( 2676/ 3000).
      {  0x0BF5136AUL,  150,  0xDA82FD44UL  },  // [ 2825] Random left roll test ( 2677/ 3000).
      {  0xA56C87BDUL,  184,  0xBDA56C87UL  },  // [ 2826] Random left roll test ( 2678/ 3000).
      {  0xFF282931UL,  205,  0x05263FE5UL  },  // [ 2827] Random left roll test ( 2679/ 3000).
      {  0xD51AFEC6UL,   69,  0xA35FD8DAUL  },  // [ 2828] Random left roll test ( 2680/ 3000).
      {  0x2D837FA4UL,  198,  0x60DFE90BUL  },  // [ 2829] Random left roll test ( 2681/ 3000).
      {  0xBC2BEF37UL,  147,  0x79BDE15FUL  },  // [ 2830] Random left roll test ( 2682/ 3000).
      {  0x7CDFE132UL,  176,  0xE1327CDFUL  },  // [ 2831] Random left roll test ( 2683/ 3000).
      {  0xEE3D5346UL,  194,  0xB8F54D1BUL  },  // [ 2832] Random left roll test ( 2684/ 3000).
      {  0x6B586345UL,    6,  0xD618D15AUL  },  // [ 2833] Random left roll test ( 2685/ 3000).
      {  0xDAE7ED66UL,  189,  0xDB5CFDACUL  },  // [ 2834] Random left roll test ( 2686/ 3000).
      {  0xB302A860UL,   84,  0x860B302AUL  },  // [ 2835] Random left roll test ( 2687/ 3000).
      {  0xB0E43B4BUL,  119,  0xA5D8721DUL  },  // [ 2836] Random left roll test ( 2688/ 3000).
      {  0x08EC949DUL,  213,  0x93A11D92UL  },  // [ 2837] Random left roll test ( 2689/ 3000).
      {  0x256E558CUL,  167,  0xB72AC612UL  },  // [ 2838] Random left roll test ( 2690/ 3000).
      {  0x3771FCC6UL,  114,  0xF318DDC7UL  },  // [ 2839] Random left roll test ( 2691/ 3000).
      {  0x1043DD41UL,  209,  0xBA822087UL  },  // [ 2840] Random left roll test ( 2692/ 3000).
      {  0x36C8124BUL,  141,  0x024966D9UL  },  // [ 2841] Random left roll test ( 2693/ 3000).
      {  0x4396DB21UL,  184,  0x214396DBUL  },  // [ 2842] Random left roll test ( 2694/ 3000).
      {  0xA2C73CE0UL,   56,  0xE0A2C73CUL  },  // [ 2843] Random left roll test ( 2695/ 3000).
      {  0x9FEAC1A3UL,  140,  0xAC1A39FEUL  },  // [ 2844] Random left roll test ( 2696/ 3000).
      {  0x4C0C5A3AUL,  249,  0x749818B4UL  },  // [ 2845] Random left roll test ( 2697/ 3000).
      {  0x8AC6139FUL,   42,  0x184E7E2BUL  },  // [ 2846] Random left roll test ( 2698/ 3000).
      {  0xAFAD5CD7UL,  176,  0x5CD7AFADUL  },  // [ 2847] Random left roll test ( 2699/ 3000).
      {  0xD868A044UL,   17,  0x4089B0D1UL  },  // [ 2848] Random left roll test ( 2700/ 3000).
      {  0x4A8B6DD6UL,   91,  0xB2545B6EUL  },  // [ 2849] Random left roll test ( 2701/ 3000).
      {  0x02D4AC46UL,  117,  0x88C05A95UL  },  // [ 2850] Random left roll test ( 2702/ 3000).
      {  0x46020C02UL,  118,  0x00918083UL  },  // [ 2851] Random left roll test ( 2703/ 3000).
      {  0x212D2000UL,  184,  0x00212D20UL  },  // [ 2852] Random left roll test ( 2704/ 3000).
      {  0x3FA77273UL,  162,  0xFE9DC9CCUL  },  // [ 2853] Random left roll test ( 2705/ 3000).
      {  0xCAC2D1BBUL,   56,  0xBBCAC2D1UL  },  // [ 2854] Random left roll test ( 2706/ 3000).
      {  0x8B8D4CBAUL,  121,  0x75171A99UL  },  // [ 2855] Random left roll test ( 2707/ 3000).
      {  0xAC006FB0UL,   52,  0xFB0AC006UL  },  // [ 2856] Random left roll test ( 2708/ 3000).
      {  0xF2536AE9UL,  222,  0x7C94DABAUL  },  // [ 2857] Random left roll test ( 2709/ 3000).
      {  0xE0F485E7UL,   16,  0x85E7E0F4UL  },  // [ 2858] Random left roll test ( 2710/ 3000).
      {  0xC345CF54UL,  176,  0xCF54C345UL  },  // [ 2859] Random left roll test ( 2711/ 3000).
      {  0xCA0133D9UL,   13,  0x267B3940UL  },  // [ 2860] Random left roll test ( 2712/ 3000).
      {  0xEB46ED66UL,   24,  0x66EB46EDUL  },  // [ 2861] Random left roll test ( 2713/ 3000).
      {  0x24ACE859UL,  201,  0x59D0B249UL  },  // [ 2862] Random left roll test ( 2714/ 3000).
      {  0x3134C46BUL,  182,  0x1ACC4D31UL  },  // [ 2863] Random left roll test ( 2715/ 3000).
      {  0x24235344UL,  107,  0x1A9A2121UL  },  // [ 2864] Random left roll test ( 2716/ 3000).
      {  0x765032DBUL,   63,  0xBB28196DUL  },  // [ 2865] Random left roll test ( 2717/ 3000).
      {  0xB9C25D26UL,  231,  0xE12E935CUL  },  // [ 2866] Random left roll test ( 2718/ 3000).
      {  0x850FE33FUL,  156,  0xF850FE33UL  },  // [ 2867] Random left roll test ( 2719/ 3000).
      {  0x0618745EUL,  108,  0x8745E061UL  },  // [ 2868] Random left roll test ( 2720/ 3000).
      {  0xD34BA041UL,  173,  0x74083A69UL  },  // [ 2869] Random left roll test ( 2721/ 3000).
      {  0x7F65D761UL,  244,  0x7617F65DUL  },  // [ 2870] Random left roll test ( 2722/ 3000).
      {  0xE1D1AA17UL,    9,  0xA3542FC3UL  },  // [ 2871] Random left roll test ( 2723/ 3000).
      {  0x48761B31UL,  234,  0xD86CC521UL  },  // [ 2872] Random left roll test ( 2724/ 3000).
      {  0x7B216309UL,   11,  0x0B184BD9UL  },  // [ 2873] Random left roll test ( 2725/ 3000).
      {  0xE0935AF7UL,   11,  0x9AD7BF04UL  },  // [ 2874] Random left roll test ( 2726/ 3000).
      {  0x319C943BUL,   57,  0x76633928UL  },  // [ 2875] Random left roll test ( 2727/ 3000).
      {  0x08F6E489UL,   51,  0x244847B7UL  },  // [ 2876] Random left roll test ( 2728/ 3000).
      {  0xA129AE5AUL,  150,  0x96A84A6BUL  },  // [ 2877] Random left roll test ( 2729/ 3000).
      {  0x4B236517UL,  240,  0x65174B23UL  },  // [ 2878] Random left roll test ( 2730/ 3000).
      {  0xE2D235DAUL,  125,  0x5C5A46BBUL  },  // [ 2879] Random left roll test ( 2731/ 3000).
      {  0x74F09765UL,  163,  0xA784BB2BUL  },  // [ 2880] Random left roll test ( 2732/ 3000).
      {  0x56DCDF85UL,  167,  0x6E6FC2ABUL  },  // [ 2881] Random left roll test ( 2733/ 3000).
      {  0xE64CB792UL,  233,  0x996F25CCUL  },  // [ 2882] Random left roll test ( 2734/ 3000).
      {  0x0117CE01UL,   32,  0x0117CE01UL  },  // [ 2883] Random left roll test ( 2735/ 3000).
      {  0xBFD20274UL,  161,  0x7FA404E9UL  },  // [ 2884] Random left roll test ( 2736/ 3000).
      {  0x9BBD0F2DUL,  177,  0x1E5B377AUL  },  // [ 2885] Random left roll test ( 2737/ 3000).
      {  0xC0B38C06UL,   85,  0x80D81671UL  },  // [ 2886] Random left roll test ( 2738/ 3000).
      {  0x87F1E5BFUL,    0,  0x87F1E5BFUL  },  // [ 2887] Random left roll test ( 2739/ 3000).
      {  0xD49EF600UL,   11,  0xF7B006A4UL  },  // [ 2888] Random left roll test ( 2740/ 3000).
      {  0x274CF4F4UL,  108,  0xCF4F4274UL  },  // [ 2889] Random left roll test ( 2741/ 3000).
      {  0x69DD47B3UL,  183,  0xD9B4EEA3UL  },  // [ 2890] Random left roll test ( 2742/ 3000).
      {  0xBB660B7AUL,   48,  0x0B7ABB66UL  },  // [ 2891] Random left roll test ( 2743/ 3000).
      {  0xA3FA4AA2UL,  140,  0xA4AA2A3FUL  },  // [ 2892] Random left roll test ( 2744/ 3000).
      {  0xF97DC3A8UL,   50,  0x0EA3E5F7UL  },  // [ 2893] Random left roll test ( 2745/ 3000).
      {  0x094A879DUL,  247,  0xCE84A543UL  },  // [ 2894] Random left roll test ( 2746/ 3000).
      {  0x89275773UL,  182,  0xDCE249D5UL  },  // [ 2895] Random left roll test ( 2747/ 3000).
      {  0x735CBDFBUL,  235,  0xE5EFDB9AUL  },  // [ 2896] Random left roll test ( 2748/ 3000).
      {  0x27D54F03UL,  255,  0x93EAA781UL  },  // [ 2897] Random left roll test ( 2749/ 3000).
      {  0xBD1D149EUL,  150,  0x27AF4745UL  },  // [ 2898] Random left roll test ( 2750/ 3000).
      {  0x49FC6DF0UL,   69,  0x3F8DBE09UL  },  // [ 2899] Random left roll test ( 2751/ 3000).
      {  0x2E6FB8BAUL,   80,  0xB8BA2E6FUL  },  // [ 2900] Random left roll test ( 2752/ 3000).
      {  0x7FFD5D69UL,   68,  0xFFD5D697UL  },  // [ 2901] Random left roll test ( 2753/ 3000).
      {  0x4D967C6BUL,   89,  0xD69B2CF8UL  },  // [ 2902] Random left roll test ( 2754/ 3000).
      {  0xB0E4346CUL,   25,  0xD961C868UL  },  // [ 2903] Random left roll test ( 2755/ 3000).
      {  0xA1897645UL,  145,  0xEC8B4312UL  },  // [ 2904] Random left roll test ( 2756/ 3000).
      {  0x4015103EUL,   36,  0x015103E4UL  },  // [ 2905] Random left roll test ( 2757/ 3000).
      {  0xBD58BBE6UL,  116,  0xBE6BD58BUL  },  // [ 2906] Random left roll test ( 2758/ 3000).
      {  0x8A75604FUL,  214,  0x13E29D58UL  },  // [ 2907] Random left roll test ( 2759/ 3000).
      {  0x2074EC3BUL,   32,  0x2074EC3BUL  },  // [ 2908] Random left roll test ( 2760/ 3000).
      {  0xD6232F23UL,  174,  0xCBC8F588UL  },  // [ 2909] Random left roll test ( 2761/ 3000).
      {  0x3D1AF74EUL,   95,  0x1E8D7BA7UL  },  // [ 2910] Random left roll test ( 2762/ 3000).
      {  0xFCEAB13FUL,  141,  0x5627FF9DUL  },  // [ 2911] Random left roll test ( 2763/ 3000).
      {  0x90DB65EEUL,   78,  0xD97BA436UL  },  // [ 2912] Random left roll test ( 2764/ 3000).
      {  0xC41259A1UL,  233,  0x24B34388UL  },  // [ 2913] Random left roll test ( 2765/ 3000).
      {  0x0DA1558EUL,  123,  0x706D0AACUL  },  // [ 2914] Random left roll test ( 2766/ 3000).
      {  0x4D86D735UL,   54,  0xCD5361B5UL  },  // [ 2915] Random left roll test ( 2767/ 3000).
      {  0xA0A5850AUL,    6,  0x296142A8UL  },  // [ 2916] Random left roll test ( 2768/ 3000).
      {  0x97F5B95EUL,  196,  0x7F5B95E9UL  },  // [ 2917] Random left roll test ( 2769/ 3000).
      {  0x602A048BUL,  220,  0xB602A048UL  },  // [ 2918] Random left roll test ( 2770/ 3000).
      {  0x6BD315BCUL,  181,  0xB78D7A62UL  },  // [ 2919] Random left roll test ( 2771/ 3000).
      {  0x095A441FUL,   60,  0xF095A441UL  },  // [ 2920] Random left roll test ( 2772/ 3000).
      {  0xB9B1DCB7UL,  101,  0x363B96F7UL  },  // [ 2921] Random left roll test ( 2773/ 3000).
      {  0x3B63848CUL,   46,  0xE1230ED8UL  },  // [ 2922] Random left roll test ( 2774/ 3000).
      {  0x64849E31UL,  177,  0x3C62C909UL  },  // [ 2923] Random left roll test ( 2775/ 3000).
      {  0x4AF7CC21UL,  159,  0xA57BE610UL  },  // [ 2924] Random left roll test ( 2776/ 3000).
      {  0x3F5F4235UL,   32,  0x3F5F4235UL  },  // [ 2925] Random left roll test ( 2777/ 3000).
      {  0x42611897UL,  117,  0x12E84C23UL  },  // [ 2926] Random left roll test ( 2778/ 3000).
      {  0xF1F1A228UL,  110,  0x688A3C7CUL  },  // [ 2927] Random left roll test ( 2779/ 3000).
      {  0x4083ABB0UL,    8,  0x83ABB040UL  },  // [ 2928] Random left roll test ( 2780/ 3000).
      {  0xAF5699E3UL,   73,  0xAD33C75EUL  },  // [ 2929] Random left roll test ( 2781/ 3000).
      {  0xAB1443CEUL,   83,  0x1E7558A2UL  },  // [ 2930] Random left roll test ( 2782/ 3000).
      {  0x027BB537UL,  253,  0xE04F76A6UL  },  // [ 2931] Random left roll test ( 2783/ 3000).
      {  0x143BC808UL,  159,  0x0A1DE404UL  },  // [ 2932] Random left roll test ( 2784/ 3000).
      {  0x549D3015UL,  142,  0x4C055527UL  },  // [ 2933] Random left roll test ( 2785/ 3000).
      {  0x1EF46E4AUL,  141,  0x8DC943DEUL  },  // [ 2934] Random left roll test ( 2786/ 3000).
      {  0x04A8DF9CUL,  185,  0x380951BFUL  },  // [ 2935] Random left roll test ( 2787/ 3000).
      {  0xECAE12A2UL,   56,  0xA2ECAE12UL  },  // [ 2936] Random left roll test ( 2788/ 3000).
      {  0xCD196314UL,  125,  0x99A32C62UL  },  // [ 2937] Random left roll test ( 2789/ 3000).
      {  0xF8BC98A2UL,   56,  0xA2F8BC98UL  },  // [ 2938] Random left roll test ( 2790/ 3000).
      {  0x9ACBE938UL,    3,  0xD65F49C4UL  },  // [ 2939] Random left roll test ( 2791/ 3000).
      {  0xE085DA5EUL,   91,  0xF7042ED2UL  },  // [ 2940] Random left roll test ( 2792/ 3000).
      {  0xB1D77B84UL,   46,  0xDEE12C75UL  },  // [ 2941] Random left roll test ( 2793/ 3000).
      {  0xFF10932AUL,  167,  0x8849957FUL  },  // [ 2942] Random left roll test ( 2794/ 3000).
      {  0x4E03E1CEUL,  142,  0xF8739380UL  },  // [ 2943] Random left roll test ( 2795/ 3000).
      {  0xB35704F9UL,   56,  0xF9B35704UL  },  // [ 2944] Random left roll test ( 2796/ 3000).
      {  0xD278B2CDUL,  112,  0xB2CDD278UL  },  // [ 2945] Random left roll test ( 2797/ 3000).
      {  0x6C713F03UL,   86,  0xC0DB1C4FUL  },  // [ 2946] Random left roll test ( 2798/ 3000).
      {  0xA467A596UL,  147,  0x2CB5233DUL  },  // [ 2947] Random left roll test ( 2799/ 3000).
      {  0x87A51AC6UL,  201,  0x4A358D0FUL  },  // [ 2948] Random left roll test ( 2800/ 3000).
      {  0x5A72C59CUL,  219,  0xE2D3962CUL  },  // [ 2949] Random left roll test ( 2801/ 3000).
      {  0xAE8E5241UL,  203,  0x72920D74UL  },  // [ 2950] Random left roll test ( 2802/ 3000).
      {  0xFCB7C1C6UL,  109,  0xF838DF96UL  },  // [ 2951] Random left roll test ( 2803/ 3000).
      {  0x5523B04CUL,  130,  0x548EC131UL  },  // [ 2952] Random left roll test ( 2804/ 3000).
      {  0xB28E6F7AUL,  116,  0xF7AB28E6UL  },  // [ 2953] Random left roll test ( 2805/ 3000).
      {  0xA3A837DEUL,  116,  0x7DEA3A83UL  },  // [ 2954] Random left roll test ( 2806/ 3000).
      {  0xCDDD9E5EUL,   61,  0xD9BBB3CBUL  },  // [ 2955] Random left roll test ( 2807/ 3000).
      {  0x3FFA78A8UL,    6,  0xFE9E2A0FUL  },  // [ 2956] Random left roll test ( 2808/ 3000).
      {  0x4AFE1B78UL,  180,  0xB784AFE1UL  },  // [ 2957] Random left roll test ( 2809/ 3000).
      {  0x92AE39D3UL,  190,  0xE4AB8E74UL  },  // [ 2958] Random left roll test ( 2810/ 3000).
      {  0x6E879DCFUL,  206,  0xE773DBA1UL  },  // [ 2959] Random left roll test ( 2811/ 3000).
      {  0xA38834F0UL,  203,  0x41A7851CUL  },  // [ 2960] Random left roll test ( 2812/ 3000).
      {  0x6D9C2E70UL,  152,  0x706D9C2EUL  },  // [ 2961] Random left roll test ( 2813/ 3000).
      {  0x65DD04BDUL,  248,  0xBD65DD04UL  },  // [ 2962] Random left roll test ( 2814/ 3000).
      {  0xFC25C158UL,  145,  0x82B1F84BUL  },  // [ 2963] Random left roll test ( 2815/ 3000).
      {  0xF9B20BB9UL,  100,  0x9B20BB9FUL  },  // [ 2964] Random left roll test ( 2816/ 3000).
      {  0xDCAD6F6DUL,  148,  0xF6DDCAD6UL  },  // [ 2965] Random left roll test ( 2817/ 3000).
      {  0xD52D327DUL,  238,  0x4C9F754BUL  },  // [ 2966] Random left roll test ( 2818/ 3000).
      {  0xFD53B582UL,   99,  0xEA9DAC17UL  },  // [ 2967] Random left roll test ( 2819/ 3000).
      {  0xAFE169AAUL,  129,  0x5FC2D355UL  },  // [ 2968] Random left roll test ( 2820/ 3000).
      {  0xB97495D7UL,   80,  0x95D7B974UL  },  // [ 2969] Random left roll test ( 2821/ 3000).
      {  0xFBFAE7CBUL,   70,  0xFEB9F2FEUL  },  // [ 2970] Random left roll test ( 2822/ 3000).
      {  0x278D5ABFUL,   24,  0xBF278D5AUL  },  // [ 2971] Random left roll test ( 2823/ 3000).
      {  0x1126A06FUL,  122,  0xBC449A81UL  },  // [ 2972] Random left roll test ( 2824/ 3000).
      {  0xC9956084UL,   26,  0x13265582UL  },  // [ 2973] Random left roll test ( 2825/ 3000).
      {  0xE25CCB74UL,  165,  0x4B996E9CUL  },  // [ 2974] Random left roll test ( 2826/ 3000).
      {  0xDB4EB435UL,  167,  0xA75A1AEDUL  },  // [ 2975] Random left roll test ( 2827/ 3000).
      {  0x1AC17EFCUL,   78,  0x5FBF06B0UL  },  // [ 2976] Random left roll test ( 2828/ 3000).
      {  0x360AEF07UL,   89,  0x0E6C15DEUL  },  // [ 2977] Random left roll test ( 2829/ 3000).
      {  0x1CCEE3C0UL,    2,  0x733B8F00UL  },  // [ 2978] Random left roll test ( 2830/ 3000).
      {  0x668DDD58UL,  209,  0xBAB0CD1BUL  },  // [ 2979] Random left roll test ( 2831/ 3000).
      {  0xF86EE4DCUL,   90,  0x73E1BB93UL  },  // [ 2980] Random left roll test ( 2832/ 3000).
      {  0x71740FAFUL,  228,  0x1740FAF7UL  },  // [ 2981] Random left roll test ( 2833/ 3000).
      {  0x7EF82495UL,   34,  0xFBE09255UL  },  // [ 2982] Random left roll test ( 2834/ 3000).
      {  0xA04DA7DCUL,    5,  0x09B4FB94UL  },  // [ 2983] Random left roll test ( 2835/ 3000).
      {  0x03687DA6UL,  214,  0x6980DA1FUL  },  // [ 2984] Random left roll test ( 2836/ 3000).
      {  0xE7E681CBUL,  179,  0x0E5F3F34UL  },  // [ 2985] Random left roll test ( 2837/ 3000).
      {  0xCC29D45BUL,  234,  0xA7516F30UL  },  // [ 2986] Random left roll test ( 2838/ 3000).
      {  0x4637C889UL,  116,  0x8894637CUL  },  // [ 2987] Random left roll test ( 2839/ 3000).
      {  0xE7A80727UL,  109,  0x00E4FCF5UL  },  // [ 2988] Random left roll test ( 2840/ 3000).
      {  0x861A73DFUL,  237,  0x4E7BF0C3UL  },  // [ 2989] Random left roll test ( 2841/ 3000).
      {  0xEBB45C42UL,  225,  0xD768B885UL  },  // [ 2990] Random left roll test ( 2842/ 3000).
      {  0x07B0C2E6UL,   49,  0x85CC0F61UL  },  // [ 2991] Random left roll test ( 2843/ 3000).
      {  0x358E2269UL,   98,  0xD63889A4UL  },  // [ 2992] Random left roll test ( 2844/ 3000).
      {  0x7DC799DEUL,    2,  0xF71E6779UL  },  // [ 2993] Random left roll test ( 2845/ 3000).
      {  0xA9EE107FUL,  196,  0x9EE107FAUL  },  // [ 2994] Random left roll test ( 2846/ 3000).
      {  0xC9352764UL,  254,  0x324D49D9UL  },  // [ 2995] Random left roll test ( 2847/ 3000).
      {  0xF641AE15UL,  145,  0x5C2BEC83UL  },  // [ 2996] Random left roll test ( 2848/ 3000).
      {  0x42463A61UL,  194,  0x0918E985UL  },  // [ 2997] Random left roll test ( 2849/ 3000).
      {  0x5FFA5F0DUL,  162,  0x7FE97C35UL  },  // [ 2998] Random left roll test ( 2850/ 3000).
      {  0x7A19879EUL,   58,  0x79E8661EUL  },  // [ 2999] Random left roll test ( 2851/ 3000).
      {  0x2E89D266UL,  158,  0x8BA27499UL  },  // [ 3000] Random left roll test ( 2852/ 3000).
      {  0x940B3B82UL,   87,  0xC14A059DUL  },  // [ 3001] Random left roll test ( 2853/ 3000).
      {  0x79D43F7FUL,  192,  0x79D43F7FUL  },  // [ 3002] Random left roll test ( 2854/ 3000).
      {  0xE7B30ECBUL,   54,  0xB2F9ECC3UL  },  // [ 3003] Random left roll test ( 2855/ 3000).
      {  0xF2CCE179UL,   41,  0x99C2F3E5UL  },  // [ 3004] Random left roll test ( 2856/ 3000).
      {  0x62580DC6UL,  133,  0x4B01B8CCUL  },  // [ 3005] Random left roll test ( 2857/ 3000).
      {  0x0AE2EC50UL,  221,  0x015C5D8AUL  },  // [ 3006] Random left roll test ( 2858/ 3000).
      {  0x62FF7246UL,  219,  0x3317FB92UL  },  // [ 3007] Random left roll test ( 2859/ 3000).
      {  0x3FA2C16FUL,   55,  0xB79FD160UL  },  // [ 3008] Random left roll test ( 2860/ 3000).
      {  0xB0B23C55UL,  225,  0x616478ABUL  },  // [ 3009] Random left roll test ( 2861/ 3000).
      {  0xA7E4D9FAUL,   28,  0xAA7E4D9FUL  },  // [ 3010] Random left roll test ( 2862/ 3000).
      {  0x8AF7EB8CUL,  206,  0xFAE322BDUL  },  // [ 3011] Random left roll test ( 2863/ 3000).
      {  0x03574FFEUL,  203,  0xBA7FF01AUL  },  // [ 3012] Random left roll test ( 2864/ 3000).
      {  0xD5FDB733UL,  199,  0xFEDB99EAUL  },  // [ 3013] Random left roll test ( 2865/ 3000).
      {  0x75E19D75UL,  211,  0xEBABAF0CUL  },  // [ 3014] Random left roll test ( 2866/ 3000).
      {  0x010A97FCUL,  251,  0xE00854BFUL  },  // [ 3015] Random left roll test ( 2867/ 3000).
      {  0x6FD304E6UL,  127,  0x37E98273UL  },  // [ 3016] Random left roll test ( 2868/ 3000).
      {  0xAA6CBF17UL,  228,  0xA6CBF17AUL  },  // [ 3017] Random left roll test ( 2869/ 3000).
      {  0x48FA283BUL,  201,  0xF4507691UL  },  // [ 3018] Random left roll test ( 2870/ 3000).
      {  0x93D9FA7CUL,  109,  0x3F4F927BUL  },  // [ 3019] Random left roll test ( 2871/ 3000).
      {  0xD60E923AUL,  229,  0xC1D2475AUL  },  // [ 3020] Random left roll test ( 2872/ 3000).
      {  0xE58D65ADUL,  188,  0xDE58D65AUL  },  // [ 3021] Random left roll test ( 2873/ 3000).
      {  0x311B4097UL,   96,  0x311B4097UL  },  // [ 3022] Random left roll test ( 2874/ 3000).
      {  0x6A72820CUL,  181,  0x418D4E50UL  },  // [ 3023] Random left roll test ( 2875/ 3000).
      {  0xD50360E0UL,  127,  0x6A81B070UL  },  // [ 3024] Random left roll test ( 2876/ 3000).
      {  0x1EE3A1A3UL,  232,  0xE3A1A31EUL  },  // [ 3025] Random left roll test ( 2877/ 3000).
      {  0x9B7E4941UL,  154,  0x066DF925UL  },  // [ 3026] Random left roll test ( 2878/ 3000).
      {  0xFF03114FUL,   18,  0x453FFC0CUL  },  // [ 3027] Random left roll test ( 2879/ 3000).
      {  0x9AA10275UL,  151,  0x3ACD5081UL  },  // [ 3028] Random left roll test ( 2880/ 3000).
      {  0x033354FAUL,  119,  0x7D0199AAUL  },  // [ 3029] Random left roll test ( 2881/ 3000).
      {  0xD5234925UL,   15,  0xA492EA91UL  },  // [ 3030] Random left roll test ( 2882/ 3000).
      {  0xA9F39951UL,   11,  0x9CCA8D4FUL  },  // [ 3031] Random left roll test ( 2883/ 3000).
      {  0xA3A338E0UL,  150,  0x3828E8CEUL  },  // [ 3032] Random left roll test ( 2884/ 3000).
      {  0x1C585149UL,  168,  0x5851491CUL  },  // [ 3033] Random left roll test ( 2885/ 3000).
      {  0x898B3FE2UL,  101,  0x3167FC51UL  },  // [ 3034] Random left roll test ( 2886/ 3000).
      {  0xC679F54BUL,  174,  0x7D52F19EUL  },  // [ 3035] Random left roll test ( 2887/ 3000).
      {  0x3734FE57UL,   60,  0x73734FE5UL  },  // [ 3036] Random left roll test ( 2888/ 3000).
      {  0x37508415UL,  220,  0x53750841UL  },  // [ 3037] Random left roll test ( 2889/ 3000).
      {  0x9232FE38UL,  107,  0x97F1C491UL  },  // [ 3038] Random left roll test ( 2890/ 3000).
      {  0x59071412UL,  224,  0x59071412UL  },  // [ 3039] Random left roll test ( 2891/ 3000).
      {  0x8F26667FUL,  133,  0xE4CCCFF1UL  },  // [ 3040] Random left roll test ( 2892/ 3000).
      {  0x2347F26DUL,  185,  0xDA468FE4UL  },  // [ 3041] Random left roll test ( 2893/ 3000).
      {  0x07F4C380UL,  240,  0xC38007F4UL  },  // [ 3042] Random left roll test ( 2894/ 3000).
      {  0x48B8E6A9UL,  131,  0x45C7354AUL  },  // [ 3043] Random left roll test ( 2895/ 3000).
      {  0x26239CB3UL,  172,  0x39CB3262UL  },  // [ 3044] Random left roll test ( 2896/ 3000).
      {  0x41D72EC1UL,   90,  0x05075CBBUL  },  // [ 3045] Random left roll test ( 2897/ 3000).
      {  0x840087ACUL,   84,  0x7AC84008UL  },  // [ 3046] Random left roll test ( 2898/ 3000).
      {  0xED8B1332UL,   96,  0xED8B1332UL  },  // [ 3047] Random left roll test ( 2899/ 3000).
      {  0x992F921CUL,   40,  0x2F921C99UL  },  // [ 3048] Random left roll test ( 2900/ 3000).
      {  0x56CD06EBUL,  161,  0xAD9A0DD6UL  },  // [ 3049] Random left roll test ( 2901/ 3000).
      {  0x784F130BUL,  114,  0x4C2DE13CUL  },  // [ 3050] Random left roll test ( 2902/ 3000).
      {  0xE4BA9DE0UL,   74,  0xEA778392UL  },  // [ 3051] Random left roll test ( 2903/ 3000).
      {  0xBA41A947UL,  157,  0xF7483528UL  },  // [ 3052] Random left roll test ( 2904/ 3000).
      {  0x430F6A01UL,  105,  0x1ED40286UL  },  // [ 3053] Random left roll test ( 2905/ 3000).
      {  0x717C4459UL,  144,  0x4459717CUL  },  // [ 3054] Random left roll test ( 2906/ 3000).
      {  0x32CB6D74UL,   21,  0xAE86596DUL  },  // [ 3055] Random left roll test ( 2907/ 3000).
      {  0x9CFB743BUL,  184,  0x3B9CFB74UL  },  // [ 3056] Random left roll test ( 2908/ 3000).
      {  0xE81C1AD5UL,  198,  0x0706B57AUL  },  // [ 3057] Random left roll test ( 2909/ 3000).
      {  0x76B8A727UL,  134,  0xAE29C9DDUL  },  // [ 3058] Random left roll test ( 2910/ 3000).
      {  0x71CF7D3FUL,  197,  0x39EFA7EEUL  },  // [ 3059] Random left roll test ( 2911/ 3000).
      {  0x45EEEA49UL,   35,  0x2F77524AUL  },  // [ 3060] Random left roll test ( 2912/ 3000).
      {  0xB3FD9F8CUL,  188,  0xCB3FD9F8UL  },  // [ 3061] Random left roll test ( 2913/ 3000).
      {  0x3E611ABAUL,  207,  0x8D5D1F30UL  },  // [ 3062] Random left roll test ( 2914/ 3000).
      {  0x133E04CEUL,  152,  0xCE133E04UL  },  // [ 3063] Random left roll test ( 2915/ 3000).
      {  0xB8430402UL,   12,  0x30402B84UL  },  // [ 3064] Random left roll test ( 2916/ 3000).
      {  0xF947AF44UL,   78,  0xEBD13E51UL  },  // [ 3065] Random left roll test ( 2917/ 3000).
      {  0xAC06C78DUL,  125,  0xB580D8F1UL  },  // [ 3066] Random left roll test ( 2918/ 3000).
      {  0x0A7620E1UL,  126,  0x429D8838UL  },  // [ 3067] Random left roll test ( 2919/ 3000).
      {  0x10AFA52BUL,   72,  0xAFA52B10UL  },  // [ 3068] Random left roll test ( 2920/ 3000).
      {  0xF50BD15FUL,  105,  0x17A2BFEAUL  },  // [ 3069] Random left roll test ( 2921/ 3000).
      {  0x238F2810UL,  233,  0x1E502047UL  },  // [ 3070] Random left roll test ( 2922/ 3000).
      {  0xDBB84082UL,    4,  0xBB84082DUL  },  // [ 3071] Random left roll test ( 2923/ 3000).
      {  0xE1E22A58UL,   92,  0x8E1E22A5UL  },  // [ 3072] Random left roll test ( 2924/ 3000).
      {  0xE2B05196UL,   36,  0x2B05196EUL  },  // [ 3073] Random left roll test ( 2925/ 3000).
      {  0xFC4E9C89UL,  157,  0x3F89D391UL  },  // [ 3074] Random left roll test ( 2926/ 3000).
      {  0xB54F88E4UL,  237,  0xF11C96A9UL  },  // [ 3075] Random left roll test ( 2927/ 3000).
      {  0x0C91B212UL,   62,  0x83246C84UL  },  // [ 3076] Random left roll test ( 2928/ 3000).
      {  0x99D52B12UL,   47,  0x95894CEAUL  },  // [ 3077] Random left roll test ( 2929/ 3000).
      {  0xCAEBFE93UL,  180,  0xE93CAEBFUL  },  // [ 3078] Random left roll test ( 2930/ 3000).
      {  0x88F8D096UL,   55,  0x4B447C68UL  },  // [ 3079] Random left roll test ( 2931/ 3000).
      {  0xAFB4BB14UL,  169,  0x6976295FUL  },  // [ 3080] Random left roll test ( 2932/ 3000).
      {  0x5A7C52B3UL,   26,  0xCD69F14AUL  },  // [ 3081] Random left roll test ( 2933/ 3000).
      {  0xF03B7ED1UL,  109,  0x6FDA3E07UL  },  // [ 3082] Random left roll test ( 2934/ 3000).
      {  0x1C7AEDFAUL,  128,  0x1C7AEDFAUL  },  // [ 3083] Random left roll test ( 2935/ 3000).
      {  0xABED1E8FUL,   10,  0xB47A3EAFUL  },  // [ 3084] Random left roll test ( 2936/ 3000).
      {  0xFB8DC357UL,    5,  0x71B86AFFUL  },  // [ 3085] Random left roll test ( 2937/ 3000).
      {  0xE92D15AEUL,   53,  0xB5DD25A2UL  },  // [ 3086] Random left roll test ( 2938/ 3000).
      {  0x5EF630FFUL,   85,  0x1FEBDEC6UL  },  // [ 3087] Random left roll test ( 2939/ 3000).
      {  0x7D574271UL,  208,  0x42717D57UL  },  // [ 3088] Random left roll test ( 2940/ 3000).
      {  0xDB91342BUL,  106,  0x44D0AF6EUL  },  // [ 3089] Random left roll test ( 2941/ 3000).
      {  0x6C621323UL,   61,  0x6D8C4264UL  },  // [ 3090] Random left roll test ( 2942/ 3000).
      {  0x58DD3558UL,  160,  0x58DD3558UL  },  // [ 3091] Random left roll test ( 2943/ 3000).
      {  0x7361DE50UL,   67,  0x9B0EF283UL  },  // [ 3092] Random left roll test ( 2944/ 3000).
      {  0x12338BABUL,   15,  0xC5D58919UL  },  // [ 3093] Random left roll test ( 2945/ 3000).
      {  0x9FA4972EUL,  212,  0x72E9FA49UL  },  // [ 3094] Random left roll test ( 2946/ 3000).
      {  0x85333AACUL,  148,  0xAAC85333UL  },  // [ 3095] Random left roll test ( 2947/ 3000).
      {  0x9CAFBBFDUL,  139,  0x7DDFECE5UL  },  // [ 3096] Random left roll test ( 2948/ 3000).
      {  0x77EEA0F7UL,  151,  0x7BBBF750UL  },  // [ 3097] Random left roll test ( 2949/ 3000).
      {  0x1CE38A0CUL,  200,  0xE38A0C1CUL  },  // [ 3098] Random left roll test ( 2950/ 3000).
      {  0xB8B3A008UL,   30,  0x2E2CE802UL  },  // [ 3099] Random left roll test ( 2951/ 3000).
      {  0xA899B080UL,  173,  0x36101513UL  },  // [ 3100] Random left roll test ( 2952/ 3000).
      {  0xEE5E1FE8UL,   92,  0x8EE5E1FEUL  },  // [ 3101] Random left roll test ( 2953/ 3000).
      {  0xA2FF9ADAUL,  142,  0xE6B6A8BFUL  },  // [ 3102] Random left roll test ( 2954/ 3000).
      {  0x52B9C201UL,   31,  0xA95CE100UL  },  // [ 3103] Random left roll test ( 2955/ 3000).
      {  0xFC9B7A10UL,   96,  0xFC9B7A10UL  },  // [ 3104] Random left roll test ( 2956/ 3000).
      {  0x707F9370UL,  113,  0x26E0E0FFUL  },  // [ 3105] Random left roll test ( 2957/ 3000).
      {  0xC2779874UL,   17,  0x30E984EFUL  },  // [ 3106] Random left roll test ( 2958/ 3000).
      {  0x6AA152ACUL,   52,  0x2AC6AA15UL  },  // [ 3107] Random left roll test ( 2959/ 3000).
      {  0x32C02C56UL,   84,  0xC5632C02UL  },  // [ 3108] Random left roll test ( 2960/ 3000).
      {  0xA02FC466UL,  165,  0x05F88CD4UL  },  // [ 3109] Random left roll test ( 2961/ 3000).
      {  0xCC5275C8UL,  154,  0x233149D7UL  },  // [ 3110] Random left roll test ( 2962/ 3000).
      {  0x4EFAABD0UL,   98,  0x3BEAAF41UL  },  // [ 3111] Random left roll test ( 2963/ 3000).
      {  0xCB5C7D30UL,   71,  0xAE3E9865UL  },  // [ 3112] Random left roll test ( 2964/ 3000).
      {  0xD20721C3UL,  125,  0x7A40E438UL  },  // [ 3113] Random left roll test ( 2965/ 3000).
      {  0xDD12638CUL,  215,  0xC66E8931UL  },  // [ 3114] Random left roll test ( 2966/ 3000).
      {  0x3B088114UL,    0,  0x3B088114UL  },  // [ 3115] Random left roll test ( 2967/ 3000).
      {  0xC44D88E3UL,   60,  0x3C44D88EUL  },  // [ 3116] Random left roll test ( 2968/ 3000).
      {  0xF4875E0AUL,  179,  0xF057A43AUL  },  // [ 3117] Random left roll test ( 2969/ 3000).
      {  0x13236EF3UL,  200,  0x236EF313UL  },  // [ 3118] Random left roll test ( 2970/ 3000).
      {  0x8D7A86BDUL,   35,  0x6BD435ECUL  },  // [ 3119] Random left roll test ( 2971/ 3000).
      {  0xC294AF89UL,   40,  0x94AF89C2UL  },  // [ 3120] Random left roll test ( 2972/ 3000).
      {  0xB14F5244UL,  172,  0xF5244B14UL  },  // [ 3121] Random left roll test ( 2973/ 3000).
      {  0x410874DCUL,  124,  0xC410874DUL  },  // [ 3122] Random left roll test ( 2974/ 3000).
      {  0x8547462AUL,  184,  0x2A854746UL  },  // [ 3123] Random left roll test ( 2975/ 3000).
      {  0x8A48D51DUL,   24,  0x1D8A48D5UL  },  // [ 3124] Random left roll test ( 2976/ 3000).
      {  0xE980F61FUL,  191,  0xF4C07B0FUL  },  // [ 3125] Random left roll test ( 2977/ 3000).
      {  0xA506A74EUL,  209,  0x4E9D4A0DUL  },  // [ 3126] Random left roll test ( 2978/ 3000).
      {  0xC0D40C17UL,  171,  0xA060BE06UL  },  // [ 3127] Random left roll test ( 2979/ 3000).
      {  0x582C9CC1UL,   95,  0xAC164E60UL  },  // [ 3128] Random left roll test ( 2980/ 3000).
      {  0x1A88A7C8UL,  252,  0x81A88A7CUL  },  // [ 3129] Random left roll test ( 2981/ 3000).
      {  0xBDEAE5ADUL,  210,  0x96B6F7ABUL  },  // [ 3130] Random left roll test ( 2982/ 3000).
      {  0x37F4DB30UL,  130,  0xDFD36CC0UL  },  // [ 3131] Random left roll test ( 2983/ 3000).
      {  0x87BE37A2UL,  130,  0x1EF8DE8AUL  },  // [ 3132] Random left roll test ( 2984/ 3000).
      {  0xE1137FB7UL,  153,  0x6FC226FFUL  },  // [ 3133] Random left roll test ( 2985/ 3000).
      {  0xA90AA9A6UL,   10,  0x2AA69AA4UL  },  // [ 3134] Random left roll test ( 2986/ 3000).
      {  0x8D0B6753UL,  126,  0xE342D9D4UL  },  // [ 3135] Random left roll test ( 2987/ 3000).
      {  0x2E1A5AE5UL,  237,  0x4B5CA5C3UL  },  // [ 3136] Random left roll test ( 2988/ 3000).
      {  0x60735671UL,  191,  0xB039AB38UL  },  // [ 3137] Random left roll test ( 2989/ 3000).
      {  0xD7D3BA33UL,  190,  0xF5F4EE8CUL  },  // [ 3138] Random left roll test ( 2990/ 3000).
      {  0x9C5A65B1UL,  121,  0x6338B4CBUL  },  // [ 3139] Random left roll test ( 2991/ 3000).
      {  0xB03D0AB4UL,  231,  0x1E855A58UL  },  // [ 3140] Random left roll test ( 2992/ 3000).
      {  0x6BCE6359UL,  141,  0xCC6B2D79UL  },  // [ 3141] Random left roll test ( 2993/ 3000).
      {  0x85FC083FUL,  192,  0x85FC083FUL  },  // [ 3142] Random left roll test ( 2994/ 3000).
      {  0xD802DF06UL,   40,  0x02DF06D8UL  },  // [ 3143] Random left roll test ( 2995/ 3000).
      {  0x15A73268UL,  159,  0x0AD39934UL  },  // [ 3144] Random left roll test ( 2996/ 3000).
      {  0x39CDFF4FUL,   83,  0xFA79CE6FUL  },  // [ 3145] Random left roll test ( 2997/ 3000).
      {  0x516A64F8UL,  231,  0xB5327C28UL  },  // [ 3146] Random left roll test ( 2998/ 3000).
      {  0xAA1A6939UL,   61,  0x35434D27UL  },  // [ 3147] Random left roll test ( 2999/ 3000).
      {  0xB873072FUL,  141,  0x60E5F70EUL  },  // [ 3148] Random left roll test ( 3000/ 3000).
   };


//Returns the number of test vectors that may be used for a speed test.
//
UCU_UINT32 UtsnBtU32RotLeftNInPlaceRxn(void)
   {
   return(sizeof(BtU32RotLeftNInPlaceRxn_Tvs)/sizeof(BtU32RotLeftNInPlaceRxn_Tvs[0]));
   }


//Runs a selected test vector.  This is used for automated speed testing.
//
void UtspBtU32RotLeftNInPlaceRxn(UCU_UINT32 test_no, void (*start_pointer)(void), void (*end_pointer)(void))
   {
   UCU_UINT32 start;
   UCU_UINT8  n;

   //Error out if the index is invalid.
   //
   if (test_no >= (sizeof(BtU32RotLeftNInPlaceRxn_Tvs)/sizeof(BtU32RotLeftNInPlaceRxn_Tvs[0])))
      {
      while(UCU_TRUE)  //Can't allow this scenario and dereference an invalid vector.
         ;
      }

   //Fetch the parameters.  This removes all of the array indexing and so on from the
   //elapsed time calculation.
   start           = BtU32RotLeftNInPlaceRxn_Tvs[test_no].start;
   n               = BtU32RotLeftNInPlaceRxn_Tvs[test_no].n;

   //We are ready to make the call.  Start the caller's timer.
   (*start_pointer)();

   //Call the function.
   UcuBtU32RotLeftNInPlaceRxn(&start, n);

   //The call is finished.  Stop the caller's timer.
   (*end_pointer)();
   }


//Runs all test vectors.  Returns TRUE if OK, FALSE if any failed.
//
UCU_BOOLEAN UtfuBtU32RotLeftNInPlaceRxn(void)
   {
   UCU_BOOLEAN rv;
   UCU_UINT16  i;
   UCU_UINT32  start, end;
   UCU_UINT8   n;

   rv = UCU_TRUE;

   for (i=0; i<(sizeof(BtU32RotLeftNInPlaceRxn_Tvs)/sizeof(BtU32RotLeftNInPlaceRxn_Tvs[0])); i++)
      {
      start           = BtU32RotLeftNInPlaceRxn_Tvs[i].start;
      end             = BtU32RotLeftNInPlaceRxn_Tvs[i].end;
      n               = BtU32RotLeftNInPlaceRxn_Tvs[i].n;

      UcuBtU32RotLeftNInPlaceRxn(&start, n);

      if (start != end)  //Actual roll result does not match expected roll result.
         rv = UCU_FALSE;
      }
		
   return(rv);
   }


//-------------------------------------------------------------------------------
//$Log: utfu_btu32rotleftninplacerxn.c,v $
//Revision 1.2  2010/05/18 21:17:11  dashley
//Extra line removed.
//
//Revision 1.1  2010/05/18 21:13:22  dashley
//Initial checkin.
//-------------------------------------------------------------------------------
//End of $RCSfile: utfu_btu32rotleftninplacerxn.c,v $
//-------------------------------------------------------------------------------

